/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DImode)
      || GET_MODE (x1) != E_RVVM8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64HImode)
      || GET_MODE (x1) != E_V64HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 0;

    case E_V512HFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 1;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 0;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4HFmode)
      || GET_MODE (x1) != E_RVVMF4HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DFmode)
      || GET_MODE (x1) != E_RVVM8DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM2DFmode)
      || GET_MODE (x1) != E_RVVM2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024HFmode)
      || GET_MODE (x1) != E_V1024HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SFmode)
      || GET_MODE (x1) != E_V32SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V256DFmode)
      || GET_MODE (x1) != E_V256DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 0;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  return pattern105 (x2); /* [-1, 2] */
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !vector_mask_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 23;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 24;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 25;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 26;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 27;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 28;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 29;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 30;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 31;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 32;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 33;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 34;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 35;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 36;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 37;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 38;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 39;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 40;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 41;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 42;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 43;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 44;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 45;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 46;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 47;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 48;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 49;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 50;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 51;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 52;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 53;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 54;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 55;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 56;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 57;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 58;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 59;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 60;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 61;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 62;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 63;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 64;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 65;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 66;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 67;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 68;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      return pattern128 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode); /* [-1, 0] */

    case E_RVVM4SFmode:
      if (pattern128 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (pattern128 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (pattern128 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (pattern128 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 4;

    case E_RVVM8DFmode:
      if (pattern128 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode) != 0)
        return -1;
      return 5;

    case E_RVVM4DFmode:
      if (pattern128 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode) != 0)
        return -1;
      return 6;

    case E_RVVM2DFmode:
      if (pattern128 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode) != 0)
        return -1;
      return 7;

    case E_RVVM1DFmode:
      if (pattern128 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode) != 0)
        return -1;
      return 8;

    case E_V1SFmode:
      if (pattern128 (x1, 
E_V1HFmode, 
E_V1SFmode) != 0)
        return -1;
      return 9;

    case E_V2SFmode:
      if (pattern128 (x1, 
E_V2HFmode, 
E_V2SFmode) != 0)
        return -1;
      return 10;

    case E_V4SFmode:
      if (pattern128 (x1, 
E_V4HFmode, 
E_V4SFmode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern128 (x1, 
E_V8HFmode, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V16SFmode:
      if (pattern128 (x1, 
E_V16HFmode, 
E_V16SFmode) != 0)
        return -1;
      return 13;

    case E_V32SFmode:
      if (pattern128 (x1, 
E_V32HFmode, 
E_V32SFmode) != 0)
        return -1;
      return 14;

    case E_V64SFmode:
      if (pattern128 (x1, 
E_V64HFmode, 
E_V64SFmode) != 0)
        return -1;
      return 15;

    case E_V128SFmode:
      if (pattern128 (x1, 
E_V128HFmode, 
E_V128SFmode) != 0)
        return -1;
      return 16;

    case E_V256SFmode:
      if (pattern128 (x1, 
E_V256HFmode, 
E_V256SFmode) != 0)
        return -1;
      return 17;

    case E_V512SFmode:
      if (pattern128 (x1, 
E_V512HFmode, 
E_V512SFmode) != 0)
        return -1;
      return 18;

    case E_V1024SFmode:
      if (pattern128 (x1, 
E_V1024HFmode, 
E_V1024SFmode) != 0)
        return -1;
      return 19;

    case E_V1DFmode:
      if (pattern128 (x1, 
E_V1SFmode, 
E_V1DFmode) != 0)
        return -1;
      return 20;

    case E_V2DFmode:
      if (pattern128 (x1, 
E_V2SFmode, 
E_V2DFmode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern128 (x1, 
E_V4SFmode, 
E_V4DFmode) != 0)
        return -1;
      return 22;

    case E_V8DFmode:
      if (pattern128 (x1, 
E_V8SFmode, 
E_V8DFmode) != 0)
        return -1;
      return 23;

    case E_V16DFmode:
      if (pattern128 (x1, 
E_V16SFmode, 
E_V16DFmode) != 0)
        return -1;
      return 24;

    case E_V32DFmode:
      if (pattern128 (x1, 
E_V32SFmode, 
E_V32DFmode) != 0)
        return -1;
      return 25;

    case E_V64DFmode:
      if (pattern128 (x1, 
E_V64SFmode, 
E_V64DFmode) != 0)
        return -1;
      return 26;

    case E_V128DFmode:
      if (pattern128 (x1, 
E_V128SFmode, 
E_V128DFmode) != 0)
        return -1;
      return 27;

    case E_V256DFmode:
      if (pattern128 (x1, 
E_V256SFmode, 
E_V256DFmode) != 0)
        return -1;
      return 28;

    case E_V512DFmode:
      if (pattern128 (x1, 
E_V512SFmode, 
E_V512DFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern136 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern136 (x1, 
E_RVVM4HFmode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern136 (x1, 
E_RVVM2HFmode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern136 (x1, 
E_RVVM1HFmode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern136 (x1, 
E_RVVMF2HFmode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern136 (x1, 
E_RVVMF4HFmode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern136 (x1, 
E_RVVM8SFmode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern136 (x1, 
E_RVVM4SFmode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern136 (x1, 
E_RVVM2SFmode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern136 (x1, 
E_RVVM1SFmode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern136 (x1, 
E_RVVMF2SFmode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern136 (x1, 
E_RVVM8DFmode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern136 (x1, 
E_RVVM4DFmode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern136 (x1, 
E_RVVM2DFmode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern136 (x1, 
E_RVVM1DFmode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern136 (x1, 
E_V1HFmode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern136 (x1, 
E_V2HFmode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern136 (x1, 
E_V4HFmode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern136 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern136 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern136 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern136 (x1, 
E_V64HFmode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern136 (x1, 
E_V128HFmode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern136 (x1, 
E_V256HFmode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern136 (x1, 
E_V512HFmode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern136 (x1, 
E_V1024HFmode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern136 (x1, 
E_V2048HFmode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern136 (x1, 
E_V1SFmode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern136 (x1, 
E_V2SFmode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern136 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern136 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern136 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern136 (x1, 
E_V32SFmode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern136 (x1, 
E_V64SFmode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern136 (x1, 
E_V128SFmode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern136 (x1, 
E_V256SFmode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern136 (x1, 
E_V512SFmode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern136 (x1, 
E_V1024SFmode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern136 (x1, 
E_V1DFmode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern136 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern136 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern136 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern136 (x1, 
E_V16DFmode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern136 (x1, 
E_V32DFmode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern136 (x1, 
E_V64DFmode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern136 (x1, 
E_V128DFmode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern136 (x1, 
E_V256DFmode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern136 (x1, 
E_V512DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      res = pattern139 (x1);
      if (res >= 0)
        return res + 48; /* [48, 107] */
      return -1;

    case NEG:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case FLOAT_EXTEND:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern140 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 108;

            case E_RVVM4SFmode:
              if (pattern140 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 109;

            case E_RVVM2SFmode:
              if (pattern140 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 110;

            case E_RVVM1SFmode:
              if (pattern140 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 111;

            case E_RVVMF2SFmode:
              if (pattern140 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 112;

            case E_RVVM8DFmode:
              if (pattern140 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 113;

            case E_RVVM4DFmode:
              if (pattern140 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 114;

            case E_RVVM2DFmode:
              if (pattern140 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 115;

            case E_RVVM1DFmode:
              if (pattern140 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 116;

            case E_V1SFmode:
              if (pattern140 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 117;

            case E_V2SFmode:
              if (pattern140 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 118;

            case E_V4SFmode:
              if (pattern140 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 119;

            case E_V8SFmode:
              if (pattern140 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 120;

            case E_V16SFmode:
              if (pattern140 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 121;

            case E_V32SFmode:
              if (pattern140 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 122;

            case E_V64SFmode:
              if (pattern140 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 123;

            case E_V128SFmode:
              if (pattern140 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 124;

            case E_V256SFmode:
              if (pattern140 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 125;

            case E_V512SFmode:
              if (pattern140 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 126;

            case E_V1024SFmode:
              if (pattern140 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 127;

            case E_V1DFmode:
              if (pattern140 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 128;

            case E_V2DFmode:
              if (pattern140 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 129;

            case E_V4DFmode:
              if (pattern140 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 130;

            case E_V8DFmode:
              if (pattern140 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 131;

            case E_V16DFmode:
              if (pattern140 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 132;

            case E_V32DFmode:
              if (pattern140 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 133;

            case E_V64DFmode:
              if (pattern140 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 134;

            case E_V128DFmode:
              if (pattern140 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 135;

            case E_V256DFmode:
              if (pattern140 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 136;

            case E_V512DFmode:
              if (pattern140 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 137;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern141 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 138;

            case E_RVVM4SFmode:
              if (pattern141 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 139;

            case E_RVVM2SFmode:
              if (pattern141 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 140;

            case E_RVVM1SFmode:
              if (pattern141 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 141;

            case E_RVVMF2SFmode:
              if (pattern141 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 142;

            case E_RVVM8DFmode:
              if (pattern141 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 143;

            case E_RVVM4DFmode:
              if (pattern141 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 144;

            case E_RVVM2DFmode:
              if (pattern141 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 145;

            case E_RVVM1DFmode:
              if (pattern141 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 146;

            case E_V1SFmode:
              if (pattern141 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 147;

            case E_V2SFmode:
              if (pattern141 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 148;

            case E_V4SFmode:
              if (pattern141 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 149;

            case E_V8SFmode:
              if (pattern141 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 150;

            case E_V16SFmode:
              if (pattern141 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 151;

            case E_V32SFmode:
              if (pattern141 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 152;

            case E_V64SFmode:
              if (pattern141 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 153;

            case E_V128SFmode:
              if (pattern141 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 154;

            case E_V256SFmode:
              if (pattern141 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 155;

            case E_V512SFmode:
              if (pattern141 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 156;

            case E_V1024SFmode:
              if (pattern141 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 157;

            case E_V1DFmode:
              if (pattern141 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 158;

            case E_V2DFmode:
              if (pattern141 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 159;

            case E_V4DFmode:
              if (pattern141 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 160;

            case E_V8DFmode:
              if (pattern141 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 161;

            case E_V16DFmode:
              if (pattern141 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 162;

            case E_V32DFmode:
              if (pattern141 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 163;

            case E_V64DFmode:
              if (pattern141 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 164;

            case E_V128DFmode:
              if (pattern141 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 165;

            case E_V256DFmode:
              if (pattern141 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 166;

            case E_V512DFmode:
              if (pattern141 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 167;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern191 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND
      || GET_MODE (x6) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[3] = x8;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x9 = XEXP (x6, 0);
  switch (GET_CODE (x9))
    {
    case NOT:
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !nonmemory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern204 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2)
      || !csr_operand (operands[3], i4)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x1) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8HImode:
          if (!register_operand (operands[2], E_RVVM8HImode))
            return -1;
          return 0;

        case E_RVVM4QImode:
          if (!register_operand (operands[2], E_RVVM4QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x1) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 2;

        case E_RVVM2QImode:
          if (!register_operand (operands[2], E_RVVM2QImode))
            return -1;
          return 3;

        case E_RVVM8SImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x1) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 5;

        case E_RVVM1QImode:
          if (!register_operand (operands[2], E_RVVM1QImode))
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x1) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 8;

        case E_RVVMF2QImode:
          if (!register_operand (operands[2], E_RVVMF2QImode))
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x1) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 11;

        case E_RVVMF4QImode:
          if (!register_operand (operands[2], E_RVVMF4QImode))
            return -1;
          return 12;

        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x1) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[2], E_RVVMF8QImode))
            return -1;
          return 15;

        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x1) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8SImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 17;

        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x1) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 19;

        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 20;

        case E_RVVM8DImode:
          if (!register_operand (operands[2], E_RVVM8DImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x1) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[3], E_RVVM2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 22;

        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 23;

        case E_RVVM4DImode:
          if (!register_operand (operands[2], E_RVVM4DImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x1) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[3], E_RVVM1SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 25;

        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 26;

        case E_RVVM2DImode:
          if (!register_operand (operands[2], E_RVVM2DImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x1) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[3], E_RVVMF2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 28;

        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 29;

        case E_RVVM1DImode:
          if (!register_operand (operands[2], E_RVVM1DImode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x1) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[3], E_RVVM8DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[2], E_RVVM8DImode))
            return -1;
          return 31;

        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x1) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[3], E_RVVM4DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4DImode:
          if (!register_operand (operands[2], E_RVVM4DImode))
            return -1;
          return 33;

        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x1) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[3], E_RVVM2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2DImode:
          if (!register_operand (operands[2], E_RVVM2DImode))
            return -1;
          return 35;

        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x1) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[3], E_RVVM1DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[2], E_RVVM1DImode))
            return -1;
          return 37;

        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x1) != E_V1HFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 39;

        case E_V1QImode:
          if (!register_operand (operands[2], E_V1QImode))
            return -1;
          return 40;

        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[2], E_V2QImode))
            return -1;
          return 43;

        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 45;

        case E_V4QImode:
          if (!register_operand (operands[2], E_V4QImode))
            return -1;
          return 46;

        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 48;

        case E_V8QImode:
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          return 49;

        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 51;

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          return 52;

        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 54;

        case E_V32QImode:
          if (!register_operand (operands[2], E_V32QImode))
            return -1;
          return 55;

        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 57;

        case E_V64QImode:
          if (!register_operand (operands[2], E_V64QImode))
            return -1;
          return 58;

        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x1) != E_V128HFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 60;

        case E_V128QImode:
          if (!register_operand (operands[2], E_V128QImode))
            return -1;
          return 61;

        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 62;

        default:
          return -1;
        }

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x1) != E_V256HFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 63;

        case E_V256QImode:
          if (!register_operand (operands[2], E_V256QImode))
            return -1;
          return 64;

        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 65;

        default:
          return -1;
        }

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x1) != E_V512HFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 66;

        case E_V512QImode:
          if (!register_operand (operands[2], E_V512QImode))
            return -1;
          return 67;

        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 68;

        default:
          return -1;
        }

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x1) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 69;

        case E_V1024QImode:
          if (!register_operand (operands[2], E_V1024QImode))
            return -1;
          return 70;

        case E_V1024SImode:
          if (!register_operand (operands[2], E_V1024SImode))
            return -1;
          return 71;

        default:
          return -1;
        }

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x1) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048BImode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2048HImode:
          if (!register_operand (operands[2], E_V2048HImode))
            return -1;
          return 72;

        case E_V2048QImode:
          if (!register_operand (operands[2], E_V2048QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[3], E_V1SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 74;

        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 75;

        case E_V1DImode:
          if (!register_operand (operands[2], E_V1DImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 77;

        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 78;

        case E_V2DImode:
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 80;

        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 81;

        case E_V4DImode:
          if (!register_operand (operands[2], E_V4DImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 83;

        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 84;

        case E_V8DImode:
          if (!register_operand (operands[2], E_V8DImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[3], E_V16SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 86;

        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 87;

        case E_V16DImode:
          if (!register_operand (operands[2], E_V16DImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[3], E_V32SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 89;

        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 90;

        case E_V32DImode:
          if (!register_operand (operands[2], E_V32DImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[3], E_V64SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 92;

        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 93;

        case E_V64DImode:
          if (!register_operand (operands[2], E_V64DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x1) != E_V128SFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[3], E_V128SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 95;

        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 96;

        case E_V128DImode:
          if (!register_operand (operands[2], E_V128DImode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x1) != E_V256SFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[3], E_V256SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 98;

        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 99;

        case E_V256DImode:
          if (!register_operand (operands[2], E_V256DImode))
            return -1;
          return 100;

        default:
          return -1;
        }

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x1) != E_V512SFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[3], E_V512SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 101;

        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 102;

        case E_V512DImode:
          if (!register_operand (operands[2], E_V512DImode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x1) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[3], E_V1024SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024SImode:
          if (!register_operand (operands[2], E_V1024SImode))
            return -1;
          return 104;

        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x1) != E_V1DFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[3], E_V1DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1DImode:
          if (!register_operand (operands[2], E_V1DImode))
            return -1;
          return 106;

        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[3], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DImode:
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          return 108;

        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 109;

        default:
          return -1;
        }

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[3], E_V4DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4DImode:
          if (!register_operand (operands[2], E_V4DImode))
            return -1;
          return 110;

        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 111;

        default:
          return -1;
        }

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[3], E_V8DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8DImode:
          if (!register_operand (operands[2], E_V8DImode))
            return -1;
          return 112;

        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x1) != E_V16DFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[3], E_V16DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16DImode:
          if (!register_operand (operands[2], E_V16DImode))
            return -1;
          return 114;

        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 115;

        default:
          return -1;
        }

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x1) != E_V32DFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[3], E_V32DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32DImode:
          if (!register_operand (operands[2], E_V32DImode))
            return -1;
          return 116;

        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 117;

        default:
          return -1;
        }

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x1) != E_V64DFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[3], E_V64DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64DImode:
          if (!register_operand (operands[2], E_V64DImode))
            return -1;
          return 118;

        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 119;

        default:
          return -1;
        }

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x1) != E_V128DFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[3], E_V128DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128DImode:
          if (!register_operand (operands[2], E_V128DImode))
            return -1;
          return 120;

        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 121;

        default:
          return -1;
        }

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x1) != E_V256DFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[3], E_V256DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256DImode:
          if (!register_operand (operands[2], E_V256DImode))
            return -1;
          return 122;

        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 123;

        default:
          return -1;
        }

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x1) != E_V512DFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[3], E_V512DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512DImode:
          if (!register_operand (operands[2], E_V512DImode))
            return -1;
          return 124;

        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 125;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern287 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern286 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern286 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8SImode)
      || GET_MODE (x1) != E_RVVM8SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF2SImode)
      || GET_MODE (x1) != E_RVVMF2SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1SImode)
      || GET_MODE (x1) != E_V1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1HImode:
      if (!register_operand (operands[1], E_V1HImode))
        return -1;
      return 0;

    case E_V1QImode:
      if (!register_operand (operands[1], E_V1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SImode)
      || GET_MODE (x1) != E_V32SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024SImode)
      || GET_MODE (x1) != E_V1024SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16DImode)
      || GET_MODE (x1) != E_V16DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  operands[5] = x3;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || GET_MODE (x1) != E_HFmode
              || !register_operand (operands[1], E_HFmode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_RVVM8HFmode:
              if (!register_operand (operands[2], E_RVVM8HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF2BImode))
                return -1;
              return 0;

            case E_RVVM4HFmode:
              if (!register_operand (operands[2], E_RVVM4HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF4BImode))
                return -1;
              return 1;

            case E_RVVM2HFmode:
              if (!register_operand (operands[2], E_RVVM2HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 2;

            case E_RVVM1HFmode:
              if (!register_operand (operands[2], E_RVVM1HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 3;

            case E_RVVMF2HFmode:
              if (!register_operand (operands[2], E_RVVMF2HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 4;

            case E_RVVMF4HFmode:
              if (!register_operand (operands[2], E_RVVMF4HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x1) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_RVVM8SFmode:
              if (!register_operand (operands[2], E_RVVM8SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF4BImode))
                return -1;
              return 6;

            case E_RVVM4SFmode:
              if (!register_operand (operands[2], E_RVVM4SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 7;

            case E_RVVM2SFmode:
              if (!register_operand (operands[2], E_RVVM2SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 8;

            case E_RVVM1SFmode:
              if (!register_operand (operands[2], E_RVVM1SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 9;

            case E_RVVMF2SFmode:
              if (!register_operand (operands[2], E_RVVMF2SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x1) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_RVVM8DFmode:
              if (!register_operand (operands[2], E_RVVM8DFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 11;

            case E_RVVM4DFmode:
              if (!register_operand (operands[2], E_RVVM4DFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 12;

            case E_RVVM2DFmode:
              if (!register_operand (operands[2], E_RVVM2DFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 13;

            case E_RVVM1DFmode:
              if (!register_operand (operands[2], E_RVVM1DFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x1) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_RVVM8SFmode:
              if (!register_operand (operands[2], E_RVVM4HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF4BImode))
                return -1;
              return 15;

            case E_RVVM4SFmode:
              if (!register_operand (operands[2], E_RVVM2HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 16;

            case E_RVVM2SFmode:
              if (!register_operand (operands[2], E_RVVM1HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 17;

            case E_RVVM1SFmode:
              if (!register_operand (operands[2], E_RVVMF2HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 18;

            case E_RVVMF2SFmode:
              if (!register_operand (operands[2], E_RVVMF4HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 19;

            case E_V1SFmode:
              if (!register_operand (operands[2], E_V1HFmode)
                  || !vector_mask_operand (operands[3], E_V1BImode))
                return -1;
              return 20;

            case E_V2SFmode:
              if (!register_operand (operands[2], E_V2HFmode)
                  || !vector_mask_operand (operands[3], E_V2BImode))
                return -1;
              return 21;

            case E_V4SFmode:
              if (!register_operand (operands[2], E_V4HFmode)
                  || !vector_mask_operand (operands[3], E_V4BImode))
                return -1;
              return 22;

            case E_V8SFmode:
              if (!register_operand (operands[2], E_V8HFmode)
                  || !vector_mask_operand (operands[3], E_V8BImode))
                return -1;
              return 23;

            case E_V16SFmode:
              if (!register_operand (operands[2], E_V16HFmode)
                  || !vector_mask_operand (operands[3], E_V16BImode))
                return -1;
              return 24;

            case E_V32SFmode:
              if (!register_operand (operands[2], E_V32HFmode)
                  || !vector_mask_operand (operands[3], E_V32BImode))
                return -1;
              return 25;

            case E_V64SFmode:
              if (!register_operand (operands[2], E_V64HFmode)
                  || !vector_mask_operand (operands[3], E_V64BImode))
                return -1;
              return 26;

            case E_V128SFmode:
              if (!register_operand (operands[2], E_V128HFmode)
                  || !vector_mask_operand (operands[3], E_V128BImode))
                return -1;
              return 27;

            case E_V256SFmode:
              if (!register_operand (operands[2], E_V256HFmode)
                  || !vector_mask_operand (operands[3], E_V256BImode))
                return -1;
              return 28;

            case E_V512SFmode:
              if (!register_operand (operands[2], E_V512HFmode)
                  || !vector_mask_operand (operands[3], E_V512BImode))
                return -1;
              return 29;

            case E_V1024SFmode:
              if (!register_operand (operands[2], E_V1024HFmode)
                  || !vector_mask_operand (operands[3], E_V1024BImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x1) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_RVVM8DFmode:
              if (!register_operand (operands[2], E_RVVM4SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 31;

            case E_RVVM4DFmode:
              if (!register_operand (operands[2], E_RVVM2SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 32;

            case E_RVVM2DFmode:
              if (!register_operand (operands[2], E_RVVM1SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 33;

            case E_RVVM1DFmode:
              if (!register_operand (operands[2], E_RVVMF2SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 34;

            case E_V1DFmode:
              if (!register_operand (operands[2], E_V1SFmode)
                  || !vector_mask_operand (operands[3], E_V1BImode))
                return -1;
              return 35;

            case E_V2DFmode:
              if (!register_operand (operands[2], E_V2SFmode)
                  || !vector_mask_operand (operands[3], E_V2BImode))
                return -1;
              return 36;

            case E_V4DFmode:
              if (!register_operand (operands[2], E_V4SFmode)
                  || !vector_mask_operand (operands[3], E_V4BImode))
                return -1;
              return 37;

            case E_V8DFmode:
              if (!register_operand (operands[2], E_V8SFmode)
                  || !vector_mask_operand (operands[3], E_V8BImode))
                return -1;
              return 38;

            case E_V16DFmode:
              if (!register_operand (operands[2], E_V16SFmode)
                  || !vector_mask_operand (operands[3], E_V16BImode))
                return -1;
              return 39;

            case E_V32DFmode:
              if (!register_operand (operands[2], E_V32SFmode)
                  || !vector_mask_operand (operands[3], E_V32BImode))
                return -1;
              return 40;

            case E_V64DFmode:
              if (!register_operand (operands[2], E_V64SFmode)
                  || !vector_mask_operand (operands[3], E_V64BImode))
                return -1;
              return 41;

            case E_V128DFmode:
              if (!register_operand (operands[2], E_V128SFmode)
                  || !vector_mask_operand (operands[3], E_V128BImode))
                return -1;
              return 42;

            case E_V256DFmode:
              if (!register_operand (operands[2], E_V256SFmode)
                  || !vector_mask_operand (operands[3], E_V256BImode))
                return -1;
              return 43;

            case E_V512DFmode:
              if (!register_operand (operands[2], E_V512SFmode)
                  || !vector_mask_operand (operands[3], E_V512BImode))
                return -1;
              return 44;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern407 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  if (!vector_length_operand (x3, E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (!const_int_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (!const_int_operand (x6, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern416 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern420 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG)
    return -1;
  x36 = XVECEXP (x1, 0, 6);
  x37 = XEXP (x36, 1);
  if (GET_CODE (x37) != MEM)
    return -1;
  x38 = XEXP (x37, 0);
  if (GET_CODE (x38) != PLUS)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_CODE (x39) != REG
      || REGNO (x39) != 2)
    return -1;
  x40 = XEXP (x38, 1);
  if (GET_CODE (x40) != CONST_INT)
    return -1;
  x41 = XEXP (x36, 0);
  if (GET_CODE (x41) != REG)
    return -1;
  x42 = XVECEXP (x1, 0, 7);
  x43 = XEXP (x42, 1);
  if (GET_CODE (x43) != MEM)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_CODE (x44) != PLUS)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_CODE (x45) != REG
      || REGNO (x45) != 2)
    return -1;
  x46 = XEXP (x44, 1);
  if (GET_CODE (x46) != CONST_INT)
    return -1;
  x47 = XEXP (x42, 0);
  if (GET_CODE (x47) != REG)
    return -1;
  return 0;
}

int
pattern448 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern460 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !scratch_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !scratch_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern467 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern466 (x1, 
E_RVVMF2BImode, 
E_RVVM8HImode, 
E_RVVM4QImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern466 (x1, 
E_RVVMF4BImode, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern466 (x1, 
E_RVVMF8BImode, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern466 (x1, 
E_RVVMF16BImode, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern466 (x1, 
E_RVVMF32BImode, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern466 (x1, 
E_RVVMF64BImode, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM8SImode
          || !vector_merge_operand (operands[1], E_RVVM8SImode)
          || !register_operand (operands[3], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[2], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4SImode
          || !vector_merge_operand (operands[1], E_RVVM4SImode)
          || !register_operand (operands[3], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[2], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2SImode
          || !vector_merge_operand (operands[1], E_RVVM2SImode)
          || !register_operand (operands[3], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[2], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1SImode
          || !vector_merge_operand (operands[1], E_RVVM1SImode)
          || !register_operand (operands[3], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[2], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2SImode
          || !vector_merge_operand (operands[1], E_RVVMF2SImode)
          || !register_operand (operands[3], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[2], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM8DImode
          || !vector_merge_operand (operands[1], E_RVVM8DImode)
          || !register_operand (operands[3], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[2], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4DImode
          || !vector_merge_operand (operands[1], E_RVVM4DImode)
          || !register_operand (operands[3], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[2], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2DImode
          || !vector_merge_operand (operands[1], E_RVVM2DImode)
          || !register_operand (operands[3], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[2], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1DImode
          || !vector_merge_operand (operands[1], E_RVVM1DImode)
          || !register_operand (operands[3], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[2], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern466 (x1, 
E_V1BImode, 
E_V1HImode, 
E_V1QImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern466 (x1, 
E_V2BImode, 
E_V2HImode, 
E_V2QImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern466 (x1, 
E_V4BImode, 
E_V4HImode, 
E_V4QImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern466 (x1, 
E_V8BImode, 
E_V8HImode, 
E_V8QImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern466 (x1, 
E_V16BImode, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern466 (x1, 
E_V32BImode, 
E_V32HImode, 
E_V32QImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern466 (x1, 
E_V64BImode, 
E_V64HImode, 
E_V64QImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern466 (x1, 
E_V128BImode, 
E_V128HImode, 
E_V128QImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern466 (x1, 
E_V256BImode, 
E_V256HImode, 
E_V256QImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern466 (x1, 
E_V512BImode, 
E_V512HImode, 
E_V512QImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern466 (x1, 
E_V1024BImode, 
E_V1024HImode, 
E_V1024QImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern466 (x1, 
E_V2048BImode, 
E_V2048HImode, 
E_V2048QImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1SImode
          || !vector_merge_operand (operands[1], E_V1SImode)
          || !register_operand (operands[3], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[2], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V2SImode
          || !vector_merge_operand (operands[1], E_V2SImode)
          || !register_operand (operands[3], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[2], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V4SImode
          || !vector_merge_operand (operands[1], E_V4SImode)
          || !register_operand (operands[3], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[2], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V8SImode
          || !vector_merge_operand (operands[1], E_V8SImode)
          || !register_operand (operands[3], E_V8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V16SImode
          || !vector_merge_operand (operands[1], E_V16SImode)
          || !register_operand (operands[3], E_V16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V32SImode
          || !vector_merge_operand (operands[1], E_V32SImode)
          || !register_operand (operands[3], E_V32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[2], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V64SImode
          || !vector_merge_operand (operands[1], E_V64SImode)
          || !register_operand (operands[3], E_V64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[2], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V128SImode
          || !vector_merge_operand (operands[1], E_V128SImode)
          || !register_operand (operands[3], E_V128BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[2], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V256SImode
          || !vector_merge_operand (operands[1], E_V256SImode)
          || !register_operand (operands[3], E_V256BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[2], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512SImode
          || !vector_merge_operand (operands[1], E_V512SImode)
          || !register_operand (operands[3], E_V512BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[2], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024SImode
          || !vector_merge_operand (operands[1], E_V1024SImode)
          || !register_operand (operands[3], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[2], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1DImode
          || !vector_merge_operand (operands[1], E_V1DImode)
          || !register_operand (operands[3], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[2], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V2DImode
          || !vector_merge_operand (operands[1], E_V2DImode)
          || !register_operand (operands[3], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[2], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V4DImode
          || !vector_merge_operand (operands[1], E_V4DImode)
          || !register_operand (operands[3], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[2], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V8DImode
          || !vector_merge_operand (operands[1], E_V8DImode)
          || !register_operand (operands[3], E_V8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V16DImode
          || !vector_merge_operand (operands[1], E_V16DImode)
          || !register_operand (operands[3], E_V16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V32DImode
          || !vector_merge_operand (operands[1], E_V32DImode)
          || !register_operand (operands[3], E_V32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[2], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V64DImode
          || !vector_merge_operand (operands[1], E_V64DImode)
          || !register_operand (operands[3], E_V64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[2], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V128DImode
          || !vector_merge_operand (operands[1], E_V128DImode)
          || !register_operand (operands[3], E_V128BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[2], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V256DImode
          || !vector_merge_operand (operands[1], E_V256DImode)
          || !register_operand (operands[3], E_V256BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[2], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512DImode
          || !vector_merge_operand (operands[1], E_V512DImode)
          || !register_operand (operands[3], E_V512BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[2], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern543 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x8, 1);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      return pattern542 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM2QImode:
      if (pattern542 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (pattern542 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (pattern542 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4QImode:
      if (pattern542 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF8QImode:
      if (pattern542 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM4HImode:
      if (pattern542 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM2HImode:
      if (pattern542 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM1HImode:
      if (pattern542 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVMF2HImode:
      if (pattern542 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF4HImode:
      if (pattern542 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern542 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern542 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern542 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVMF2SImode:
      if (pattern542 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1QImode:
      if (pattern542 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2QImode:
      if (pattern542 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4QImode:
      if (pattern542 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8QImode:
      if (pattern542 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16QImode:
      if (pattern542 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32QImode:
      if (pattern542 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64QImode:
      if (pattern542 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128QImode:
      if (pattern542 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256QImode:
      if (pattern542 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512QImode:
      if (pattern542 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024QImode:
      if (pattern542 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048QImode:
      if (pattern542 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1HImode:
      if (pattern542 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2HImode:
      if (pattern542 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4HImode:
      if (pattern542 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8HImode:
      if (pattern542 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16HImode:
      if (pattern542 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32HImode:
      if (pattern542 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64HImode:
      if (pattern542 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128HImode:
      if (pattern542 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256HImode:
      if (pattern542 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512HImode:
      if (pattern542 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024HImode:
      if (pattern542 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1SImode:
      if (pattern542 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2SImode:
      if (pattern542 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4SImode:
      if (pattern542 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8SImode:
      if (pattern542 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16SImode:
      if (pattern542 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32SImode:
      if (pattern542 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64SImode:
      if (pattern542 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128SImode:
      if (pattern542 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256SImode:
      if (pattern542 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512SImode:
      if (pattern542 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern560 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[4] = x8;
  if (!register_operand (operands[4], E_SFmode))
    return -1;
  x9 = XVECEXP (x7, 0, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM2QImode:
      return pattern559 (x1, 
E_RVVM2QImode, 
E_RVVM8SFmode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM1QImode:
      if (pattern559 (x1, 
E_RVVM1QImode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (pattern559 (x1, 
E_RVVMF2QImode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF4QImode:
      if (pattern559 (x1, 
E_RVVMF4QImode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF8QImode:
      if (pattern559 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern563 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[5] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[6] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[7] = x7;
  x8 = XVECEXP (x4, 0, 4);
  operands[8] = x8;
  x9 = XEXP (x2, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern492 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern492 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern492 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern492 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern492 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern492 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (pattern492 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SImode:
      if (pattern492 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SImode:
      if (pattern492 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SImode:
      if (pattern492 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SImode:
      if (pattern492 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DImode:
      if (pattern492 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DImode:
      if (pattern492 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DImode:
      if (pattern492 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DImode:
      if (pattern492 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1HImode:
      if (pattern492 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2HImode:
      if (pattern492 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4HImode:
      if (pattern492 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8HImode:
      if (pattern492 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16HImode:
      if (pattern492 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32HImode:
      if (pattern492 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64HImode:
      if (pattern492 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128HImode:
      if (pattern492 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256HImode:
      if (pattern492 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512HImode:
      if (pattern492 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024HImode:
      if (pattern492 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048HImode:
      if (pattern492 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1SImode:
      if (pattern492 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2SImode:
      if (pattern492 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4SImode:
      if (pattern492 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8SImode:
      if (pattern492 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16SImode:
      if (pattern492 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32SImode:
      if (pattern492 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64SImode:
      if (pattern492 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128SImode:
      if (pattern492 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256SImode:
      if (pattern492 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512SImode:
      if (pattern492 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024SImode:
      if (pattern492 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1DImode:
      if (pattern492 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2DImode:
      if (pattern492 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4DImode:
      if (pattern492 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8DImode:
      if (pattern492 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16DImode:
      if (pattern492 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32DImode:
      if (pattern492 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64DImode:
      if (pattern492 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128DImode:
      if (pattern492 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256DImode:
      if (pattern492 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512DImode:
      if (pattern492 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern583 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[3], i4))
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_MODE (x8) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern587 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!vector_arith_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern591 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  return pattern467 (x1); /* [-1, 91] */
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_arith_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern597 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_broadcast_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !direct_broadcast_operand (operands[3], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern601 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern538 (x1, 
E_RVVM8QImode, 
E_QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern538 (x1, 
E_RVVM4QImode, 
E_QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern538 (x1, 
E_RVVM2QImode, 
E_QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern538 (x1, 
E_RVVM1QImode, 
E_QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2QImode:
          if (pattern538 (x1, 
E_RVVMF2QImode, 
E_QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4QImode:
          if (pattern538 (x1, 
E_RVVMF4QImode, 
E_QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 5;

        case E_RVVMF8QImode:
          if (pattern538 (x1, 
E_RVVMF8QImode, 
E_QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 6;

        case E_RVVM8HImode:
          if (pattern538 (x1, 
E_RVVM8HImode, 
E_HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 7;

        case E_RVVM4HImode:
          if (pattern538 (x1, 
E_RVVM4HImode, 
E_HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM2HImode:
          if (pattern538 (x1, 
E_RVVM2HImode, 
E_HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM1HImode:
          if (pattern538 (x1, 
E_RVVM1HImode, 
E_HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVMF2HImode:
          if (pattern538 (x1, 
E_RVVMF2HImode, 
E_HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVMF4HImode:
          if (pattern538 (x1, 
E_RVVMF4HImode, 
E_HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 12;

        case E_RVVM8SImode:
          if (pattern538 (x1, 
E_RVVM8SImode, 
E_SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 13;

        case E_RVVM4SImode:
          if (pattern538 (x1, 
E_RVVM4SImode, 
E_SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 14;

        case E_RVVM2SImode:
          if (pattern538 (x1, 
E_RVVM2SImode, 
E_SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 15;

        case E_RVVM1SImode:
          if (pattern538 (x1, 
E_RVVM1SImode, 
E_SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF2SImode:
          if (pattern538 (x1, 
E_RVVMF2SImode, 
E_SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 17;

        case E_V1QImode:
          if (pattern538 (x1, 
E_V1QImode, 
E_QImode, 
E_V1BImode) != 0)
            return -1;
          return 18;

        case E_V2QImode:
          if (pattern538 (x1, 
E_V2QImode, 
E_QImode, 
E_V2BImode) != 0)
            return -1;
          return 19;

        case E_V4QImode:
          if (pattern538 (x1, 
E_V4QImode, 
E_QImode, 
E_V4BImode) != 0)
            return -1;
          return 20;

        case E_V8QImode:
          if (pattern538 (x1, 
E_V8QImode, 
E_QImode, 
E_V8BImode) != 0)
            return -1;
          return 21;

        case E_V16QImode:
          if (pattern538 (x1, 
E_V16QImode, 
E_QImode, 
E_V16BImode) != 0)
            return -1;
          return 22;

        case E_V32QImode:
          if (pattern538 (x1, 
E_V32QImode, 
E_QImode, 
E_V32BImode) != 0)
            return -1;
          return 23;

        case E_V64QImode:
          if (pattern538 (x1, 
E_V64QImode, 
E_QImode, 
E_V64BImode) != 0)
            return -1;
          return 24;

        case E_V128QImode:
          if (pattern538 (x1, 
E_V128QImode, 
E_QImode, 
E_V128BImode) != 0)
            return -1;
          return 25;

        case E_V256QImode:
          if (pattern538 (x1, 
E_V256QImode, 
E_QImode, 
E_V256BImode) != 0)
            return -1;
          return 26;

        case E_V512QImode:
          if (pattern538 (x1, 
E_V512QImode, 
E_QImode, 
E_V512BImode) != 0)
            return -1;
          return 27;

        case E_V1024QImode:
          if (pattern538 (x1, 
E_V1024QImode, 
E_QImode, 
E_V1024BImode) != 0)
            return -1;
          return 28;

        case E_V2048QImode:
          if (pattern538 (x1, 
E_V2048QImode, 
E_QImode, 
E_V2048BImode) != 0)
            return -1;
          return 29;

        case E_V4096QImode:
          if (pattern538 (x1, 
E_V4096QImode, 
E_QImode, 
E_V4096BImode) != 0)
            return -1;
          return 30;

        case E_V1HImode:
          if (pattern538 (x1, 
E_V1HImode, 
E_HImode, 
E_V1BImode) != 0)
            return -1;
          return 31;

        case E_V2HImode:
          if (pattern538 (x1, 
E_V2HImode, 
E_HImode, 
E_V2BImode) != 0)
            return -1;
          return 32;

        case E_V4HImode:
          if (pattern538 (x1, 
E_V4HImode, 
E_HImode, 
E_V4BImode) != 0)
            return -1;
          return 33;

        case E_V8HImode:
          if (pattern538 (x1, 
E_V8HImode, 
E_HImode, 
E_V8BImode) != 0)
            return -1;
          return 34;

        case E_V16HImode:
          if (pattern538 (x1, 
E_V16HImode, 
E_HImode, 
E_V16BImode) != 0)
            return -1;
          return 35;

        case E_V32HImode:
          if (pattern538 (x1, 
E_V32HImode, 
E_HImode, 
E_V32BImode) != 0)
            return -1;
          return 36;

        case E_V64HImode:
          if (pattern538 (x1, 
E_V64HImode, 
E_HImode, 
E_V64BImode) != 0)
            return -1;
          return 37;

        case E_V128HImode:
          if (pattern538 (x1, 
E_V128HImode, 
E_HImode, 
E_V128BImode) != 0)
            return -1;
          return 38;

        case E_V256HImode:
          if (pattern538 (x1, 
E_V256HImode, 
E_HImode, 
E_V256BImode) != 0)
            return -1;
          return 39;

        case E_V512HImode:
          if (pattern538 (x1, 
E_V512HImode, 
E_HImode, 
E_V512BImode) != 0)
            return -1;
          return 40;

        case E_V1024HImode:
          if (pattern538 (x1, 
E_V1024HImode, 
E_HImode, 
E_V1024BImode) != 0)
            return -1;
          return 41;

        case E_V2048HImode:
          if (pattern538 (x1, 
E_V2048HImode, 
E_HImode, 
E_V2048BImode) != 0)
            return -1;
          return 42;

        case E_V1SImode:
          if (pattern538 (x1, 
E_V1SImode, 
E_SImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2SImode:
          if (pattern538 (x1, 
E_V2SImode, 
E_SImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4SImode:
          if (pattern538 (x1, 
E_V4SImode, 
E_SImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8SImode:
          if (pattern538 (x1, 
E_V8SImode, 
E_SImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16SImode:
          if (pattern538 (x1, 
E_V16SImode, 
E_SImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32SImode:
          if (pattern538 (x1, 
E_V32SImode, 
E_SImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64SImode:
          if (pattern538 (x1, 
E_V64SImode, 
E_SImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128SImode:
          if (pattern538 (x1, 
E_V128SImode, 
E_SImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256SImode:
          if (pattern538 (x1, 
E_V256SImode, 
E_SImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512SImode:
          if (pattern538 (x1, 
E_V512SImode, 
E_SImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024SImode:
          if (pattern538 (x1, 
E_V1024SImode, 
E_SImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_RVVM8DImode:
          if (pattern496 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
            return -1;
          return 54;

        case E_RVVM4DImode:
          if (pattern496 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
            return -1;
          return 55;

        case E_RVVM2DImode:
          if (pattern496 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
            return -1;
          return 56;

        case E_RVVM1DImode:
          if (pattern496 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
            return -1;
          return 57;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          if (pattern498 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 58;

        case E_RVVM4DImode:
          if (pattern498 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 59;

        case E_RVVM2DImode:
          if (pattern498 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 60;

        case E_RVVM1DImode:
          if (pattern498 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 61;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern636 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[1], E_RVVM1DImode)
          || !register_operand (operands[2], E_RVVM1DImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode)
          || !register_operand (operands[2], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode)
          || !register_operand (operands[2], E_RVVMF4HImode))
        return -1;
      return 2;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode)
          || !register_operand (operands[2], E_RVVMF2SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern643 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF2BImode
      || !vector_mask_operand (operands[1], E_RVVMF2BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[4], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      if (!register_operand (operands[4], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern649 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF2BImode
      || !vector_mask_operand (operands[1], E_RVVMF2BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8HImode:
      if (!register_operand (operands[4], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM4QImode:
      if (!register_operand (operands[4], E_RVVM4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern654 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern661 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF16BImode
      || !vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4DImode:
      if (!register_operand (operands[4], E_RVVM4DImode))
        return -1;
      return 0;

    case E_RVVM2SImode:
      if (!register_operand (operands[4], E_RVVM2SImode))
        return -1;
      return 1;

    case E_RVVM1HImode:
      if (!register_operand (operands[4], E_RVVM1HImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[4], E_RVVMF2QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern668 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern673 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVM1BImode:
      if (!vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[3], E_RVVM8QImode))
        return -1;
      return 0;

    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM4QImode))
        return -1;
      return 1;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM2QImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM1QImode))
        return -1;
      return 3;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVMF2QImode))
        return -1;
      return 4;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF4QImode))
        return -1;
      return 5;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF8QImode))
        return -1;
      return 6;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1QImode))
        return -1;
      return 7;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2QImode))
        return -1;
      return 8;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4QImode))
        return -1;
      return 9;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8QImode))
        return -1;
      return 10;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16QImode))
        return -1;
      return 11;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32QImode))
        return -1;
      return 12;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64QImode))
        return -1;
      return 13;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128QImode))
        return -1;
      return 14;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256QImode))
        return -1;
      return 15;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512QImode))
        return -1;
      return 16;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024QImode))
        return -1;
      return 17;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048QImode))
        return -1;
      return 18;

    case E_V4096BImode:
      if (!vector_mask_operand (operands[1], E_V4096BImode)
          || !register_operand (operands[3], E_V4096QImode))
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern685 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern692 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x12, 1);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern702 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[9] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], i1))
    return -1;
  x10 = XEXP (x8, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], i1))
    return -1;
  x11 = XEXP (x1, 2);
  operands[2] = x11;
  if (!vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern706 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[2], i3)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern711 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern714 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew32_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern718 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern599 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern599 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern599 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern599 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern599 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern599 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern599 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern599 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern599 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern599 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern599 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern599 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern599 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern599 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern599 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern599 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern599 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern599 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern599 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern599 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern599 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern599 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_V1QImode:
          if (pattern599 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 22;

        case E_V2QImode:
          if (pattern599 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 23;

        case E_V4QImode:
          if (pattern599 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 24;

        case E_V8QImode:
          if (pattern599 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 25;

        case E_V16QImode:
          if (pattern599 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 26;

        case E_V32QImode:
          if (pattern599 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 27;

        case E_V64QImode:
          if (pattern599 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 28;

        case E_V128QImode:
          if (pattern599 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 29;

        case E_V256QImode:
          if (pattern599 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 30;

        case E_V512QImode:
          if (pattern599 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 31;

        case E_V1024QImode:
          if (pattern599 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 32;

        case E_V2048QImode:
          if (pattern599 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 33;

        case E_V4096QImode:
          if (pattern599 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 34;

        case E_V1HImode:
          if (pattern599 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 35;

        case E_V2HImode:
          if (pattern599 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 36;

        case E_V4HImode:
          if (pattern599 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 37;

        case E_V8HImode:
          if (pattern599 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 38;

        case E_V16HImode:
          if (pattern599 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 39;

        case E_V32HImode:
          if (pattern599 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 40;

        case E_V64HImode:
          if (pattern599 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 41;

        case E_V128HImode:
          if (pattern599 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 42;

        case E_V256HImode:
          if (pattern599 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 43;

        case E_V512HImode:
          if (pattern599 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 44;

        case E_V1024HImode:
          if (pattern599 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 45;

        case E_V2048HImode:
          if (pattern599 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 46;

        case E_V1SImode:
          if (pattern599 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 47;

        case E_V2SImode:
          if (pattern599 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 48;

        case E_V4SImode:
          if (pattern599 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 49;

        case E_V8SImode:
          if (pattern599 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 50;

        case E_V16SImode:
          if (pattern599 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 51;

        case E_V32SImode:
          if (pattern599 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 52;

        case E_V64SImode:
          if (pattern599 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 53;

        case E_V128SImode:
          if (pattern599 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 54;

        case E_V256SImode:
          if (pattern599 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 55;

        case E_V512SImode:
          if (pattern599 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 56;

        case E_V1024SImode:
          if (pattern599 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 57;

        case E_V1DImode:
          if (pattern550 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 58;

        case E_V2DImode:
          if (pattern550 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 59;

        case E_V4DImode:
          if (pattern550 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 60;

        case E_V8DImode:
          if (pattern550 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 61;

        case E_V16DImode:
          if (pattern550 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 62;

        case E_V32DImode:
          if (pattern550 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 63;

        case E_V64DImode:
          if (pattern550 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 64;

        case E_V128DImode:
          if (pattern550 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 65;

        case E_V256DImode:
          if (pattern550 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 66;

        case E_V512DImode:
          if (pattern550 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 67;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[4] = x4;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          if (pattern599 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 68;

        case E_RVVM4DImode:
          if (pattern599 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 69;

        case E_RVVM2DImode:
          if (pattern599 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 70;

        case E_RVVM1DImode:
          if (pattern599 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 71;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern742 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern748 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern750 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != USE)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1
      || !stack_pop_up_to_s6_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern754 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  return 0;
}

int
pattern759 (rtx x1, unsigned int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x8) != SET
      || pattern758 (x8, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern762 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 4);
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 5);
      x19 = XEXP (x18, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 6);
      x23 = XEXP (x22, 1);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      x27 = XEXP (x26, 1);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 8);
      x31 = XEXP (x30, 1);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 9);
      x35 = XEXP (x34, 1);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 4);
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 5);
      x19 = XEXP (x18, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 6);
      x23 = XEXP (x22, 1);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      x27 = XEXP (x26, 1);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 8);
      x31 = XEXP (x30, 1);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 9);
      x35 = XEXP (x34, 1);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern772 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      x38 = XVECEXP (x1, 0, 9);
      x39 = XEXP (x38, 0);
      x40 = XEXP (x39, 0);
      x41 = XEXP (x40, 1);
      if (XWINT (x41, 0) != -40L)
        return -1;
      x42 = XVECEXP (x1, 0, 10);
      x43 = XEXP (x42, 0);
      x44 = XEXP (x43, 0);
      x45 = XEXP (x44, 1);
      if (XWINT (x45, 0) != -44L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      x38 = XVECEXP (x1, 0, 9);
      x39 = XEXP (x38, 0);
      x40 = XEXP (x39, 0);
      x41 = XEXP (x40, 1);
      if (XWINT (x41, 0) != -80L)
        return -1;
      x42 = XVECEXP (x1, 0, 10);
      x43 = XEXP (x42, 0);
      x44 = XEXP (x43, 0);
      x45 = XEXP (x44, 1);
      if (XWINT (x45, 0) != -88L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern788 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != -80L)
    return -1;
  x6 = XEXP (x1, 0);
  return pattern786 (x6, 
E_DImode); /* [-1, 0] */
}

int
pattern793 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 7);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 8);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != PLUS
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 2
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (GET_CODE (x14) != CONST_INT
      || XWINT (x14, 0) != -80L)
    return -1;
  x15 = XEXP (x10, 0);
  if (REGNO (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 11);
  return pattern792 (x16); /* [-1, 0] */
}

int
pattern799 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != -96L)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (arith_operand (operands[2], E_SImode))
    return 4; /* *addsi3 */
  if (!const_two_s12 (operands[2], E_SImode)
      || !(
#line 734 "../../../gcc/config/riscv/riscv.md"
(!riscv_reg_frame_related (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    return -1;
  return 6; /* *addsi3_const_sum_of_two_s12 */
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern231 (x2))
    {
    case 0:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30258; /* *dual_widen_fmaurvvm8hi */

    case 1:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30260; /* *dual_widen_fmaurvvm4hi */

    case 2:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30262; /* *dual_widen_fmaurvvm2hi */

    case 3:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30264; /* *dual_widen_fmaurvvm1hi */

    case 4:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30266; /* *dual_widen_fmaurvvmf2hi */

    case 5:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30268; /* *dual_widen_fmaurvvmf4hi */

    case 6:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30270; /* *dual_widen_fmaurvvm8si */

    case 7:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30272; /* *dual_widen_fmaurvvm4si */

    case 8:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30274; /* *dual_widen_fmaurvvm2si */

    case 9:
      if (!
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30276; /* *dual_widen_fmaurvvm1si */

    case 10:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30278; /* *dual_widen_fmaurvvmf2si */

    case 11:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30280; /* *dual_widen_fmaurvvm8di */

    case 12:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30282; /* *dual_widen_fmaurvvm4di */

    case 13:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30284; /* *dual_widen_fmaurvvm2di */

    case 14:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30286; /* *dual_widen_fmaurvvm1di */

    case 15:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30288; /* *dual_widen_fmauv1hi */

    case 16:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30290; /* *dual_widen_fmauv2hi */

    case 17:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30292; /* *dual_widen_fmauv4hi */

    case 18:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30294; /* *dual_widen_fmauv8hi */

    case 19:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30296; /* *dual_widen_fmauv16hi */

    case 20:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30298; /* *dual_widen_fmauv32hi */

    case 21:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30300; /* *dual_widen_fmauv64hi */

    case 22:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30302; /* *dual_widen_fmauv128hi */

    case 23:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30304; /* *dual_widen_fmauv256hi */

    case 24:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30306; /* *dual_widen_fmauv512hi */

    case 25:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30308; /* *dual_widen_fmauv1024hi */

    case 26:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30310; /* *dual_widen_fmauv2048hi */

    case 27:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30312; /* *dual_widen_fmauv1si */

    case 28:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30314; /* *dual_widen_fmauv2si */

    case 29:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30316; /* *dual_widen_fmauv4si */

    case 30:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30318; /* *dual_widen_fmauv8si */

    case 31:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30320; /* *dual_widen_fmauv16si */

    case 32:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30322; /* *dual_widen_fmauv32si */

    case 33:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30324; /* *dual_widen_fmauv64si */

    case 34:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30326; /* *dual_widen_fmauv128si */

    case 35:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30328; /* *dual_widen_fmauv256si */

    case 36:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30330; /* *dual_widen_fmauv512si */

    case 37:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30332; /* *dual_widen_fmauv1024si */

    case 38:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30334; /* *dual_widen_fmauv1di */

    case 39:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30336; /* *dual_widen_fmauv2di */

    case 40:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30338; /* *dual_widen_fmauv4di */

    case 41:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30340; /* *dual_widen_fmauv8di */

    case 42:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30342; /* *dual_widen_fmauv16di */

    case 43:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30344; /* *dual_widen_fmauv32di */

    case 44:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30346; /* *dual_widen_fmauv64di */

    case 45:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30348; /* *dual_widen_fmauv128di */

    case 46:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30350; /* *dual_widen_fmauv256di */

    case 47:
      if (!(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30352; /* *dual_widen_fmauv512di */

    case 48:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30401; /* *dual_widen_fmausrvvm8hi */

    case 49:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30402; /* *dual_widen_fmausrvvm4hi */

    case 50:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30403; /* *dual_widen_fmausrvvm2hi */

    case 51:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30404; /* *dual_widen_fmausrvvm1hi */

    case 52:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30405; /* *dual_widen_fmausrvvmf2hi */

    case 53:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30406; /* *dual_widen_fmausrvvmf4hi */

    case 54:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30407; /* *dual_widen_fmausrvvm8si */

    case 55:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30408; /* *dual_widen_fmausrvvm4si */

    case 56:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30409; /* *dual_widen_fmausrvvm2si */

    case 57:
      if (!
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30410; /* *dual_widen_fmausrvvm1si */

    case 58:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30411; /* *dual_widen_fmausrvvmf2si */

    case 59:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30412; /* *dual_widen_fmausrvvm8di */

    case 60:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30413; /* *dual_widen_fmausrvvm4di */

    case 61:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30414; /* *dual_widen_fmausrvvm2di */

    case 62:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30415; /* *dual_widen_fmausrvvm1di */

    case 63:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30416; /* *dual_widen_fmausv1hi */

    case 64:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30417; /* *dual_widen_fmausv2hi */

    case 65:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30418; /* *dual_widen_fmausv4hi */

    case 66:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30419; /* *dual_widen_fmausv8hi */

    case 67:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30420; /* *dual_widen_fmausv16hi */

    case 68:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30421; /* *dual_widen_fmausv32hi */

    case 69:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30422; /* *dual_widen_fmausv64hi */

    case 70:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30423; /* *dual_widen_fmausv128hi */

    case 71:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30424; /* *dual_widen_fmausv256hi */

    case 72:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30425; /* *dual_widen_fmausv512hi */

    case 73:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30426; /* *dual_widen_fmausv1024hi */

    case 74:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30427; /* *dual_widen_fmausv2048hi */

    case 75:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30428; /* *dual_widen_fmausv1si */

    case 76:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30429; /* *dual_widen_fmausv2si */

    case 77:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30430; /* *dual_widen_fmausv4si */

    case 78:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30431; /* *dual_widen_fmausv8si */

    case 79:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30432; /* *dual_widen_fmausv16si */

    case 80:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30433; /* *dual_widen_fmausv32si */

    case 81:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30434; /* *dual_widen_fmausv64si */

    case 82:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30435; /* *dual_widen_fmausv128si */

    case 83:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30436; /* *dual_widen_fmausv256si */

    case 84:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30437; /* *dual_widen_fmausv512si */

    case 85:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30438; /* *dual_widen_fmausv1024si */

    case 86:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30439; /* *dual_widen_fmausv1di */

    case 87:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30440; /* *dual_widen_fmausv2di */

    case 88:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30441; /* *dual_widen_fmausv4di */

    case 89:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30442; /* *dual_widen_fmausv8di */

    case 90:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30443; /* *dual_widen_fmausv16di */

    case 91:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30444; /* *dual_widen_fmausv32di */

    case 92:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30445; /* *dual_widen_fmausv64di */

    case 93:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30446; /* *dual_widen_fmausv128di */

    case 94:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30447; /* *dual_widen_fmausv256di */

    case 95:
      if (!(
#line 947 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30448; /* *dual_widen_fmausv512di */

    case 96:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30450; /* *single_widen_fmaurvvm8hi */

    case 97:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30452; /* *single_widen_fmaurvvm4hi */

    case 98:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30454; /* *single_widen_fmaurvvm2hi */

    case 99:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30456; /* *single_widen_fmaurvvm1hi */

    case 100:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30458; /* *single_widen_fmaurvvmf2hi */

    case 101:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30460; /* *single_widen_fmaurvvmf4hi */

    case 102:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30462; /* *single_widen_fmaurvvm8si */

    case 103:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30464; /* *single_widen_fmaurvvm4si */

    case 104:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30466; /* *single_widen_fmaurvvm2si */

    case 105:
      if (!
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30468; /* *single_widen_fmaurvvm1si */

    case 106:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30470; /* *single_widen_fmaurvvmf2si */

    case 107:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30472; /* *single_widen_fmaurvvm8di */

    case 108:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30474; /* *single_widen_fmaurvvm4di */

    case 109:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30476; /* *single_widen_fmaurvvm2di */

    case 110:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30478; /* *single_widen_fmaurvvm1di */

    case 111:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30480; /* *single_widen_fmauv1hi */

    case 112:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30482; /* *single_widen_fmauv2hi */

    case 113:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30484; /* *single_widen_fmauv4hi */

    case 114:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30486; /* *single_widen_fmauv8hi */

    case 115:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30488; /* *single_widen_fmauv16hi */

    case 116:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30490; /* *single_widen_fmauv32hi */

    case 117:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30492; /* *single_widen_fmauv64hi */

    case 118:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30494; /* *single_widen_fmauv128hi */

    case 119:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30496; /* *single_widen_fmauv256hi */

    case 120:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30498; /* *single_widen_fmauv512hi */

    case 121:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30500; /* *single_widen_fmauv1024hi */

    case 122:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30502; /* *single_widen_fmauv2048hi */

    case 123:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30504; /* *single_widen_fmauv1si */

    case 124:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30506; /* *single_widen_fmauv2si */

    case 125:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30508; /* *single_widen_fmauv4si */

    case 126:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30510; /* *single_widen_fmauv8si */

    case 127:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30512; /* *single_widen_fmauv16si */

    case 128:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30514; /* *single_widen_fmauv32si */

    case 129:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30516; /* *single_widen_fmauv64si */

    case 130:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30518; /* *single_widen_fmauv128si */

    case 131:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30520; /* *single_widen_fmauv256si */

    case 132:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30522; /* *single_widen_fmauv512si */

    case 133:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30524; /* *single_widen_fmauv1024si */

    case 134:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30526; /* *single_widen_fmauv1di */

    case 135:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30528; /* *single_widen_fmauv2di */

    case 136:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30530; /* *single_widen_fmauv4di */

    case 137:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30532; /* *single_widen_fmauv8di */

    case 138:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30534; /* *single_widen_fmauv16di */

    case 139:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30536; /* *single_widen_fmauv32di */

    case 140:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30538; /* *single_widen_fmauv64di */

    case 141:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30540; /* *single_widen_fmauv128di */

    case 142:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30542; /* *single_widen_fmauv256di */

    case 143:
      if (!(
#line 971 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30544; /* *single_widen_fmauv512di */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !(
#line 1106 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 23; /* mulsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 1106 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 24; /* muldf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 1106 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 25; /* mulhf3 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SImode) != 0
          || !
#line 1115 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZMMUL || TARGET_MUL))
        return -1;
      return 26; /* *mulsi3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DImode) != 0
          || !
#line 1142 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 27; /* muldi3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23623; /* mulrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23637; /* mulrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23651; /* mulrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23665; /* mulrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23679; /* mulrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23693; /* mulrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23707; /* mulrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23721; /* mulrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23735; /* mulrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23749; /* mulrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23763; /* mulrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23777; /* mulrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23791; /* mulrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23805; /* mulrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23819; /* mulrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23833; /* mulrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23847; /* mulrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23861; /* mulrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23875; /* mulrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23889; /* mulrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23903; /* mulrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23917; /* mulrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23931; /* mulv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23945; /* mulv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23959; /* mulv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23973; /* mulv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23987; /* mulv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24001; /* mulv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24015; /* mulv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24029; /* mulv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24043; /* mulv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24057; /* mulv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24071; /* mulv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24085; /* mulv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24099; /* mulv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24113; /* mulv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24127; /* mulv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24141; /* mulv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24155; /* mulv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24169; /* mulv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24183; /* mulv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24197; /* mulv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24211; /* mulv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24225; /* mulv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24239; /* mulv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24253; /* mulv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24267; /* mulv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24281; /* mulv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24295; /* mulv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24309; /* mulv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24323; /* mulv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24337; /* mulv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24351; /* mulv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24365; /* mulv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24379; /* mulv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24393; /* mulv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24407; /* mulv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24421; /* mulv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24435; /* mulv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24449; /* mulv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24463; /* mulv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24477; /* mulv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24491; /* mulv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24505; /* mulv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24519; /* mulv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24533; /* mulv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24547; /* mulv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24561; /* mulv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26581; /* mulrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26585; /* mulrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26589; /* mulrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26593; /* mulrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26597; /* mulrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26601; /* mulrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26605; /* mulrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26609; /* mulrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26613; /* mulrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26617; /* mulrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26621; /* mulrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26625; /* mulrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26629; /* mulrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26633; /* mulrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26637; /* mulrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26641; /* mulv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26645; /* mulv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26649; /* mulv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26653; /* mulv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26657; /* mulv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26661; /* mulv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26665; /* mulv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26669; /* mulv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26673; /* mulv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26677; /* mulv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26681; /* mulv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26685; /* mulv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26689; /* mulv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26693; /* mulv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26697; /* mulv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26701; /* mulv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26705; /* mulv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26709; /* mulv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26713; /* mulv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26717; /* mulv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26721; /* mulv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26725; /* mulv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26729; /* mulv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26733; /* mulv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26737; /* mulv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26741; /* mulv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26745; /* mulv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26749; /* mulv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26753; /* mulv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26757; /* mulv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26761; /* mulv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26765; /* mulv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26769; /* mulv512df3 */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2424; /* *pred_th_extractrvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2425; /* *pred_th_extractrvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2426; /* *pred_th_extractrvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2427; /* *pred_th_extractrvvm1qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2440; /* *pred_th_extractrvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 2443; /* *pred_th_extractv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 2444; /* *pred_th_extractv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 2445; /* *pred_th_extractv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 2446; /* *pred_th_extractv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 2447; /* *pred_th_extractv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 2448; /* *pred_th_extractv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2449; /* *pred_th_extractv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2450; /* *pred_th_extractv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2451; /* *pred_th_extractv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2452; /* *pred_th_extractv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2453; /* *pred_th_extractv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2454; /* *pred_th_extractv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2455; /* *pred_th_extractv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2428; /* *pred_th_extractrvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2429; /* *pred_th_extractrvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2430; /* *pred_th_extractrvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2431; /* *pred_th_extractrvvm1hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2441; /* *pred_th_extractrvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 2456; /* *pred_th_extractv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 2457; /* *pred_th_extractv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 2458; /* *pred_th_extractv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 2459; /* *pred_th_extractv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 2460; /* *pred_th_extractv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2461; /* *pred_th_extractv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2462; /* *pred_th_extractv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2463; /* *pred_th_extractv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2464; /* *pred_th_extractv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2465; /* *pred_th_extractv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2466; /* *pred_th_extractv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2467; /* *pred_th_extractv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern442 (x2))
            {
            case 0:
              if (!
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2432; /* *pred_th_extractrvvm8si */

            case 1:
              if (!
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2433; /* *pred_th_extractrvvm4si */

            case 2:
              if (!
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2434; /* *pred_th_extractrvvm2si */

            case 3:
              if (!
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2435; /* *pred_th_extractrvvm1si */

            case 4:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2442; /* *pred_th_extractrvvmf2si */

            case 5:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 2468; /* *pred_th_extractv1si */

            case 6:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 2469; /* *pred_th_extractv2si */

            case 7:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 2470; /* *pred_th_extractv4si */

            case 8:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 2471; /* *pred_th_extractv8si */

            case 9:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2472; /* *pred_th_extractv16si */

            case 10:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2473; /* *pred_th_extractv32si */

            case 11:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2474; /* *pred_th_extractv64si */

            case 12:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2475; /* *pred_th_extractv128si */

            case 13:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2476; /* *pred_th_extractv256si */

            case 14:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2477; /* *pred_th_extractv512si */

            case 15:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2478; /* *pred_th_extractv1024si */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern443 (x2))
            {
            case 0:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2436; /* *pred_th_extractrvvm8di */

            case 1:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2437; /* *pred_th_extractrvvm4di */

            case 2:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2438; /* *pred_th_extractrvvm2di */

            case 3:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2439; /* *pred_th_extractrvvm1di */

            case 4:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2479; /* *pred_th_extractv1di */

            case 5:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2480; /* *pred_th_extractv2di */

            case 6:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2481; /* *pred_th_extractv4di */

            case 7:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2482; /* *pred_th_extractv8di */

            case 8:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2483; /* *pred_th_extractv16di */

            case 9:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2484; /* *pred_th_extractv32di */

            case 10:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2485; /* *pred_th_extractv64di */

            case 11:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2486; /* *pred_th_extractv128di */

            case 12:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2487; /* *pred_th_extractv256di */

            case 13:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2488; /* *pred_th_extractv512di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      return recog_30 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern171 ())
        {
        case 0:
          if (!(
#line 3571 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 405; /* fclasssfsi */

        case 1:
          if (!(
#line 3571 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 407; /* fclassdfsi */

        case 2:
          if (!(
#line 3571 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 409; /* fclasshfsi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      switch (pattern171 ())
        {
        case 0:
          if (!(
#line 3571 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 406; /* fclasssfdi */

        case 1:
          if (!(
#line 3571 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 408; /* fclassdfdi */

        case 2:
          if (!(
#line 3571 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 410; /* fclasshfdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern585 (x2, 
E_RVVMF16BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 3495 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8678; /* pred_madcrvvmf2qi_scalar */

    case E_RVVM1HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 3495 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8684; /* pred_madcrvvm1hi_scalar */

    case E_RVVM2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 3495 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8689; /* pred_madcrvvm2si_scalar */

    case E_RVVM4DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 3566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8783; /* *pred_madcrvvm4di_scalar */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18114; /* pred_redminrvvm8qi */

        case 1:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18122; /* pred_redminrvvm4qi */

        case 2:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18130; /* pred_redminrvvm2qi */

        case 3:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18138; /* pred_redminrvvm1qi */

        case 4:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18242; /* pred_redminrvvmf2qi */

        case 5:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18250; /* pred_redminrvvmf4qi */

        case 6:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18258; /* pred_redminrvvmf8qi */

        case 7:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18290; /* pred_redminv1qi */

        case 8:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18298; /* pred_redminv2qi */

        case 9:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18306; /* pred_redminv4qi */

        case 10:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18314; /* pred_redminv8qi */

        case 11:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18322; /* pred_redminv16qi */

        case 12:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18330; /* pred_redminv32qi */

        case 13:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18338; /* pred_redminv64qi */

        case 14:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18346; /* pred_redminv128qi */

        case 15:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18354; /* pred_redminv256qi */

        case 16:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18362; /* pred_redminv512qi */

        case 17:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18370; /* pred_redminv1024qi */

        case 18:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18378; /* pred_redminv2048qi */

        case 19:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18386; /* pred_redminv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18146; /* pred_redminrvvm8hi */

        case 1:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18154; /* pred_redminrvvm4hi */

        case 2:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18162; /* pred_redminrvvm2hi */

        case 3:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18170; /* pred_redminrvvm1hi */

        case 4:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18266; /* pred_redminrvvmf2hi */

        case 5:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18274; /* pred_redminrvvmf4hi */

        case 6:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18394; /* pred_redminv1hi */

        case 7:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18402; /* pred_redminv2hi */

        case 8:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18410; /* pred_redminv4hi */

        case 9:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18418; /* pred_redminv8hi */

        case 10:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18426; /* pred_redminv16hi */

        case 11:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18434; /* pred_redminv32hi */

        case 12:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18442; /* pred_redminv64hi */

        case 13:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18450; /* pred_redminv128hi */

        case 14:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18458; /* pred_redminv256hi */

        case 15:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18466; /* pred_redminv512hi */

        case 16:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18474; /* pred_redminv1024hi */

        case 17:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18482; /* pred_redminv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18178; /* pred_redminrvvm8si */

        case 1:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18186; /* pred_redminrvvm4si */

        case 2:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18194; /* pred_redminrvvm2si */

        case 3:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18202; /* pred_redminrvvm1si */

        case 4:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18282; /* pred_redminrvvmf2si */

        case 5:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18490; /* pred_redminv1si */

        case 6:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18498; /* pred_redminv2si */

        case 7:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18506; /* pred_redminv4si */

        case 8:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18514; /* pred_redminv8si */

        case 9:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18522; /* pred_redminv16si */

        case 10:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18530; /* pred_redminv32si */

        case 11:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18538; /* pred_redminv64si */

        case 12:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18546; /* pred_redminv128si */

        case 13:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18554; /* pred_redminv256si */

        case 14:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18562; /* pred_redminv512si */

        case 15:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18570; /* pred_redminv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2))
        {
        case 0:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18210; /* pred_redminrvvm8di */

        case 1:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18218; /* pred_redminrvvm4di */

        case 2:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18226; /* pred_redminrvvm2di */

        case 3:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18234; /* pred_redminrvvm1di */

        case 4:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18578; /* pred_redminv1di */

        case 5:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18586; /* pred_redminv2di */

        case 6:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18594; /* pred_redminv4di */

        case 7:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18602; /* pred_redminv8di */

        case 8:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18610; /* pred_redminv16di */

        case 9:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18618; /* pred_redminv32di */

        case 10:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18626; /* pred_redminv64di */

        case 11:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18634; /* pred_redminv128di */

        case 12:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18642; /* pred_redminv256di */

        case 13:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18650; /* pred_redminv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18763; /* pred_redminrvvm8hf */

        case 1:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18765; /* pred_redminrvvm4hf */

        case 2:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18767; /* pred_redminrvvm2hf */

        case 3:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18769; /* pred_redminrvvm1hf */

        case 4:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18771; /* pred_redminrvvmf2hf */

        case 5:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18773; /* pred_redminrvvmf4hf */

        case 6:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 18793; /* pred_redminv1hf */

        case 7:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 18795; /* pred_redminv2hf */

        case 8:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 18797; /* pred_redminv4hf */

        case 9:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 18799; /* pred_redminv8hf */

        case 10:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 18801; /* pred_redminv16hf */

        case 11:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18803; /* pred_redminv32hf */

        case 12:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18805; /* pred_redminv64hf */

        case 13:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18807; /* pred_redminv128hf */

        case 14:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18809; /* pred_redminv256hf */

        case 15:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18811; /* pred_redminv512hf */

        case 16:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18813; /* pred_redminv1024hf */

        case 17:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18815; /* pred_redminv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18775; /* pred_redminrvvm8sf */

        case 1:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18777; /* pred_redminrvvm4sf */

        case 2:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18779; /* pred_redminrvvm2sf */

        case 3:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18781; /* pred_redminrvvm1sf */

        case 4:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18783; /* pred_redminrvvmf2sf */

        case 5:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18817; /* pred_redminv1sf */

        case 6:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18819; /* pred_redminv2sf */

        case 7:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18821; /* pred_redminv4sf */

        case 8:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18823; /* pred_redminv8sf */

        case 9:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18825; /* pred_redminv16sf */

        case 10:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18827; /* pred_redminv32sf */

        case 11:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18829; /* pred_redminv64sf */

        case 12:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18831; /* pred_redminv128sf */

        case 13:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18833; /* pred_redminv256sf */

        case 14:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18835; /* pred_redminv512sf */

        case 15:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18837; /* pred_redminv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2))
        {
        case 0:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18785; /* pred_redminrvvm8df */

        case 1:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18787; /* pred_redminrvvm4df */

        case 2:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18789; /* pred_redminrvvm2df */

        case 3:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18791; /* pred_redminrvvm1df */

        case 4:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18839; /* pred_redminv1df */

        case 5:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18841; /* pred_redminv2df */

        case 6:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18843; /* pred_redminv4df */

        case 7:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18845; /* pred_redminv8df */

        case 8:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18847; /* pred_redminv16df */

        case 9:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18849; /* pred_redminv32df */

        case 10:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18851; /* pred_redminv64df */

        case 11:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18853; /* pred_redminv128df */

        case 12:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18855; /* pred_redminv256df */

        case 13:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18857; /* pred_redminv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern447 (x2))
    {
    case 0:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 925; /* pred_th_whole_movrvvm8qi */

    case 1:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 926; /* pred_th_whole_movrvvm4qi */

    case 2:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 927; /* pred_th_whole_movrvvm2qi */

    case 3:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 928; /* pred_th_whole_movrvvm1qi */

    case 4:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 929; /* pred_th_whole_movrvvm8hi */

    case 5:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 930; /* pred_th_whole_movrvvm4hi */

    case 6:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 931; /* pred_th_whole_movrvvm2hi */

    case 7:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 932; /* pred_th_whole_movrvvm1hi */

    case 8:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 933; /* pred_th_whole_movrvvm8si */

    case 9:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 934; /* pred_th_whole_movrvvm4si */

    case 10:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 935; /* pred_th_whole_movrvvm2si */

    case 11:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 936; /* pred_th_whole_movrvvm1si */

    case 12:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 937; /* pred_th_whole_movrvvm8di */

    case 13:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 938; /* pred_th_whole_movrvvm4di */

    case 14:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 939; /* pred_th_whole_movrvvm2di */

    case 15:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 940; /* pred_th_whole_movrvvm1di */

    case 16:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 941; /* pred_th_whole_movrvvmf8qi */

    case 17:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 942; /* pred_th_whole_movrvvmf4hi */

    case 18:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 943; /* pred_th_whole_movrvvmf2si */

    case 19:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 944; /* pred_th_whole_movrvvm8bf */

    case 20:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 945; /* pred_th_whole_movrvvm4bf */

    case 21:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 946; /* pred_th_whole_movrvvm2bf */

    case 22:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 947; /* pred_th_whole_movrvvm1bf */

    case 23:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 948; /* pred_th_whole_movrvvmf2bf */

    case 24:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 949; /* pred_th_whole_movrvvmf4bf */

    case 25:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 950; /* pred_th_whole_movrvvm8hf */

    case 26:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 951; /* pred_th_whole_movrvvm4hf */

    case 27:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 952; /* pred_th_whole_movrvvm2hf */

    case 28:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 953; /* pred_th_whole_movrvvm1hf */

    case 29:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 954; /* pred_th_whole_movrvvmf2hf */

    case 30:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 955; /* pred_th_whole_movrvvmf4hf */

    case 31:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 956; /* pred_th_whole_movrvvm8sf */

    case 32:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 957; /* pred_th_whole_movrvvm4sf */

    case 33:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 958; /* pred_th_whole_movrvvm2sf */

    case 34:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 959; /* pred_th_whole_movrvvm1sf */

    case 35:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 960; /* pred_th_whole_movrvvmf2sf */

    case 36:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 961; /* pred_th_whole_movrvvm8df */

    case 37:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 962; /* pred_th_whole_movrvvm4df */

    case 38:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 963; /* pred_th_whole_movrvvm2df */

    case 39:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 964; /* pred_th_whole_movrvvm1df */

    case 40:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 965; /* pred_th_whole_movv1qi */

    case 41:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 966; /* pred_th_whole_movv2qi */

    case 42:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 967; /* pred_th_whole_movv4qi */

    case 43:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 968; /* pred_th_whole_movv8qi */

    case 44:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 969; /* pred_th_whole_movv16qi */

    case 45:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 970; /* pred_th_whole_movv32qi */

    case 46:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 971; /* pred_th_whole_movv64qi */

    case 47:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 972; /* pred_th_whole_movv128qi */

    case 48:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 973; /* pred_th_whole_movv256qi */

    case 49:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 974; /* pred_th_whole_movv512qi */

    case 50:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 975; /* pred_th_whole_movv1024qi */

    case 51:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 976; /* pred_th_whole_movv2048qi */

    case 52:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 977; /* pred_th_whole_movv4096qi */

    case 53:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 978; /* pred_th_whole_movv1hi */

    case 54:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 979; /* pred_th_whole_movv2hi */

    case 55:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 980; /* pred_th_whole_movv4hi */

    case 56:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 981; /* pred_th_whole_movv8hi */

    case 57:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 982; /* pred_th_whole_movv16hi */

    case 58:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 983; /* pred_th_whole_movv32hi */

    case 59:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 984; /* pred_th_whole_movv64hi */

    case 60:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 985; /* pred_th_whole_movv128hi */

    case 61:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 986; /* pred_th_whole_movv256hi */

    case 62:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 987; /* pred_th_whole_movv512hi */

    case 63:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 988; /* pred_th_whole_movv1024hi */

    case 64:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 989; /* pred_th_whole_movv2048hi */

    case 65:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 990; /* pred_th_whole_movv1si */

    case 66:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 991; /* pred_th_whole_movv2si */

    case 67:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 992; /* pred_th_whole_movv4si */

    case 68:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 993; /* pred_th_whole_movv8si */

    case 69:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 994; /* pred_th_whole_movv16si */

    case 70:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 995; /* pred_th_whole_movv32si */

    case 71:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 996; /* pred_th_whole_movv64si */

    case 72:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 997; /* pred_th_whole_movv128si */

    case 73:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 998; /* pred_th_whole_movv256si */

    case 74:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 999; /* pred_th_whole_movv512si */

    case 75:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1000; /* pred_th_whole_movv1024si */

    case 76:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1001; /* pred_th_whole_movv1di */

    case 77:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1002; /* pred_th_whole_movv2di */

    case 78:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1003; /* pred_th_whole_movv4di */

    case 79:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1004; /* pred_th_whole_movv8di */

    case 80:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1005; /* pred_th_whole_movv16di */

    case 81:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1006; /* pred_th_whole_movv32di */

    case 82:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1007; /* pred_th_whole_movv64di */

    case 83:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1008; /* pred_th_whole_movv128di */

    case 84:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1009; /* pred_th_whole_movv256di */

    case 85:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1010; /* pred_th_whole_movv512di */

    case 86:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1011; /* pred_th_whole_movv1hf */

    case 87:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1012; /* pred_th_whole_movv2hf */

    case 88:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1013; /* pred_th_whole_movv4hf */

    case 89:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1014; /* pred_th_whole_movv8hf */

    case 90:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1015; /* pred_th_whole_movv16hf */

    case 91:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1016; /* pred_th_whole_movv32hf */

    case 92:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1017; /* pred_th_whole_movv64hf */

    case 93:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1018; /* pred_th_whole_movv128hf */

    case 94:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1019; /* pred_th_whole_movv256hf */

    case 95:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1020; /* pred_th_whole_movv512hf */

    case 96:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1021; /* pred_th_whole_movv1024hf */

    case 97:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1022; /* pred_th_whole_movv2048hf */

    case 98:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1023; /* pred_th_whole_movv1sf */

    case 99:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1024; /* pred_th_whole_movv2sf */

    case 100:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1025; /* pred_th_whole_movv4sf */

    case 101:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1026; /* pred_th_whole_movv8sf */

    case 102:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1027; /* pred_th_whole_movv16sf */

    case 103:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1028; /* pred_th_whole_movv32sf */

    case 104:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1029; /* pred_th_whole_movv64sf */

    case 105:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1030; /* pred_th_whole_movv128sf */

    case 106:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1031; /* pred_th_whole_movv256sf */

    case 107:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1032; /* pred_th_whole_movv512sf */

    case 108:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1033; /* pred_th_whole_movv1024sf */

    case 109:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1034; /* pred_th_whole_movv1df */

    case 110:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1035; /* pred_th_whole_movv2df */

    case 111:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1036; /* pred_th_whole_movv4df */

    case 112:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1037; /* pred_th_whole_movv8df */

    case 113:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1038; /* pred_th_whole_movv16df */

    case 114:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1039; /* pred_th_whole_movv32df */

    case 115:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1040; /* pred_th_whole_movv64df */

    case 116:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1041; /* pred_th_whole_movv128df */

    case 117:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1042; /* pred_th_whole_movv256df */

    case 118:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1043; /* pred_th_whole_movv512df */

    case 119:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1044; /* pred_th_whole_movrvvmf8x2qi */

    case 120:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1045; /* pred_th_whole_movrvvmf8x3qi */

    case 121:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1046; /* pred_th_whole_movrvvmf8x4qi */

    case 122:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1047; /* pred_th_whole_movrvvmf8x5qi */

    case 123:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1048; /* pred_th_whole_movrvvmf8x6qi */

    case 124:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1049; /* pred_th_whole_movrvvmf8x7qi */

    case 125:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1050; /* pred_th_whole_movrvvmf8x8qi */

    case 126:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1051; /* pred_th_whole_movrvvmf4x2hi */

    case 127:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1052; /* pred_th_whole_movrvvmf4x3hi */

    case 128:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1053; /* pred_th_whole_movrvvmf4x4hi */

    case 129:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1054; /* pred_th_whole_movrvvmf4x5hi */

    case 130:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1055; /* pred_th_whole_movrvvmf4x6hi */

    case 131:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1056; /* pred_th_whole_movrvvmf4x7hi */

    case 132:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1057; /* pred_th_whole_movrvvmf4x8hi */

    case 133:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1058; /* pred_th_whole_movrvvmf2x2si */

    case 134:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1059; /* pred_th_whole_movrvvmf2x3si */

    case 135:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1060; /* pred_th_whole_movrvvmf2x4si */

    case 136:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1061; /* pred_th_whole_movrvvmf2x5si */

    case 137:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1062; /* pred_th_whole_movrvvmf2x6si */

    case 138:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1063; /* pred_th_whole_movrvvmf2x7si */

    case 139:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1064; /* pred_th_whole_movrvvmf2x8si */

    case 140:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1065; /* pred_th_whole_movrvvm1x2di */

    case 141:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1066; /* pred_th_whole_movrvvm1x3di */

    case 142:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1067; /* pred_th_whole_movrvvm1x4di */

    case 143:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1068; /* pred_th_whole_movrvvm1x5di */

    case 144:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1069; /* pred_th_whole_movrvvm1x6di */

    case 145:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1070; /* pred_th_whole_movrvvm1x7di */

    case 146:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1071; /* pred_th_whole_movrvvm1x8di */

    case 147:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1072; /* pred_th_whole_movrvvmf4x2bf */

    case 148:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1073; /* pred_th_whole_movrvvmf4x3bf */

    case 149:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1074; /* pred_th_whole_movrvvmf4x4bf */

    case 150:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1075; /* pred_th_whole_movrvvmf4x5bf */

    case 151:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1076; /* pred_th_whole_movrvvmf4x6bf */

    case 152:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1077; /* pred_th_whole_movrvvmf4x7bf */

    case 153:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1078; /* pred_th_whole_movrvvmf4x8bf */

    case 154:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1079; /* pred_th_whole_movrvvmf4x2hf */

    case 155:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1080; /* pred_th_whole_movrvvmf4x3hf */

    case 156:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1081; /* pred_th_whole_movrvvmf4x4hf */

    case 157:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1082; /* pred_th_whole_movrvvmf4x5hf */

    case 158:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1083; /* pred_th_whole_movrvvmf4x6hf */

    case 159:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1084; /* pred_th_whole_movrvvmf4x7hf */

    case 160:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1085; /* pred_th_whole_movrvvmf4x8hf */

    case 161:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1086; /* pred_th_whole_movrvvmf2x2sf */

    case 162:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1087; /* pred_th_whole_movrvvmf2x3sf */

    case 163:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1088; /* pred_th_whole_movrvvmf2x4sf */

    case 164:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1089; /* pred_th_whole_movrvvmf2x5sf */

    case 165:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1090; /* pred_th_whole_movrvvmf2x6sf */

    case 166:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1091; /* pred_th_whole_movrvvmf2x7sf */

    case 167:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1092; /* pred_th_whole_movrvvmf2x8sf */

    case 168:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1093; /* pred_th_whole_movrvvm1x2df */

    case 169:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1094; /* pred_th_whole_movrvvm1x3df */

    case 170:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1095; /* pred_th_whole_movrvvm1x4df */

    case 171:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1096; /* pred_th_whole_movrvvm1x5df */

    case 172:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1097; /* pred_th_whole_movrvvm1x6df */

    case 173:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1098; /* pred_th_whole_movrvvm1x7df */

    case 174:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1099; /* pred_th_whole_movrvvm1x8df */

    case 175:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1100; /* pred_th_whole_movrvvmf4x2qi */

    case 176:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1101; /* pred_th_whole_movrvvmf4x3qi */

    case 177:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1102; /* pred_th_whole_movrvvmf4x4qi */

    case 178:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1103; /* pred_th_whole_movrvvmf4x5qi */

    case 179:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1104; /* pred_th_whole_movrvvmf4x6qi */

    case 180:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1105; /* pred_th_whole_movrvvmf4x7qi */

    case 181:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1106; /* pred_th_whole_movrvvmf4x8qi */

    case 182:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1107; /* pred_th_whole_movrvvmf2x2hi */

    case 183:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1108; /* pred_th_whole_movrvvmf2x3hi */

    case 184:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1109; /* pred_th_whole_movrvvmf2x4hi */

    case 185:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1110; /* pred_th_whole_movrvvmf2x5hi */

    case 186:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1111; /* pred_th_whole_movrvvmf2x6hi */

    case 187:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1112; /* pred_th_whole_movrvvmf2x7hi */

    case 188:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1113; /* pred_th_whole_movrvvmf2x8hi */

    case 189:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1114; /* pred_th_whole_movrvvm1x2si */

    case 190:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1115; /* pred_th_whole_movrvvm1x3si */

    case 191:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1116; /* pred_th_whole_movrvvm1x4si */

    case 192:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1117; /* pred_th_whole_movrvvm1x5si */

    case 193:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1118; /* pred_th_whole_movrvvm1x6si */

    case 194:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1119; /* pred_th_whole_movrvvm1x7si */

    case 195:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1120; /* pred_th_whole_movrvvm1x8si */

    case 196:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1233 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1121; /* pred_th_whole_movrvvm2x2di */

    case 197:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1122; /* pred_th_whole_movrvvm2x3di */

    case 198:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1235 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1123; /* pred_th_whole_movrvvm2x4di */

    case 199:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1236 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1124; /* pred_th_whole_movrvvmf2x2bf */

    case 200:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1237 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1125; /* pred_th_whole_movrvvmf2x3bf */

    case 201:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1126; /* pred_th_whole_movrvvmf2x4bf */

    case 202:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1239 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1127; /* pred_th_whole_movrvvmf2x5bf */

    case 203:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1128; /* pred_th_whole_movrvvmf2x6bf */

    case 204:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1241 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1129; /* pred_th_whole_movrvvmf2x7bf */

    case 205:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1130; /* pred_th_whole_movrvvmf2x8bf */

    case 206:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1243 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1131; /* pred_th_whole_movrvvmf2x2hf */

    case 207:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1244 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1132; /* pred_th_whole_movrvvmf2x3hf */

    case 208:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1245 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1133; /* pred_th_whole_movrvvmf2x4hf */

    case 209:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1134; /* pred_th_whole_movrvvmf2x5hf */

    case 210:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1135; /* pred_th_whole_movrvvmf2x6hf */

    case 211:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1136; /* pred_th_whole_movrvvmf2x7hf */

    case 212:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1137; /* pred_th_whole_movrvvmf2x8hf */

    case 213:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1138; /* pred_th_whole_movrvvm1x2sf */

    case 214:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1139; /* pred_th_whole_movrvvm1x3sf */

    case 215:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1140; /* pred_th_whole_movrvvm1x4sf */

    case 216:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1141; /* pred_th_whole_movrvvm1x5sf */

    case 217:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1142; /* pred_th_whole_movrvvm1x6sf */

    case 218:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1143; /* pred_th_whole_movrvvm1x7sf */

    case 219:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1144; /* pred_th_whole_movrvvm1x8sf */

    case 220:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1145; /* pred_th_whole_movrvvm2x2df */

    case 221:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1146; /* pred_th_whole_movrvvm2x3df */

    case 222:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1147; /* pred_th_whole_movrvvm2x4df */

    case 223:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1148; /* pred_th_whole_movrvvmf2x2qi */

    case 224:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1149; /* pred_th_whole_movrvvmf2x3qi */

    case 225:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1150; /* pred_th_whole_movrvvmf2x4qi */

    case 226:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1151; /* pred_th_whole_movrvvmf2x5qi */

    case 227:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1152; /* pred_th_whole_movrvvmf2x6qi */

    case 228:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1153; /* pred_th_whole_movrvvmf2x7qi */

    case 229:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1154; /* pred_th_whole_movrvvmf2x8qi */

    case 230:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1155; /* pred_th_whole_movrvvm1x2hi */

    case 231:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1156; /* pred_th_whole_movrvvm1x3hi */

    case 232:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1157; /* pred_th_whole_movrvvm1x4hi */

    case 233:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1158; /* pred_th_whole_movrvvm1x5hi */

    case 234:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1159; /* pred_th_whole_movrvvm1x6hi */

    case 235:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1160; /* pred_th_whole_movrvvm1x7hi */

    case 236:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1161; /* pred_th_whole_movrvvm1x8hi */

    case 237:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1162; /* pred_th_whole_movrvvm2x2si */

    case 238:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1163; /* pred_th_whole_movrvvm2x3si */

    case 239:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1164; /* pred_th_whole_movrvvm2x4si */

    case 240:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1280 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1165; /* pred_th_whole_movrvvm4x2di */

    case 241:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1166; /* pred_th_whole_movrvvm1x2bf */

    case 242:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1282 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1167; /* pred_th_whole_movrvvm1x3bf */

    case 243:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1168; /* pred_th_whole_movrvvm1x4bf */

    case 244:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1284 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1169; /* pred_th_whole_movrvvm1x5bf */

    case 245:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1170; /* pred_th_whole_movrvvm1x6bf */

    case 246:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1286 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1171; /* pred_th_whole_movrvvm1x7bf */

    case 247:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1287 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1172; /* pred_th_whole_movrvvm1x8bf */

    case 248:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1173; /* pred_th_whole_movrvvm1x2hf */

    case 249:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1289 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1174; /* pred_th_whole_movrvvm1x3hf */

    case 250:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1175; /* pred_th_whole_movrvvm1x4hf */

    case 251:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1291 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1176; /* pred_th_whole_movrvvm1x5hf */

    case 252:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1177; /* pred_th_whole_movrvvm1x6hf */

    case 253:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1293 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1178; /* pred_th_whole_movrvvm1x7hf */

    case 254:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1179; /* pred_th_whole_movrvvm1x8hf */

    case 255:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1180; /* pred_th_whole_movrvvm2x2sf */

    case 256:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1181; /* pred_th_whole_movrvvm2x3sf */

    case 257:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1182; /* pred_th_whole_movrvvm2x4sf */

    case 258:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1183; /* pred_th_whole_movrvvm4x2df */

    case 259:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1184; /* pred_th_whole_movrvvm1x2qi */

    case 260:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1185; /* pred_th_whole_movrvvm1x3qi */

    case 261:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1186; /* pred_th_whole_movrvvm1x4qi */

    case 262:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1187; /* pred_th_whole_movrvvm1x5qi */

    case 263:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1188; /* pred_th_whole_movrvvm1x6qi */

    case 264:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1189; /* pred_th_whole_movrvvm1x7qi */

    case 265:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1190; /* pred_th_whole_movrvvm1x8qi */

    case 266:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1191; /* pred_th_whole_movrvvm2x2hi */

    case 267:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1192; /* pred_th_whole_movrvvm2x3hi */

    case 268:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1193; /* pred_th_whole_movrvvm2x4hi */

    case 269:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1194; /* pred_th_whole_movrvvm4x2si */

    case 270:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1195; /* pred_th_whole_movrvvm2x2bf */

    case 271:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1196; /* pred_th_whole_movrvvm2x3bf */

    case 272:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1315 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1197; /* pred_th_whole_movrvvm2x4bf */

    case 273:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1198; /* pred_th_whole_movrvvm2x2hf */

    case 274:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1199; /* pred_th_whole_movrvvm2x3hf */

    case 275:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1318 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1200; /* pred_th_whole_movrvvm2x4hf */

    case 276:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1201; /* pred_th_whole_movrvvm4x2sf */

    case 277:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1202; /* pred_th_whole_movrvvm2x2qi */

    case 278:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1203; /* pred_th_whole_movrvvm2x3qi */

    case 279:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1204; /* pred_th_whole_movrvvm2x4qi */

    case 280:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1205; /* pred_th_whole_movrvvm4x2hi */

    case 281:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1206; /* pred_th_whole_movrvvm4x2bf */

    case 282:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1207; /* pred_th_whole_movrvvm4x2hf */

    case 283:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1208; /* pred_th_whole_movrvvm4x2qi */

    case 284:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1209; /* pred_th_whole_movrvvmf64bi */

    case 285:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1210; /* pred_th_whole_movrvvmf32bi */

    case 286:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1211; /* pred_th_whole_movrvvmf16bi */

    case 287:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1212; /* pred_th_whole_movrvvmf8bi */

    case 288:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1213; /* pred_th_whole_movrvvmf4bi */

    case 289:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1214; /* pred_th_whole_movrvvmf2bi */

    case 290:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1215; /* pred_th_whole_movrvvm1bi */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
    return 114; /* one_cmplsi2 */
  if (!
#line 1774 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
    return -1;
  return 116; /* *one_cmplsi2_internal */
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return recog_95 (x1, insn, pnum_clobbers);

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      return 115; /* one_cmpldi2 */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 25034; /* one_cmplrvvmf64bi2 */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25035; /* one_cmplrvvmf32bi2 */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25036; /* one_cmplrvvmf16bi2 */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25037; /* one_cmplrvvmf8bi2 */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25038; /* one_cmplrvvmf4bi2 */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25039; /* one_cmplrvvmf2bi2 */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25040; /* one_cmplrvvm1bi2 */

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 25041; /* one_cmplv1bi2 */

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25042; /* one_cmplv2bi2 */

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25043; /* one_cmplv4bi2 */

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25044; /* one_cmplv8bi2 */

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25045; /* one_cmplv16bi2 */

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25046; /* one_cmplv32bi2 */

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25047; /* one_cmplv64bi2 */

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25048; /* one_cmplv128bi2 */

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25049; /* one_cmplv256bi2 */

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25050; /* one_cmplv512bi2 */

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25051; /* one_cmplv1024bi2 */

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25052; /* one_cmplv2048bi2 */

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25053; /* one_cmplv4096bi2 */

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25973; /* one_cmplrvvm8qi2 */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25975; /* one_cmplrvvm4qi2 */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25977; /* one_cmplrvvm2qi2 */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25979; /* one_cmplrvvm1qi2 */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25981; /* one_cmplrvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25983; /* one_cmplrvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25985; /* one_cmplrvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25987; /* one_cmplrvvm1hi2 */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25989; /* one_cmplrvvm8si2 */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25991; /* one_cmplrvvm4si2 */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25993; /* one_cmplrvvm2si2 */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25995; /* one_cmplrvvm1si2 */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25997; /* one_cmplrvvm8di2 */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25999; /* one_cmplrvvm4di2 */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26001; /* one_cmplrvvm2di2 */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26003; /* one_cmplrvvm1di2 */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26005; /* one_cmplrvvmf2qi2 */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26007; /* one_cmplrvvmf4qi2 */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26009; /* one_cmplrvvmf8qi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26011; /* one_cmplrvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26013; /* one_cmplrvvmf4hi2 */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26015; /* one_cmplrvvmf2si2 */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26017; /* one_cmplv1qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26019; /* one_cmplv2qi2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26021; /* one_cmplv4qi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26023; /* one_cmplv8qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26025; /* one_cmplv16qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26027; /* one_cmplv32qi2 */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26029; /* one_cmplv64qi2 */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26031; /* one_cmplv128qi2 */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26033; /* one_cmplv256qi2 */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26035; /* one_cmplv512qi2 */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26037; /* one_cmplv1024qi2 */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26039; /* one_cmplv2048qi2 */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26041; /* one_cmplv4096qi2 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26043; /* one_cmplv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26045; /* one_cmplv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26047; /* one_cmplv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26049; /* one_cmplv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26051; /* one_cmplv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26053; /* one_cmplv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26055; /* one_cmplv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26057; /* one_cmplv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26059; /* one_cmplv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26061; /* one_cmplv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26063; /* one_cmplv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26065; /* one_cmplv2048hi2 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26067; /* one_cmplv1si2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26069; /* one_cmplv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26071; /* one_cmplv4si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 26073; /* one_cmplv8si2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26075; /* one_cmplv16si2 */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26077; /* one_cmplv32si2 */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26079; /* one_cmplv64si2 */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26081; /* one_cmplv128si2 */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26083; /* one_cmplv256si2 */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26085; /* one_cmplv512si2 */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26087; /* one_cmplv1024si2 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26089; /* one_cmplv1di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26091; /* one_cmplv2di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26093; /* one_cmplv4di2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26095; /* one_cmplv8di2 */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26097; /* one_cmplv16di2 */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26099; /* one_cmplv32di2 */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26101; /* one_cmplv64di2 */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26103; /* one_cmplv128di2 */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26105; /* one_cmplv256di2 */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26107; /* one_cmplv512di2 */

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF16BImode)
      && register_operand (operands[1], E_RVVMF16BImode)
      && 
#line 1293 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2799; /* *movrvvmf16bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF16BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF16BImode))
    return -1;
  if ((
#line 1353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2837; /* *movrvvmf16bisi_lra */
    }
  if (!(
#line 1353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2838; /* *movrvvmf16bidi_lra */
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4BFmode)
      && register_operand (operands[1], E_RVVMF4BFmode)
      && (
#line 1256 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 922 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
    return 2781; /* *movrvvmf4bf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4BFmode))
    return -1;
  if ((
#line 1331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2817; /* *movrvvmf4bfsi_lra */
    }
  if (!(
#line 1331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2828; /* *movrvvmf4bfdi_lra */
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16BImode)
      && reg_or_mem_operand (operands[1], E_V16BImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))) && 
#line 4285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
    return 3216; /* *movv16bi */
  if (!register_operand (operands[0], E_V16BImode)
      || !register_operand (operands[1], E_V16BImode)
      || !(
#line 1529 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
    return -1;
  return 3483; /* *movv16bi_vls */
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DFmode)
      && reg_or_mem_operand (operands[1], E_V8DFmode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DFmode)
       || register_operand (operands[1], V8DFmode))) && 
#line 4278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 3210; /* *movv8df */
  if (!register_operand (operands[0], E_V8DFmode)
      || !register_operand (operands[1], E_V8DFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3393; /* *movv8df_vls */
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SFmode)
      && reg_or_mem_operand (operands[1], E_V2SFmode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))) && 
#line 4271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3203; /* *movv2sf */
  if (!register_operand (operands[0], E_V2SFmode)
      || !register_operand (operands[1], E_V2SFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3380; /* *movv2sf_vls */
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DImode)
      && reg_or_mem_operand (operands[1], E_V16DImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DImode)
       || register_operand (operands[1], V16DImode))) && 
#line 4264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 3196; /* *movv16di */
  if (!register_operand (operands[0], E_V16DImode)
      || !register_operand (operands[1], E_V16DImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3361; /* *movv16di_vls */
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 3189; /* *movv4si */
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 3348; /* *movv4si_vls */
}

 int
recog_204 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HImode)
      && reg_or_mem_operand (operands[1], E_V1HImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HImode)
       || register_operand (operands[1], V1HImode))) && 
#line 4250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 3182; /* *movv1hi */
  if (!register_operand (operands[0], E_V1HImode)
      || !register_operand (operands[1], E_V1HImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 3334; /* *movv1hi_vls */
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3175; /* *movrvvm4x2qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3176; /* *movrvvm4x2qi_di */
}

 int
recog_218 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3161; /* *movrvvm4x2sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3162; /* *movrvvm4x2sf_di */
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3147; /* *movrvvm4x2si_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3148; /* *movrvvm4x2si_di */
}

 int
recog_232 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3133; /* *movrvvm1x5qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3134; /* *movrvvm1x5qi_di */
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3119; /* *movrvvm2x2sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3120; /* *movrvvm2x2sf_di */
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2HFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3105; /* *movrvvm1x2hf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3106; /* *movrvvm1x2hf_di */
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3091; /* *movrvvm1x2bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3092; /* *movrvvm1x2bf_di */
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6HImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3077; /* *movrvvm1x6hi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3078; /* *movrvvm1x6hi_di */
}

 int
recog_267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3063; /* *movrvvmf2x6qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3064; /* *movrvvmf2x6qi_di */
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3047; /* *movrvvm1x8sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3048; /* *movrvvm1x8sf_di */
}

 int
recog_283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7HFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3031; /* *movrvvmf2x7hf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3032; /* *movrvvmf2x7hf_di */
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3015; /* *movrvvmf2x6bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3016; /* *movrvvmf2x6bf_di */
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8SImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2999; /* *movrvvm1x8si_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3000; /* *movrvvm1x8si_di */
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3SImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2989; /* *movrvvm1x3si_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2990; /* *movrvvm1x3si_di */
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2HImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2973; /* *movrvvmf2x2hi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2974; /* *movrvvmf2x2hi_di */
}

 int
recog_320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8DFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2957; /* *movrvvm1x8df_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2958; /* *movrvvm1x8df_di */
}

 int
recog_328 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2941; /* *movrvvmf2x7sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2942; /* *movrvvmf2x7sf_di */
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x6HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x6HFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2925; /* *movrvvmf4x6hf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2926; /* *movrvvmf4x6hf_di */
}

 int
recog_344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x5BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x5BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2909; /* *movrvvmf4x5bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2910; /* *movrvvmf4x5bf_di */
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4DImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2893; /* *movrvvm1x4di_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2894; /* *movrvvm1x4di_di */
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !move_operand (operands[1], E_HFmode))
        return -1;
      if (
#line 2040 "../../../gcc/config/riscv/riscv.md"
(((TARGET_ZFHMIN && HFmode == HFmode)
    || (TARGET_ZFBFMIN && HFmode == BFmode))
   && (register_operand (operands[0], HFmode)
       || reg_or_0_operand (operands[1], HFmode))))
        return 138; /* *movhf_hardfloat */
      if (!
#line 2052 "../../../gcc/config/riscv/riscv.md"
(((!TARGET_ZFHMIN && HFmode == HFmode) || (HFmode == BFmode))
   && (register_operand (operands[0], HFmode)
       || reg_or_0_operand (operands[1], HFmode))))
        return -1;
      return 140; /* *movhf_softfloat */

    case E_BFmode:
      if (!nonimmediate_operand (operands[0], E_BFmode)
          || !move_operand (operands[1], E_BFmode))
        return -1;
      if (
#line 2040 "../../../gcc/config/riscv/riscv.md"
(((TARGET_ZFHMIN && BFmode == HFmode)
    || (TARGET_ZFBFMIN && BFmode == BFmode))
   && (register_operand (operands[0], BFmode)
       || reg_or_0_operand (operands[1], BFmode))))
        return 139; /* *movbf_hardfloat */
      if (!
#line 2052 "../../../gcc/config/riscv/riscv.md"
(((!TARGET_ZFHMIN && BFmode == HFmode) || (BFmode == BFmode))
   && (register_operand (operands[0], BFmode)
       || reg_or_0_operand (operands[1], BFmode))))
        return -1;
      return 141; /* *movbf_softfloat */

    case E_SImode:
      return recog_210 (x1, insn, pnum_clobbers);

    case E_DImode:
      return recog_169 (x1, insn, pnum_clobbers);

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !move_operand (operands[1], E_HImode)
          || !
#line 2548 "../../../gcc/config/riscv/riscv.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))))
        return -1;
      return 279; /* *movhi_internal */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !move_operand (operands[1], E_QImode)
          || !
#line 2592 "../../../gcc/config/riscv/riscv.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))))
        return -1;
      return 284; /* *movqi_internal */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !move_operand (operands[1], E_SFmode))
        return -1;
      if (
#line 2614 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
        return 285; /* *movsf_hardfloat */
      if (!
#line 2625 "../../../gcc/config/riscv/riscv.md"
(!TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
        return -1;
      return 286; /* *movsf_softfloat */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !move_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 2650 "../../../gcc/config/riscv/riscv.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return 287; /* *movdf_hardfloat_rv32 */
      if (
#line 2661 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return 288; /* *movdf_hardfloat_rv64 */
      if (!
#line 2672 "../../../gcc/config/riscv/riscv.md"
(!TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return -1;
      return 289; /* *movdf_softfloat */

    case E_RVVM8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8QImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2711; /* *movrvvm8qi_whole */

    case E_RVVM4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4QImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2712; /* *movrvvm4qi_whole */

    case E_RVVM2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2QImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2713; /* *movrvvm2qi_whole */

    case E_RVVM1QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1QImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2714; /* *movrvvm1qi_whole */

    case E_RVVM8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8HImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2715; /* *movrvvm8hi_whole */

    case E_RVVM4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4HImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2716; /* *movrvvm4hi_whole */

    case E_RVVM2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2HImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2717; /* *movrvvm2hi_whole */

    case E_RVVM1HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1HImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2718; /* *movrvvm1hi_whole */

    case E_RVVM8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8BFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 899 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2719; /* *movrvvm8bf_whole */

    case E_RVVM4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4BFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 899 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2720; /* *movrvvm4bf_whole */

    case E_RVVM2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2BFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 900 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2721; /* *movrvvm2bf_whole */

    case E_RVVM1BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1BFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 900 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2722; /* *movrvvm1bf_whole */

    case E_RVVM8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8HFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 902 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2723; /* *movrvvm8hf_whole */

    case E_RVVM4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4HFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 902 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2724; /* *movrvvm4hf_whole */

    case E_RVVM2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2HFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 903 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2725; /* *movrvvm2hf_whole */

    case E_RVVM1HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1HFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 903 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2726; /* *movrvvm1hf_whole */

    case E_RVVM8SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8SImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2727; /* *movrvvm8si_whole */

    case E_RVVM4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4SImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2728; /* *movrvvm4si_whole */

    case E_RVVM2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2SImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2729; /* *movrvvm2si_whole */

    case E_RVVM1SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1SImode)
          || !
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2730; /* *movrvvm1si_whole */

    case E_RVVM8SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8SFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 907 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2731; /* *movrvvm8sf_whole */

    case E_RVVM4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4SFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 907 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2732; /* *movrvvm4sf_whole */

    case E_RVVM2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2SFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 908 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2733; /* *movrvvm2sf_whole */

    case E_RVVM1SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1SFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 908 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2734; /* *movrvvm1sf_whole */

    case E_RVVM8DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8DImode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 910 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2735; /* *movrvvm8di_whole */

    case E_RVVM4DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4DImode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 910 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2736; /* *movrvvm4di_whole */

    case E_RVVM2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2DImode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 911 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2737; /* *movrvvm2di_whole */

    case E_RVVM1DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1DImode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 911 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2738; /* *movrvvm1di_whole */

    case E_RVVM8DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8DFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2739; /* *movrvvm8df_whole */

    case E_RVVM4DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4DFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2740; /* *movrvvm4df_whole */

    case E_RVVM2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2DFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2741; /* *movrvvm2df_whole */

    case E_RVVM1DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1DFmode)
          || !(
#line 1221 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2742; /* *movrvvm1df_whole */

    case E_RVVMF2QImode:
      return recog_168 (x1, insn, pnum_clobbers);

    case E_RVVMF4QImode:
      return recog_167 (x1, insn, pnum_clobbers);

    case E_RVVMF8QImode:
      return recog_166 (x1, insn, pnum_clobbers);

    case E_RVVMF2HImode:
      return recog_165 (x1, insn, pnum_clobbers);

    case E_RVVMF4HImode:
      return recog_164 (x1, insn, pnum_clobbers);

    case E_RVVMF2BFmode:
      return recog_163 (x1, insn, pnum_clobbers);

    case E_RVVMF4BFmode:
      return recog_162 (x1, insn, pnum_clobbers);

    case E_RVVMF2HFmode:
      return recog_161 (x1, insn, pnum_clobbers);

    case E_RVVMF4HFmode:
      return recog_160 (x1, insn, pnum_clobbers);

    case E_RVVMF2SImode:
      return recog_159 (x1, insn, pnum_clobbers);

    case E_RVVMF2SFmode:
      return recog_158 (x1, insn, pnum_clobbers);

    case E_RVVMF64BImode:
      return recog_157 (x1, insn, pnum_clobbers);

    case E_RVVMF32BImode:
      return recog_156 (x1, insn, pnum_clobbers);

    case E_RVVMF16BImode:
      return recog_155 (x1, insn, pnum_clobbers);

    case E_RVVMF8BImode:
      return recog_154 (x1, insn, pnum_clobbers);

    case E_RVVMF4BImode:
      return recog_153 (x1, insn, pnum_clobbers);

    case E_RVVMF2BImode:
      return recog_152 (x1, insn, pnum_clobbers);

    case E_RVVM1BImode:
      return recog_151 (x1, insn, pnum_clobbers);

    case E_RVVMF8x2QImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF8x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x2QImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2847; /* *movrvvmf8x2qi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2848; /* *movrvvmf8x2qi_di */

    case E_RVVMF8x3QImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF8x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x3QImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2849; /* *movrvvmf8x3qi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2850; /* *movrvvmf8x3qi_di */

    case E_RVVMF8x4QImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF8x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x4QImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2851; /* *movrvvmf8x4qi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2852; /* *movrvvmf8x4qi_di */

    case E_RVVMF8x5QImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF8x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x5QImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2853; /* *movrvvmf8x5qi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2854; /* *movrvvmf8x5qi_di */

    case E_RVVMF8x6QImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF8x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x6QImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2855; /* *movrvvmf8x6qi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2856; /* *movrvvmf8x6qi_di */

    case E_RVVMF8x7QImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF8x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x7QImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2857; /* *movrvvmf8x7qi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2858; /* *movrvvmf8x7qi_di */

    case E_RVVMF8x8QImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF8x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x8QImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2859; /* *movrvvmf8x8qi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2860; /* *movrvvmf8x8qi_di */

    case E_RVVMF4x2HImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF4x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2HImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2861; /* *movrvvmf4x2hi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2862; /* *movrvvmf4x2hi_di */

    case E_RVVMF4x3HImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF4x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3HImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2863; /* *movrvvmf4x3hi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2864; /* *movrvvmf4x3hi_di */

    case E_RVVMF4x4HImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF4x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4HImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2865; /* *movrvvmf4x4hi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2866; /* *movrvvmf4x4hi_di */

    case E_RVVMF4x5HImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF4x5HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5HImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2867; /* *movrvvmf4x5hi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2868; /* *movrvvmf4x5hi_di */

    case E_RVVMF4x6HImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF4x6HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6HImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2869; /* *movrvvmf4x6hi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2870; /* *movrvvmf4x6hi_di */

    case E_RVVMF4x7HImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF4x7HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7HImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2871; /* *movrvvmf4x7hi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2872; /* *movrvvmf4x7hi_di */

    case E_RVVMF4x8HImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF4x8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8HImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2873; /* *movrvvmf4x8hi_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2874; /* *movrvvmf4x8hi_di */

    case E_RVVMF2x2SImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF2x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2SImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2875; /* *movrvvmf2x2si_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2876; /* *movrvvmf2x2si_di */

    case E_RVVMF2x3SImode:
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_RVVMF2x3SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3SImode))
        return -1;
      if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 3;
          return 2877; /* *movrvvmf2x3si_si */
        }
      if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      *pnum_clobbers = 3;
      return 2878; /* *movrvvmf2x3si_di */

    case E_RVVMF2x4SImode:
      return recog_359 (x1, insn, pnum_clobbers);

    case E_RVVMF2x5SImode:
      return recog_358 (x1, insn, pnum_clobbers);

    case E_RVVMF2x6SImode:
      return recog_357 (x1, insn, pnum_clobbers);

    case E_RVVMF2x7SImode:
      return recog_356 (x1, insn, pnum_clobbers);

    case E_RVVMF2x8SImode:
      return recog_355 (x1, insn, pnum_clobbers);

    case E_RVVM1x2DImode:
      return recog_354 (x1, insn, pnum_clobbers);

    case E_RVVM1x3DImode:
      return recog_353 (x1, insn, pnum_clobbers);

    case E_RVVM1x4DImode:
      return recog_352 (x1, insn, pnum_clobbers);

    case E_RVVM1x5DImode:
      return recog_351 (x1, insn, pnum_clobbers);

    case E_RVVM1x6DImode:
      return recog_350 (x1, insn, pnum_clobbers);

    case E_RVVM1x7DImode:
      return recog_349 (x1, insn, pnum_clobbers);

    case E_RVVM1x8DImode:
      return recog_348 (x1, insn, pnum_clobbers);

    case E_RVVMF4x2BFmode:
      return recog_347 (x1, insn, pnum_clobbers);

    case E_RVVMF4x3BFmode:
      return recog_346 (x1, insn, pnum_clobbers);

    case E_RVVMF4x4BFmode:
      return recog_345 (x1, insn, pnum_clobbers);

    case E_RVVMF4x5BFmode:
      return recog_344 (x1, insn, pnum_clobbers);

    case E_RVVMF4x6BFmode:
      return recog_343 (x1, insn, pnum_clobbers);

    case E_RVVMF4x7BFmode:
      return recog_342 (x1, insn, pnum_clobbers);

    case E_RVVMF4x8BFmode:
      return recog_341 (x1, insn, pnum_clobbers);

    case E_RVVMF4x2HFmode:
      return recog_340 (x1, insn, pnum_clobbers);

    case E_RVVMF4x3HFmode:
      return recog_339 (x1, insn, pnum_clobbers);

    case E_RVVMF4x4HFmode:
      return recog_338 (x1, insn, pnum_clobbers);

    case E_RVVMF4x5HFmode:
      return recog_337 (x1, insn, pnum_clobbers);

    case E_RVVMF4x6HFmode:
      return recog_336 (x1, insn, pnum_clobbers);

    case E_RVVMF4x7HFmode:
      return recog_335 (x1, insn, pnum_clobbers);

    case E_RVVMF4x8HFmode:
      return recog_334 (x1, insn, pnum_clobbers);

    case E_RVVMF2x2SFmode:
      return recog_333 (x1, insn, pnum_clobbers);

    case E_RVVMF2x3SFmode:
      return recog_332 (x1, insn, pnum_clobbers);

    case E_RVVMF2x4SFmode:
      return recog_331 (x1, insn, pnum_clobbers);

    case E_RVVMF2x5SFmode:
      return recog_330 (x1, insn, pnum_clobbers);

    case E_RVVMF2x6SFmode:
      return recog_329 (x1, insn, pnum_clobbers);

    case E_RVVMF2x7SFmode:
      return recog_328 (x1, insn, pnum_clobbers);

    case E_RVVMF2x8SFmode:
      return recog_327 (x1, insn, pnum_clobbers);

    case E_RVVM1x2DFmode:
      return recog_326 (x1, insn, pnum_clobbers);

    case E_RVVM1x3DFmode:
      return recog_325 (x1, insn, pnum_clobbers);

    case E_RVVM1x4DFmode:
      return recog_324 (x1, insn, pnum_clobbers);

    case E_RVVM1x5DFmode:
      return recog_323 (x1, insn, pnum_clobbers);

    case E_RVVM1x6DFmode:
      return recog_322 (x1, insn, pnum_clobbers);

    case E_RVVM1x7DFmode:
      return recog_321 (x1, insn, pnum_clobbers);

    case E_RVVM1x8DFmode:
      return recog_320 (x1, insn, pnum_clobbers);

    case E_RVVMF4x2QImode:
      return recog_319 (x1, insn, pnum_clobbers);

    case E_RVVMF4x3QImode:
      return recog_318 (x1, insn, pnum_clobbers);

    case E_RVVMF4x4QImode:
      return recog_317 (x1, insn, pnum_clobbers);

    case E_RVVMF4x5QImode:
      return recog_316 (x1, insn, pnum_clobbers);

    case E_RVVMF4x6QImode:
      return recog_315 (x1, insn, pnum_clobbers);

    case E_RVVMF4x7QImode:
      return recog_314 (x1, insn, pnum_clobbers);

    case E_RVVMF4x8QImode:
      return recog_313 (x1, insn, pnum_clobbers);

    case E_RVVMF2x2HImode:
      return recog_312 (x1, insn, pnum_clobbers);

    case E_RVVMF2x3HImode:
      return recog_311 (x1, insn, pnum_clobbers);

    case E_RVVMF2x4HImode:
      return recog_310 (x1, insn, pnum_clobbers);

    case E_RVVMF2x5HImode:
      return recog_309 (x1, insn, pnum_clobbers);

    case E_RVVMF2x6HImode:
      return recog_308 (x1, insn, pnum_clobbers);

    case E_RVVMF2x7HImode:
      return recog_307 (x1, insn, pnum_clobbers);

    case E_RVVMF2x8HImode:
      return recog_306 (x1, insn, pnum_clobbers);

    case E_RVVM1x2SImode:
      return recog_305 (x1, insn, pnum_clobbers);

    case E_RVVM1x3SImode:
      return recog_304 (x1, insn, pnum_clobbers);

    case E_RVVM1x4SImode:
      return recog_303 (x1, insn, pnum_clobbers);

    case E_RVVM1x5SImode:
      return recog_302 (x1, insn, pnum_clobbers);

    case E_RVVM1x6SImode:
      return recog_301 (x1, insn, pnum_clobbers);

    case E_RVVM1x7SImode:
      return recog_300 (x1, insn, pnum_clobbers);

    case E_RVVM1x8SImode:
      return recog_299 (x1, insn, pnum_clobbers);

    case E_RVVM2x2DImode:
      return recog_298 (x1, insn, pnum_clobbers);

    case E_RVVM2x3DImode:
      return recog_297 (x1, insn, pnum_clobbers);

    case E_RVVM2x4DImode:
      return recog_296 (x1, insn, pnum_clobbers);

    case E_RVVMF2x2BFmode:
      return recog_295 (x1, insn, pnum_clobbers);

    case E_RVVMF2x3BFmode:
      return recog_294 (x1, insn, pnum_clobbers);

    case E_RVVMF2x4BFmode:
      return recog_293 (x1, insn, pnum_clobbers);

    case E_RVVMF2x5BFmode:
      return recog_292 (x1, insn, pnum_clobbers);

    case E_RVVMF2x6BFmode:
      return recog_291 (x1, insn, pnum_clobbers);

    case E_RVVMF2x7BFmode:
      return recog_290 (x1, insn, pnum_clobbers);

    case E_RVVMF2x8BFmode:
      return recog_289 (x1, insn, pnum_clobbers);

    case E_RVVMF2x2HFmode:
      return recog_288 (x1, insn, pnum_clobbers);

    case E_RVVMF2x3HFmode:
      return recog_287 (x1, insn, pnum_clobbers);

    case E_RVVMF2x4HFmode:
      return recog_286 (x1, insn, pnum_clobbers);

    case E_RVVMF2x5HFmode:
      return recog_285 (x1, insn, pnum_clobbers);

    case E_RVVMF2x6HFmode:
      return recog_284 (x1, insn, pnum_clobbers);

    case E_RVVMF2x7HFmode:
      return recog_283 (x1, insn, pnum_clobbers);

    case E_RVVMF2x8HFmode:
      return recog_282 (x1, insn, pnum_clobbers);

    case E_RVVM1x2SFmode:
      return recog_281 (x1, insn, pnum_clobbers);

    case E_RVVM1x3SFmode:
      return recog_280 (x1, insn, pnum_clobbers);

    case E_RVVM1x4SFmode:
      return recog_279 (x1, insn, pnum_clobbers);

    case E_RVVM1x5SFmode:
      return recog_278 (x1, insn, pnum_clobbers);

    case E_RVVM1x6SFmode:
      return recog_277 (x1, insn, pnum_clobbers);

    case E_RVVM1x7SFmode:
      return recog_276 (x1, insn, pnum_clobbers);

    case E_RVVM1x8SFmode:
      return recog_275 (x1, insn, pnum_clobbers);

    case E_RVVM2x2DFmode:
      return recog_274 (x1, insn, pnum_clobbers);

    case E_RVVM2x3DFmode:
      return recog_273 (x1, insn, pnum_clobbers);

    case E_RVVM2x4DFmode:
      return recog_272 (x1, insn, pnum_clobbers);

    case E_RVVMF2x2QImode:
      return recog_271 (x1, insn, pnum_clobbers);

    case E_RVVMF2x3QImode:
      return recog_270 (x1, insn, pnum_clobbers);

    case E_RVVMF2x4QImode:
      return recog_269 (x1, insn, pnum_clobbers);

    case E_RVVMF2x5QImode:
      return recog_268 (x1, insn, pnum_clobbers);

    case E_RVVMF2x6QImode:
      return recog_267 (x1, insn, pnum_clobbers);

    case E_RVVMF2x7QImode:
      return recog_266 (x1, insn, pnum_clobbers);

    case E_RVVMF2x8QImode:
      return recog_265 (x1, insn, pnum_clobbers);

    case E_RVVM1x2HImode:
      return recog_264 (x1, insn, pnum_clobbers);

    case E_RVVM1x3HImode:
      return recog_263 (x1, insn, pnum_clobbers);

    case E_RVVM1x4HImode:
      return recog_262 (x1, insn, pnum_clobbers);

    case E_RVVM1x5HImode:
      return recog_261 (x1, insn, pnum_clobbers);

    case E_RVVM1x6HImode:
      return recog_260 (x1, insn, pnum_clobbers);

    case E_RVVM1x7HImode:
      return recog_259 (x1, insn, pnum_clobbers);

    case E_RVVM1x8HImode:
      return recog_258 (x1, insn, pnum_clobbers);

    case E_RVVM2x2SImode:
      return recog_257 (x1, insn, pnum_clobbers);

    case E_RVVM2x3SImode:
      return recog_256 (x1, insn, pnum_clobbers);

    case E_RVVM2x4SImode:
      return recog_255 (x1, insn, pnum_clobbers);

    case E_RVVM4x2DImode:
      return recog_254 (x1, insn, pnum_clobbers);

    case E_RVVM1x2BFmode:
      return recog_253 (x1, insn, pnum_clobbers);

    case E_RVVM1x3BFmode:
      return recog_252 (x1, insn, pnum_clobbers);

    case E_RVVM1x4BFmode:
      return recog_251 (x1, insn, pnum_clobbers);

    case E_RVVM1x5BFmode:
      return recog_250 (x1, insn, pnum_clobbers);

    case E_RVVM1x6BFmode:
      return recog_249 (x1, insn, pnum_clobbers);

    case E_RVVM1x7BFmode:
      return recog_248 (x1, insn, pnum_clobbers);

    case E_RVVM1x8BFmode:
      return recog_247 (x1, insn, pnum_clobbers);

    case E_RVVM1x2HFmode:
      return recog_246 (x1, insn, pnum_clobbers);

    case E_RVVM1x3HFmode:
      return recog_245 (x1, insn, pnum_clobbers);

    case E_RVVM1x4HFmode:
      return recog_244 (x1, insn, pnum_clobbers);

    case E_RVVM1x5HFmode:
      return recog_243 (x1, insn, pnum_clobbers);

    case E_RVVM1x6HFmode:
      return recog_242 (x1, insn, pnum_clobbers);

    case E_RVVM1x7HFmode:
      return recog_241 (x1, insn, pnum_clobbers);

    case E_RVVM1x8HFmode:
      return recog_240 (x1, insn, pnum_clobbers);

    case E_RVVM2x2SFmode:
      return recog_239 (x1, insn, pnum_clobbers);

    case E_RVVM2x3SFmode:
      return recog_238 (x1, insn, pnum_clobbers);

    case E_RVVM2x4SFmode:
      return recog_237 (x1, insn, pnum_clobbers);

    case E_RVVM4x2DFmode:
      return recog_236 (x1, insn, pnum_clobbers);

    case E_RVVM1x2QImode:
      return recog_235 (x1, insn, pnum_clobbers);

    case E_RVVM1x3QImode:
      return recog_234 (x1, insn, pnum_clobbers);

    case E_RVVM1x4QImode:
      return recog_233 (x1, insn, pnum_clobbers);

    case E_RVVM1x5QImode:
      return recog_232 (x1, insn, pnum_clobbers);

    case E_RVVM1x6QImode:
      return recog_231 (x1, insn, pnum_clobbers);

    case E_RVVM1x7QImode:
      return recog_230 (x1, insn, pnum_clobbers);

    case E_RVVM1x8QImode:
      return recog_229 (x1, insn, pnum_clobbers);

    case E_RVVM2x2HImode:
      return recog_228 (x1, insn, pnum_clobbers);

    case E_RVVM2x3HImode:
      return recog_227 (x1, insn, pnum_clobbers);

    case E_RVVM2x4HImode:
      return recog_226 (x1, insn, pnum_clobbers);

    case E_RVVM4x2SImode:
      return recog_225 (x1, insn, pnum_clobbers);

    case E_RVVM2x2BFmode:
      return recog_224 (x1, insn, pnum_clobbers);

    case E_RVVM2x3BFmode:
      return recog_223 (x1, insn, pnum_clobbers);

    case E_RVVM2x4BFmode:
      return recog_222 (x1, insn, pnum_clobbers);

    case E_RVVM2x2HFmode:
      return recog_221 (x1, insn, pnum_clobbers);

    case E_RVVM2x3HFmode:
      return recog_220 (x1, insn, pnum_clobbers);

    case E_RVVM2x4HFmode:
      return recog_219 (x1, insn, pnum_clobbers);

    case E_RVVM4x2SFmode:
      return recog_218 (x1, insn, pnum_clobbers);

    case E_RVVM2x2QImode:
      return recog_217 (x1, insn, pnum_clobbers);

    case E_RVVM2x3QImode:
      return recog_216 (x1, insn, pnum_clobbers);

    case E_RVVM2x4QImode:
      return recog_215 (x1, insn, pnum_clobbers);

    case E_RVVM4x2HImode:
      return recog_214 (x1, insn, pnum_clobbers);

    case E_RVVM4x2BFmode:
      return recog_213 (x1, insn, pnum_clobbers);

    case E_RVVM4x2HFmode:
      return recog_212 (x1, insn, pnum_clobbers);

    case E_RVVM4x2QImode:
      return recog_211 (x1, insn, pnum_clobbers);

    case E_V1QImode:
      return recog_209 (x1, insn, pnum_clobbers);

    case E_V2QImode:
      return recog_208 (x1, insn, pnum_clobbers);

    case E_V4QImode:
      return recog_207 (x1, insn, pnum_clobbers);

    case E_V8QImode:
      return recog_206 (x1, insn, pnum_clobbers);

    case E_V16QImode:
      return recog_205 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_204 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_203 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_202 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_201 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_200 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_199 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_198 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_197 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_196 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_195 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_194 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_193 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_192 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_191 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_190 (x1, insn, pnum_clobbers);

    case E_V1HFmode:
      return recog_189 (x1, insn, pnum_clobbers);

    case E_V2HFmode:
      return recog_188 (x1, insn, pnum_clobbers);

    case E_V4HFmode:
      return recog_187 (x1, insn, pnum_clobbers);

    case E_V8HFmode:
      return recog_186 (x1, insn, pnum_clobbers);

    case E_V16HFmode:
      return recog_185 (x1, insn, pnum_clobbers);

    case E_V1SFmode:
      return recog_184 (x1, insn, pnum_clobbers);

    case E_V2SFmode:
      return recog_183 (x1, insn, pnum_clobbers);

    case E_V4SFmode:
      return recog_182 (x1, insn, pnum_clobbers);

    case E_V8SFmode:
      return recog_181 (x1, insn, pnum_clobbers);

    case E_V16SFmode:
      return recog_180 (x1, insn, pnum_clobbers);

    case E_V1DFmode:
      return recog_179 (x1, insn, pnum_clobbers);

    case E_V2DFmode:
      return recog_178 (x1, insn, pnum_clobbers);

    case E_V4DFmode:
      return recog_177 (x1, insn, pnum_clobbers);

    case E_V8DFmode:
      return recog_176 (x1, insn, pnum_clobbers);

    case E_V16DFmode:
      return recog_175 (x1, insn, pnum_clobbers);

    case E_V1BImode:
      return recog_174 (x1, insn, pnum_clobbers);

    case E_V2BImode:
      return recog_173 (x1, insn, pnum_clobbers);

    case E_V4BImode:
      return recog_172 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_171 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_170 (x1, insn, pnum_clobbers);

    case E_V32QImode:
      return recog_150 (x1, insn, pnum_clobbers);

    case E_V64QImode:
      return recog_149 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_148 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_147 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_146 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_145 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_144 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_143 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_142 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_141 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_140 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_139 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_138 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_137 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_136 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_135 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_134 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_133 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_132 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_131 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_130 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_129 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_128 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_127 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_126 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_125 (x1, insn, pnum_clobbers);

    case E_V32HFmode:
      return recog_124 (x1, insn, pnum_clobbers);

    case E_V64HFmode:
      return recog_123 (x1, insn, pnum_clobbers);

    case E_V128HFmode:
      return recog_122 (x1, insn, pnum_clobbers);

    case E_V256HFmode:
      return recog_121 (x1, insn, pnum_clobbers);

    case E_V512HFmode:
      return recog_120 (x1, insn, pnum_clobbers);

    case E_V1024HFmode:
      return recog_119 (x1, insn, pnum_clobbers);

    case E_V2048HFmode:
      return recog_118 (x1, insn, pnum_clobbers);

    case E_V32SFmode:
      return recog_117 (x1, insn, pnum_clobbers);

    case E_V64SFmode:
      return recog_116 (x1, insn, pnum_clobbers);

    case E_V128SFmode:
      return recog_115 (x1, insn, pnum_clobbers);

    case E_V256SFmode:
      return recog_114 (x1, insn, pnum_clobbers);

    case E_V512SFmode:
      return recog_113 (x1, insn, pnum_clobbers);

    case E_V1024SFmode:
      return recog_112 (x1, insn, pnum_clobbers);

    case E_V32DFmode:
      return recog_111 (x1, insn, pnum_clobbers);

    case E_V64DFmode:
      return recog_110 (x1, insn, pnum_clobbers);

    case E_V128DFmode:
      return recog_109 (x1, insn, pnum_clobbers);

    case E_V256DFmode:
      return recog_108 (x1, insn, pnum_clobbers);

    case E_V512DFmode:
      return recog_107 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_106 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_105 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_104 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_103 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_102 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      return recog_101 (x1, insn, pnum_clobbers);

    case E_V2048BImode:
      return recog_100 (x1, insn, pnum_clobbers);

    case E_V4096BImode:
      return recog_99 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_392 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (!vector_length_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (XVECLEN (x6, 0))
    {
    case 2:
      switch (XINT (x6, 1))
        {
        case 100:
          return recog_385 (x1, insn, pnum_clobbers);

        case 101:
          return recog_384 (x1, insn, pnum_clobbers);

        case 186:
          switch (pattern477 (x2))
            {
            case 0:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32444; /* pred_crypto_vvgmulvvrvvm8si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32504; /* pred_crypto_vvgmulvvx1rvvm8si_scalar */

            case 1:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32564; /* pred_crypto_vvgmulvvx2rvvm4si_scalar */

            case 2:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32612; /* pred_crypto_vvgmulvvx4rvvm2si_scalar */

            case 3:
              if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32648; /* pred_crypto_vvgmulvvx8rvvm1si_scalar */

            case 4:
              if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32672; /* pred_crypto_vvgmulvvx16rvvmf2si_scalar */

            case 5:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32456; /* pred_crypto_vvgmulvvrvvm4si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32516; /* pred_crypto_vvgmulvvx1rvvm4si_scalar */

            case 6:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32576; /* pred_crypto_vvgmulvvx2rvvm2si_scalar */

            case 7:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32624; /* pred_crypto_vvgmulvvx4rvvm1si_scalar */

            case 8:
              if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32660; /* pred_crypto_vvgmulvvx8rvvmf2si_scalar */

            case 9:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32468; /* pred_crypto_vvgmulvvrvvm2si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32528; /* pred_crypto_vvgmulvvx1rvvm2si_scalar */

            case 10:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32588; /* pred_crypto_vvgmulvvx2rvvm1si_scalar */

            case 11:
              if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32636; /* pred_crypto_vvgmulvvx4rvvmf2si_scalar */

            case 12:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32480; /* pred_crypto_vvgmulvvrvvm1si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32540; /* pred_crypto_vvgmulvvx1rvvm1si_scalar */

            case 13:
              if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32600; /* pred_crypto_vvgmulvvx2rvvmf2si_scalar */

            case 14:
              if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return 32492; /* pred_crypto_vvgmulvvrvvmf2si */
              if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32552; /* pred_crypto_vvgmulvvx1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 188:
          switch (pattern477 (x2))
            {
            case 0:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32445; /* pred_crypto_vvaesefvvrvvm8si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32505; /* pred_crypto_vvaesefvvx1rvvm8si_scalar */

            case 1:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32565; /* pred_crypto_vvaesefvvx2rvvm4si_scalar */

            case 2:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32613; /* pred_crypto_vvaesefvvx4rvvm2si_scalar */

            case 3:
              if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32649; /* pred_crypto_vvaesefvvx8rvvm1si_scalar */

            case 4:
              if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32673; /* pred_crypto_vvaesefvvx16rvvmf2si_scalar */

            case 5:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32457; /* pred_crypto_vvaesefvvrvvm4si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32517; /* pred_crypto_vvaesefvvx1rvvm4si_scalar */

            case 6:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32577; /* pred_crypto_vvaesefvvx2rvvm2si_scalar */

            case 7:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32625; /* pred_crypto_vvaesefvvx4rvvm1si_scalar */

            case 8:
              if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32661; /* pred_crypto_vvaesefvvx8rvvmf2si_scalar */

            case 9:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32469; /* pred_crypto_vvaesefvvrvvm2si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32529; /* pred_crypto_vvaesefvvx1rvvm2si_scalar */

            case 10:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32589; /* pred_crypto_vvaesefvvx2rvvm1si_scalar */

            case 11:
              if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32637; /* pred_crypto_vvaesefvvx4rvvmf2si_scalar */

            case 12:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32481; /* pred_crypto_vvaesefvvrvvm1si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32541; /* pred_crypto_vvaesefvvx1rvvm1si_scalar */

            case 13:
              if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32601; /* pred_crypto_vvaesefvvx2rvvmf2si_scalar */

            case 14:
              if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return 32493; /* pred_crypto_vvaesefvvrvvmf2si */
              if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32553; /* pred_crypto_vvaesefvvx1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 191:
          switch (pattern477 (x2))
            {
            case 0:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32446; /* pred_crypto_vvaesemvvrvvm8si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32506; /* pred_crypto_vvaesemvvx1rvvm8si_scalar */

            case 1:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32566; /* pred_crypto_vvaesemvvx2rvvm4si_scalar */

            case 2:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32614; /* pred_crypto_vvaesemvvx4rvvm2si_scalar */

            case 3:
              if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32650; /* pred_crypto_vvaesemvvx8rvvm1si_scalar */

            case 4:
              if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32674; /* pred_crypto_vvaesemvvx16rvvmf2si_scalar */

            case 5:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32458; /* pred_crypto_vvaesemvvrvvm4si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32518; /* pred_crypto_vvaesemvvx1rvvm4si_scalar */

            case 6:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32578; /* pred_crypto_vvaesemvvx2rvvm2si_scalar */

            case 7:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32626; /* pred_crypto_vvaesemvvx4rvvm1si_scalar */

            case 8:
              if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32662; /* pred_crypto_vvaesemvvx8rvvmf2si_scalar */

            case 9:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32470; /* pred_crypto_vvaesemvvrvvm2si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32530; /* pred_crypto_vvaesemvvx1rvvm2si_scalar */

            case 10:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32590; /* pred_crypto_vvaesemvvx2rvvm1si_scalar */

            case 11:
              if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32638; /* pred_crypto_vvaesemvvx4rvvmf2si_scalar */

            case 12:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32482; /* pred_crypto_vvaesemvvrvvm1si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32542; /* pred_crypto_vvaesemvvx1rvvm1si_scalar */

            case 13:
              if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32602; /* pred_crypto_vvaesemvvx2rvvmf2si_scalar */

            case 14:
              if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return 32494; /* pred_crypto_vvaesemvvrvvmf2si */
              if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32554; /* pred_crypto_vvaesemvvx1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 194:
          switch (pattern477 (x2))
            {
            case 0:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32447; /* pred_crypto_vvaesdfvvrvvm8si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32507; /* pred_crypto_vvaesdfvvx1rvvm8si_scalar */

            case 1:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32567; /* pred_crypto_vvaesdfvvx2rvvm4si_scalar */

            case 2:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32615; /* pred_crypto_vvaesdfvvx4rvvm2si_scalar */

            case 3:
              if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32651; /* pred_crypto_vvaesdfvvx8rvvm1si_scalar */

            case 4:
              if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32675; /* pred_crypto_vvaesdfvvx16rvvmf2si_scalar */

            case 5:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32459; /* pred_crypto_vvaesdfvvrvvm4si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32519; /* pred_crypto_vvaesdfvvx1rvvm4si_scalar */

            case 6:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32579; /* pred_crypto_vvaesdfvvx2rvvm2si_scalar */

            case 7:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32627; /* pred_crypto_vvaesdfvvx4rvvm1si_scalar */

            case 8:
              if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32663; /* pred_crypto_vvaesdfvvx8rvvmf2si_scalar */

            case 9:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32471; /* pred_crypto_vvaesdfvvrvvm2si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32531; /* pred_crypto_vvaesdfvvx1rvvm2si_scalar */

            case 10:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32591; /* pred_crypto_vvaesdfvvx2rvvm1si_scalar */

            case 11:
              if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32639; /* pred_crypto_vvaesdfvvx4rvvmf2si_scalar */

            case 12:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32483; /* pred_crypto_vvaesdfvvrvvm1si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32543; /* pred_crypto_vvaesdfvvx1rvvm1si_scalar */

            case 13:
              if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32603; /* pred_crypto_vvaesdfvvx2rvvmf2si_scalar */

            case 14:
              if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return 32495; /* pred_crypto_vvaesdfvvrvvmf2si */
              if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32555; /* pred_crypto_vvaesdfvvx1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 197:
          switch (pattern477 (x2))
            {
            case 0:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32448; /* pred_crypto_vvaesdmvvrvvm8si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32508; /* pred_crypto_vvaesdmvvx1rvvm8si_scalar */

            case 1:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32568; /* pred_crypto_vvaesdmvvx2rvvm4si_scalar */

            case 2:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32616; /* pred_crypto_vvaesdmvvx4rvvm2si_scalar */

            case 3:
              if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32652; /* pred_crypto_vvaesdmvvx8rvvm1si_scalar */

            case 4:
              if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32676; /* pred_crypto_vvaesdmvvx16rvvmf2si_scalar */

            case 5:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32460; /* pred_crypto_vvaesdmvvrvvm4si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32520; /* pred_crypto_vvaesdmvvx1rvvm4si_scalar */

            case 6:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32580; /* pred_crypto_vvaesdmvvx2rvvm2si_scalar */

            case 7:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32628; /* pred_crypto_vvaesdmvvx4rvvm1si_scalar */

            case 8:
              if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32664; /* pred_crypto_vvaesdmvvx8rvvmf2si_scalar */

            case 9:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32472; /* pred_crypto_vvaesdmvvrvvm2si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32532; /* pred_crypto_vvaesdmvvx1rvvm2si_scalar */

            case 10:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32592; /* pred_crypto_vvaesdmvvx2rvvm1si_scalar */

            case 11:
              if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32640; /* pred_crypto_vvaesdmvvx4rvvmf2si_scalar */

            case 12:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32484; /* pred_crypto_vvaesdmvvrvvm1si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32544; /* pred_crypto_vvaesdmvvx1rvvm1si_scalar */

            case 13:
              if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32604; /* pred_crypto_vvaesdmvvx2rvvmf2si_scalar */

            case 14:
              if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return 32496; /* pred_crypto_vvaesdmvvrvvmf2si */
              if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32556; /* pred_crypto_vvaesdmvvx1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 189:
          switch (pattern477 (x2))
            {
            case 0:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32449; /* pred_crypto_vvaesefvsrvvm8si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32509; /* pred_crypto_vvaesefvsx1rvvm8si_scalar */

            case 1:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32569; /* pred_crypto_vvaesefvsx2rvvm4si_scalar */

            case 2:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32617; /* pred_crypto_vvaesefvsx4rvvm2si_scalar */

            case 3:
              if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32653; /* pred_crypto_vvaesefvsx8rvvm1si_scalar */

            case 4:
              if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32677; /* pred_crypto_vvaesefvsx16rvvmf2si_scalar */

            case 5:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32461; /* pred_crypto_vvaesefvsrvvm4si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32521; /* pred_crypto_vvaesefvsx1rvvm4si_scalar */

            case 6:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32581; /* pred_crypto_vvaesefvsx2rvvm2si_scalar */

            case 7:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32629; /* pred_crypto_vvaesefvsx4rvvm1si_scalar */

            case 8:
              if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32665; /* pred_crypto_vvaesefvsx8rvvmf2si_scalar */

            case 9:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32473; /* pred_crypto_vvaesefvsrvvm2si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32533; /* pred_crypto_vvaesefvsx1rvvm2si_scalar */

            case 10:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32593; /* pred_crypto_vvaesefvsx2rvvm1si_scalar */

            case 11:
              if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32641; /* pred_crypto_vvaesefvsx4rvvmf2si_scalar */

            case 12:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32485; /* pred_crypto_vvaesefvsrvvm1si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32545; /* pred_crypto_vvaesefvsx1rvvm1si_scalar */

            case 13:
              if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32605; /* pred_crypto_vvaesefvsx2rvvmf2si_scalar */

            case 14:
              if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return 32497; /* pred_crypto_vvaesefvsrvvmf2si */
              if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32557; /* pred_crypto_vvaesefvsx1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 192:
          switch (pattern477 (x2))
            {
            case 0:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32450; /* pred_crypto_vvaesemvsrvvm8si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32510; /* pred_crypto_vvaesemvsx1rvvm8si_scalar */

            case 1:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32570; /* pred_crypto_vvaesemvsx2rvvm4si_scalar */

            case 2:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32618; /* pred_crypto_vvaesemvsx4rvvm2si_scalar */

            case 3:
              if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32654; /* pred_crypto_vvaesemvsx8rvvm1si_scalar */

            case 4:
              if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32678; /* pred_crypto_vvaesemvsx16rvvmf2si_scalar */

            case 5:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32462; /* pred_crypto_vvaesemvsrvvm4si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32522; /* pred_crypto_vvaesemvsx1rvvm4si_scalar */

            case 6:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32582; /* pred_crypto_vvaesemvsx2rvvm2si_scalar */

            case 7:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32630; /* pred_crypto_vvaesemvsx4rvvm1si_scalar */

            case 8:
              if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32666; /* pred_crypto_vvaesemvsx8rvvmf2si_scalar */

            case 9:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32474; /* pred_crypto_vvaesemvsrvvm2si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32534; /* pred_crypto_vvaesemvsx1rvvm2si_scalar */

            case 10:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32594; /* pred_crypto_vvaesemvsx2rvvm1si_scalar */

            case 11:
              if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32642; /* pred_crypto_vvaesemvsx4rvvmf2si_scalar */

            case 12:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32486; /* pred_crypto_vvaesemvsrvvm1si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32546; /* pred_crypto_vvaesemvsx1rvvm1si_scalar */

            case 13:
              if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32606; /* pred_crypto_vvaesemvsx2rvvmf2si_scalar */

            case 14:
              if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return 32498; /* pred_crypto_vvaesemvsrvvmf2si */
              if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32558; /* pred_crypto_vvaesemvsx1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 195:
          switch (pattern477 (x2))
            {
            case 0:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32451; /* pred_crypto_vvaesdfvsrvvm8si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32511; /* pred_crypto_vvaesdfvsx1rvvm8si_scalar */

            case 1:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32571; /* pred_crypto_vvaesdfvsx2rvvm4si_scalar */

            case 2:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32619; /* pred_crypto_vvaesdfvsx4rvvm2si_scalar */

            case 3:
              if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32655; /* pred_crypto_vvaesdfvsx8rvvm1si_scalar */

            case 4:
              if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32679; /* pred_crypto_vvaesdfvsx16rvvmf2si_scalar */

            case 5:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32463; /* pred_crypto_vvaesdfvsrvvm4si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32523; /* pred_crypto_vvaesdfvsx1rvvm4si_scalar */

            case 6:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32583; /* pred_crypto_vvaesdfvsx2rvvm2si_scalar */

            case 7:
              if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32631; /* pred_crypto_vvaesdfvsx4rvvm1si_scalar */

            case 8:
              if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32667; /* pred_crypto_vvaesdfvsx8rvvmf2si_scalar */

            case 9:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32475; /* pred_crypto_vvaesdfvsrvvm2si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32535; /* pred_crypto_vvaesdfvsx1rvvm2si_scalar */

            case 10:
              if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32595; /* pred_crypto_vvaesdfvsx2rvvm1si_scalar */

            case 11:
              if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32643; /* pred_crypto_vvaesdfvsx4rvvmf2si_scalar */

            case 12:
              if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
                return 32487; /* pred_crypto_vvaesdfvsrvvm1si */
              if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32547; /* pred_crypto_vvaesdfvsx1rvvm1si_scalar */

            case 13:
              if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32607; /* pred_crypto_vvaesdfvsx2rvvmf2si_scalar */

            case 14:
              if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return 32499; /* pred_crypto_vvaesdfvsrvvmf2si */
              if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32559; /* pred_crypto_vvaesdfvsx1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 198:
          return recog_389 (x1, insn, pnum_clobbers);

        case 201:
          return recog_388 (x1, insn, pnum_clobbers);

        case 209:
          return recog_387 (x1, insn, pnum_clobbers);

        case 210:
          return recog_386 (x1, insn, pnum_clobbers);

        case 202:
          switch (pattern479 (x2))
            {
            case 0:
              if (!
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32684; /* pred_crypto_viaeskf1rvvm8si_scalar */

            case 1:
              if (!
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32686; /* pred_crypto_viaeskf1rvvm4si_scalar */

            case 2:
              if (!
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32688; /* pred_crypto_viaeskf1rvvm2si_scalar */

            case 3:
              if (!
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32690; /* pred_crypto_viaeskf1rvvm1si_scalar */

            case 4:
              if (!(
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32692; /* pred_crypto_viaeskf1rvvmf2si_scalar */

            default:
              return -1;
            }

        case 207:
          switch (pattern479 (x2))
            {
            case 0:
              if (!
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32685; /* pred_crypto_vism4krvvm8si_scalar */

            case 1:
              if (!
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32687; /* pred_crypto_vism4krvvm4si_scalar */

            case 2:
              if (!
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32689; /* pred_crypto_vism4krvvm2si_scalar */

            case 3:
              if (!
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
                return -1;
              return 32691; /* pred_crypto_vism4krvvm1si_scalar */

            case 4:
              if (!(
#line 611 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32693; /* pred_crypto_vism4krvvmf2si_scalar */

            default:
              return -1;
            }

        case 211:
          operands[4] = x4;
          operands[5] = x5;
          x7 = XVECEXP (x3, 0, 2);
          operands[6] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[2] = x8;
          x9 = XVECEXP (x6, 0, 1);
          operands[3] = x9;
          x10 = XEXP (x2, 2);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SImode:
              if (pattern595 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
                  || !
#line 651 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKSH))
                return -1;
              return 32704; /* pred_vsm3mervvm8si */

            case E_RVVM4SImode:
              if (pattern595 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
                  || !
#line 651 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKSH))
                return -1;
              return 32705; /* pred_vsm3mervvm4si */

            case E_RVVM2SImode:
              if (pattern595 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
                  || !
#line 651 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKSH))
                return -1;
              return 32706; /* pred_vsm3mervvm2si */

            case E_RVVM1SImode:
              if (pattern595 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
                  || !
#line 651 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKSH))
                return -1;
              return 32707; /* pred_vsm3mervvm1si */

            case E_RVVMF2SImode:
              if (pattern595 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 651 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKSH) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 32708; /* pred_vsm3mervvmf2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      return recog_391 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_438 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8DImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 4298; /* *pred_broadcastv8di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8DImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4420; /* *pred_broadcastv8di_imm */
}

 int
recog_443 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512SImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 4293; /* *pred_broadcastv512si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512SImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4415; /* *pred_broadcastv512si_imm */
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16SImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 4288; /* *pred_broadcastv16si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16SImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4410; /* *pred_broadcastv16si_imm */
}

 int
recog_456 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256HImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 4280; /* *pred_broadcastv256hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256HImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4402; /* *pred_broadcastv256hi_imm */
}

 int
recog_463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2HImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 4273; /* *pred_broadcastv2hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2HImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 4395; /* *pred_broadcastv2hi_imm */
}

 int
recog_471 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64QImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 4265; /* *pred_broadcastv64qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64QImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4387; /* *pred_broadcastv64qi_imm */
}

 int
recog_480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
      && vector_const_0_operand (operands[3], E_RVVM4DFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4256; /* *pred_broadcastrvvm4df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4DFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4378; /* *pred_broadcastrvvm4df_imm */
}

 int
recog_488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVMF2HFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4248; /* *pred_broadcastrvvmf2hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2HFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4370; /* *pred_broadcastrvvmf2hf_imm */
}

 int
recog_495 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern665 (x2))
    {
    case 0:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4704; /* pred_indexed_oloadrvvm8qi_same_eew */

    case 1:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4706; /* pred_indexed_oloadrvvm4qi_same_eew */

    case 2:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5072; /* pred_indexed_oloadrvvm4qi_x2_smaller_eew */

    case 3:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4708; /* pred_indexed_oloadrvvm2qi_same_eew */

    case 4:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5074; /* pred_indexed_oloadrvvm2qi_x2_smaller_eew */

    case 5:
      if (!
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5130; /* pred_indexed_oloadrvvm2qi_x4_smaller_eew */

    case 6:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4710; /* pred_indexed_oloadrvvm1qi_same_eew */

    case 7:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5076; /* pred_indexed_oloadrvvm1qi_x2_smaller_eew */

    case 8:
      if (!
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5132; /* pred_indexed_oloadrvvm1qi_x4_smaller_eew */

    case 9:
      if (!(
#line 2570 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 381 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5164; /* pred_indexed_oloadrvvm1qi_x8_smaller_eew */

    case 10:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4712; /* pred_indexed_oloadrvvmf2qi_same_eew */

    case 11:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5078; /* pred_indexed_oloadrvvmf2qi_x2_smaller_eew */

    case 12:
      if (!
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5134; /* pred_indexed_oloadrvvmf2qi_x4_smaller_eew */

    case 13:
      if (!(
#line 2570 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 382 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5166; /* pred_indexed_oloadrvvmf2qi_x8_smaller_eew */

    case 14:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4714; /* pred_indexed_oloadrvvmf4qi_same_eew */

    case 15:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5080; /* pred_indexed_oloadrvvmf4qi_x2_smaller_eew */

    case 16:
      if (!
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5136; /* pred_indexed_oloadrvvmf4qi_x4_smaller_eew */

    case 17:
      if (!(
#line 2570 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 383 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5168; /* pred_indexed_oloadrvvmf4qi_x8_smaller_eew */

    case 18:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4716; /* pred_indexed_oloadrvvmf8qi_same_eew */

    case 19:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 338 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5082; /* pred_indexed_oloadrvvmf8qi_x2_smaller_eew */

    case 20:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 362 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5138; /* pred_indexed_oloadrvvmf8qi_x4_smaller_eew */

    case 21:
      if (!(
#line 2570 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 384 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5170; /* pred_indexed_oloadrvvmf8qi_x8_smaller_eew */

    case 22:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4718; /* pred_indexed_oloadrvvm8hi_same_eew */

    case 23:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4948; /* pred_indexed_oloadrvvm8hi_x2_greater_eew */

    case 24:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4720; /* pred_indexed_oloadrvvm4hi_same_eew */

    case 25:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4950; /* pred_indexed_oloadrvvm4hi_x2_greater_eew */

    case 26:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5084; /* pred_indexed_oloadrvvm4hi_x2_smaller_eew */

    case 27:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4722; /* pred_indexed_oloadrvvm2hi_same_eew */

    case 28:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4952; /* pred_indexed_oloadrvvm2hi_x2_greater_eew */

    case 29:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5086; /* pred_indexed_oloadrvvm2hi_x2_smaller_eew */

    case 30:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 364 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5140; /* pred_indexed_oloadrvvm2hi_x4_smaller_eew */

    case 31:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4724; /* pred_indexed_oloadrvvm1hi_same_eew */

    case 32:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4954; /* pred_indexed_oloadrvvm1hi_x2_greater_eew */

    case 33:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5088; /* pred_indexed_oloadrvvm1hi_x2_smaller_eew */

    case 34:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 365 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5142; /* pred_indexed_oloadrvvm1hi_x4_smaller_eew */

    case 35:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4726; /* pred_indexed_oloadrvvmf2hi_same_eew */

    case 36:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4956; /* pred_indexed_oloadrvvmf2hi_x2_greater_eew */

    case 37:
      if (!
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5090; /* pred_indexed_oloadrvvmf2hi_x2_smaller_eew */

    case 38:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 366 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5144; /* pred_indexed_oloadrvvmf2hi_x4_smaller_eew */

    case 39:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4728; /* pred_indexed_oloadrvvmf4hi_same_eew */

    case 40:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4958; /* pred_indexed_oloadrvvmf4hi_x2_greater_eew */

    case 41:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5092; /* pred_indexed_oloadrvvmf4hi_x2_smaller_eew */

    case 42:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 367 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5146; /* pred_indexed_oloadrvvmf4hi_x4_smaller_eew */

    case 43:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4730; /* pred_indexed_oloadrvvm8si_same_eew */

    case 44:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4984; /* pred_indexed_oloadrvvm8si_x2_greater_eew */

    case 45:
      if (!
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5020; /* pred_indexed_oloadrvvm8si_x4_greater_eew */

    case 46:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4732; /* pred_indexed_oloadrvvm4si_same_eew */

    case 47:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4986; /* pred_indexed_oloadrvvm4si_x2_greater_eew */

    case 48:
      if (!
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5022; /* pred_indexed_oloadrvvm4si_x4_greater_eew */

    case 49:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 350 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5114; /* pred_indexed_oloadrvvm4si_x2_smaller_eew */

    case 50:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4734; /* pred_indexed_oloadrvvm2si_same_eew */

    case 51:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4988; /* pred_indexed_oloadrvvm2si_x2_greater_eew */

    case 52:
      if (!
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5024; /* pred_indexed_oloadrvvm2si_x4_greater_eew */

    case 53:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 351 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5116; /* pred_indexed_oloadrvvm2si_x2_smaller_eew */

    case 54:
      if (!
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4736; /* pred_indexed_oloadrvvm1si_same_eew */

    case 55:
      if (!
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4990; /* pred_indexed_oloadrvvm1si_x2_greater_eew */

    case 56:
      if (!
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5026; /* pred_indexed_oloadrvvm1si_x4_greater_eew */

    case 57:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5118; /* pred_indexed_oloadrvvm1si_x2_smaller_eew */

    case 58:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1532 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4738; /* pred_indexed_oloadrvvmf2si_same_eew */

    case 59:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4992; /* pred_indexed_oloadrvvmf2si_x2_greater_eew */

    case 60:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5028; /* pred_indexed_oloadrvvmf2si_x4_greater_eew */

    case 61:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 353 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5120; /* pred_indexed_oloadrvvmf2si_x2_smaller_eew */

    case 62:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1534 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4740; /* pred_indexed_oloadrvvm8di_same_eew */

    case 63:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5004; /* pred_indexed_oloadrvvm8di_x2_greater_eew */

    case 64:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 322 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5040; /* pred_indexed_oloadrvvm8di_x4_greater_eew */

    case 65:
      if (!(
#line 2506 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5056; /* pred_indexed_oloadrvvm8di_x8_greater_eew */

    case 66:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1535 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4742; /* pred_indexed_oloadrvvm4di_same_eew */

    case 67:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5006; /* pred_indexed_oloadrvvm4di_x2_greater_eew */

    case 68:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 322 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5042; /* pred_indexed_oloadrvvm4di_x4_greater_eew */

    case 69:
      if (!(
#line 2506 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5058; /* pred_indexed_oloadrvvm4di_x8_greater_eew */

    case 70:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1536 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4744; /* pred_indexed_oloadrvvm2di_same_eew */

    case 71:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5008; /* pred_indexed_oloadrvvm2di_x2_greater_eew */

    case 72:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5044; /* pred_indexed_oloadrvvm2di_x4_greater_eew */

    case 73:
      if (!(
#line 2506 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5060; /* pred_indexed_oloadrvvm2di_x8_greater_eew */

    case 74:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1537 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4746; /* pred_indexed_oloadrvvm1di_same_eew */

    case 75:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5010; /* pred_indexed_oloadrvvm1di_x2_greater_eew */

    case 76:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5046; /* pred_indexed_oloadrvvm1di_x4_greater_eew */

    case 77:
      if (!(
#line 2506 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5062; /* pred_indexed_oloadrvvm1di_x8_greater_eew */

    case 78:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1539 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4748; /* pred_indexed_oloadrvvm8bf_same_eew */

    case 79:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4960; /* pred_indexed_oloadrvvm8bf_x2_greater_eew */

    case 80:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1540 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4750; /* pred_indexed_oloadrvvm4bf_same_eew */

    case 81:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4962; /* pred_indexed_oloadrvvm4bf_x2_greater_eew */

    case 82:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5094; /* pred_indexed_oloadrvvm4bf_x2_smaller_eew */

    case 83:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1541 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4752; /* pred_indexed_oloadrvvm2bf_same_eew */

    case 84:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4964; /* pred_indexed_oloadrvvm2bf_x2_greater_eew */

    case 85:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5096; /* pred_indexed_oloadrvvm2bf_x2_smaller_eew */

    case 86:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 369 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5148; /* pred_indexed_oloadrvvm2bf_x4_smaller_eew */

    case 87:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1542 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4754; /* pred_indexed_oloadrvvm1bf_same_eew */

    case 88:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4966; /* pred_indexed_oloadrvvm1bf_x2_greater_eew */

    case 89:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 343 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5098; /* pred_indexed_oloadrvvm1bf_x2_smaller_eew */

    case 90:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 370 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5150; /* pred_indexed_oloadrvvm1bf_x4_smaller_eew */

    case 91:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1543 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4756; /* pred_indexed_oloadrvvmf2bf_same_eew */

    case 92:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4968; /* pred_indexed_oloadrvvmf2bf_x2_greater_eew */

    case 93:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 343 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5100; /* pred_indexed_oloadrvvmf2bf_x2_smaller_eew */

    case 94:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 371 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5152; /* pred_indexed_oloadrvvmf2bf_x4_smaller_eew */

    case 95:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1544 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4758; /* pred_indexed_oloadrvvmf4bf_same_eew */

    case 96:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4970; /* pred_indexed_oloadrvvmf4bf_x2_greater_eew */

    case 97:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5102; /* pred_indexed_oloadrvvmf4bf_x2_smaller_eew */

    case 98:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 372 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5154; /* pred_indexed_oloadrvvmf4bf_x4_smaller_eew */

    case 99:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4760; /* pred_indexed_oloadrvvm8hf_same_eew */

    case 100:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4972; /* pred_indexed_oloadrvvm8hf_x2_greater_eew */

    case 101:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4762; /* pred_indexed_oloadrvvm4hf_same_eew */

    case 102:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4974; /* pred_indexed_oloadrvvm4hf_x2_greater_eew */

    case 103:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 346 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5104; /* pred_indexed_oloadrvvm4hf_x2_smaller_eew */

    case 104:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4764; /* pred_indexed_oloadrvvm2hf_same_eew */

    case 105:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4976; /* pred_indexed_oloadrvvm2hf_x2_greater_eew */

    case 106:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 346 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5106; /* pred_indexed_oloadrvvm2hf_x2_smaller_eew */

    case 107:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 374 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5156; /* pred_indexed_oloadrvvm2hf_x4_smaller_eew */

    case 108:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1547 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4766; /* pred_indexed_oloadrvvm1hf_same_eew */

    case 109:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4978; /* pred_indexed_oloadrvvm1hf_x2_greater_eew */

    case 110:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5108; /* pred_indexed_oloadrvvm1hf_x2_smaller_eew */

    case 111:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 375 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5158; /* pred_indexed_oloadrvvm1hf_x4_smaller_eew */

    case 112:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1547 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4768; /* pred_indexed_oloadrvvmf2hf_same_eew */

    case 113:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4980; /* pred_indexed_oloadrvvmf2hf_x2_greater_eew */

    case 114:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5110; /* pred_indexed_oloadrvvmf2hf_x2_smaller_eew */

    case 115:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 376 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5160; /* pred_indexed_oloadrvvmf2hf_x4_smaller_eew */

    case 116:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1548 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4770; /* pred_indexed_oloadrvvmf4hf_same_eew */

    case 117:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4982; /* pred_indexed_oloadrvvmf4hf_x2_greater_eew */

    case 118:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5112; /* pred_indexed_oloadrvvmf4hf_x2_smaller_eew */

    case 119:
      if (!(
#line 2549 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 377 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5162; /* pred_indexed_oloadrvvmf4hf_x4_smaller_eew */

    case 120:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1550 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4772; /* pred_indexed_oloadrvvm8sf_same_eew */

    case 121:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4994; /* pred_indexed_oloadrvvm8sf_x2_greater_eew */

    case 122:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5030; /* pred_indexed_oloadrvvm8sf_x4_greater_eew */

    case 123:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1550 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4774; /* pred_indexed_oloadrvvm4sf_same_eew */

    case 124:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4996; /* pred_indexed_oloadrvvm4sf_x2_greater_eew */

    case 125:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5032; /* pred_indexed_oloadrvvm4sf_x4_greater_eew */

    case 126:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 355 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5122; /* pred_indexed_oloadrvvm4sf_x2_smaller_eew */

    case 127:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1551 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4776; /* pred_indexed_oloadrvvm2sf_same_eew */

    case 128:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4998; /* pred_indexed_oloadrvvm2sf_x2_greater_eew */

    case 129:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5034; /* pred_indexed_oloadrvvm2sf_x4_greater_eew */

    case 130:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5124; /* pred_indexed_oloadrvvm2sf_x2_smaller_eew */

    case 131:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1551 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4778; /* pred_indexed_oloadrvvm1sf_same_eew */

    case 132:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5000; /* pred_indexed_oloadrvvm1sf_x2_greater_eew */

    case 133:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5036; /* pred_indexed_oloadrvvm1sf_x4_greater_eew */

    case 134:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5126; /* pred_indexed_oloadrvvm1sf_x2_smaller_eew */

    case 135:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1552 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4780; /* pred_indexed_oloadrvvmf2sf_same_eew */

    case 136:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5002; /* pred_indexed_oloadrvvmf2sf_x2_greater_eew */

    case 137:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5038; /* pred_indexed_oloadrvvmf2sf_x4_greater_eew */

    case 138:
      if (!(
#line 2528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 358 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5128; /* pred_indexed_oloadrvvmf2sf_x2_smaller_eew */

    case 139:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1554 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4782; /* pred_indexed_oloadrvvm8df_same_eew */

    case 140:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 312 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5012; /* pred_indexed_oloadrvvm8df_x2_greater_eew */

    case 141:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 325 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5048; /* pred_indexed_oloadrvvm8df_x4_greater_eew */

    case 142:
      if (!(
#line 2506 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5064; /* pred_indexed_oloadrvvm8df_x8_greater_eew */

    case 143:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1555 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4784; /* pred_indexed_oloadrvvm4df_same_eew */

    case 144:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 312 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5014; /* pred_indexed_oloadrvvm4df_x2_greater_eew */

    case 145:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 325 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5050; /* pred_indexed_oloadrvvm4df_x4_greater_eew */

    case 146:
      if (!(
#line 2506 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5066; /* pred_indexed_oloadrvvm4df_x8_greater_eew */

    case 147:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1556 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4786; /* pred_indexed_oloadrvvm2df_same_eew */

    case 148:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5016; /* pred_indexed_oloadrvvm2df_x2_greater_eew */

    case 149:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5052; /* pred_indexed_oloadrvvm2df_x4_greater_eew */

    case 150:
      if (!(
#line 2506 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5068; /* pred_indexed_oloadrvvm2df_x8_greater_eew */

    case 151:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1557 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4788; /* pred_indexed_oloadrvvm1df_same_eew */

    case 152:
      if (!(
#line 2464 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5018; /* pred_indexed_oloadrvvm1df_x2_greater_eew */

    case 153:
      if (!(
#line 2485 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5054; /* pred_indexed_oloadrvvm1df_x4_greater_eew */

    case 154:
      if (!(
#line 2506 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5070; /* pred_indexed_oloadrvvm1df_x8_greater_eew */

    case 155:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1559 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4790; /* pred_indexed_oloadv1qi_same_eew */

    case 156:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4792; /* pred_indexed_oloadv2qi_same_eew */

    case 157:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4794; /* pred_indexed_oloadv4qi_same_eew */

    case 158:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1562 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4796; /* pred_indexed_oloadv8qi_same_eew */

    case 159:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1563 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4798; /* pred_indexed_oloadv16qi_same_eew */

    case 160:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4800; /* pred_indexed_oloadv32qi_same_eew */

    case 161:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4802; /* pred_indexed_oloadv64qi_same_eew */

    case 162:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1566 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4804; /* pred_indexed_oloadv128qi_same_eew */

    case 163:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1567 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4806; /* pred_indexed_oloadv256qi_same_eew */

    case 164:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1568 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4808; /* pred_indexed_oloadv512qi_same_eew */

    case 165:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1569 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4810; /* pred_indexed_oloadv1024qi_same_eew */

    case 166:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1570 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4812; /* pred_indexed_oloadv2048qi_same_eew */

    case 167:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4814; /* pred_indexed_oloadv4096qi_same_eew */

    case 168:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4816; /* pred_indexed_oloadv1hi_same_eew */

    case 169:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4818; /* pred_indexed_oloadv2hi_same_eew */

    case 170:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4820; /* pred_indexed_oloadv4hi_same_eew */

    case 171:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4822; /* pred_indexed_oloadv8hi_same_eew */

    case 172:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4824; /* pred_indexed_oloadv16hi_same_eew */

    case 173:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4826; /* pred_indexed_oloadv32hi_same_eew */

    case 174:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4828; /* pred_indexed_oloadv64hi_same_eew */

    case 175:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4830; /* pred_indexed_oloadv128hi_same_eew */

    case 176:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4832; /* pred_indexed_oloadv256hi_same_eew */

    case 177:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4834; /* pred_indexed_oloadv512hi_same_eew */

    case 178:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4836; /* pred_indexed_oloadv1024hi_same_eew */

    case 179:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4838; /* pred_indexed_oloadv2048hi_same_eew */

    case 180:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4840; /* pred_indexed_oloadv1si_same_eew */

    case 181:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4842; /* pred_indexed_oloadv2si_same_eew */

    case 182:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4844; /* pred_indexed_oloadv4si_same_eew */

    case 183:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4846; /* pred_indexed_oloadv8si_same_eew */

    case 184:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4848; /* pred_indexed_oloadv16si_same_eew */

    case 185:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4850; /* pred_indexed_oloadv32si_same_eew */

    case 186:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4852; /* pred_indexed_oloadv64si_same_eew */

    case 187:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4854; /* pred_indexed_oloadv128si_same_eew */

    case 188:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4856; /* pred_indexed_oloadv256si_same_eew */

    case 189:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1593 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4858; /* pred_indexed_oloadv512si_same_eew */

    case 190:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1594 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4860; /* pred_indexed_oloadv1024si_same_eew */

    case 191:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1595 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4862; /* pred_indexed_oloadv1di_same_eew */

    case 192:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1596 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4864; /* pred_indexed_oloadv2di_same_eew */

    case 193:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1597 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4866; /* pred_indexed_oloadv4di_same_eew */

    case 194:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1598 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4868; /* pred_indexed_oloadv8di_same_eew */

    case 195:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1599 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4870; /* pred_indexed_oloadv16di_same_eew */

    case 196:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1600 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4872; /* pred_indexed_oloadv32di_same_eew */

    case 197:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1601 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4874; /* pred_indexed_oloadv64di_same_eew */

    case 198:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1602 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4876; /* pred_indexed_oloadv128di_same_eew */

    case 199:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1603 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4878; /* pred_indexed_oloadv256di_same_eew */

    case 200:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1604 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4880; /* pred_indexed_oloadv512di_same_eew */

    case 201:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1606 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 4882; /* pred_indexed_oloadv1hf_same_eew */

    case 202:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1607 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 4884; /* pred_indexed_oloadv2hf_same_eew */

    case 203:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1608 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 4886; /* pred_indexed_oloadv4hf_same_eew */

    case 204:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1609 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 4888; /* pred_indexed_oloadv8hf_same_eew */

    case 205:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1610 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 4890; /* pred_indexed_oloadv16hf_same_eew */

    case 206:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1611 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4892; /* pred_indexed_oloadv32hf_same_eew */

    case 207:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1612 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4894; /* pred_indexed_oloadv64hf_same_eew */

    case 208:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1613 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4896; /* pred_indexed_oloadv128hf_same_eew */

    case 209:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1614 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4898; /* pred_indexed_oloadv256hf_same_eew */

    case 210:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1615 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4900; /* pred_indexed_oloadv512hf_same_eew */

    case 211:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1616 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4902; /* pred_indexed_oloadv1024hf_same_eew */

    case 212:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1617 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4904; /* pred_indexed_oloadv2048hf_same_eew */

    case 213:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1618 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4906; /* pred_indexed_oloadv1sf_same_eew */

    case 214:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1619 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4908; /* pred_indexed_oloadv2sf_same_eew */

    case 215:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1620 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4910; /* pred_indexed_oloadv4sf_same_eew */

    case 216:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1621 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4912; /* pred_indexed_oloadv8sf_same_eew */

    case 217:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1622 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4914; /* pred_indexed_oloadv16sf_same_eew */

    case 218:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1623 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4916; /* pred_indexed_oloadv32sf_same_eew */

    case 219:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1624 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4918; /* pred_indexed_oloadv64sf_same_eew */

    case 220:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1625 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4920; /* pred_indexed_oloadv128sf_same_eew */

    case 221:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1626 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4922; /* pred_indexed_oloadv256sf_same_eew */

    case 222:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1627 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4924; /* pred_indexed_oloadv512sf_same_eew */

    case 223:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1628 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4926; /* pred_indexed_oloadv1024sf_same_eew */

    case 224:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1629 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4928; /* pred_indexed_oloadv1df_same_eew */

    case 225:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1630 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4930; /* pred_indexed_oloadv2df_same_eew */

    case 226:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1631 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4932; /* pred_indexed_oloadv4df_same_eew */

    case 227:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1632 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4934; /* pred_indexed_oloadv8df_same_eew */

    case 228:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1633 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4936; /* pred_indexed_oloadv16df_same_eew */

    case 229:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1634 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4938; /* pred_indexed_oloadv32df_same_eew */

    case 230:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1635 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4940; /* pred_indexed_oloadv64df_same_eew */

    case 231:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1636 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4942; /* pred_indexed_oloadv128df_same_eew */

    case 232:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1637 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4944; /* pred_indexed_oloadv256df_same_eew */

    case 233:
      if (!(
#line 2442 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1638 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4946; /* pred_indexed_oloadv512df_same_eew */

    case 234:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21006; /* pred_indexed_oloadrvvmf8x2qirvvmf8qi */

    case 235:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21008; /* pred_indexed_oloadrvvmf8x2qirvvmf4hi */

    case 236:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21010; /* pred_indexed_oloadrvvmf8x2qirvvmf2si */

    case 237:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21012; /* pred_indexed_oloadrvvmf8x2qirvvm1di */

    case 238:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21014; /* pred_indexed_oloadrvvmf8x3qirvvmf8qi */

    case 239:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21016; /* pred_indexed_oloadrvvmf8x3qirvvmf4hi */

    case 240:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21018; /* pred_indexed_oloadrvvmf8x3qirvvmf2si */

    case 241:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21020; /* pred_indexed_oloadrvvmf8x3qirvvm1di */

    case 242:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21022; /* pred_indexed_oloadrvvmf8x4qirvvmf8qi */

    case 243:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21024; /* pred_indexed_oloadrvvmf8x4qirvvmf4hi */

    case 244:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21026; /* pred_indexed_oloadrvvmf8x4qirvvmf2si */

    case 245:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21028; /* pred_indexed_oloadrvvmf8x4qirvvm1di */

    case 246:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21030; /* pred_indexed_oloadrvvmf8x5qirvvmf8qi */

    case 247:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21032; /* pred_indexed_oloadrvvmf8x5qirvvmf4hi */

    case 248:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21034; /* pred_indexed_oloadrvvmf8x5qirvvmf2si */

    case 249:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21036; /* pred_indexed_oloadrvvmf8x5qirvvm1di */

    case 250:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21038; /* pred_indexed_oloadrvvmf8x6qirvvmf8qi */

    case 251:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21040; /* pred_indexed_oloadrvvmf8x6qirvvmf4hi */

    case 252:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21042; /* pred_indexed_oloadrvvmf8x6qirvvmf2si */

    case 253:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21044; /* pred_indexed_oloadrvvmf8x6qirvvm1di */

    case 254:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21046; /* pred_indexed_oloadrvvmf8x7qirvvmf8qi */

    case 255:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21048; /* pred_indexed_oloadrvvmf8x7qirvvmf4hi */

    case 256:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21050; /* pred_indexed_oloadrvvmf8x7qirvvmf2si */

    case 257:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21052; /* pred_indexed_oloadrvvmf8x7qirvvm1di */

    case 258:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21054; /* pred_indexed_oloadrvvmf8x8qirvvmf8qi */

    case 259:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21056; /* pred_indexed_oloadrvvmf8x8qirvvmf4hi */

    case 260:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21058; /* pred_indexed_oloadrvvmf8x8qirvvmf2si */

    case 261:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21060; /* pred_indexed_oloadrvvmf8x8qirvvm1di */

    case 262:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21062; /* pred_indexed_oloadrvvmf4x2hirvvmf8qi */

    case 263:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21064; /* pred_indexed_oloadrvvmf4x2hirvvmf4hi */

    case 264:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21066; /* pred_indexed_oloadrvvmf4x2hirvvmf2si */

    case 265:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21068; /* pred_indexed_oloadrvvmf4x2hirvvm1di */

    case 266:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21070; /* pred_indexed_oloadrvvmf4x3hirvvmf8qi */

    case 267:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21072; /* pred_indexed_oloadrvvmf4x3hirvvmf4hi */

    case 268:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21074; /* pred_indexed_oloadrvvmf4x3hirvvmf2si */

    case 269:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21076; /* pred_indexed_oloadrvvmf4x3hirvvm1di */

    case 270:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21078; /* pred_indexed_oloadrvvmf4x4hirvvmf8qi */

    case 271:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21080; /* pred_indexed_oloadrvvmf4x4hirvvmf4hi */

    case 272:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21082; /* pred_indexed_oloadrvvmf4x4hirvvmf2si */

    case 273:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21084; /* pred_indexed_oloadrvvmf4x4hirvvm1di */

    case 274:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21086; /* pred_indexed_oloadrvvmf4x5hirvvmf8qi */

    case 275:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21088; /* pred_indexed_oloadrvvmf4x5hirvvmf4hi */

    case 276:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21090; /* pred_indexed_oloadrvvmf4x5hirvvmf2si */

    case 277:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21092; /* pred_indexed_oloadrvvmf4x5hirvvm1di */

    case 278:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21094; /* pred_indexed_oloadrvvmf4x6hirvvmf8qi */

    case 279:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21096; /* pred_indexed_oloadrvvmf4x6hirvvmf4hi */

    case 280:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21098; /* pred_indexed_oloadrvvmf4x6hirvvmf2si */

    case 281:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21100; /* pred_indexed_oloadrvvmf4x6hirvvm1di */

    case 282:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21102; /* pred_indexed_oloadrvvmf4x7hirvvmf8qi */

    case 283:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21104; /* pred_indexed_oloadrvvmf4x7hirvvmf4hi */

    case 284:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21106; /* pred_indexed_oloadrvvmf4x7hirvvmf2si */

    case 285:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21108; /* pred_indexed_oloadrvvmf4x7hirvvm1di */

    case 286:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21110; /* pred_indexed_oloadrvvmf4x8hirvvmf8qi */

    case 287:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21112; /* pred_indexed_oloadrvvmf4x8hirvvmf4hi */

    case 288:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21114; /* pred_indexed_oloadrvvmf4x8hirvvmf2si */

    case 289:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21116; /* pred_indexed_oloadrvvmf4x8hirvvm1di */

    case 290:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21118; /* pred_indexed_oloadrvvmf2x2sirvvmf8qi */

    case 291:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21120; /* pred_indexed_oloadrvvmf2x2sirvvmf4hi */

    case 292:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21122; /* pred_indexed_oloadrvvmf2x2sirvvmf2si */

    case 293:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21124; /* pred_indexed_oloadrvvmf2x2sirvvm1di */

    case 294:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21126; /* pred_indexed_oloadrvvmf2x3sirvvmf8qi */

    case 295:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21128; /* pred_indexed_oloadrvvmf2x3sirvvmf4hi */

    case 296:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21130; /* pred_indexed_oloadrvvmf2x3sirvvmf2si */

    case 297:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21132; /* pred_indexed_oloadrvvmf2x3sirvvm1di */

    case 298:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21134; /* pred_indexed_oloadrvvmf2x4sirvvmf8qi */

    case 299:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21136; /* pred_indexed_oloadrvvmf2x4sirvvmf4hi */

    case 300:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21138; /* pred_indexed_oloadrvvmf2x4sirvvmf2si */

    case 301:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21140; /* pred_indexed_oloadrvvmf2x4sirvvm1di */

    case 302:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21142; /* pred_indexed_oloadrvvmf2x5sirvvmf8qi */

    case 303:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21144; /* pred_indexed_oloadrvvmf2x5sirvvmf4hi */

    case 304:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21146; /* pred_indexed_oloadrvvmf2x5sirvvmf2si */

    case 305:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21148; /* pred_indexed_oloadrvvmf2x5sirvvm1di */

    case 306:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21150; /* pred_indexed_oloadrvvmf2x6sirvvmf8qi */

    case 307:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21152; /* pred_indexed_oloadrvvmf2x6sirvvmf4hi */

    case 308:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21154; /* pred_indexed_oloadrvvmf2x6sirvvmf2si */

    case 309:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21156; /* pred_indexed_oloadrvvmf2x6sirvvm1di */

    case 310:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21158; /* pred_indexed_oloadrvvmf2x7sirvvmf8qi */

    case 311:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21160; /* pred_indexed_oloadrvvmf2x7sirvvmf4hi */

    case 312:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21162; /* pred_indexed_oloadrvvmf2x7sirvvmf2si */

    case 313:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21164; /* pred_indexed_oloadrvvmf2x7sirvvm1di */

    case 314:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21166; /* pred_indexed_oloadrvvmf2x8sirvvmf8qi */

    case 315:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21168; /* pred_indexed_oloadrvvmf2x8sirvvmf4hi */

    case 316:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21170; /* pred_indexed_oloadrvvmf2x8sirvvmf2si */

    case 317:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21172; /* pred_indexed_oloadrvvmf2x8sirvvm1di */

    case 318:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21174; /* pred_indexed_oloadrvvm1x2dirvvmf8qi */

    case 319:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21176; /* pred_indexed_oloadrvvm1x2dirvvmf4hi */

    case 320:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21178; /* pred_indexed_oloadrvvm1x2dirvvmf2si */

    case 321:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21180; /* pred_indexed_oloadrvvm1x2dirvvm1di */

    case 322:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21182; /* pred_indexed_oloadrvvm1x3dirvvmf8qi */

    case 323:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21184; /* pred_indexed_oloadrvvm1x3dirvvmf4hi */

    case 324:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21186; /* pred_indexed_oloadrvvm1x3dirvvmf2si */

    case 325:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21188; /* pred_indexed_oloadrvvm1x3dirvvm1di */

    case 326:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21190; /* pred_indexed_oloadrvvm1x4dirvvmf8qi */

    case 327:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21192; /* pred_indexed_oloadrvvm1x4dirvvmf4hi */

    case 328:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21194; /* pred_indexed_oloadrvvm1x4dirvvmf2si */

    case 329:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21196; /* pred_indexed_oloadrvvm1x4dirvvm1di */

    case 330:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21198; /* pred_indexed_oloadrvvm1x5dirvvmf8qi */

    case 331:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21200; /* pred_indexed_oloadrvvm1x5dirvvmf4hi */

    case 332:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21202; /* pred_indexed_oloadrvvm1x5dirvvmf2si */

    case 333:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21204; /* pred_indexed_oloadrvvm1x5dirvvm1di */

    case 334:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21206; /* pred_indexed_oloadrvvm1x6dirvvmf8qi */

    case 335:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21208; /* pred_indexed_oloadrvvm1x6dirvvmf4hi */

    case 336:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21210; /* pred_indexed_oloadrvvm1x6dirvvmf2si */

    case 337:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21212; /* pred_indexed_oloadrvvm1x6dirvvm1di */

    case 338:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21214; /* pred_indexed_oloadrvvm1x7dirvvmf8qi */

    case 339:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21216; /* pred_indexed_oloadrvvm1x7dirvvmf4hi */

    case 340:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21218; /* pred_indexed_oloadrvvm1x7dirvvmf2si */

    case 341:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21220; /* pred_indexed_oloadrvvm1x7dirvvm1di */

    case 342:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21222; /* pred_indexed_oloadrvvm1x8dirvvmf8qi */

    case 343:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21224; /* pred_indexed_oloadrvvm1x8dirvvmf4hi */

    case 344:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21226; /* pred_indexed_oloadrvvm1x8dirvvmf2si */

    case 345:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21228; /* pred_indexed_oloadrvvm1x8dirvvm1di */

    case 346:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21230; /* pred_indexed_oloadrvvmf4x2bfrvvmf8qi */

    case 347:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21232; /* pred_indexed_oloadrvvmf4x2bfrvvmf4hi */

    case 348:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21234; /* pred_indexed_oloadrvvmf4x2bfrvvmf2si */

    case 349:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21236; /* pred_indexed_oloadrvvmf4x2bfrvvm1di */

    case 350:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21238; /* pred_indexed_oloadrvvmf4x3bfrvvmf8qi */

    case 351:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21240; /* pred_indexed_oloadrvvmf4x3bfrvvmf4hi */

    case 352:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21242; /* pred_indexed_oloadrvvmf4x3bfrvvmf2si */

    case 353:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21244; /* pred_indexed_oloadrvvmf4x3bfrvvm1di */

    case 354:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21246; /* pred_indexed_oloadrvvmf4x4bfrvvmf8qi */

    case 355:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21248; /* pred_indexed_oloadrvvmf4x4bfrvvmf4hi */

    case 356:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21250; /* pred_indexed_oloadrvvmf4x4bfrvvmf2si */

    case 357:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21252; /* pred_indexed_oloadrvvmf4x4bfrvvm1di */

    case 358:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21254; /* pred_indexed_oloadrvvmf4x5bfrvvmf8qi */

    case 359:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21256; /* pred_indexed_oloadrvvmf4x5bfrvvmf4hi */

    case 360:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21258; /* pred_indexed_oloadrvvmf4x5bfrvvmf2si */

    case 361:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21260; /* pred_indexed_oloadrvvmf4x5bfrvvm1di */

    case 362:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21262; /* pred_indexed_oloadrvvmf4x6bfrvvmf8qi */

    case 363:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21264; /* pred_indexed_oloadrvvmf4x6bfrvvmf4hi */

    case 364:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21266; /* pred_indexed_oloadrvvmf4x6bfrvvmf2si */

    case 365:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21268; /* pred_indexed_oloadrvvmf4x6bfrvvm1di */

    case 366:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21270; /* pred_indexed_oloadrvvmf4x7bfrvvmf8qi */

    case 367:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21272; /* pred_indexed_oloadrvvmf4x7bfrvvmf4hi */

    case 368:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21274; /* pred_indexed_oloadrvvmf4x7bfrvvmf2si */

    case 369:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21276; /* pred_indexed_oloadrvvmf4x7bfrvvm1di */

    case 370:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21278; /* pred_indexed_oloadrvvmf4x8bfrvvmf8qi */

    case 371:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21280; /* pred_indexed_oloadrvvmf4x8bfrvvmf4hi */

    case 372:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21282; /* pred_indexed_oloadrvvmf4x8bfrvvmf2si */

    case 373:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21284; /* pred_indexed_oloadrvvmf4x8bfrvvm1di */

    case 374:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21286; /* pred_indexed_oloadrvvmf4x2hfrvvmf8qi */

    case 375:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21288; /* pred_indexed_oloadrvvmf4x2hfrvvmf4hi */

    case 376:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21290; /* pred_indexed_oloadrvvmf4x2hfrvvmf2si */

    case 377:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21292; /* pred_indexed_oloadrvvmf4x2hfrvvm1di */

    case 378:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21294; /* pred_indexed_oloadrvvmf4x3hfrvvmf8qi */

    case 379:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21296; /* pred_indexed_oloadrvvmf4x3hfrvvmf4hi */

    case 380:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21298; /* pred_indexed_oloadrvvmf4x3hfrvvmf2si */

    case 381:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21300; /* pred_indexed_oloadrvvmf4x3hfrvvm1di */

    case 382:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21302; /* pred_indexed_oloadrvvmf4x4hfrvvmf8qi */

    case 383:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21304; /* pred_indexed_oloadrvvmf4x4hfrvvmf4hi */

    case 384:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21306; /* pred_indexed_oloadrvvmf4x4hfrvvmf2si */

    case 385:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21308; /* pred_indexed_oloadrvvmf4x4hfrvvm1di */

    case 386:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21310; /* pred_indexed_oloadrvvmf4x5hfrvvmf8qi */

    case 387:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21312; /* pred_indexed_oloadrvvmf4x5hfrvvmf4hi */

    case 388:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21314; /* pred_indexed_oloadrvvmf4x5hfrvvmf2si */

    case 389:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21316; /* pred_indexed_oloadrvvmf4x5hfrvvm1di */

    case 390:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21318; /* pred_indexed_oloadrvvmf4x6hfrvvmf8qi */

    case 391:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21320; /* pred_indexed_oloadrvvmf4x6hfrvvmf4hi */

    case 392:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21322; /* pred_indexed_oloadrvvmf4x6hfrvvmf2si */

    case 393:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21324; /* pred_indexed_oloadrvvmf4x6hfrvvm1di */

    case 394:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21326; /* pred_indexed_oloadrvvmf4x7hfrvvmf8qi */

    case 395:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21328; /* pred_indexed_oloadrvvmf4x7hfrvvmf4hi */

    case 396:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21330; /* pred_indexed_oloadrvvmf4x7hfrvvmf2si */

    case 397:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21332; /* pred_indexed_oloadrvvmf4x7hfrvvm1di */

    case 398:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21334; /* pred_indexed_oloadrvvmf4x8hfrvvmf8qi */

    case 399:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21336; /* pred_indexed_oloadrvvmf4x8hfrvvmf4hi */

    case 400:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21338; /* pred_indexed_oloadrvvmf4x8hfrvvmf2si */

    case 401:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21340; /* pred_indexed_oloadrvvmf4x8hfrvvm1di */

    case 402:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21342; /* pred_indexed_oloadrvvmf2x2sfrvvmf8qi */

    case 403:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21344; /* pred_indexed_oloadrvvmf2x2sfrvvmf4hi */

    case 404:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21346; /* pred_indexed_oloadrvvmf2x2sfrvvmf2si */

    case 405:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21348; /* pred_indexed_oloadrvvmf2x2sfrvvm1di */

    case 406:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21350; /* pred_indexed_oloadrvvmf2x3sfrvvmf8qi */

    case 407:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21352; /* pred_indexed_oloadrvvmf2x3sfrvvmf4hi */

    case 408:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21354; /* pred_indexed_oloadrvvmf2x3sfrvvmf2si */

    case 409:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21356; /* pred_indexed_oloadrvvmf2x3sfrvvm1di */

    case 410:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21358; /* pred_indexed_oloadrvvmf2x4sfrvvmf8qi */

    case 411:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21360; /* pred_indexed_oloadrvvmf2x4sfrvvmf4hi */

    case 412:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21362; /* pred_indexed_oloadrvvmf2x4sfrvvmf2si */

    case 413:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21364; /* pred_indexed_oloadrvvmf2x4sfrvvm1di */

    case 414:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21366; /* pred_indexed_oloadrvvmf2x5sfrvvmf8qi */

    case 415:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21368; /* pred_indexed_oloadrvvmf2x5sfrvvmf4hi */

    case 416:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21370; /* pred_indexed_oloadrvvmf2x5sfrvvmf2si */

    case 417:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21372; /* pred_indexed_oloadrvvmf2x5sfrvvm1di */

    case 418:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21374; /* pred_indexed_oloadrvvmf2x6sfrvvmf8qi */

    case 419:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21376; /* pred_indexed_oloadrvvmf2x6sfrvvmf4hi */

    case 420:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21378; /* pred_indexed_oloadrvvmf2x6sfrvvmf2si */

    case 421:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21380; /* pred_indexed_oloadrvvmf2x6sfrvvm1di */

    case 422:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21382; /* pred_indexed_oloadrvvmf2x7sfrvvmf8qi */

    case 423:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21384; /* pred_indexed_oloadrvvmf2x7sfrvvmf4hi */

    case 424:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21386; /* pred_indexed_oloadrvvmf2x7sfrvvmf2si */

    case 425:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21388; /* pred_indexed_oloadrvvmf2x7sfrvvm1di */

    case 426:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21390; /* pred_indexed_oloadrvvmf2x8sfrvvmf8qi */

    case 427:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21392; /* pred_indexed_oloadrvvmf2x8sfrvvmf4hi */

    case 428:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21394; /* pred_indexed_oloadrvvmf2x8sfrvvmf2si */

    case 429:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21396; /* pred_indexed_oloadrvvmf2x8sfrvvm1di */

    case 430:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21398; /* pred_indexed_oloadrvvm1x2dfrvvmf8qi */

    case 431:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21400; /* pred_indexed_oloadrvvm1x2dfrvvmf4hi */

    case 432:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21402; /* pred_indexed_oloadrvvm1x2dfrvvmf2si */

    case 433:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21404; /* pred_indexed_oloadrvvm1x2dfrvvm1di */

    case 434:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21406; /* pred_indexed_oloadrvvm1x3dfrvvmf8qi */

    case 435:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21408; /* pred_indexed_oloadrvvm1x3dfrvvmf4hi */

    case 436:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21410; /* pred_indexed_oloadrvvm1x3dfrvvmf2si */

    case 437:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21412; /* pred_indexed_oloadrvvm1x3dfrvvm1di */

    case 438:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21414; /* pred_indexed_oloadrvvm1x4dfrvvmf8qi */

    case 439:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21416; /* pred_indexed_oloadrvvm1x4dfrvvmf4hi */

    case 440:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21418; /* pred_indexed_oloadrvvm1x4dfrvvmf2si */

    case 441:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21420; /* pred_indexed_oloadrvvm1x4dfrvvm1di */

    case 442:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21422; /* pred_indexed_oloadrvvm1x5dfrvvmf8qi */

    case 443:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21424; /* pred_indexed_oloadrvvm1x5dfrvvmf4hi */

    case 444:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21426; /* pred_indexed_oloadrvvm1x5dfrvvmf2si */

    case 445:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21428; /* pred_indexed_oloadrvvm1x5dfrvvm1di */

    case 446:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21430; /* pred_indexed_oloadrvvm1x6dfrvvmf8qi */

    case 447:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21432; /* pred_indexed_oloadrvvm1x6dfrvvmf4hi */

    case 448:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21434; /* pred_indexed_oloadrvvm1x6dfrvvmf2si */

    case 449:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21436; /* pred_indexed_oloadrvvm1x6dfrvvm1di */

    case 450:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21438; /* pred_indexed_oloadrvvm1x7dfrvvmf8qi */

    case 451:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21440; /* pred_indexed_oloadrvvm1x7dfrvvmf4hi */

    case 452:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21442; /* pred_indexed_oloadrvvm1x7dfrvvmf2si */

    case 453:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21444; /* pred_indexed_oloadrvvm1x7dfrvvm1di */

    case 454:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21446; /* pred_indexed_oloadrvvm1x8dfrvvmf8qi */

    case 455:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21448; /* pred_indexed_oloadrvvm1x8dfrvvmf4hi */

    case 456:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21450; /* pred_indexed_oloadrvvm1x8dfrvvmf2si */

    case 457:
      if (!(
#line 8353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21452; /* pred_indexed_oloadrvvm1x8dfrvvm1di */

    case 458:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21454; /* pred_indexed_oloadrvvmf4x2qirvvmf4qi */

    case 459:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21550; /* pred_indexed_oloadrvvmf4x2qirvvmf2hi */

    case 460:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21646; /* pred_indexed_oloadrvvmf4x2qirvvm1si */

    case 461:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21742; /* pred_indexed_oloadrvvmf4x2qirvvm2di */

    case 462:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21456; /* pred_indexed_oloadrvvmf4x3qirvvmf4qi */

    case 463:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21552; /* pred_indexed_oloadrvvmf4x3qirvvmf2hi */

    case 464:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21648; /* pred_indexed_oloadrvvmf4x3qirvvm1si */

    case 465:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21744; /* pred_indexed_oloadrvvmf4x3qirvvm2di */

    case 466:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21458; /* pred_indexed_oloadrvvmf4x4qirvvmf4qi */

    case 467:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21554; /* pred_indexed_oloadrvvmf4x4qirvvmf2hi */

    case 468:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21650; /* pred_indexed_oloadrvvmf4x4qirvvm1si */

    case 469:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21746; /* pred_indexed_oloadrvvmf4x4qirvvm2di */

    case 470:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21460; /* pred_indexed_oloadrvvmf4x5qirvvmf4qi */

    case 471:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21556; /* pred_indexed_oloadrvvmf4x5qirvvmf2hi */

    case 472:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21652; /* pred_indexed_oloadrvvmf4x5qirvvm1si */

    case 473:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21748; /* pred_indexed_oloadrvvmf4x5qirvvm2di */

    case 474:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21462; /* pred_indexed_oloadrvvmf4x6qirvvmf4qi */

    case 475:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21558; /* pred_indexed_oloadrvvmf4x6qirvvmf2hi */

    case 476:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21654; /* pred_indexed_oloadrvvmf4x6qirvvm1si */

    case 477:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21750; /* pred_indexed_oloadrvvmf4x6qirvvm2di */

    case 478:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21464; /* pred_indexed_oloadrvvmf4x7qirvvmf4qi */

    case 479:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21560; /* pred_indexed_oloadrvvmf4x7qirvvmf2hi */

    case 480:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21656; /* pred_indexed_oloadrvvmf4x7qirvvm1si */

    case 481:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21752; /* pred_indexed_oloadrvvmf4x7qirvvm2di */

    case 482:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21466; /* pred_indexed_oloadrvvmf4x8qirvvmf4qi */

    case 483:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21562; /* pred_indexed_oloadrvvmf4x8qirvvmf2hi */

    case 484:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21658; /* pred_indexed_oloadrvvmf4x8qirvvm1si */

    case 485:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21754; /* pred_indexed_oloadrvvmf4x8qirvvm2di */

    case 486:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21468; /* pred_indexed_oloadrvvmf2x2hirvvmf4qi */

    case 487:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21564; /* pred_indexed_oloadrvvmf2x2hirvvmf2hi */

    case 488:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21660; /* pred_indexed_oloadrvvmf2x2hirvvm1si */

    case 489:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21756; /* pred_indexed_oloadrvvmf2x2hirvvm2di */

    case 490:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21470; /* pred_indexed_oloadrvvmf2x3hirvvmf4qi */

    case 491:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21566; /* pred_indexed_oloadrvvmf2x3hirvvmf2hi */

    case 492:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21662; /* pred_indexed_oloadrvvmf2x3hirvvm1si */

    case 493:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21758; /* pred_indexed_oloadrvvmf2x3hirvvm2di */

    case 494:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21472; /* pred_indexed_oloadrvvmf2x4hirvvmf4qi */

    case 495:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21568; /* pred_indexed_oloadrvvmf2x4hirvvmf2hi */

    case 496:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21664; /* pred_indexed_oloadrvvmf2x4hirvvm1si */

    case 497:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21760; /* pred_indexed_oloadrvvmf2x4hirvvm2di */

    case 498:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21474; /* pred_indexed_oloadrvvmf2x5hirvvmf4qi */

    case 499:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21570; /* pred_indexed_oloadrvvmf2x5hirvvmf2hi */

    case 500:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21666; /* pred_indexed_oloadrvvmf2x5hirvvm1si */

    case 501:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21762; /* pred_indexed_oloadrvvmf2x5hirvvm2di */

    case 502:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21476; /* pred_indexed_oloadrvvmf2x6hirvvmf4qi */

    case 503:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21572; /* pred_indexed_oloadrvvmf2x6hirvvmf2hi */

    case 504:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21668; /* pred_indexed_oloadrvvmf2x6hirvvm1si */

    case 505:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21764; /* pred_indexed_oloadrvvmf2x6hirvvm2di */

    case 506:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21478; /* pred_indexed_oloadrvvmf2x7hirvvmf4qi */

    case 507:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21574; /* pred_indexed_oloadrvvmf2x7hirvvmf2hi */

    case 508:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21670; /* pred_indexed_oloadrvvmf2x7hirvvm1si */

    case 509:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21766; /* pred_indexed_oloadrvvmf2x7hirvvm2di */

    case 510:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21480; /* pred_indexed_oloadrvvmf2x8hirvvmf4qi */

    case 511:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21576; /* pred_indexed_oloadrvvmf2x8hirvvmf2hi */

    case 512:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21672; /* pred_indexed_oloadrvvmf2x8hirvvm1si */

    case 513:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21768; /* pred_indexed_oloadrvvmf2x8hirvvm2di */

    case 514:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21482; /* pred_indexed_oloadrvvm1x2sirvvmf4qi */

    case 515:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21578; /* pred_indexed_oloadrvvm1x2sirvvmf2hi */

    case 516:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21674; /* pred_indexed_oloadrvvm1x2sirvvm1si */

    case 517:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21770; /* pred_indexed_oloadrvvm1x2sirvvm2di */

    case 518:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21484; /* pred_indexed_oloadrvvm1x3sirvvmf4qi */

    case 519:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21580; /* pred_indexed_oloadrvvm1x3sirvvmf2hi */

    case 520:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21676; /* pred_indexed_oloadrvvm1x3sirvvm1si */

    case 521:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21772; /* pred_indexed_oloadrvvm1x3sirvvm2di */

    case 522:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21486; /* pred_indexed_oloadrvvm1x4sirvvmf4qi */

    case 523:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21582; /* pred_indexed_oloadrvvm1x4sirvvmf2hi */

    case 524:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21678; /* pred_indexed_oloadrvvm1x4sirvvm1si */

    case 525:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21774; /* pred_indexed_oloadrvvm1x4sirvvm2di */

    case 526:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21488; /* pred_indexed_oloadrvvm1x5sirvvmf4qi */

    case 527:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21584; /* pred_indexed_oloadrvvm1x5sirvvmf2hi */

    case 528:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21680; /* pred_indexed_oloadrvvm1x5sirvvm1si */

    case 529:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21776; /* pred_indexed_oloadrvvm1x5sirvvm2di */

    case 530:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21490; /* pred_indexed_oloadrvvm1x6sirvvmf4qi */

    case 531:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21586; /* pred_indexed_oloadrvvm1x6sirvvmf2hi */

    case 532:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21682; /* pred_indexed_oloadrvvm1x6sirvvm1si */

    case 533:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21778; /* pred_indexed_oloadrvvm1x6sirvvm2di */

    case 534:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21492; /* pred_indexed_oloadrvvm1x7sirvvmf4qi */

    case 535:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21588; /* pred_indexed_oloadrvvm1x7sirvvmf2hi */

    case 536:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21684; /* pred_indexed_oloadrvvm1x7sirvvm1si */

    case 537:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21780; /* pred_indexed_oloadrvvm1x7sirvvm2di */

    case 538:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21494; /* pred_indexed_oloadrvvm1x8sirvvmf4qi */

    case 539:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21590; /* pred_indexed_oloadrvvm1x8sirvvmf2hi */

    case 540:
      if (!
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21686; /* pred_indexed_oloadrvvm1x8sirvvm1si */

    case 541:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21782; /* pred_indexed_oloadrvvm1x8sirvvm2di */

    case 542:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21496; /* pred_indexed_oloadrvvm2x2dirvvmf4qi */

    case 543:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21592; /* pred_indexed_oloadrvvm2x2dirvvmf2hi */

    case 544:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21688; /* pred_indexed_oloadrvvm2x2dirvvm1si */

    case 545:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1233 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1233 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21784; /* pred_indexed_oloadrvvm2x2dirvvm2di */

    case 546:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21498; /* pred_indexed_oloadrvvm2x3dirvvmf4qi */

    case 547:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21594; /* pred_indexed_oloadrvvm2x3dirvvmf2hi */

    case 548:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21690; /* pred_indexed_oloadrvvm2x3dirvvm1si */

    case 549:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21786; /* pred_indexed_oloadrvvm2x3dirvvm2di */

    case 550:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21500; /* pred_indexed_oloadrvvm2x4dirvvmf4qi */

    case 551:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21596; /* pred_indexed_oloadrvvm2x4dirvvmf2hi */

    case 552:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21692; /* pred_indexed_oloadrvvm2x4dirvvm1si */

    case 553:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1235 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1235 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21788; /* pred_indexed_oloadrvvm2x4dirvvm2di */

    case 554:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21502; /* pred_indexed_oloadrvvmf2x2bfrvvmf4qi */

    case 555:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21598; /* pred_indexed_oloadrvvmf2x2bfrvvmf2hi */

    case 556:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21694; /* pred_indexed_oloadrvvmf2x2bfrvvm1si */

    case 557:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1236 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1236 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21790; /* pred_indexed_oloadrvvmf2x2bfrvvm2di */

    case 558:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21504; /* pred_indexed_oloadrvvmf2x3bfrvvmf4qi */

    case 559:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21600; /* pred_indexed_oloadrvvmf2x3bfrvvmf2hi */

    case 560:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21696; /* pred_indexed_oloadrvvmf2x3bfrvvm1si */

    case 561:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1237 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1237 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21792; /* pred_indexed_oloadrvvmf2x3bfrvvm2di */

    case 562:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21506; /* pred_indexed_oloadrvvmf2x4bfrvvmf4qi */

    case 563:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21602; /* pred_indexed_oloadrvvmf2x4bfrvvmf2hi */

    case 564:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21698; /* pred_indexed_oloadrvvmf2x4bfrvvm1si */

    case 565:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21794; /* pred_indexed_oloadrvvmf2x4bfrvvm2di */

    case 566:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21508; /* pred_indexed_oloadrvvmf2x5bfrvvmf4qi */

    case 567:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21604; /* pred_indexed_oloadrvvmf2x5bfrvvmf2hi */

    case 568:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21700; /* pred_indexed_oloadrvvmf2x5bfrvvm1si */

    case 569:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1239 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1239 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21796; /* pred_indexed_oloadrvvmf2x5bfrvvm2di */

    case 570:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21510; /* pred_indexed_oloadrvvmf2x6bfrvvmf4qi */

    case 571:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21606; /* pred_indexed_oloadrvvmf2x6bfrvvmf2hi */

    case 572:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21702; /* pred_indexed_oloadrvvmf2x6bfrvvm1si */

    case 573:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21798; /* pred_indexed_oloadrvvmf2x6bfrvvm2di */

    case 574:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21512; /* pred_indexed_oloadrvvmf2x7bfrvvmf4qi */

    case 575:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21608; /* pred_indexed_oloadrvvmf2x7bfrvvmf2hi */

    case 576:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21704; /* pred_indexed_oloadrvvmf2x7bfrvvm1si */

    case 577:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1241 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1241 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21800; /* pred_indexed_oloadrvvmf2x7bfrvvm2di */

    case 578:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21514; /* pred_indexed_oloadrvvmf2x8bfrvvmf4qi */

    case 579:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21610; /* pred_indexed_oloadrvvmf2x8bfrvvmf2hi */

    case 580:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21706; /* pred_indexed_oloadrvvmf2x8bfrvvm1si */

    case 581:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21802; /* pred_indexed_oloadrvvmf2x8bfrvvm2di */

    case 582:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21516; /* pred_indexed_oloadrvvmf2x2hfrvvmf4qi */

    case 583:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21612; /* pred_indexed_oloadrvvmf2x2hfrvvmf2hi */

    case 584:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21708; /* pred_indexed_oloadrvvmf2x2hfrvvm1si */

    case 585:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1243 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1243 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21804; /* pred_indexed_oloadrvvmf2x2hfrvvm2di */

    case 586:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21518; /* pred_indexed_oloadrvvmf2x3hfrvvmf4qi */

    case 587:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21614; /* pred_indexed_oloadrvvmf2x3hfrvvmf2hi */

    case 588:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21710; /* pred_indexed_oloadrvvmf2x3hfrvvm1si */

    case 589:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1244 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1244 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21806; /* pred_indexed_oloadrvvmf2x3hfrvvm2di */

    case 590:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21520; /* pred_indexed_oloadrvvmf2x4hfrvvmf4qi */

    case 591:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21616; /* pred_indexed_oloadrvvmf2x4hfrvvmf2hi */

    case 592:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21712; /* pred_indexed_oloadrvvmf2x4hfrvvm1si */

    case 593:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1245 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1245 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21808; /* pred_indexed_oloadrvvmf2x4hfrvvm2di */

    case 594:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21522; /* pred_indexed_oloadrvvmf2x5hfrvvmf4qi */

    case 595:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21618; /* pred_indexed_oloadrvvmf2x5hfrvvmf2hi */

    case 596:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21714; /* pred_indexed_oloadrvvmf2x5hfrvvm1si */

    case 597:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21810; /* pred_indexed_oloadrvvmf2x5hfrvvm2di */

    case 598:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21524; /* pred_indexed_oloadrvvmf2x6hfrvvmf4qi */

    case 599:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21620; /* pred_indexed_oloadrvvmf2x6hfrvvmf2hi */

    case 600:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21716; /* pred_indexed_oloadrvvmf2x6hfrvvm1si */

    case 601:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21812; /* pred_indexed_oloadrvvmf2x6hfrvvm2di */

    case 602:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21526; /* pred_indexed_oloadrvvmf2x7hfrvvmf4qi */

    case 603:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21622; /* pred_indexed_oloadrvvmf2x7hfrvvmf2hi */

    case 604:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21718; /* pred_indexed_oloadrvvmf2x7hfrvvm1si */

    case 605:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21814; /* pred_indexed_oloadrvvmf2x7hfrvvm2di */

    case 606:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21528; /* pred_indexed_oloadrvvmf2x8hfrvvmf4qi */

    case 607:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21624; /* pred_indexed_oloadrvvmf2x8hfrvvmf2hi */

    case 608:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21720; /* pred_indexed_oloadrvvmf2x8hfrvvm1si */

    case 609:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21816; /* pred_indexed_oloadrvvmf2x8hfrvvm2di */

    case 610:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21530; /* pred_indexed_oloadrvvm1x2sfrvvmf4qi */

    case 611:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21626; /* pred_indexed_oloadrvvm1x2sfrvvmf2hi */

    case 612:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21722; /* pred_indexed_oloadrvvm1x2sfrvvm1si */

    case 613:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21818; /* pred_indexed_oloadrvvm1x2sfrvvm2di */

    case 614:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21532; /* pred_indexed_oloadrvvm1x3sfrvvmf4qi */

    case 615:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21628; /* pred_indexed_oloadrvvm1x3sfrvvmf2hi */

    case 616:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21724; /* pred_indexed_oloadrvvm1x3sfrvvm1si */

    case 617:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21820; /* pred_indexed_oloadrvvm1x3sfrvvm2di */

    case 618:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21534; /* pred_indexed_oloadrvvm1x4sfrvvmf4qi */

    case 619:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21630; /* pred_indexed_oloadrvvm1x4sfrvvmf2hi */

    case 620:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21726; /* pred_indexed_oloadrvvm1x4sfrvvm1si */

    case 621:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21822; /* pred_indexed_oloadrvvm1x4sfrvvm2di */

    case 622:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21536; /* pred_indexed_oloadrvvm1x5sfrvvmf4qi */

    case 623:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21632; /* pred_indexed_oloadrvvm1x5sfrvvmf2hi */

    case 624:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21728; /* pred_indexed_oloadrvvm1x5sfrvvm1si */

    case 625:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21824; /* pred_indexed_oloadrvvm1x5sfrvvm2di */

    case 626:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21538; /* pred_indexed_oloadrvvm1x6sfrvvmf4qi */

    case 627:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21634; /* pred_indexed_oloadrvvm1x6sfrvvmf2hi */

    case 628:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21730; /* pred_indexed_oloadrvvm1x6sfrvvm1si */

    case 629:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21826; /* pred_indexed_oloadrvvm1x6sfrvvm2di */

    case 630:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21540; /* pred_indexed_oloadrvvm1x7sfrvvmf4qi */

    case 631:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21636; /* pred_indexed_oloadrvvm1x7sfrvvmf2hi */

    case 632:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21732; /* pred_indexed_oloadrvvm1x7sfrvvm1si */

    case 633:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21828; /* pred_indexed_oloadrvvm1x7sfrvvm2di */

    case 634:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21542; /* pred_indexed_oloadrvvm1x8sfrvvmf4qi */

    case 635:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21638; /* pred_indexed_oloadrvvm1x8sfrvvmf2hi */

    case 636:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21734; /* pred_indexed_oloadrvvm1x8sfrvvm1si */

    case 637:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21830; /* pred_indexed_oloadrvvm1x8sfrvvm2di */

    case 638:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21544; /* pred_indexed_oloadrvvm2x2dfrvvmf4qi */

    case 639:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21640; /* pred_indexed_oloadrvvm2x2dfrvvmf2hi */

    case 640:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21736; /* pred_indexed_oloadrvvm2x2dfrvvm1si */

    case 641:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21832; /* pred_indexed_oloadrvvm2x2dfrvvm2di */

    case 642:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21546; /* pred_indexed_oloadrvvm2x3dfrvvmf4qi */

    case 643:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21642; /* pred_indexed_oloadrvvm2x3dfrvvmf2hi */

    case 644:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21738; /* pred_indexed_oloadrvvm2x3dfrvvm1si */

    case 645:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21834; /* pred_indexed_oloadrvvm2x3dfrvvm2di */

    case 646:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21548; /* pred_indexed_oloadrvvm2x4dfrvvmf4qi */

    case 647:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21644; /* pred_indexed_oloadrvvm2x4dfrvvmf2hi */

    case 648:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21740; /* pred_indexed_oloadrvvm2x4dfrvvm1si */

    case 649:
      if (!(
#line 8374 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 866 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21836; /* pred_indexed_oloadrvvm2x4dfrvvm2di */

    case 650:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21838; /* pred_indexed_oloadrvvmf2x2qirvvmf2qi */

    case 651:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21910; /* pred_indexed_oloadrvvmf2x2qirvvm1hi */

    case 652:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21982; /* pred_indexed_oloadrvvmf2x2qirvvm2si */

    case 653:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22054; /* pred_indexed_oloadrvvmf2x2qirvvm4di */

    case 654:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21840; /* pred_indexed_oloadrvvmf2x3qirvvmf2qi */

    case 655:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21912; /* pred_indexed_oloadrvvmf2x3qirvvm1hi */

    case 656:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21984; /* pred_indexed_oloadrvvmf2x3qirvvm2si */

    case 657:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22056; /* pred_indexed_oloadrvvmf2x3qirvvm4di */

    case 658:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21842; /* pred_indexed_oloadrvvmf2x4qirvvmf2qi */

    case 659:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21914; /* pred_indexed_oloadrvvmf2x4qirvvm1hi */

    case 660:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21986; /* pred_indexed_oloadrvvmf2x4qirvvm2si */

    case 661:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22058; /* pred_indexed_oloadrvvmf2x4qirvvm4di */

    case 662:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21844; /* pred_indexed_oloadrvvmf2x5qirvvmf2qi */

    case 663:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21916; /* pred_indexed_oloadrvvmf2x5qirvvm1hi */

    case 664:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21988; /* pred_indexed_oloadrvvmf2x5qirvvm2si */

    case 665:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22060; /* pred_indexed_oloadrvvmf2x5qirvvm4di */

    case 666:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21846; /* pred_indexed_oloadrvvmf2x6qirvvmf2qi */

    case 667:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21918; /* pred_indexed_oloadrvvmf2x6qirvvm1hi */

    case 668:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21990; /* pred_indexed_oloadrvvmf2x6qirvvm2si */

    case 669:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22062; /* pred_indexed_oloadrvvmf2x6qirvvm4di */

    case 670:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21848; /* pred_indexed_oloadrvvmf2x7qirvvmf2qi */

    case 671:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21920; /* pred_indexed_oloadrvvmf2x7qirvvm1hi */

    case 672:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21992; /* pred_indexed_oloadrvvmf2x7qirvvm2si */

    case 673:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22064; /* pred_indexed_oloadrvvmf2x7qirvvm4di */

    case 674:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21850; /* pred_indexed_oloadrvvmf2x8qirvvmf2qi */

    case 675:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21922; /* pred_indexed_oloadrvvmf2x8qirvvm1hi */

    case 676:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21994; /* pred_indexed_oloadrvvmf2x8qirvvm2si */

    case 677:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22066; /* pred_indexed_oloadrvvmf2x8qirvvm4di */

    case 678:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21852; /* pred_indexed_oloadrvvm1x2hirvvmf2qi */

    case 679:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21924; /* pred_indexed_oloadrvvm1x2hirvvm1hi */

    case 680:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21996; /* pred_indexed_oloadrvvm1x2hirvvm2si */

    case 681:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22068; /* pred_indexed_oloadrvvm1x2hirvvm4di */

    case 682:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21854; /* pred_indexed_oloadrvvm1x3hirvvmf2qi */

    case 683:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21926; /* pred_indexed_oloadrvvm1x3hirvvm1hi */

    case 684:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21998; /* pred_indexed_oloadrvvm1x3hirvvm2si */

    case 685:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22070; /* pred_indexed_oloadrvvm1x3hirvvm4di */

    case 686:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21856; /* pred_indexed_oloadrvvm1x4hirvvmf2qi */

    case 687:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21928; /* pred_indexed_oloadrvvm1x4hirvvm1hi */

    case 688:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22000; /* pred_indexed_oloadrvvm1x4hirvvm2si */

    case 689:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22072; /* pred_indexed_oloadrvvm1x4hirvvm4di */

    case 690:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21858; /* pred_indexed_oloadrvvm1x5hirvvmf2qi */

    case 691:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21930; /* pred_indexed_oloadrvvm1x5hirvvm1hi */

    case 692:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22002; /* pred_indexed_oloadrvvm1x5hirvvm2si */

    case 693:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22074; /* pred_indexed_oloadrvvm1x5hirvvm4di */

    case 694:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21860; /* pred_indexed_oloadrvvm1x6hirvvmf2qi */

    case 695:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21932; /* pred_indexed_oloadrvvm1x6hirvvm1hi */

    case 696:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22004; /* pred_indexed_oloadrvvm1x6hirvvm2si */

    case 697:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22076; /* pred_indexed_oloadrvvm1x6hirvvm4di */

    case 698:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21862; /* pred_indexed_oloadrvvm1x7hirvvmf2qi */

    case 699:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21934; /* pred_indexed_oloadrvvm1x7hirvvm1hi */

    case 700:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22006; /* pred_indexed_oloadrvvm1x7hirvvm2si */

    case 701:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22078; /* pred_indexed_oloadrvvm1x7hirvvm4di */

    case 702:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21864; /* pred_indexed_oloadrvvm1x8hirvvmf2qi */

    case 703:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21936; /* pred_indexed_oloadrvvm1x8hirvvm1hi */

    case 704:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22008; /* pred_indexed_oloadrvvm1x8hirvvm2si */

    case 705:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22080; /* pred_indexed_oloadrvvm1x8hirvvm4di */

    case 706:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21866; /* pred_indexed_oloadrvvm2x2sirvvmf2qi */

    case 707:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21938; /* pred_indexed_oloadrvvm2x2sirvvm1hi */

    case 708:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22010; /* pred_indexed_oloadrvvm2x2sirvvm2si */

    case 709:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22082; /* pred_indexed_oloadrvvm2x2sirvvm4di */

    case 710:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21868; /* pred_indexed_oloadrvvm2x3sirvvmf2qi */

    case 711:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21940; /* pred_indexed_oloadrvvm2x3sirvvm1hi */

    case 712:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22012; /* pred_indexed_oloadrvvm2x3sirvvm2si */

    case 713:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22084; /* pred_indexed_oloadrvvm2x3sirvvm4di */

    case 714:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21870; /* pred_indexed_oloadrvvm2x4sirvvmf2qi */

    case 715:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21942; /* pred_indexed_oloadrvvm2x4sirvvm1hi */

    case 716:
      if (!
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22014; /* pred_indexed_oloadrvvm2x4sirvvm2si */

    case 717:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22086; /* pred_indexed_oloadrvvm2x4sirvvm4di */

    case 718:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21872; /* pred_indexed_oloadrvvm4x2dirvvmf2qi */

    case 719:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21944; /* pred_indexed_oloadrvvm4x2dirvvm1hi */

    case 720:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22016; /* pred_indexed_oloadrvvm4x2dirvvm2si */

    case 721:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1280 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1280 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22088; /* pred_indexed_oloadrvvm4x2dirvvm4di */

    case 722:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21874; /* pred_indexed_oloadrvvm1x2bfrvvmf2qi */

    case 723:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21946; /* pred_indexed_oloadrvvm1x2bfrvvm1hi */

    case 724:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22018; /* pred_indexed_oloadrvvm1x2bfrvvm2si */

    case 725:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22090; /* pred_indexed_oloadrvvm1x2bfrvvm4di */

    case 726:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21876; /* pred_indexed_oloadrvvm1x3bfrvvmf2qi */

    case 727:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21948; /* pred_indexed_oloadrvvm1x3bfrvvm1hi */

    case 728:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22020; /* pred_indexed_oloadrvvm1x3bfrvvm2si */

    case 729:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1282 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1282 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22092; /* pred_indexed_oloadrvvm1x3bfrvvm4di */

    case 730:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21878; /* pred_indexed_oloadrvvm1x4bfrvvmf2qi */

    case 731:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21950; /* pred_indexed_oloadrvvm1x4bfrvvm1hi */

    case 732:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22022; /* pred_indexed_oloadrvvm1x4bfrvvm2si */

    case 733:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22094; /* pred_indexed_oloadrvvm1x4bfrvvm4di */

    case 734:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21880; /* pred_indexed_oloadrvvm1x5bfrvvmf2qi */

    case 735:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21952; /* pred_indexed_oloadrvvm1x5bfrvvm1hi */

    case 736:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22024; /* pred_indexed_oloadrvvm1x5bfrvvm2si */

    case 737:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1284 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1284 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22096; /* pred_indexed_oloadrvvm1x5bfrvvm4di */

    case 738:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21882; /* pred_indexed_oloadrvvm1x6bfrvvmf2qi */

    case 739:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21954; /* pred_indexed_oloadrvvm1x6bfrvvm1hi */

    case 740:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22026; /* pred_indexed_oloadrvvm1x6bfrvvm2si */

    case 741:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22098; /* pred_indexed_oloadrvvm1x6bfrvvm4di */

    case 742:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21884; /* pred_indexed_oloadrvvm1x7bfrvvmf2qi */

    case 743:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21956; /* pred_indexed_oloadrvvm1x7bfrvvm1hi */

    case 744:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22028; /* pred_indexed_oloadrvvm1x7bfrvvm2si */

    case 745:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1286 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1286 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22100; /* pred_indexed_oloadrvvm1x7bfrvvm4di */

    case 746:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21886; /* pred_indexed_oloadrvvm1x8bfrvvmf2qi */

    case 747:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21958; /* pred_indexed_oloadrvvm1x8bfrvvm1hi */

    case 748:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22030; /* pred_indexed_oloadrvvm1x8bfrvvm2si */

    case 749:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1287 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1287 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22102; /* pred_indexed_oloadrvvm1x8bfrvvm4di */

    case 750:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21888; /* pred_indexed_oloadrvvm1x2hfrvvmf2qi */

    case 751:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21960; /* pred_indexed_oloadrvvm1x2hfrvvm1hi */

    case 752:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22032; /* pred_indexed_oloadrvvm1x2hfrvvm2si */

    case 753:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22104; /* pred_indexed_oloadrvvm1x2hfrvvm4di */

    case 754:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21890; /* pred_indexed_oloadrvvm1x3hfrvvmf2qi */

    case 755:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21962; /* pred_indexed_oloadrvvm1x3hfrvvm1hi */

    case 756:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22034; /* pred_indexed_oloadrvvm1x3hfrvvm2si */

    case 757:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1289 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1289 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22106; /* pred_indexed_oloadrvvm1x3hfrvvm4di */

    case 758:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21892; /* pred_indexed_oloadrvvm1x4hfrvvmf2qi */

    case 759:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21964; /* pred_indexed_oloadrvvm1x4hfrvvm1hi */

    case 760:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22036; /* pred_indexed_oloadrvvm1x4hfrvvm2si */

    case 761:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22108; /* pred_indexed_oloadrvvm1x4hfrvvm4di */

    case 762:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21894; /* pred_indexed_oloadrvvm1x5hfrvvmf2qi */

    case 763:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21966; /* pred_indexed_oloadrvvm1x5hfrvvm1hi */

    case 764:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22038; /* pred_indexed_oloadrvvm1x5hfrvvm2si */

    case 765:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1291 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1291 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22110; /* pred_indexed_oloadrvvm1x5hfrvvm4di */

    case 766:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21896; /* pred_indexed_oloadrvvm1x6hfrvvmf2qi */

    case 767:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21968; /* pred_indexed_oloadrvvm1x6hfrvvm1hi */

    case 768:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22040; /* pred_indexed_oloadrvvm1x6hfrvvm2si */

    case 769:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22112; /* pred_indexed_oloadrvvm1x6hfrvvm4di */

    case 770:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21898; /* pred_indexed_oloadrvvm1x7hfrvvmf2qi */

    case 771:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21970; /* pred_indexed_oloadrvvm1x7hfrvvm1hi */

    case 772:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22042; /* pred_indexed_oloadrvvm1x7hfrvvm2si */

    case 773:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1293 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1293 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22114; /* pred_indexed_oloadrvvm1x7hfrvvm4di */

    case 774:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21900; /* pred_indexed_oloadrvvm1x8hfrvvmf2qi */

    case 775:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21972; /* pred_indexed_oloadrvvm1x8hfrvvm1hi */

    case 776:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22044; /* pred_indexed_oloadrvvm1x8hfrvvm2si */

    case 777:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22116; /* pred_indexed_oloadrvvm1x8hfrvvm4di */

    case 778:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21902; /* pred_indexed_oloadrvvm2x2sfrvvmf2qi */

    case 779:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21974; /* pred_indexed_oloadrvvm2x2sfrvvm1hi */

    case 780:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22046; /* pred_indexed_oloadrvvm2x2sfrvvm2si */

    case 781:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22118; /* pred_indexed_oloadrvvm2x2sfrvvm4di */

    case 782:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21904; /* pred_indexed_oloadrvvm2x3sfrvvmf2qi */

    case 783:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21976; /* pred_indexed_oloadrvvm2x3sfrvvm1hi */

    case 784:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22048; /* pred_indexed_oloadrvvm2x3sfrvvm2si */

    case 785:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22120; /* pred_indexed_oloadrvvm2x3sfrvvm4di */

    case 786:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21906; /* pred_indexed_oloadrvvm2x4sfrvvmf2qi */

    case 787:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21978; /* pred_indexed_oloadrvvm2x4sfrvvm1hi */

    case 788:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22050; /* pred_indexed_oloadrvvm2x4sfrvvm2si */

    case 789:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22122; /* pred_indexed_oloadrvvm2x4sfrvvm4di */

    case 790:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21908; /* pred_indexed_oloadrvvm4x2dfrvvmf2qi */

    case 791:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21980; /* pred_indexed_oloadrvvm4x2dfrvvm1hi */

    case 792:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22052; /* pred_indexed_oloadrvvm4x2dfrvvm2si */

    case 793:
      if (!(
#line 8395 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22124; /* pred_indexed_oloadrvvm4x2dfrvvm4di */

    case 794:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22126; /* pred_indexed_oloadrvvm1x2qirvvm1qi */

    case 795:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22128; /* pred_indexed_oloadrvvm1x2qirvvm2hi */

    case 796:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22130; /* pred_indexed_oloadrvvm1x2qirvvm4si */

    case 797:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22132; /* pred_indexed_oloadrvvm1x2qirvvm8di */

    case 798:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22134; /* pred_indexed_oloadrvvm1x3qirvvm1qi */

    case 799:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22136; /* pred_indexed_oloadrvvm1x3qirvvm2hi */

    case 800:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22138; /* pred_indexed_oloadrvvm1x3qirvvm4si */

    case 801:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22140; /* pred_indexed_oloadrvvm1x3qirvvm8di */

    case 802:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22142; /* pred_indexed_oloadrvvm1x4qirvvm1qi */

    case 803:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22144; /* pred_indexed_oloadrvvm1x4qirvvm2hi */

    case 804:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22146; /* pred_indexed_oloadrvvm1x4qirvvm4si */

    case 805:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22148; /* pred_indexed_oloadrvvm1x4qirvvm8di */

    case 806:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22150; /* pred_indexed_oloadrvvm1x5qirvvm1qi */

    case 807:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22152; /* pred_indexed_oloadrvvm1x5qirvvm2hi */

    case 808:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22154; /* pred_indexed_oloadrvvm1x5qirvvm4si */

    case 809:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22156; /* pred_indexed_oloadrvvm1x5qirvvm8di */

    case 810:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22158; /* pred_indexed_oloadrvvm1x6qirvvm1qi */

    case 811:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22160; /* pred_indexed_oloadrvvm1x6qirvvm2hi */

    case 812:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22162; /* pred_indexed_oloadrvvm1x6qirvvm4si */

    case 813:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22164; /* pred_indexed_oloadrvvm1x6qirvvm8di */

    case 814:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22166; /* pred_indexed_oloadrvvm1x7qirvvm1qi */

    case 815:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22168; /* pred_indexed_oloadrvvm1x7qirvvm2hi */

    case 816:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22170; /* pred_indexed_oloadrvvm1x7qirvvm4si */

    case 817:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22172; /* pred_indexed_oloadrvvm1x7qirvvm8di */

    case 818:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22174; /* pred_indexed_oloadrvvm1x8qirvvm1qi */

    case 819:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22176; /* pred_indexed_oloadrvvm1x8qirvvm2hi */

    case 820:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22178; /* pred_indexed_oloadrvvm1x8qirvvm4si */

    case 821:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22180; /* pred_indexed_oloadrvvm1x8qirvvm8di */

    case 822:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22182; /* pred_indexed_oloadrvvm2x2hirvvm1qi */

    case 823:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22184; /* pred_indexed_oloadrvvm2x2hirvvm2hi */

    case 824:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22186; /* pred_indexed_oloadrvvm2x2hirvvm4si */

    case 825:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22188; /* pred_indexed_oloadrvvm2x2hirvvm8di */

    case 826:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22190; /* pred_indexed_oloadrvvm2x3hirvvm1qi */

    case 827:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22192; /* pred_indexed_oloadrvvm2x3hirvvm2hi */

    case 828:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22194; /* pred_indexed_oloadrvvm2x3hirvvm4si */

    case 829:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22196; /* pred_indexed_oloadrvvm2x3hirvvm8di */

    case 830:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22198; /* pred_indexed_oloadrvvm2x4hirvvm1qi */

    case 831:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22200; /* pred_indexed_oloadrvvm2x4hirvvm2hi */

    case 832:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22202; /* pred_indexed_oloadrvvm2x4hirvvm4si */

    case 833:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22204; /* pred_indexed_oloadrvvm2x4hirvvm8di */

    case 834:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22206; /* pred_indexed_oloadrvvm4x2sirvvm1qi */

    case 835:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22208; /* pred_indexed_oloadrvvm4x2sirvvm2hi */

    case 836:
      if (!
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22210; /* pred_indexed_oloadrvvm4x2sirvvm4si */

    case 837:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22212; /* pred_indexed_oloadrvvm4x2sirvvm8di */

    case 838:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22214; /* pred_indexed_oloadrvvm2x2bfrvvm1qi */

    case 839:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22216; /* pred_indexed_oloadrvvm2x2bfrvvm2hi */

    case 840:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22218; /* pred_indexed_oloadrvvm2x2bfrvvm4si */

    case 841:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22220; /* pred_indexed_oloadrvvm2x2bfrvvm8di */

    case 842:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22222; /* pred_indexed_oloadrvvm2x3bfrvvm1qi */

    case 843:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22224; /* pred_indexed_oloadrvvm2x3bfrvvm2hi */

    case 844:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22226; /* pred_indexed_oloadrvvm2x3bfrvvm4si */

    case 845:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22228; /* pred_indexed_oloadrvvm2x3bfrvvm8di */

    case 846:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22230; /* pred_indexed_oloadrvvm2x4bfrvvm1qi */

    case 847:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22232; /* pred_indexed_oloadrvvm2x4bfrvvm2hi */

    case 848:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22234; /* pred_indexed_oloadrvvm2x4bfrvvm4si */

    case 849:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1315 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1315 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22236; /* pred_indexed_oloadrvvm2x4bfrvvm8di */

    case 850:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22238; /* pred_indexed_oloadrvvm2x2hfrvvm1qi */

    case 851:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22240; /* pred_indexed_oloadrvvm2x2hfrvvm2hi */

    case 852:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22242; /* pred_indexed_oloadrvvm2x2hfrvvm4si */

    case 853:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22244; /* pred_indexed_oloadrvvm2x2hfrvvm8di */

    case 854:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22246; /* pred_indexed_oloadrvvm2x3hfrvvm1qi */

    case 855:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22248; /* pred_indexed_oloadrvvm2x3hfrvvm2hi */

    case 856:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22250; /* pred_indexed_oloadrvvm2x3hfrvvm4si */

    case 857:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22252; /* pred_indexed_oloadrvvm2x3hfrvvm8di */

    case 858:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22254; /* pred_indexed_oloadrvvm2x4hfrvvm1qi */

    case 859:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22256; /* pred_indexed_oloadrvvm2x4hfrvvm2hi */

    case 860:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22258; /* pred_indexed_oloadrvvm2x4hfrvvm4si */

    case 861:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1318 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1318 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22260; /* pred_indexed_oloadrvvm2x4hfrvvm8di */

    case 862:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22262; /* pred_indexed_oloadrvvm4x2sfrvvm1qi */

    case 863:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22264; /* pred_indexed_oloadrvvm4x2sfrvvm2hi */

    case 864:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22266; /* pred_indexed_oloadrvvm4x2sfrvvm4si */

    case 865:
      if (!(
#line 8416 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22268; /* pred_indexed_oloadrvvm4x2sfrvvm8di */

    case 866:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22270; /* pred_indexed_oloadrvvm2x2qirvvm2qi */

    case 867:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22272; /* pred_indexed_oloadrvvm2x2qirvvm4hi */

    case 868:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22274; /* pred_indexed_oloadrvvm2x2qirvvm8si */

    case 869:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22276; /* pred_indexed_oloadrvvm2x3qirvvm2qi */

    case 870:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22278; /* pred_indexed_oloadrvvm2x3qirvvm4hi */

    case 871:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22280; /* pred_indexed_oloadrvvm2x3qirvvm8si */

    case 872:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22282; /* pred_indexed_oloadrvvm2x4qirvvm2qi */

    case 873:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22284; /* pred_indexed_oloadrvvm2x4qirvvm4hi */

    case 874:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22286; /* pred_indexed_oloadrvvm2x4qirvvm8si */

    case 875:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22288; /* pred_indexed_oloadrvvm4x2hirvvm2qi */

    case 876:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22290; /* pred_indexed_oloadrvvm4x2hirvvm4hi */

    case 877:
      if (!
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22292; /* pred_indexed_oloadrvvm4x2hirvvm8si */

    case 878:
      if (!(
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22294; /* pred_indexed_oloadrvvm4x2bfrvvm2qi */

    case 879:
      if (!(
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22296; /* pred_indexed_oloadrvvm4x2bfrvvm4hi */

    case 880:
      if (!(
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22298; /* pred_indexed_oloadrvvm4x2bfrvvm8si */

    case 881:
      if (!(
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22300; /* pred_indexed_oloadrvvm4x2hfrvvm2qi */

    case 882:
      if (!(
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22302; /* pred_indexed_oloadrvvm4x2hfrvvm4hi */

    case 883:
      if (!(
#line 8437 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22304; /* pred_indexed_oloadrvvm4x2hfrvvm8si */

    case 884:
      if (!
#line 8458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22306; /* pred_indexed_oloadrvvm4x2qirvvm4qi */

    case 885:
      if (!
#line 8458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22308; /* pred_indexed_oloadrvvm4x2qirvvm8hi */

    default:
      return -1;
    }
}

 int
recog_884 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern499 (x2))
    {
    case 0:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5496; /* pred_udivrvvm8qi */

    case 1:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5513; /* pred_udivrvvm4qi */

    case 2:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5530; /* pred_udivrvvm2qi */

    case 3:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5547; /* pred_udivrvvm1qi */

    case 4:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5564; /* pred_udivrvvm8hi */

    case 5:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5581; /* pred_udivrvvm4hi */

    case 6:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5598; /* pred_udivrvvm2hi */

    case 7:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5615; /* pred_udivrvvm1hi */

    case 8:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5632; /* pred_udivrvvm8si */

    case 9:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5649; /* pred_udivrvvm4si */

    case 10:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5666; /* pred_udivrvvm2si */

    case 11:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5683; /* pred_udivrvvm1si */

    case 12:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5700; /* pred_udivrvvm8di */

    case 13:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5717; /* pred_udivrvvm4di */

    case 14:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5734; /* pred_udivrvvm2di */

    case 15:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5751; /* pred_udivrvvm1di */

    case 16:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5768; /* pred_udivrvvmf2qi */

    case 17:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5785; /* pred_udivrvvmf4qi */

    case 18:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5802; /* pred_udivrvvmf8qi */

    case 19:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5819; /* pred_udivrvvmf2hi */

    case 20:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5836; /* pred_udivrvvmf4hi */

    case 21:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5853; /* pred_udivrvvmf2si */

    case 22:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5870; /* pred_udivv1qi */

    case 23:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5887; /* pred_udivv2qi */

    case 24:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5904; /* pred_udivv4qi */

    case 25:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5921; /* pred_udivv8qi */

    case 26:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5938; /* pred_udivv16qi */

    case 27:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5955; /* pred_udivv32qi */

    case 28:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5972; /* pred_udivv64qi */

    case 29:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5989; /* pred_udivv128qi */

    case 30:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6006; /* pred_udivv256qi */

    case 31:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6023; /* pred_udivv512qi */

    case 32:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6040; /* pred_udivv1024qi */

    case 33:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6057; /* pred_udivv2048qi */

    case 34:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6074; /* pred_udivv4096qi */

    case 35:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6091; /* pred_udivv1hi */

    case 36:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6108; /* pred_udivv2hi */

    case 37:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6125; /* pred_udivv4hi */

    case 38:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6142; /* pred_udivv8hi */

    case 39:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6159; /* pred_udivv16hi */

    case 40:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6176; /* pred_udivv32hi */

    case 41:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6193; /* pred_udivv64hi */

    case 42:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6210; /* pred_udivv128hi */

    case 43:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6227; /* pred_udivv256hi */

    case 44:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6244; /* pred_udivv512hi */

    case 45:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6261; /* pred_udivv1024hi */

    case 46:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6278; /* pred_udivv2048hi */

    case 47:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6295; /* pred_udivv1si */

    case 48:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6312; /* pred_udivv2si */

    case 49:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6329; /* pred_udivv4si */

    case 50:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6346; /* pred_udivv8si */

    case 51:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6363; /* pred_udivv16si */

    case 52:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6380; /* pred_udivv32si */

    case 53:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6397; /* pred_udivv64si */

    case 54:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6414; /* pred_udivv128si */

    case 55:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6431; /* pred_udivv256si */

    case 56:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6448; /* pred_udivv512si */

    case 57:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6465; /* pred_udivv1024si */

    case 58:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6482; /* pred_udivv1di */

    case 59:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6499; /* pred_udivv2di */

    case 60:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6516; /* pred_udivv4di */

    case 61:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6533; /* pred_udivv8di */

    case 62:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6550; /* pred_udivv16di */

    case 63:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6567; /* pred_udivv32di */

    case 64:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6584; /* pred_udivv64di */

    case 65:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6601; /* pred_udivv128di */

    case 66:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6618; /* pred_udivv256di */

    case 67:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6635; /* pred_udivv512di */

    case 68:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7330; /* pred_udivrvvm8qi_scalar */

    case 69:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7335; /* pred_udivrvvm4qi_scalar */

    case 70:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7340; /* pred_udivrvvm2qi_scalar */

    case 71:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7345; /* pred_udivrvvm1qi_scalar */

    case 72:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7350; /* pred_udivrvvmf2qi_scalar */

    case 73:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7355; /* pred_udivrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7360; /* pred_udivrvvmf8qi_scalar */

    case 75:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7365; /* pred_udivrvvm8hi_scalar */

    case 76:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7370; /* pred_udivrvvm4hi_scalar */

    case 77:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7375; /* pred_udivrvvm2hi_scalar */

    case 78:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7380; /* pred_udivrvvm1hi_scalar */

    case 79:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7385; /* pred_udivrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7390; /* pred_udivrvvmf4hi_scalar */

    case 81:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7395; /* pred_udivrvvm8si_scalar */

    case 82:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7400; /* pred_udivrvvm4si_scalar */

    case 83:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7405; /* pred_udivrvvm2si_scalar */

    case 84:
      if (!
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7410; /* pred_udivrvvm1si_scalar */

    case 85:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7415; /* pred_udivrvvmf2si_scalar */

    case 86:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7420; /* pred_udivv1qi_scalar */

    case 87:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7425; /* pred_udivv2qi_scalar */

    case 88:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7430; /* pred_udivv4qi_scalar */

    case 89:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7435; /* pred_udivv8qi_scalar */

    case 90:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7440; /* pred_udivv16qi_scalar */

    case 91:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7445; /* pred_udivv32qi_scalar */

    case 92:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7450; /* pred_udivv64qi_scalar */

    case 93:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7455; /* pred_udivv128qi_scalar */

    case 94:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7460; /* pred_udivv256qi_scalar */

    case 95:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7465; /* pred_udivv512qi_scalar */

    case 96:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7470; /* pred_udivv1024qi_scalar */

    case 97:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7475; /* pred_udivv2048qi_scalar */

    case 98:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7480; /* pred_udivv4096qi_scalar */

    case 99:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7485; /* pred_udivv1hi_scalar */

    case 100:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7490; /* pred_udivv2hi_scalar */

    case 101:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7495; /* pred_udivv4hi_scalar */

    case 102:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7500; /* pred_udivv8hi_scalar */

    case 103:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7505; /* pred_udivv16hi_scalar */

    case 104:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7510; /* pred_udivv32hi_scalar */

    case 105:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7515; /* pred_udivv64hi_scalar */

    case 106:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7520; /* pred_udivv128hi_scalar */

    case 107:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7525; /* pred_udivv256hi_scalar */

    case 108:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7530; /* pred_udivv512hi_scalar */

    case 109:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7535; /* pred_udivv1024hi_scalar */

    case 110:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7540; /* pred_udivv2048hi_scalar */

    case 111:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7545; /* pred_udivv1si_scalar */

    case 112:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7550; /* pred_udivv2si_scalar */

    case 113:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7555; /* pred_udivv4si_scalar */

    case 114:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7560; /* pred_udivv8si_scalar */

    case 115:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7565; /* pred_udivv16si_scalar */

    case 116:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7570; /* pred_udivv32si_scalar */

    case 117:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7575; /* pred_udivv64si_scalar */

    case 118:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7580; /* pred_udivv128si_scalar */

    case 119:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7585; /* pred_udivv256si_scalar */

    case 120:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7590; /* pred_udivv512si_scalar */

    case 121:
      if (!(
#line 2801 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7595; /* pred_udivv1024si_scalar */

    case 122:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7906; /* *pred_udivrvvm8di_scalar */

    case 123:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7911; /* *pred_udivrvvm4di_scalar */

    case 124:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7916; /* *pred_udivrvvm2di_scalar */

    case 125:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7921; /* *pred_udivrvvm1di_scalar */

    case 126:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7926; /* *pred_udivv1di_scalar */

    case 127:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7931; /* *pred_udivv2di_scalar */

    case 128:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7936; /* *pred_udivv4di_scalar */

    case 129:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7941; /* *pred_udivv8di_scalar */

    case 130:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7946; /* *pred_udivv16di_scalar */

    case 131:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7951; /* *pred_udivv32di_scalar */

    case 132:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7956; /* *pred_udivv64di_scalar */

    case 133:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7961; /* *pred_udivv128di_scalar */

    case 134:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7966; /* *pred_udivv256di_scalar */

    case 135:
      if (!(
#line 2954 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7971; /* *pred_udivv512di_scalar */

    case 136:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7976; /* *pred_udivrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7981; /* *pred_udivrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7986; /* *pred_udivrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7991; /* *pred_udivrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7996; /* *pred_udivv1di_extended_scalar */

    case 141:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8001; /* *pred_udivv2di_extended_scalar */

    case 142:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8006; /* *pred_udivv4di_extended_scalar */

    case 143:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8011; /* *pred_udivv8di_extended_scalar */

    case 144:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8016; /* *pred_udivv16di_extended_scalar */

    case 145:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8021; /* *pred_udivv32di_extended_scalar */

    case 146:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8026; /* *pred_udivv64di_extended_scalar */

    case 147:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8031; /* *pred_udivv128di_extended_scalar */

    case 148:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8036; /* *pred_udivv256di_extended_scalar */

    case 149:
      if (!(
#line 2976 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8041; /* *pred_udivv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_893 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      switch (pattern494 (x2))
        {
        case 0:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10873; /* pred_ussubrvvm8qi */

        case 1:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10877; /* pred_ussubrvvm4qi */

        case 2:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10881; /* pred_ussubrvvm2qi */

        case 3:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10885; /* pred_ussubrvvm1qi */

        case 4:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10889; /* pred_ussubrvvm8hi */

        case 5:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10893; /* pred_ussubrvvm4hi */

        case 6:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10897; /* pred_ussubrvvm2hi */

        case 7:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10901; /* pred_ussubrvvm1hi */

        case 8:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10905; /* pred_ussubrvvm8si */

        case 9:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10909; /* pred_ussubrvvm4si */

        case 10:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10913; /* pred_ussubrvvm2si */

        case 11:
          if (!
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10917; /* pred_ussubrvvm1si */

        case 12:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10921; /* pred_ussubrvvm8di */

        case 13:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10925; /* pred_ussubrvvm4di */

        case 14:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10929; /* pred_ussubrvvm2di */

        case 15:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10933; /* pred_ussubrvvm1di */

        case 16:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10937; /* pred_ussubrvvmf2qi */

        case 17:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10941; /* pred_ussubrvvmf4qi */

        case 18:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10945; /* pred_ussubrvvmf8qi */

        case 19:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10949; /* pred_ussubrvvmf2hi */

        case 20:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10953; /* pred_ussubrvvmf4hi */

        case 21:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10957; /* pred_ussubrvvmf2si */

        case 22:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 10961; /* pred_ussubv1qi */

        case 23:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 10965; /* pred_ussubv2qi */

        case 24:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 10969; /* pred_ussubv4qi */

        case 25:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 10973; /* pred_ussubv8qi */

        case 26:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 10977; /* pred_ussubv16qi */

        case 27:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 10981; /* pred_ussubv32qi */

        case 28:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10985; /* pred_ussubv64qi */

        case 29:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10989; /* pred_ussubv128qi */

        case 30:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10993; /* pred_ussubv256qi */

        case 31:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10997; /* pred_ussubv512qi */

        case 32:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11001; /* pred_ussubv1024qi */

        case 33:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11005; /* pred_ussubv2048qi */

        case 34:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11009; /* pred_ussubv4096qi */

        case 35:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11013; /* pred_ussubv1hi */

        case 36:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11017; /* pred_ussubv2hi */

        case 37:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11021; /* pred_ussubv4hi */

        case 38:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11025; /* pred_ussubv8hi */

        case 39:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11029; /* pred_ussubv16hi */

        case 40:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11033; /* pred_ussubv32hi */

        case 41:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11037; /* pred_ussubv64hi */

        case 42:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11041; /* pred_ussubv128hi */

        case 43:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11045; /* pred_ussubv256hi */

        case 44:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11049; /* pred_ussubv512hi */

        case 45:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11053; /* pred_ussubv1024hi */

        case 46:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11057; /* pred_ussubv2048hi */

        case 47:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11061; /* pred_ussubv1si */

        case 48:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11065; /* pred_ussubv2si */

        case 49:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11069; /* pred_ussubv4si */

        case 50:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11073; /* pred_ussubv8si */

        case 51:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11077; /* pred_ussubv16si */

        case 52:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11081; /* pred_ussubv32si */

        case 53:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11085; /* pred_ussubv64si */

        case 54:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11089; /* pred_ussubv128si */

        case 55:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11093; /* pred_ussubv256si */

        case 56:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11097; /* pred_ussubv512si */

        case 57:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11101; /* pred_ussubv1024si */

        case 58:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11105; /* pred_ussubv1di */

        case 59:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11109; /* pred_ussubv2di */

        case 60:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11113; /* pred_ussubv4di */

        case 61:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11117; /* pred_ussubv8di */

        case 62:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11121; /* pred_ussubv16di */

        case 63:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11125; /* pred_ussubv32di */

        case 64:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11129; /* pred_ussubv64di */

        case 65:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11133; /* pred_ussubv128di */

        case 66:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11137; /* pred_ussubv256di */

        case 67:
          if (!(
#line 4317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11141; /* pred_ussubv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern601 (x2))
        {
        case 0:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11251; /* pred_ussubrvvm8qi_scalar */

        case 1:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11253; /* pred_ussubrvvm4qi_scalar */

        case 2:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11255; /* pred_ussubrvvm2qi_scalar */

        case 3:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11257; /* pred_ussubrvvm1qi_scalar */

        case 4:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11259; /* pred_ussubrvvmf2qi_scalar */

        case 5:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11261; /* pred_ussubrvvmf4qi_scalar */

        case 6:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11263; /* pred_ussubrvvmf8qi_scalar */

        case 7:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11265; /* pred_ussubrvvm8hi_scalar */

        case 8:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11267; /* pred_ussubrvvm4hi_scalar */

        case 9:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11269; /* pred_ussubrvvm2hi_scalar */

        case 10:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11271; /* pred_ussubrvvm1hi_scalar */

        case 11:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11273; /* pred_ussubrvvmf2hi_scalar */

        case 12:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11275; /* pred_ussubrvvmf4hi_scalar */

        case 13:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11277; /* pred_ussubrvvm8si_scalar */

        case 14:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11279; /* pred_ussubrvvm4si_scalar */

        case 15:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11281; /* pred_ussubrvvm2si_scalar */

        case 16:
          if (!
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11283; /* pred_ussubrvvm1si_scalar */

        case 17:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11285; /* pred_ussubrvvmf2si_scalar */

        case 18:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 557 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 11287; /* pred_ussubv1qi_scalar */

        case 19:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 558 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 11289; /* pred_ussubv2qi_scalar */

        case 20:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 559 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 11291; /* pred_ussubv4qi_scalar */

        case 21:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 560 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 11293; /* pred_ussubv8qi_scalar */

        case 22:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 561 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 11295; /* pred_ussubv16qi_scalar */

        case 23:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 562 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 11297; /* pred_ussubv32qi_scalar */

        case 24:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 563 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11299; /* pred_ussubv64qi_scalar */

        case 25:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 564 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11301; /* pred_ussubv128qi_scalar */

        case 26:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11303; /* pred_ussubv256qi_scalar */

        case 27:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 566 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11305; /* pred_ussubv512qi_scalar */

        case 28:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11307; /* pred_ussubv1024qi_scalar */

        case 29:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 568 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11309; /* pred_ussubv2048qi_scalar */

        case 30:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11311; /* pred_ussubv4096qi_scalar */

        case 31:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 570 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11313; /* pred_ussubv1hi_scalar */

        case 32:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11315; /* pred_ussubv2hi_scalar */

        case 33:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11317; /* pred_ussubv4hi_scalar */

        case 34:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11319; /* pred_ussubv8hi_scalar */

        case 35:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11321; /* pred_ussubv16hi_scalar */

        case 36:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11323; /* pred_ussubv32hi_scalar */

        case 37:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11325; /* pred_ussubv64hi_scalar */

        case 38:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11327; /* pred_ussubv128hi_scalar */

        case 39:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11329; /* pred_ussubv256hi_scalar */

        case 40:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11331; /* pred_ussubv512hi_scalar */

        case 41:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11333; /* pred_ussubv1024hi_scalar */

        case 42:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11335; /* pred_ussubv2048hi_scalar */

        case 43:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11337; /* pred_ussubv1si_scalar */

        case 44:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11339; /* pred_ussubv2si_scalar */

        case 45:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11341; /* pred_ussubv4si_scalar */

        case 46:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11343; /* pred_ussubv8si_scalar */

        case 47:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11345; /* pred_ussubv16si_scalar */

        case 48:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11347; /* pred_ussubv32si_scalar */

        case 49:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11349; /* pred_ussubv64si_scalar */

        case 50:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11351; /* pred_ussubv128si_scalar */

        case 51:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11353; /* pred_ussubv256si_scalar */

        case 52:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11355; /* pred_ussubv512si_scalar */

        case 53:
          if (!(
#line 4368 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11357; /* pred_ussubv1024si_scalar */

        case 54:
          if (!(
#line 4498 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11375; /* *pred_ussubrvvm8di_scalar */

        case 55:
          if (!(
#line 4498 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11377; /* *pred_ussubrvvm4di_scalar */

        case 56:
          if (!(
#line 4498 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11379; /* *pred_ussubrvvm2di_scalar */

        case 57:
          if (!(
#line 4498 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11381; /* *pred_ussubrvvm1di_scalar */

        case 58:
          if (!(
#line 4520 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11383; /* *pred_ussubrvvm8di_extended_scalar */

        case 59:
          if (!(
#line 4520 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11385; /* *pred_ussubrvvm4di_extended_scalar */

        case 60:
          if (!(
#line 4520 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11387; /* *pred_ussubrvvm2di_extended_scalar */

        case 61:
          if (!(
#line 4520 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11389; /* *pred_ussubrvvm1di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_905 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x3;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 4);
      operands[7] = x8;
      x9 = XEXP (x2, 2);
      operands[2] = x9;
      return recog_397 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 4);
      operands[7] = x8;
      x10 = XEXP (x3, 0);
      operands[3] = x10;
      x9 = XEXP (x2, 2);
      operands[2] = x9;
      res = recog_398 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x10) != SIGN_EXTEND
          || GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          if (pattern683 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4202; /* *pred_broadcastrvvm8di_extended_scalar */

        case E_RVVM4DImode:
          if (pattern683 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4203; /* *pred_broadcastrvvm4di_extended_scalar */

        case E_RVVM2DImode:
          if (pattern683 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4204; /* *pred_broadcastrvvm2di_extended_scalar */

        case E_RVVM1DImode:
          if (pattern683 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4205; /* *pred_broadcastrvvm1di_extended_scalar */

        case E_V1DImode:
          if (pattern683 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4206; /* *pred_broadcastv1di_extended_scalar */

        case E_V2DImode:
          if (pattern683 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4207; /* *pred_broadcastv2di_extended_scalar */

        case E_V4DImode:
          if (pattern683 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4208; /* *pred_broadcastv4di_extended_scalar */

        case E_V8DImode:
          if (pattern683 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 4209; /* *pred_broadcastv8di_extended_scalar */

        case E_V16DImode:
          if (pattern683 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 4210; /* *pred_broadcastv16di_extended_scalar */

        case E_V32DImode:
          if (pattern683 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 4211; /* *pred_broadcastv32di_extended_scalar */

        case E_V64DImode:
          if (pattern683 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 4212; /* *pred_broadcastv64di_extended_scalar */

        case E_V128DImode:
          if (pattern683 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 4213; /* *pred_broadcastv128di_extended_scalar */

        case E_V256DImode:
          if (pattern683 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 4214; /* *pred_broadcastv256di_extended_scalar */

        case E_V512DImode:
          if (pattern683 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 2317 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 4215; /* *pred_broadcastv512di_extended_scalar */

        default:
          return -1;
        }

    case CONST_VECTOR:
      return recog_876 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_878 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_879 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_877 (x1, insn, pnum_clobbers);

    case AND:
      return recog_882 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_889 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_890 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_875 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_872 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_871 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_873 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_888 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_874 (x1, insn, pnum_clobbers);

    case UMIN:
      return recog_887 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_881 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_885 (x1, insn, pnum_clobbers);

    case UDIV:
      return recog_884 (x1, insn, pnum_clobbers);

    case MOD:
      return recog_886 (x1, insn, pnum_clobbers);

    case UMOD:
      return recog_883 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_903 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_892 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_901 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_900 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_899 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      return recog_895 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      return recog_904 (x1, insn, pnum_clobbers);

    case US_PLUS:
      return recog_894 (x1, insn, pnum_clobbers);

    case US_MINUS:
      return recog_893 (x1, insn, pnum_clobbers);

    case VEC_SERIES:
      return recog_891 (x1, insn, pnum_clobbers);

    case ABS:
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 4);
      operands[7] = x8;
      switch (pattern571 (x2))
        {
        case 0:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16248; /* pred_absrvvm8hf */

        case 1:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16250; /* pred_absrvvm4hf */

        case 2:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16252; /* pred_absrvvm2hf */

        case 3:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16254; /* pred_absrvvm1hf */

        case 4:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16256; /* pred_absrvvmf2hf */

        case 5:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16258; /* pred_absrvvmf4hf */

        case 6:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16260; /* pred_absrvvm8sf */

        case 7:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16262; /* pred_absrvvm4sf */

        case 8:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16264; /* pred_absrvvm2sf */

        case 9:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16266; /* pred_absrvvm1sf */

        case 10:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16268; /* pred_absrvvmf2sf */

        case 11:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16270; /* pred_absrvvm8df */

        case 12:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16272; /* pred_absrvvm4df */

        case 13:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16274; /* pred_absrvvm2df */

        case 14:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16276; /* pred_absrvvm1df */

        case 15:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 16278; /* pred_absv1hf */

        case 16:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 16280; /* pred_absv2hf */

        case 17:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 16282; /* pred_absv4hf */

        case 18:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 16284; /* pred_absv8hf */

        case 19:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 16286; /* pred_absv16hf */

        case 20:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16288; /* pred_absv32hf */

        case 21:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16290; /* pred_absv64hf */

        case 22:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16292; /* pred_absv128hf */

        case 23:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16294; /* pred_absv256hf */

        case 24:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16296; /* pred_absv512hf */

        case 25:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16298; /* pred_absv1024hf */

        case 26:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16300; /* pred_absv2048hf */

        case 27:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16302; /* pred_absv1sf */

        case 28:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16304; /* pred_absv2sf */

        case 29:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16306; /* pred_absv4sf */

        case 30:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16308; /* pred_absv8sf */

        case 31:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16310; /* pred_absv16sf */

        case 32:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16312; /* pred_absv32sf */

        case 33:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16314; /* pred_absv64sf */

        case 34:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16316; /* pred_absv128sf */

        case 35:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16318; /* pred_absv256sf */

        case 36:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16320; /* pred_absv512sf */

        case 37:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16322; /* pred_absv1024sf */

        case 38:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16324; /* pred_absv1df */

        case 39:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16326; /* pred_absv2df */

        case 40:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16328; /* pred_absv4df */

        case 41:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16330; /* pred_absv8df */

        case 42:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16332; /* pred_absv16df */

        case 43:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16334; /* pred_absv32df */

        case 44:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16336; /* pred_absv64df */

        case 45:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16338; /* pred_absv128df */

        case 46:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16340; /* pred_absv256df */

        case 47:
          if (!(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16342; /* pred_absv512df */

        default:
          return -1;
        }

    case FIX:
      return recog_896 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_897 (x1, insn, pnum_clobbers);

    case FLOAT:
      switch (pattern504 (x2))
        {
        case 0:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17672; /* pred_widen_floatrvvm8hf */

        case 1:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17674; /* pred_widen_floatrvvm4hf */

        case 2:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17676; /* pred_widen_floatrvvm2hf */

        case 3:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17678; /* pred_widen_floatrvvm1hf */

        case 4:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17680; /* pred_widen_floatrvvmf2hf */

        case 5:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17682; /* pred_widen_floatrvvmf4hf */

        case 6:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17684; /* pred_widen_floatrvvm8sf */

        case 7:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17686; /* pred_widen_floatrvvm4sf */

        case 8:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17688; /* pred_widen_floatrvvm2sf */

        case 9:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17690; /* pred_widen_floatrvvm1sf */

        case 10:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17692; /* pred_widen_floatrvvmf2sf */

        case 11:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17694; /* pred_widen_floatrvvm8df */

        case 12:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17696; /* pred_widen_floatrvvm4df */

        case 13:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17698; /* pred_widen_floatrvvm2df */

        case 14:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17700; /* pred_widen_floatrvvm1df */

        case 15:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17702; /* pred_widen_floatv1hf */

        case 16:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17704; /* pred_widen_floatv2hf */

        case 17:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17706; /* pred_widen_floatv4hf */

        case 18:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 17708; /* pred_widen_floatv8hf */

        case 19:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 17710; /* pred_widen_floatv16hf */

        case 20:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17712; /* pred_widen_floatv32hf */

        case 21:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17714; /* pred_widen_floatv64hf */

        case 22:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17716; /* pred_widen_floatv128hf */

        case 23:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17718; /* pred_widen_floatv256hf */

        case 24:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17720; /* pred_widen_floatv512hf */

        case 25:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17722; /* pred_widen_floatv1024hf */

        case 26:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17724; /* pred_widen_floatv2048hf */

        case 27:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17726; /* pred_widen_floatv1sf */

        case 28:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17728; /* pred_widen_floatv2sf */

        case 29:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17730; /* pred_widen_floatv4sf */

        case 30:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17732; /* pred_widen_floatv8sf */

        case 31:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17734; /* pred_widen_floatv16sf */

        case 32:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17736; /* pred_widen_floatv32sf */

        case 33:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17738; /* pred_widen_floatv64sf */

        case 34:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17740; /* pred_widen_floatv128sf */

        case 35:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17742; /* pred_widen_floatv256sf */

        case 36:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17744; /* pred_widen_floatv512sf */

        case 37:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17746; /* pred_widen_floatv1024sf */

        case 38:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17748; /* pred_widen_floatv1df */

        case 39:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17750; /* pred_widen_floatv2df */

        case 40:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17752; /* pred_widen_floatv4df */

        case 41:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17754; /* pred_widen_floatv8df */

        case 42:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17756; /* pred_widen_floatv16df */

        case 43:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17758; /* pred_widen_floatv32df */

        case 44:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17760; /* pred_widen_floatv64df */

        case 45:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17762; /* pred_widen_floatv128df */

        case 46:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17764; /* pred_widen_floatv256df */

        case 47:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17766; /* pred_widen_floatv512df */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern504 (x2))
        {
        case 0:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17673; /* pred_widen_floatunsrvvm8hf */

        case 1:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17675; /* pred_widen_floatunsrvvm4hf */

        case 2:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17677; /* pred_widen_floatunsrvvm2hf */

        case 3:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17679; /* pred_widen_floatunsrvvm1hf */

        case 4:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17681; /* pred_widen_floatunsrvvmf2hf */

        case 5:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17683; /* pred_widen_floatunsrvvmf4hf */

        case 6:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17685; /* pred_widen_floatunsrvvm8sf */

        case 7:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17687; /* pred_widen_floatunsrvvm4sf */

        case 8:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17689; /* pred_widen_floatunsrvvm2sf */

        case 9:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17691; /* pred_widen_floatunsrvvm1sf */

        case 10:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17693; /* pred_widen_floatunsrvvmf2sf */

        case 11:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17695; /* pred_widen_floatunsrvvm8df */

        case 12:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17697; /* pred_widen_floatunsrvvm4df */

        case 13:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17699; /* pred_widen_floatunsrvvm2df */

        case 14:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17701; /* pred_widen_floatunsrvvm1df */

        case 15:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17703; /* pred_widen_floatunsv1hf */

        case 16:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17705; /* pred_widen_floatunsv2hf */

        case 17:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17707; /* pred_widen_floatunsv4hf */

        case 18:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 17709; /* pred_widen_floatunsv8hf */

        case 19:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 17711; /* pred_widen_floatunsv16hf */

        case 20:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17713; /* pred_widen_floatunsv32hf */

        case 21:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17715; /* pred_widen_floatunsv64hf */

        case 22:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17717; /* pred_widen_floatunsv128hf */

        case 23:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17719; /* pred_widen_floatunsv256hf */

        case 24:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17721; /* pred_widen_floatunsv512hf */

        case 25:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17723; /* pred_widen_floatunsv1024hf */

        case 26:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17725; /* pred_widen_floatunsv2048hf */

        case 27:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17727; /* pred_widen_floatunsv1sf */

        case 28:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17729; /* pred_widen_floatunsv2sf */

        case 29:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17731; /* pred_widen_floatunsv4sf */

        case 30:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17733; /* pred_widen_floatunsv8sf */

        case 31:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17735; /* pred_widen_floatunsv16sf */

        case 32:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17737; /* pred_widen_floatunsv32sf */

        case 33:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17739; /* pred_widen_floatunsv64sf */

        case 34:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17741; /* pred_widen_floatunsv128sf */

        case 35:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17743; /* pred_widen_floatunsv256sf */

        case 36:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17745; /* pred_widen_floatunsv512sf */

        case 37:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17747; /* pred_widen_floatunsv1024sf */

        case 38:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17749; /* pred_widen_floatunsv1df */

        case 39:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17751; /* pred_widen_floatunsv2df */

        case 40:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17753; /* pred_widen_floatunsv4df */

        case 41:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17755; /* pred_widen_floatunsv8df */

        case 42:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17757; /* pred_widen_floatunsv16df */

        case 43:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17759; /* pred_widen_floatunsv32df */

        case 44:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17761; /* pred_widen_floatunsv64df */

        case 45:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17763; /* pred_widen_floatunsv128df */

        case 46:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17765; /* pred_widen_floatunsv256df */

        case 47:
          if (!(
#line 7597 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17767; /* pred_widen_floatunsv512df */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      return recog_902 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_898 (x1, insn, pnum_clobbers);

    case ROTATERT:
      return recog_880 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_919 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern718 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11390; /* pred_aaddurvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11866; /* pred_aaddurvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11397; /* pred_aaddurvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11871; /* pred_aaddurvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11404; /* pred_aaddurvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11876; /* pred_aaddurvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11411; /* pred_aaddurvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11881; /* pred_aaddurvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11418; /* pred_aaddurvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11901; /* pred_aaddurvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11425; /* pred_aaddurvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11906; /* pred_aaddurvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11432; /* pred_aaddurvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11911; /* pred_aaddurvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11439; /* pred_aaddurvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11916; /* pred_aaddurvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11446; /* pred_aaddurvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11931; /* pred_aaddurvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11453; /* pred_aaddurvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11936; /* pred_aaddurvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11460; /* pred_aaddurvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11941; /* pred_aaddurvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11467; /* pred_aaddurvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11946; /* pred_aaddurvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11474; /* pred_aaddurvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12180; /* *pred_aaddurvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11481; /* pred_aaddurvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12185; /* *pred_aaddurvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11488; /* pred_aaddurvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12190; /* *pred_aaddurvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11495; /* pred_aaddurvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12195; /* *pred_aaddurvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11502; /* pred_aaddurvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11886; /* pred_aaddurvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11509; /* pred_aaddurvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11891; /* pred_aaddurvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11516; /* pred_aaddurvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11896; /* pred_aaddurvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11523; /* pred_aaddurvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11921; /* pred_aaddurvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11530; /* pred_aaddurvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11926; /* pred_aaddurvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11537; /* pred_aaddurvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11951; /* pred_aaddurvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11544; /* pred_aadduv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 557 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11956; /* pred_aadduv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11551; /* pred_aadduv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 558 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11961; /* pred_aadduv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11558; /* pred_aadduv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 559 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11966; /* pred_aadduv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11565; /* pred_aadduv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 560 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11971; /* pred_aadduv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11572; /* pred_aadduv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 561 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11976; /* pred_aadduv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11579; /* pred_aadduv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 562 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11981; /* pred_aadduv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11586; /* pred_aadduv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 563 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11986; /* pred_aadduv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11593; /* pred_aadduv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 564 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11991; /* pred_aadduv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11600; /* pred_aadduv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11996; /* pred_aadduv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11607; /* pred_aadduv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 566 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12001; /* pred_aadduv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11614; /* pred_aadduv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12006; /* pred_aadduv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11621; /* pred_aadduv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 568 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12011; /* pred_aadduv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11628; /* pred_aadduv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12016; /* pred_aadduv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11635; /* pred_aadduv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 570 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12021; /* pred_aadduv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11642; /* pred_aadduv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12026; /* pred_aadduv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11649; /* pred_aadduv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12031; /* pred_aadduv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11656; /* pred_aadduv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12036; /* pred_aadduv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11663; /* pred_aadduv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12041; /* pred_aadduv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11670; /* pred_aadduv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12046; /* pred_aadduv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11677; /* pred_aadduv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12051; /* pred_aadduv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11684; /* pred_aadduv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12056; /* pred_aadduv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11691; /* pred_aadduv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12061; /* pred_aadduv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11698; /* pred_aadduv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12066; /* pred_aadduv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11705; /* pred_aadduv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12071; /* pred_aadduv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11712; /* pred_aadduv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12076; /* pred_aadduv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11719; /* pred_aadduv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12081; /* pred_aadduv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11726; /* pred_aadduv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12086; /* pred_aadduv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11733; /* pred_aadduv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12091; /* pred_aadduv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11740; /* pred_aadduv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12096; /* pred_aadduv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11747; /* pred_aadduv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12101; /* pred_aadduv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11754; /* pred_aadduv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12106; /* pred_aadduv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11761; /* pred_aadduv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12111; /* pred_aadduv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11768; /* pred_aadduv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12116; /* pred_aadduv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11775; /* pred_aadduv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12121; /* pred_aadduv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11782; /* pred_aadduv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12126; /* pred_aadduv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11789; /* pred_aadduv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12131; /* pred_aadduv1024si_scalar */

    case 58:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11796; /* pred_aadduv1di */

    case 59:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11803; /* pred_aadduv2di */

    case 60:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11810; /* pred_aadduv4di */

    case 61:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11817; /* pred_aadduv8di */

    case 62:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11824; /* pred_aadduv16di */

    case 63:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11831; /* pred_aadduv32di */

    case 64:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11838; /* pred_aadduv64di */

    case 65:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11845; /* pred_aadduv128di */

    case 66:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11852; /* pred_aadduv256di */

    case 67:
      if (!(
#line 4542 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11859; /* pred_aadduv512di */

    case 68:
      if (!(
#line 4668 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12200; /* *pred_aaddurvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4668 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12205; /* *pred_aaddurvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4668 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12210; /* *pred_aaddurvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4668 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12215; /* *pred_aaddurvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_1056 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15773; /* *pred_mul_neg_addv1sf_undef */
}

 int
recog_1065 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15791; /* *pred_mul_neg_addv512sf_undef */
}

 int
recog_1075 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15811; /* *pred_mul_neg_addv256df_undef */
}

 int
recog_1085 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1068 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15893; /* *pred_nmsubv2df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15989; /* *pred_nmsacv2df */
}

 int
recog_1095 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1058 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15873; /* *pred_nmsubv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15969; /* *pred_nmsacv4sf */
}

 int
recog_1105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1048 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15853; /* *pred_nmsubv16hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15949; /* *pred_nmsacv16hf */
}

 int
recog_1115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1038 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15833; /* *pred_nmsubrvvm1sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15929; /* *pred_nmsacrvvm1sf */
}

 int
recog_1125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern579 (x2))
    {
    case 0:
      return recog_1028 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1027 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1026 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1025 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1024 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1023 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1022 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1021 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1020 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1019 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1018 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1017 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1016 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1015 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1014 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1013 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1012 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1011 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1010 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1009 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1008 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1007 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1006 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1005 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1004 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1003 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1002 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1001 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1000 (x1, insn, pnum_clobbers);

    case 29:
      return recog_999 (x1, insn, pnum_clobbers);

    case 30:
      return recog_998 (x1, insn, pnum_clobbers);

    case 31:
      return recog_997 (x1, insn, pnum_clobbers);

    case 32:
      return recog_996 (x1, insn, pnum_clobbers);

    case 33:
      return recog_995 (x1, insn, pnum_clobbers);

    case 34:
      return recog_994 (x1, insn, pnum_clobbers);

    case 35:
      return recog_993 (x1, insn, pnum_clobbers);

    case 36:
      return recog_992 (x1, insn, pnum_clobbers);

    case 37:
      return recog_991 (x1, insn, pnum_clobbers);

    case 38:
      return recog_990 (x1, insn, pnum_clobbers);

    case 39:
      return recog_989 (x1, insn, pnum_clobbers);

    case 40:
      return recog_988 (x1, insn, pnum_clobbers);

    case 41:
      return recog_987 (x1, insn, pnum_clobbers);

    case 42:
      return recog_986 (x1, insn, pnum_clobbers);

    case 43:
      return recog_985 (x1, insn, pnum_clobbers);

    case 44:
      return recog_984 (x1, insn, pnum_clobbers);

    case 45:
      return recog_983 (x1, insn, pnum_clobbers);

    case 46:
      return recog_982 (x1, insn, pnum_clobbers);

    case 47:
      return recog_981 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15527; /* *pred_maddrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15623; /* *pred_maccrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15529; /* *pred_maddrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15625; /* *pred_maccrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15531; /* *pred_maddrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15627; /* *pred_maccrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15533; /* *pred_maddrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15629; /* *pred_maccrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15535; /* *pred_maddrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15631; /* *pred_maccrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return 15537; /* *pred_maddrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15633; /* *pred_maccrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15539; /* *pred_maddrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15635; /* *pred_maccrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15541; /* *pred_maddrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15637; /* *pred_maccrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15543; /* *pred_maddrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15639; /* *pred_maccrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15545; /* *pred_maddrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15641; /* *pred_maccrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 15547; /* *pred_maddrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15643; /* *pred_maccrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15549; /* *pred_maddrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15645; /* *pred_maccrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15551; /* *pred_maddrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15647; /* *pred_maccrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15553; /* *pred_maddrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15649; /* *pred_maccrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15555; /* *pred_maddrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15651; /* *pred_maccrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 15557; /* *pred_maddv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15653; /* *pred_maccv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 15559; /* *pred_maddv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15655; /* *pred_maccv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 15561; /* *pred_maddv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15657; /* *pred_maccv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 15563; /* *pred_maddv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15659; /* *pred_maccv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 15565; /* *pred_maddv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15661; /* *pred_maccv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 15567; /* *pred_maddv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15663; /* *pred_maccv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 15569; /* *pred_maddv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15665; /* *pred_maccv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 15571; /* *pred_maddv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15667; /* *pred_maccv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 15573; /* *pred_maddv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15669; /* *pred_maccv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 15575; /* *pred_maddv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15671; /* *pred_maccv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 15577; /* *pred_maddv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15673; /* *pred_maccv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 15579; /* *pred_maddv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15675; /* *pred_maccv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15581; /* *pred_maddv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15677; /* *pred_maccv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15583; /* *pred_maddv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15679; /* *pred_maccv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15585; /* *pred_maddv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15681; /* *pred_maccv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15587; /* *pred_maddv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15683; /* *pred_maccv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 15589; /* *pred_maddv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15685; /* *pred_maccv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 15591; /* *pred_maddv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15687; /* *pred_maccv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 15593; /* *pred_maddv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15689; /* *pred_maccv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 15595; /* *pred_maddv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15691; /* *pred_maccv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 15597; /* *pred_maddv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15693; /* *pred_maccv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 15599; /* *pred_maddv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15695; /* *pred_maccv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 15601; /* *pred_maddv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15697; /* *pred_maccv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15603; /* *pred_maddv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15699; /* *pred_maccv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15605; /* *pred_maddv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15701; /* *pred_maccv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15607; /* *pred_maddv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15703; /* *pred_maccv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 15609; /* *pred_maddv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15705; /* *pred_maccv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 15611; /* *pred_maddv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15707; /* *pred_maccv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 15613; /* *pred_maddv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15709; /* *pred_maccv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 15615; /* *pred_maddv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15711; /* *pred_maccv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 15617; /* *pred_maddv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15713; /* *pred_maccv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 15619; /* *pred_maddv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15715; /* *pred_maccv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 15621; /* *pred_maddv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15717; /* *pred_maccv512df_scalar */

    case 96:
      return recog_980 (x1, insn, pnum_clobbers);

    case 97:
      return recog_979 (x1, insn, pnum_clobbers);

    case 98:
      return recog_978 (x1, insn, pnum_clobbers);

    case 99:
      return recog_977 (x1, insn, pnum_clobbers);

    case 100:
      return recog_976 (x1, insn, pnum_clobbers);

    case 101:
      if (pattern698 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16698; /* pred_widen_mul_addrvvm8df */

    case 102:
      if (pattern698 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16700; /* pred_widen_mul_addrvvm4df */

    case 103:
      if (pattern698 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16702; /* pred_widen_mul_addrvvm2df */

    case 104:
      if (pattern698 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16704; /* pred_widen_mul_addrvvm1df */

    case 105:
      if (pattern698 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16706; /* pred_widen_mul_addv1sf */

    case 106:
      if (pattern698 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16708; /* pred_widen_mul_addv2sf */

    case 107:
      if (pattern698 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1020 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16710; /* pred_widen_mul_addv4sf */

    case 108:
      if (pattern698 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1021 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16712; /* pred_widen_mul_addv8sf */

    case 109:
      if (pattern698 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1022 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16714; /* pred_widen_mul_addv16sf */

    case 110:
      if (pattern698 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16716; /* pred_widen_mul_addv32sf */

    case 111:
      if (pattern698 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16718; /* pred_widen_mul_addv64sf */

    case 112:
      if (pattern698 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16720; /* pred_widen_mul_addv128sf */

    case 113:
      if (pattern698 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16722; /* pred_widen_mul_addv256sf */

    case 114:
      if (pattern698 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16724; /* pred_widen_mul_addv512sf */

    case 115:
      if (pattern698 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1028 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16726; /* pred_widen_mul_addv1024sf */

    case 116:
      if (pattern698 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16728; /* pred_widen_mul_addv1df */

    case 117:
      if (pattern698 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16730; /* pred_widen_mul_addv2df */

    case 118:
      if (pattern698 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1031 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16732; /* pred_widen_mul_addv4df */

    case 119:
      if (pattern698 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16734; /* pred_widen_mul_addv8df */

    case 120:
      if (pattern698 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16736; /* pred_widen_mul_addv16df */

    case 121:
      if (pattern698 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16738; /* pred_widen_mul_addv32df */

    case 122:
      if (pattern698 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16740; /* pred_widen_mul_addv64df */

    case 123:
      if (pattern698 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16742; /* pred_widen_mul_addv128df */

    case 124:
      if (pattern698 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16744; /* pred_widen_mul_addv256df */

    case 125:
      if (pattern698 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16746; /* pred_widen_mul_addv512df */

    case 126:
      return recog_975 (x1, insn, pnum_clobbers);

    case 127:
      return recog_974 (x1, insn, pnum_clobbers);

    case 128:
      return recog_973 (x1, insn, pnum_clobbers);

    case 129:
      return recog_972 (x1, insn, pnum_clobbers);

    case 130:
      return recog_971 (x1, insn, pnum_clobbers);

    case 131:
      if (pattern700 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16758; /* pred_widen_mul_addrvvm8df_scalar */

    case 132:
      if (pattern700 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16760; /* pred_widen_mul_addrvvm4df_scalar */

    case 133:
      if (pattern700 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16762; /* pred_widen_mul_addrvvm2df_scalar */

    case 134:
      if (pattern700 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16764; /* pred_widen_mul_addrvvm1df_scalar */

    case 135:
      if (pattern700 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16766; /* pred_widen_mul_addv1sf_scalar */

    case 136:
      if (pattern700 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16768; /* pred_widen_mul_addv2sf_scalar */

    case 137:
      if (pattern700 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1020 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16770; /* pred_widen_mul_addv4sf_scalar */

    case 138:
      if (pattern700 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1021 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16772; /* pred_widen_mul_addv8sf_scalar */

    case 139:
      if (pattern700 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1022 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16774; /* pred_widen_mul_addv16sf_scalar */

    case 140:
      if (pattern700 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16776; /* pred_widen_mul_addv32sf_scalar */

    case 141:
      if (pattern700 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16778; /* pred_widen_mul_addv64sf_scalar */

    case 142:
      if (pattern700 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16780; /* pred_widen_mul_addv128sf_scalar */

    case 143:
      if (pattern700 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16782; /* pred_widen_mul_addv256sf_scalar */

    case 144:
      if (pattern700 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16784; /* pred_widen_mul_addv512sf_scalar */

    case 145:
      if (pattern700 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1028 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16786; /* pred_widen_mul_addv1024sf_scalar */

    case 146:
      if (pattern700 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16788; /* pred_widen_mul_addv1df_scalar */

    case 147:
      if (pattern700 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16790; /* pred_widen_mul_addv2df_scalar */

    case 148:
      if (pattern700 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1031 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16792; /* pred_widen_mul_addv4df_scalar */

    case 149:
      if (pattern700 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16794; /* pred_widen_mul_addv8df_scalar */

    case 150:
      if (pattern700 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16796; /* pred_widen_mul_addv16df_scalar */

    case 151:
      if (pattern700 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16798; /* pred_widen_mul_addv32df_scalar */

    case 152:
      if (pattern700 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16800; /* pred_widen_mul_addv64df_scalar */

    case 153:
      if (pattern700 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16802; /* pred_widen_mul_addv128df_scalar */

    case 154:
      if (pattern700 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16804; /* pred_widen_mul_addv256df_scalar */

    case 155:
      if (pattern700 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16806; /* pred_widen_mul_addv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern572 (x2))
    {
    case 0:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17457; /* pred_floatunsrvvm8hf */

    case 1:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17459; /* pred_floatunsrvvm4hf */

    case 2:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17991; /* pred_narrow_floatunsrvvm8si */

    case 3:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17461; /* pred_floatunsrvvm2hf */

    case 4:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17993; /* pred_narrow_floatunsrvvm4si */

    case 5:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17463; /* pred_floatunsrvvm1hf */

    case 6:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17995; /* pred_narrow_floatunsrvvm2si */

    case 7:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17465; /* pred_floatunsrvvmf2hf */

    case 8:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17997; /* pred_narrow_floatunsrvvm1si */

    case 9:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17467; /* pred_floatunsrvvmf4hf */

    case 10:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17999; /* pred_narrow_floatunsrvvmf2si */

    case 11:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17469; /* pred_floatunsrvvm8sf */

    case 12:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17471; /* pred_floatunsrvvm4sf */

    case 13:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18001; /* pred_narrow_floatunsrvvm8di */

    case 14:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17473; /* pred_floatunsrvvm2sf */

    case 15:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18003; /* pred_narrow_floatunsrvvm4di */

    case 16:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17475; /* pred_floatunsrvvm1sf */

    case 17:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18005; /* pred_narrow_floatunsrvvm2di */

    case 18:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17477; /* pred_floatunsrvvmf2sf */

    case 19:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18007; /* pred_narrow_floatunsrvvm1di */

    case 20:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17479; /* pred_floatunsrvvm8df */

    case 21:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17481; /* pred_floatunsrvvm4df */

    case 22:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17483; /* pred_floatunsrvvm2df */

    case 23:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17485; /* pred_floatunsrvvm1df */

    case 24:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17487; /* pred_floatunsv1hf */

    case 25:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 18009; /* pred_narrow_floatunsv1si */

    case 26:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17489; /* pred_floatunsv2hf */

    case 27:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 18011; /* pred_narrow_floatunsv2si */

    case 28:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17491; /* pred_floatunsv4hf */

    case 29:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 18013; /* pred_narrow_floatunsv4si */

    case 30:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17493; /* pred_floatunsv8hf */

    case 31:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 18015; /* pred_narrow_floatunsv8si */

    case 32:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17495; /* pred_floatunsv16hf */

    case 33:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 18017; /* pred_narrow_floatunsv16si */

    case 34:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17497; /* pred_floatunsv32hf */

    case 35:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 18019; /* pred_narrow_floatunsv32si */

    case 36:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17499; /* pred_floatunsv64hf */

    case 37:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 18021; /* pred_narrow_floatunsv64si */

    case 38:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17501; /* pred_floatunsv128hf */

    case 39:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 18023; /* pred_narrow_floatunsv128si */

    case 40:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17503; /* pred_floatunsv256hf */

    case 41:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18025; /* pred_narrow_floatunsv256si */

    case 42:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17505; /* pred_floatunsv512hf */

    case 43:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18027; /* pred_narrow_floatunsv512si */

    case 44:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17507; /* pred_floatunsv1024hf */

    case 45:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18029; /* pred_narrow_floatunsv1024si */

    case 46:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17509; /* pred_floatunsv2048hf */

    case 47:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17511; /* pred_floatunsv1sf */

    case 48:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18031; /* pred_narrow_floatunsv1di */

    case 49:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17513; /* pred_floatunsv2sf */

    case 50:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18033; /* pred_narrow_floatunsv2di */

    case 51:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17515; /* pred_floatunsv4sf */

    case 52:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18035; /* pred_narrow_floatunsv4di */

    case 53:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17517; /* pred_floatunsv8sf */

    case 54:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 18037; /* pred_narrow_floatunsv8di */

    case 55:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17519; /* pred_floatunsv16sf */

    case 56:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 18039; /* pred_narrow_floatunsv16di */

    case 57:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17521; /* pred_floatunsv32sf */

    case 58:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 18041; /* pred_narrow_floatunsv32di */

    case 59:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17523; /* pred_floatunsv64sf */

    case 60:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 18043; /* pred_narrow_floatunsv64di */

    case 61:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17525; /* pred_floatunsv128sf */

    case 62:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18045; /* pred_narrow_floatunsv128di */

    case 63:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17527; /* pred_floatunsv256sf */

    case 64:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18047; /* pred_narrow_floatunsv256di */

    case 65:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17529; /* pred_floatunsv512sf */

    case 66:
      if (!(
#line 7687 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18049; /* pred_narrow_floatunsv512di */

    case 67:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17531; /* pred_floatunsv1024sf */

    case 68:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17533; /* pred_floatunsv1df */

    case 69:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17535; /* pred_floatunsv2df */

    case 70:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17537; /* pred_floatunsv4df */

    case 71:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17539; /* pred_floatunsv8df */

    case 72:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17541; /* pred_floatunsv16df */

    case 73:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17543; /* pred_floatunsv32df */

    case 74:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17545; /* pred_floatunsv64df */

    case 75:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17547; /* pred_floatunsv128df */

    case 76:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17549; /* pred_floatunsv256df */

    case 77:
      if (!(
#line 7527 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17551; /* pred_floatunsv512df */

    default:
      return -1;
    }
}

 int
recog_1340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode)
          || !vector_arith_operand (operands[4], E_V8QImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12437; /* *pred_cmpv8qi_merge_tie_mask */

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode)
          || !vector_arith_operand (operands[4], E_V8HImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12450; /* *pred_cmpv8hi_merge_tie_mask */

    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !vector_arith_operand (operands[4], E_V8SImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12462; /* *pred_cmpv8si_merge_tie_mask */

    case E_V8DImode:
      if (!register_operand (operands[3], E_V8DImode)
          || !vector_arith_operand (operands[4], E_V8DImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12473; /* *pred_cmpv8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256QImode:
      if (!register_operand (operands[3], E_V256QImode)
          || !vector_arith_operand (operands[4], E_V256QImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12442; /* *pred_cmpv256qi_merge_tie_mask */

    case E_V256HImode:
      if (!register_operand (operands[3], E_V256HImode)
          || !vector_arith_operand (operands[4], E_V256HImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12455; /* *pred_cmpv256hi_merge_tie_mask */

    case E_V256SImode:
      if (!register_operand (operands[3], E_V256SImode)
          || !vector_arith_operand (operands[4], E_V256SImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12467; /* *pred_cmpv256si_merge_tie_mask */

    case E_V256DImode:
      if (!register_operand (operands[3], E_V256DImode)
          || !vector_arith_operand (operands[4], E_V256DImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12478; /* *pred_cmpv256di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1342 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32QImode:
      if (!register_operand (operands[4], E_V32QImode)
          || !vector_arith_operand (operands[5], E_V32QImode))
        return -1;
      if ((
#line 4782 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32QImode)) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 12507; /* *pred_cmpv32qi */
      if (!(
#line 4803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32QImode)) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12575; /* *pred_cmpv32qi_narrow */

    case E_V32HImode:
      if (!register_operand (operands[4], E_V32HImode)
          || !vector_arith_operand (operands[5], E_V32HImode))
        return -1;
      if ((
#line 4782 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HImode)) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12520; /* *pred_cmpv32hi */
      if (!(
#line 4803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HImode)) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12588; /* *pred_cmpv32hi_narrow */

    case E_V32SImode:
      if (!register_operand (operands[4], E_V32SImode)
          || !vector_arith_operand (operands[5], E_V32SImode))
        return -1;
      if ((
#line 4782 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SImode)) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12532; /* *pred_cmpv32si */
      if (!(
#line 4803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SImode)) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12600; /* *pred_cmpv32si_narrow */

    case E_V32DImode:
      if (!register_operand (operands[4], E_V32DImode)
          || !vector_arith_operand (operands[5], E_V32DImode))
        return -1;
      if ((
#line 4782 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DImode)) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12543; /* *pred_cmpv32di */
      if (!(
#line 4803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DImode)) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12611; /* *pred_cmpv32di_narrow */

    default:
      return -1;
    }
}

 int
recog_1360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1QImode)
          || !
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12619; /* *pred_ltgervvm1qi_merge_tie_mask */

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM2HImode)
          || !
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12622; /* *pred_ltgervvm2hi_merge_tie_mask */

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM4SImode)
          || !
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12625; /* *pred_ltgervvm4si_merge_tie_mask */

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM8DImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12628; /* *pred_ltgervvm8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2QImode:
      if (!register_operand (operands[3], E_V2QImode)
          || !vector_neg_arith_operand (operands[4], E_V2QImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 12639; /* *pred_ltgev2qi_merge_tie_mask */

    case E_V2HImode:
      if (!register_operand (operands[3], E_V2HImode)
          || !vector_neg_arith_operand (operands[4], E_V2HImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12652; /* *pred_ltgev2hi_merge_tie_mask */

    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode)
          || !vector_neg_arith_operand (operands[4], E_V2SImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12664; /* *pred_ltgev2si_merge_tie_mask */

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode)
          || !vector_neg_arith_operand (operands[4], E_V2DImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12675; /* *pred_ltgev2di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V128QImode:
      if (!register_operand (operands[3], E_V128QImode)
          || !vector_neg_arith_operand (operands[4], E_V128QImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12645; /* *pred_ltgev128qi_merge_tie_mask */

    case E_V128HImode:
      if (!register_operand (operands[3], E_V128HImode)
          || !vector_neg_arith_operand (operands[4], E_V128HImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12658; /* *pred_ltgev128hi_merge_tie_mask */

    case E_V128SImode:
      if (!register_operand (operands[3], E_V128SImode)
          || !vector_neg_arith_operand (operands[4], E_V128SImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12670; /* *pred_ltgev128si_merge_tie_mask */

    case E_V128DImode:
      if (!register_operand (operands[3], E_V128DImode)
          || !vector_neg_arith_operand (operands[4], E_V128DImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12681; /* *pred_ltgev128di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1378 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern533 (x2, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V128BImode))
    {
      res = recog_1371 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128QImode:
      if (!register_operand (operands[4], E_V128QImode)
          || !vector_neg_arith_operand (operands[5], E_V128QImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128QImode)) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 12713; /* *pred_ltgev128qi */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128QImode)) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12781; /* *pred_ltgev128qi_narrow */

    case E_V128HImode:
      if (!register_operand (operands[4], E_V128HImode)
          || !vector_neg_arith_operand (operands[5], E_V128HImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HImode)) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12726; /* *pred_ltgev128hi */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HImode)) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12794; /* *pred_ltgev128hi_narrow */

    case E_V128SImode:
      if (!register_operand (operands[4], E_V128SImode)
          || !vector_neg_arith_operand (operands[5], E_V128SImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SImode)) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12738; /* *pred_ltgev128si */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SImode)) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12806; /* *pred_ltgev128si_narrow */

    case E_V128DImode:
      if (!register_operand (operands[4], E_V128DImode)
          || !vector_neg_arith_operand (operands[5], E_V128DImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12749; /* *pred_ltgev128di */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12817; /* *pred_ltgev128di_narrow */

    default:
      return -1;
    }
}

 int
recog_1390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF8QImode:
      if (!register_operand (operands[3], E_RVVMF8QImode)
          || GET_MODE (x9) != E_RVVMF8QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12826; /* *pred_cmprvvmf8qi_scalar_merge_tie_mask */

    case E_RVVMF4HImode:
      if (!register_operand (operands[3], E_RVVMF4HImode)
          || GET_MODE (x9) != E_RVVMF4HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12832; /* *pred_cmprvvmf4hi_scalar_merge_tie_mask */

    case E_RVVMF2SImode:
      if (!register_operand (operands[3], E_RVVMF2SImode)
          || GET_MODE (x9) != E_RVVMF2SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12837; /* *pred_cmprvvmf2si_scalar_merge_tie_mask */

    case E_RVVM1DImode:
      if (!register_operand (operands[3], E_RVVM1DImode)
          || GET_MODE (x9) != E_RVVM1DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5034 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12985; /* *pred_cmprvvm1di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1397 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V64QImode:
      if (!register_operand (operands[3], E_V64QImode)
          || GET_MODE (x9) != E_V64QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12844; /* *pred_cmpv64qi_scalar_merge_tie_mask */

    case E_V64HImode:
      if (!register_operand (operands[3], E_V64HImode)
          || GET_MODE (x9) != E_V64HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12857; /* *pred_cmpv64hi_scalar_merge_tie_mask */

    case E_V64SImode:
      if (!register_operand (operands[3], E_V64SImode)
          || GET_MODE (x9) != E_V64SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12869; /* *pred_cmpv64si_scalar_merge_tie_mask */

    case E_V64DImode:
      if (!register_operand (operands[3], E_V64DImode)
          || GET_MODE (x9) != E_V64DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5034 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12992; /* *pred_cmpv64di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1404 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern567 (x2, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V256BImode))
    {
      res = recog_1399 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V256BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V256BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V256QImode:
      if (!register_operand (operands[4], E_V256QImode)
          || GET_MODE (x9) != E_V256QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256QImode)) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 12900; /* *pred_cmpv256qi_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256QImode)) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12954; /* *pred_cmpv256qi_scalar_narrow */

    case E_V256HImode:
      if (!register_operand (operands[4], E_V256HImode)
          || GET_MODE (x9) != E_V256HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256HImode)) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12913; /* *pred_cmpv256hi_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256HImode)) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12967; /* *pred_cmpv256hi_scalar_narrow */

    case E_V256SImode:
      if (!register_operand (operands[4], E_V256SImode)
          || GET_MODE (x9) != E_V256SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256SImode)) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12925; /* *pred_cmpv256si_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256SImode)) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12979; /* *pred_cmpv256si_scalar_narrow */

    case E_V256DImode:
      if (!register_operand (operands[4], E_V256DImode)
          || GET_MODE (x9) != E_V256DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5059 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DImode)) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 13008; /* *pred_cmpv256di_scalar */
      if (!(
#line 5081 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DImode)) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 13022; /* *pred_cmpv256di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern567 (x2, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V2BImode))
    {
      res = recog_1392 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V2BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V2BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V2QImode:
      if (!register_operand (operands[4], E_V2QImode)
          || GET_MODE (x9) != E_V2QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2QImode)) && 
#line 717 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 12893; /* *pred_cmpv2qi_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2QImode)) && 
#line 717 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 12947; /* *pred_cmpv2qi_scalar_narrow */

    case E_V2HImode:
      if (!register_operand (operands[4], E_V2HImode)
          || GET_MODE (x9) != E_V2HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HImode)) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 12906; /* *pred_cmpv2hi_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HImode)) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12960; /* *pred_cmpv2hi_scalar_narrow */

    case E_V2SImode:
      if (!register_operand (operands[4], E_V2SImode)
          || GET_MODE (x9) != E_V2SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SImode)) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 12918; /* *pred_cmpv2si_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SImode)) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12972; /* *pred_cmpv2si_scalar_narrow */

    case E_V2DImode:
      if (!register_operand (operands[4], E_V2DImode)
          || GET_MODE (x9) != E_V2DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5059 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode)) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 13001; /* *pred_cmpv2di_scalar */
      if (!(
#line 5081 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode)) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13015; /* *pred_cmpv2di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1420 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1HFmode:
      if (!register_operand (operands[3], E_V1HFmode)
          || !register_operand (operands[4], E_V1HFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16991; /* *pred_cmpv1hf_narrow_merge_tie_mask */

    case E_V1SFmode:
      if (!register_operand (operands[3], E_V1SFmode)
          || !register_operand (operands[4], E_V1SFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17003; /* *pred_cmpv1sf_narrow_merge_tie_mask */

    case E_V1DFmode:
      if (!register_operand (operands[3], E_V1DFmode)
          || !register_operand (operands[4], E_V1DFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17014; /* *pred_cmpv1df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[3], E_V32HFmode)
          || !register_operand (operands[4], E_V32HFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16996; /* *pred_cmpv32hf_narrow_merge_tie_mask */

    case E_V32SFmode:
      if (!register_operand (operands[3], E_V32SFmode)
          || !register_operand (operands[4], E_V32SFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17008; /* *pred_cmpv32sf_narrow_merge_tie_mask */

    case E_V32DFmode:
      if (!register_operand (operands[3], E_V32DFmode)
          || !register_operand (operands[4], E_V32DFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17019; /* *pred_cmpv32df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1430 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[3], E_V1024HFmode)
          || !register_operand (operands[4], E_V1024HFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17001; /* *pred_cmpv1024hf_narrow_merge_tie_mask */

    case E_V1024SFmode:
      if (!register_operand (operands[3], E_V1024SFmode)
          || !register_operand (operands[4], E_V1024SFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17013; /* *pred_cmpv1024sf_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1434 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_RVVMF2HFmode)
          || GET_MODE (x9) != E_RVVMF2HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17076; /* *pred_cmprvvmf2hf_scalar_merge_tie_mask */

    case E_RVVM1SFmode:
      if (!register_operand (operands[3], E_RVVM1SFmode)
          || GET_MODE (x9) != E_RVVM1SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17081; /* *pred_cmprvvm1sf_scalar_merge_tie_mask */

    case E_RVVM2DFmode:
      if (!register_operand (operands[3], E_RVVM2DFmode)
          || GET_MODE (x9) != E_RVVM2DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17085; /* *pred_cmprvvm2df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1440 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[3], E_V16HFmode)
          || GET_MODE (x9) != E_V16HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17091; /* *pred_cmpv16hf_scalar_merge_tie_mask */

    case E_V16SFmode:
      if (!register_operand (operands[3], E_V16SFmode)
          || GET_MODE (x9) != E_V16SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17103; /* *pred_cmpv16sf_scalar_merge_tie_mask */

    case E_V16DFmode:
      if (!register_operand (operands[3], E_V16DFmode)
          || GET_MODE (x9) != E_V16DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17114; /* *pred_cmpv16df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1446 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[3], E_V1024HFmode)
          || GET_MODE (x9) != E_V1024HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17097; /* *pred_cmpv1024hf_scalar_merge_tie_mask */

    case E_V1024SFmode:
      if (!register_operand (operands[3], E_V1024SFmode)
          || GET_MODE (x9) != E_V1024SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17109; /* *pred_cmpv1024sf_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1451 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern544 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1441 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[4], E_V32HFmode)
          || GET_MODE (x9) != E_V32HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HFmode)) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 17140; /* *pred_cmpv32hf_scalar */
      if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HFmode)) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17188; /* *pred_cmpv32hf_scalar_narrow */

    case E_V32SFmode:
      if (!register_operand (operands[4], E_V32SFmode)
          || GET_MODE (x9) != E_V32SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SFmode)) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 17152; /* *pred_cmpv32sf_scalar */
      if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SFmode)) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17200; /* *pred_cmpv32sf_scalar_narrow */

    case E_V32DFmode:
      if (!register_operand (operands[4], E_V32DFmode)
          || GET_MODE (x9) != E_V32DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DFmode)) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 17163; /* *pred_cmpv32df_scalar */
      if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DFmode)) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17211; /* *pred_cmpv32df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1458 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern214 (x2))
    {
    case 0:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25054; /* vcond_mask_rvvm8qirvvm1bi */

    case 1:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25055; /* vcond_mask_rvvm4qirvvmf2bi */

    case 2:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25056; /* vcond_mask_rvvm2qirvvmf4bi */

    case 3:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25057; /* vcond_mask_rvvm1qirvvmf8bi */

    case 4:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25058; /* vcond_mask_rvvm8hirvvmf2bi */

    case 5:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25059; /* vcond_mask_rvvm4hirvvmf4bi */

    case 6:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25060; /* vcond_mask_rvvm2hirvvmf8bi */

    case 7:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25061; /* vcond_mask_rvvm1hirvvmf16bi */

    case 8:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25062; /* vcond_mask_rvvm8sirvvmf4bi */

    case 9:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25063; /* vcond_mask_rvvm4sirvvmf8bi */

    case 10:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25064; /* vcond_mask_rvvm2sirvvmf16bi */

    case 11:
      if (!
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25065; /* vcond_mask_rvvm1sirvvmf32bi */

    case 12:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25066; /* vcond_mask_rvvm8dirvvmf8bi */

    case 13:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25067; /* vcond_mask_rvvm4dirvvmf16bi */

    case 14:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25068; /* vcond_mask_rvvm2dirvvmf32bi */

    case 15:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25069; /* vcond_mask_rvvm1dirvvmf64bi */

    case 16:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25070; /* vcond_mask_rvvmf2qirvvmf16bi */

    case 17:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25071; /* vcond_mask_rvvmf4qirvvmf32bi */

    case 18:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25072; /* vcond_mask_rvvmf8qirvvmf64bi */

    case 19:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25073; /* vcond_mask_rvvmf2hirvvmf32bi */

    case 20:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25074; /* vcond_mask_rvvmf4hirvvmf64bi */

    case 21:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25075; /* vcond_mask_rvvmf2sirvvmf64bi */

    case 22:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25076; /* vcond_mask_rvvm8bfrvvmf2bi */

    case 23:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25077; /* vcond_mask_rvvm4bfrvvmf4bi */

    case 24:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25078; /* vcond_mask_rvvm2bfrvvmf8bi */

    case 25:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25079; /* vcond_mask_rvvm1bfrvvmf16bi */

    case 26:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25080; /* vcond_mask_rvvmf2bfrvvmf32bi */

    case 27:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25081; /* vcond_mask_rvvmf4bfrvvmf64bi */

    case 28:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25082; /* vcond_mask_rvvm8hfrvvmf2bi */

    case 29:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25083; /* vcond_mask_rvvm4hfrvvmf4bi */

    case 30:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25084; /* vcond_mask_rvvm2hfrvvmf8bi */

    case 31:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25085; /* vcond_mask_rvvm1hfrvvmf16bi */

    case 32:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25086; /* vcond_mask_rvvmf2hfrvvmf32bi */

    case 33:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25087; /* vcond_mask_rvvmf4hfrvvmf64bi */

    case 34:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25088; /* vcond_mask_rvvm8sfrvvmf4bi */

    case 35:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25089; /* vcond_mask_rvvm4sfrvvmf8bi */

    case 36:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25090; /* vcond_mask_rvvm2sfrvvmf16bi */

    case 37:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25091; /* vcond_mask_rvvm1sfrvvmf32bi */

    case 38:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25092; /* vcond_mask_rvvmf2sfrvvmf64bi */

    case 39:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25093; /* vcond_mask_rvvm8dfrvvmf8bi */

    case 40:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25094; /* vcond_mask_rvvm4dfrvvmf16bi */

    case 41:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25095; /* vcond_mask_rvvm2dfrvvmf32bi */

    case 42:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25096; /* vcond_mask_rvvm1dfrvvmf64bi */

    case 43:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 25097; /* vcond_mask_v1qiv1bi */

    case 44:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 25098; /* vcond_mask_v2qiv2bi */

    case 45:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 25099; /* vcond_mask_v4qiv4bi */

    case 46:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 25100; /* vcond_mask_v8qiv8bi */

    case 47:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 25101; /* vcond_mask_v16qiv16bi */

    case 48:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 25102; /* vcond_mask_v32qiv32bi */

    case 49:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25103; /* vcond_mask_v64qiv64bi */

    case 50:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25104; /* vcond_mask_v128qiv128bi */

    case 51:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25105; /* vcond_mask_v256qiv256bi */

    case 52:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25106; /* vcond_mask_v512qiv512bi */

    case 53:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25107; /* vcond_mask_v1024qiv1024bi */

    case 54:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25108; /* vcond_mask_v2048qiv2048bi */

    case 55:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25109; /* vcond_mask_v4096qiv4096bi */

    case 56:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25110; /* vcond_mask_v1hiv1bi */

    case 57:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25111; /* vcond_mask_v2hiv2bi */

    case 58:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25112; /* vcond_mask_v4hiv4bi */

    case 59:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25113; /* vcond_mask_v8hiv8bi */

    case 60:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25114; /* vcond_mask_v16hiv16bi */

    case 61:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25115; /* vcond_mask_v32hiv32bi */

    case 62:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25116; /* vcond_mask_v64hiv64bi */

    case 63:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25117; /* vcond_mask_v128hiv128bi */

    case 64:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25118; /* vcond_mask_v256hiv256bi */

    case 65:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25119; /* vcond_mask_v512hiv512bi */

    case 66:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25120; /* vcond_mask_v1024hiv1024bi */

    case 67:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25121; /* vcond_mask_v2048hiv2048bi */

    case 68:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25122; /* vcond_mask_v1siv1bi */

    case 69:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25123; /* vcond_mask_v2siv2bi */

    case 70:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25124; /* vcond_mask_v4siv4bi */

    case 71:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25125; /* vcond_mask_v8siv8bi */

    case 72:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25126; /* vcond_mask_v16siv16bi */

    case 73:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25127; /* vcond_mask_v32siv32bi */

    case 74:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25128; /* vcond_mask_v64siv64bi */

    case 75:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25129; /* vcond_mask_v128siv128bi */

    case 76:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25130; /* vcond_mask_v256siv256bi */

    case 77:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25131; /* vcond_mask_v512siv512bi */

    case 78:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25132; /* vcond_mask_v1024siv1024bi */

    case 79:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25133; /* vcond_mask_v1div1bi */

    case 80:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25134; /* vcond_mask_v2div2bi */

    case 81:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25135; /* vcond_mask_v4div4bi */

    case 82:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25136; /* vcond_mask_v8div8bi */

    case 83:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25137; /* vcond_mask_v16div16bi */

    case 84:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25138; /* vcond_mask_v32div32bi */

    case 85:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25139; /* vcond_mask_v64div64bi */

    case 86:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25140; /* vcond_mask_v128div128bi */

    case 87:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25141; /* vcond_mask_v256div256bi */

    case 88:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25142; /* vcond_mask_v512div512bi */

    case 89:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25143; /* vcond_mask_v1hfv1bi */

    case 90:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25144; /* vcond_mask_v2hfv2bi */

    case 91:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25145; /* vcond_mask_v4hfv4bi */

    case 92:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25146; /* vcond_mask_v8hfv8bi */

    case 93:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25147; /* vcond_mask_v16hfv16bi */

    case 94:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25148; /* vcond_mask_v32hfv32bi */

    case 95:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25149; /* vcond_mask_v64hfv64bi */

    case 96:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25150; /* vcond_mask_v128hfv128bi */

    case 97:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25151; /* vcond_mask_v256hfv256bi */

    case 98:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25152; /* vcond_mask_v512hfv512bi */

    case 99:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25153; /* vcond_mask_v1024hfv1024bi */

    case 100:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25154; /* vcond_mask_v2048hfv2048bi */

    case 101:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25155; /* vcond_mask_v1sfv1bi */

    case 102:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25156; /* vcond_mask_v2sfv2bi */

    case 103:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25157; /* vcond_mask_v4sfv4bi */

    case 104:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25158; /* vcond_mask_v8sfv8bi */

    case 105:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25159; /* vcond_mask_v16sfv16bi */

    case 106:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25160; /* vcond_mask_v32sfv32bi */

    case 107:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25161; /* vcond_mask_v64sfv64bi */

    case 108:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25162; /* vcond_mask_v128sfv128bi */

    case 109:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25163; /* vcond_mask_v256sfv256bi */

    case 110:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25164; /* vcond_mask_v512sfv512bi */

    case 111:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25165; /* vcond_mask_v1024sfv1024bi */

    case 112:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25166; /* vcond_mask_v1dfv1bi */

    case 113:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25167; /* vcond_mask_v2dfv2bi */

    case 114:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25168; /* vcond_mask_v4dfv4bi */

    case 115:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25169; /* vcond_mask_v8dfv8bi */

    case 116:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25170; /* vcond_mask_v16dfv16bi */

    case 117:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25171; /* vcond_mask_v32dfv32bi */

    case 118:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25172; /* vcond_mask_v64dfv64bi */

    case 119:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25173; /* vcond_mask_v128dfv128bi */

    case 120:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25174; /* vcond_mask_v256dfv256bi */

    case 121:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25175; /* vcond_mask_v512dfv512bi */

    case 122:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27401; /* *cond_absrvvm8hf */

    case 123:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27402; /* *cond_absrvvm4hf */

    case 124:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27403; /* *cond_absrvvm2hf */

    case 125:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27404; /* *cond_absrvvm1hf */

    case 126:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27405; /* *cond_absrvvmf2hf */

    case 127:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27406; /* *cond_absrvvmf4hf */

    case 128:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27407; /* *cond_absrvvm8sf */

    case 129:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27408; /* *cond_absrvvm4sf */

    case 130:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27409; /* *cond_absrvvm2sf */

    case 131:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27410; /* *cond_absrvvm1sf */

    case 132:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27411; /* *cond_absrvvmf2sf */

    case 133:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27412; /* *cond_absrvvm8df */

    case 134:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27413; /* *cond_absrvvm4df */

    case 135:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27414; /* *cond_absrvvm2df */

    case 136:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27415; /* *cond_absrvvm1df */

    case 137:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27416; /* *cond_absv1hf */

    case 138:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27417; /* *cond_absv2hf */

    case 139:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27418; /* *cond_absv4hf */

    case 140:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27419; /* *cond_absv8hf */

    case 141:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27420; /* *cond_absv16hf */

    case 142:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27421; /* *cond_absv32hf */

    case 143:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27422; /* *cond_absv64hf */

    case 144:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27423; /* *cond_absv128hf */

    case 145:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27424; /* *cond_absv256hf */

    case 146:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27425; /* *cond_absv512hf */

    case 147:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27426; /* *cond_absv1024hf */

    case 148:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27427; /* *cond_absv2048hf */

    case 149:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27428; /* *cond_absv1sf */

    case 150:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27429; /* *cond_absv2sf */

    case 151:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27430; /* *cond_absv4sf */

    case 152:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27431; /* *cond_absv8sf */

    case 153:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27432; /* *cond_absv16sf */

    case 154:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27433; /* *cond_absv32sf */

    case 155:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27434; /* *cond_absv64sf */

    case 156:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27435; /* *cond_absv128sf */

    case 157:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27436; /* *cond_absv256sf */

    case 158:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27437; /* *cond_absv512sf */

    case 159:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27438; /* *cond_absv1024sf */

    case 160:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27439; /* *cond_absv1df */

    case 161:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27440; /* *cond_absv2df */

    case 162:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27441; /* *cond_absv4df */

    case 163:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27442; /* *cond_absv8df */

    case 164:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27443; /* *cond_absv16df */

    case 165:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27444; /* *cond_absv32df */

    case 166:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27445; /* *cond_absv64df */

    case 167:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27446; /* *cond_absv128df */

    case 168:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27447; /* *cond_absv256df */

    case 169:
      if (!(
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27448; /* *cond_absv512df */

    case 170:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27449; /* *cond_sqrtrvvm8hf */

    case 171:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27450; /* *cond_sqrtrvvm4hf */

    case 172:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27451; /* *cond_sqrtrvvm2hf */

    case 173:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27452; /* *cond_sqrtrvvm1hf */

    case 174:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27453; /* *cond_sqrtrvvmf2hf */

    case 175:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27454; /* *cond_sqrtrvvmf4hf */

    case 176:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27455; /* *cond_sqrtrvvm8sf */

    case 177:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27456; /* *cond_sqrtrvvm4sf */

    case 178:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27457; /* *cond_sqrtrvvm2sf */

    case 179:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27458; /* *cond_sqrtrvvm1sf */

    case 180:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27459; /* *cond_sqrtrvvmf2sf */

    case 181:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27460; /* *cond_sqrtrvvm8df */

    case 182:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27461; /* *cond_sqrtrvvm4df */

    case 183:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27462; /* *cond_sqrtrvvm2df */

    case 184:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27463; /* *cond_sqrtrvvm1df */

    case 185:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27464; /* *cond_sqrtv1hf */

    case 186:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27465; /* *cond_sqrtv2hf */

    case 187:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27466; /* *cond_sqrtv4hf */

    case 188:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27467; /* *cond_sqrtv8hf */

    case 189:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27468; /* *cond_sqrtv16hf */

    case 190:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27469; /* *cond_sqrtv32hf */

    case 191:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27470; /* *cond_sqrtv64hf */

    case 192:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27471; /* *cond_sqrtv128hf */

    case 193:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27472; /* *cond_sqrtv256hf */

    case 194:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27473; /* *cond_sqrtv512hf */

    case 195:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27474; /* *cond_sqrtv1024hf */

    case 196:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27475; /* *cond_sqrtv2048hf */

    case 197:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27476; /* *cond_sqrtv1sf */

    case 198:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27477; /* *cond_sqrtv2sf */

    case 199:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27478; /* *cond_sqrtv4sf */

    case 200:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27479; /* *cond_sqrtv8sf */

    case 201:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27480; /* *cond_sqrtv16sf */

    case 202:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27481; /* *cond_sqrtv32sf */

    case 203:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27482; /* *cond_sqrtv64sf */

    case 204:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27483; /* *cond_sqrtv128sf */

    case 205:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27484; /* *cond_sqrtv256sf */

    case 206:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27485; /* *cond_sqrtv512sf */

    case 207:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27486; /* *cond_sqrtv1024sf */

    case 208:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27487; /* *cond_sqrtv1df */

    case 209:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27488; /* *cond_sqrtv2df */

    case 210:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27489; /* *cond_sqrtv4df */

    case 211:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27490; /* *cond_sqrtv8df */

    case 212:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27491; /* *cond_sqrtv16df */

    case 213:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27492; /* *cond_sqrtv32df */

    case 214:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27493; /* *cond_sqrtv64df */

    case 215:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27494; /* *cond_sqrtv128df */

    case 216:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27495; /* *cond_sqrtv256df */

    case 217:
      if (!(
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27496; /* *cond_sqrtv512df */

    case 218:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27497; /* *cond_extendrvvm4qirvvm8hi */

    case 219:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27499; /* *cond_extendrvvm2qirvvm4hi */

    case 220:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27501; /* *cond_extendrvvm1qirvvm2hi */

    case 221:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27503; /* *cond_extendrvvmf2qirvvm1hi */

    case 222:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27505; /* *cond_extendrvvmf4qirvvmf2hi */

    case 223:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27507; /* *cond_extendrvvmf8qirvvmf4hi */

    case 224:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27509; /* *cond_extendrvvm4hirvvm8si */

    case 225:
      if (!
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27593; /* *cond_extendrvvm2qirvvm8si */

    case 226:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27511; /* *cond_extendrvvm2hirvvm4si */

    case 227:
      if (!
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27595; /* *cond_extendrvvm1qirvvm4si */

    case 228:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27513; /* *cond_extendrvvm1hirvvm2si */

    case 229:
      if (!
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27597; /* *cond_extendrvvmf2qirvvm2si */

    case 230:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27515; /* *cond_extendrvvmf2hirvvm1si */

    case 231:
      if (!
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27599; /* *cond_extendrvvmf4qirvvm1si */

    case 232:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27517; /* *cond_extendrvvmf4hirvvmf2si */

    case 233:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1092 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27601; /* *cond_extendrvvmf8qirvvmf2si */

    case 234:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27519; /* *cond_extendrvvm4sirvvm8di */

    case 235:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27603; /* *cond_extendrvvm2hirvvm8di */

    case 236:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27653; /* *cond_extendrvvm1qirvvm8di */

    case 237:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27521; /* *cond_extendrvvm2sirvvm4di */

    case 238:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27605; /* *cond_extendrvvm1hirvvm4di */

    case 239:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27655; /* *cond_extendrvvmf2qirvvm4di */

    case 240:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27523; /* *cond_extendrvvm1sirvvm2di */

    case 241:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27607; /* *cond_extendrvvmf2hirvvm2di */

    case 242:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27657; /* *cond_extendrvvmf4qirvvm2di */

    case 243:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27525; /* *cond_extendrvvmf2sirvvm1di */

    case 244:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27609; /* *cond_extendrvvmf4hirvvm1di */

    case 245:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27659; /* *cond_extendrvvmf8qirvvm1di */

    case 246:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27527; /* *cond_extendv1qiv1hi */

    case 247:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27529; /* *cond_extendv2qiv2hi */

    case 248:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27531; /* *cond_extendv4qiv4hi */

    case 249:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27533; /* *cond_extendv8qiv8hi */

    case 250:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27535; /* *cond_extendv16qiv16hi */

    case 251:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27537; /* *cond_extendv32qiv32hi */

    case 252:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27539; /* *cond_extendv64qiv64hi */

    case 253:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27541; /* *cond_extendv128qiv128hi */

    case 254:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27543; /* *cond_extendv256qiv256hi */

    case 255:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27545; /* *cond_extendv512qiv512hi */

    case 256:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27547; /* *cond_extendv1024qiv1024hi */

    case 257:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27549; /* *cond_extendv2048qiv2048hi */

    case 258:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27551; /* *cond_extendv1hiv1si */

    case 259:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1097 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27611; /* *cond_extendv1qiv1si */

    case 260:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27553; /* *cond_extendv2hiv2si */

    case 261:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1098 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27613; /* *cond_extendv2qiv2si */

    case 262:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27555; /* *cond_extendv4hiv4si */

    case 263:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1099 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27615; /* *cond_extendv4qiv4si */

    case 264:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27557; /* *cond_extendv8hiv8si */

    case 265:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1100 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27617; /* *cond_extendv8qiv8si */

    case 266:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27559; /* *cond_extendv16hiv16si */

    case 267:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1101 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27619; /* *cond_extendv16qiv16si */

    case 268:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27561; /* *cond_extendv32hiv32si */

    case 269:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1102 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27621; /* *cond_extendv32qiv32si */

    case 270:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27563; /* *cond_extendv64hiv64si */

    case 271:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1103 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27623; /* *cond_extendv64qiv64si */

    case 272:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27565; /* *cond_extendv128hiv128si */

    case 273:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1104 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27625; /* *cond_extendv128qiv128si */

    case 274:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27567; /* *cond_extendv256hiv256si */

    case 275:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1105 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27627; /* *cond_extendv256qiv256si */

    case 276:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27569; /* *cond_extendv512hiv512si */

    case 277:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27629; /* *cond_extendv512qiv512si */

    case 278:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27571; /* *cond_extendv1024hiv1024si */

    case 279:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1107 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27631; /* *cond_extendv1024qiv1024si */

    case 280:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27573; /* *cond_extendv1siv1di */

    case 281:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27633; /* *cond_extendv1hiv1di */

    case 282:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1140 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27661; /* *cond_extendv1qiv1di */

    case 283:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27575; /* *cond_extendv2siv2di */

    case 284:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27635; /* *cond_extendv2hiv2di */

    case 285:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1141 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27663; /* *cond_extendv2qiv2di */

    case 286:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27577; /* *cond_extendv4siv4di */

    case 287:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1110 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27637; /* *cond_extendv4hiv4di */

    case 288:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1142 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27665; /* *cond_extendv4qiv4di */

    case 289:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27579; /* *cond_extendv8siv8di */

    case 290:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27639; /* *cond_extendv8hiv8di */

    case 291:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1143 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27667; /* *cond_extendv8qiv8di */

    case 292:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27581; /* *cond_extendv16siv16di */

    case 293:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27641; /* *cond_extendv16hiv16di */

    case 294:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1144 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27669; /* *cond_extendv16qiv16di */

    case 295:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27583; /* *cond_extendv32siv32di */

    case 296:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27643; /* *cond_extendv32hiv32di */

    case 297:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1145 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27671; /* *cond_extendv32qiv32di */

    case 298:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27585; /* *cond_extendv64siv64di */

    case 299:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27645; /* *cond_extendv64hiv64di */

    case 300:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1146 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27673; /* *cond_extendv64qiv64di */

    case 301:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27587; /* *cond_extendv128siv128di */

    case 302:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27647; /* *cond_extendv128hiv128di */

    case 303:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1147 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27675; /* *cond_extendv128qiv128di */

    case 304:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27589; /* *cond_extendv256siv256di */

    case 305:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27649; /* *cond_extendv256hiv256di */

    case 306:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1148 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27677; /* *cond_extendv256qiv256di */

    case 307:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27591; /* *cond_extendv512siv512di */

    case 308:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27651; /* *cond_extendv512hiv512di */

    case 309:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1149 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27679; /* *cond_extendv512qiv512di */

    case 310:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27498; /* *cond_zero_extendrvvm4qirvvm8hi */

    case 311:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27500; /* *cond_zero_extendrvvm2qirvvm4hi */

    case 312:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27502; /* *cond_zero_extendrvvm1qirvvm2hi */

    case 313:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27504; /* *cond_zero_extendrvvmf2qirvvm1hi */

    case 314:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27506; /* *cond_zero_extendrvvmf4qirvvmf2hi */

    case 315:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27508; /* *cond_zero_extendrvvmf8qirvvmf4hi */

    case 316:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27510; /* *cond_zero_extendrvvm4hirvvm8si */

    case 317:
      if (!
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27594; /* *cond_zero_extendrvvm2qirvvm8si */

    case 318:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27512; /* *cond_zero_extendrvvm2hirvvm4si */

    case 319:
      if (!
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27596; /* *cond_zero_extendrvvm1qirvvm4si */

    case 320:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27514; /* *cond_zero_extendrvvm1hirvvm2si */

    case 321:
      if (!
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27598; /* *cond_zero_extendrvvmf2qirvvm2si */

    case 322:
      if (!
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27516; /* *cond_zero_extendrvvmf2hirvvm1si */

    case 323:
      if (!
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27600; /* *cond_zero_extendrvvmf4qirvvm1si */

    case 324:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27518; /* *cond_zero_extendrvvmf4hirvvmf2si */

    case 325:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1092 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27602; /* *cond_zero_extendrvvmf8qirvvmf2si */

    case 326:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27520; /* *cond_zero_extendrvvm4sirvvm8di */

    case 327:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27604; /* *cond_zero_extendrvvm2hirvvm8di */

    case 328:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27654; /* *cond_zero_extendrvvm1qirvvm8di */

    case 329:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27522; /* *cond_zero_extendrvvm2sirvvm4di */

    case 330:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27606; /* *cond_zero_extendrvvm1hirvvm4di */

    case 331:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27656; /* *cond_zero_extendrvvmf2qirvvm4di */

    case 332:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27524; /* *cond_zero_extendrvvm1sirvvm2di */

    case 333:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27608; /* *cond_zero_extendrvvmf2hirvvm2di */

    case 334:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27658; /* *cond_zero_extendrvvmf4qirvvm2di */

    case 335:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27526; /* *cond_zero_extendrvvmf2sirvvm1di */

    case 336:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27610; /* *cond_zero_extendrvvmf4hirvvm1di */

    case 337:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27660; /* *cond_zero_extendrvvmf8qirvvm1di */

    case 338:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27528; /* *cond_zero_extendv1qiv1hi */

    case 339:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27530; /* *cond_zero_extendv2qiv2hi */

    case 340:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27532; /* *cond_zero_extendv4qiv4hi */

    case 341:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27534; /* *cond_zero_extendv8qiv8hi */

    case 342:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27536; /* *cond_zero_extendv16qiv16hi */

    case 343:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27538; /* *cond_zero_extendv32qiv32hi */

    case 344:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27540; /* *cond_zero_extendv64qiv64hi */

    case 345:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27542; /* *cond_zero_extendv128qiv128hi */

    case 346:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27544; /* *cond_zero_extendv256qiv256hi */

    case 347:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27546; /* *cond_zero_extendv512qiv512hi */

    case 348:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27548; /* *cond_zero_extendv1024qiv1024hi */

    case 349:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27550; /* *cond_zero_extendv2048qiv2048hi */

    case 350:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27552; /* *cond_zero_extendv1hiv1si */

    case 351:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1097 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27612; /* *cond_zero_extendv1qiv1si */

    case 352:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27554; /* *cond_zero_extendv2hiv2si */

    case 353:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1098 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27614; /* *cond_zero_extendv2qiv2si */

    case 354:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27556; /* *cond_zero_extendv4hiv4si */

    case 355:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1099 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27616; /* *cond_zero_extendv4qiv4si */

    case 356:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27558; /* *cond_zero_extendv8hiv8si */

    case 357:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1100 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27618; /* *cond_zero_extendv8qiv8si */

    case 358:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27560; /* *cond_zero_extendv16hiv16si */

    case 359:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1101 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27620; /* *cond_zero_extendv16qiv16si */

    case 360:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27562; /* *cond_zero_extendv32hiv32si */

    case 361:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1102 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27622; /* *cond_zero_extendv32qiv32si */

    case 362:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27564; /* *cond_zero_extendv64hiv64si */

    case 363:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1103 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27624; /* *cond_zero_extendv64qiv64si */

    case 364:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27566; /* *cond_zero_extendv128hiv128si */

    case 365:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1104 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27626; /* *cond_zero_extendv128qiv128si */

    case 366:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27568; /* *cond_zero_extendv256hiv256si */

    case 367:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1105 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27628; /* *cond_zero_extendv256qiv256si */

    case 368:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27570; /* *cond_zero_extendv512hiv512si */

    case 369:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27630; /* *cond_zero_extendv512qiv512si */

    case 370:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27572; /* *cond_zero_extendv1024hiv1024si */

    case 371:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1107 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27632; /* *cond_zero_extendv1024qiv1024si */

    case 372:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27574; /* *cond_zero_extendv1siv1di */

    case 373:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27634; /* *cond_zero_extendv1hiv1di */

    case 374:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1140 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27662; /* *cond_zero_extendv1qiv1di */

    case 375:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27576; /* *cond_zero_extendv2siv2di */

    case 376:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27636; /* *cond_zero_extendv2hiv2di */

    case 377:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1141 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27664; /* *cond_zero_extendv2qiv2di */

    case 378:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27578; /* *cond_zero_extendv4siv4di */

    case 379:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1110 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27638; /* *cond_zero_extendv4hiv4di */

    case 380:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1142 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27666; /* *cond_zero_extendv4qiv4di */

    case 381:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27580; /* *cond_zero_extendv8siv8di */

    case 382:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27640; /* *cond_zero_extendv8hiv8di */

    case 383:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1143 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27668; /* *cond_zero_extendv8qiv8di */

    case 384:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27582; /* *cond_zero_extendv16siv16di */

    case 385:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27642; /* *cond_zero_extendv16hiv16di */

    case 386:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1144 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27670; /* *cond_zero_extendv16qiv16di */

    case 387:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27584; /* *cond_zero_extendv32siv32di */

    case 388:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27644; /* *cond_zero_extendv32hiv32di */

    case 389:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1145 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27672; /* *cond_zero_extendv32qiv32di */

    case 390:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27586; /* *cond_zero_extendv64siv64di */

    case 391:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27646; /* *cond_zero_extendv64hiv64di */

    case 392:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1146 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27674; /* *cond_zero_extendv64qiv64di */

    case 393:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27588; /* *cond_zero_extendv128siv128di */

    case 394:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27648; /* *cond_zero_extendv128hiv128di */

    case 395:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1147 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27676; /* *cond_zero_extendv128qiv128di */

    case 396:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27590; /* *cond_zero_extendv256siv256di */

    case 397:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27650; /* *cond_zero_extendv256hiv256di */

    case 398:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1148 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27678; /* *cond_zero_extendv256qiv256di */

    case 399:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27592; /* *cond_zero_extendv512siv512di */

    case 400:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27652; /* *cond_zero_extendv512hiv512di */

    case 401:
      if (!(
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1149 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27680; /* *cond_zero_extendv512qiv512di */

    case 402:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27865; /* *cond_truncrvvm8hirvvm4qi */

    case 403:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27866; /* *cond_truncrvvm4hirvvm2qi */

    case 404:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27867; /* *cond_truncrvvm2hirvvm1qi */

    case 405:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27868; /* *cond_truncrvvm1hirvvmf2qi */

    case 406:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27869; /* *cond_truncrvvmf2hirvvmf4qi */

    case 407:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27870; /* *cond_truncrvvmf4hirvvmf8qi */

    case 408:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27871; /* *cond_truncrvvm8sirvvm4hi */

    case 409:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27872; /* *cond_truncrvvm4sirvvm2hi */

    case 410:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27873; /* *cond_truncrvvm2sirvvm1hi */

    case 411:
      if (!
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27874; /* *cond_truncrvvm1sirvvmf2hi */

    case 412:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27875; /* *cond_truncrvvmf2sirvvmf4hi */

    case 413:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27876; /* *cond_truncrvvm8dirvvm4si */

    case 414:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27877; /* *cond_truncrvvm4dirvvm2si */

    case 415:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27878; /* *cond_truncrvvm2dirvvm1si */

    case 416:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27879; /* *cond_truncrvvm1dirvvmf2si */

    case 417:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27880; /* *cond_truncv1hiv1qi */

    case 418:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27881; /* *cond_truncv2hiv2qi */

    case 419:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27882; /* *cond_truncv4hiv4qi */

    case 420:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27883; /* *cond_truncv8hiv8qi */

    case 421:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27884; /* *cond_truncv16hiv16qi */

    case 422:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27885; /* *cond_truncv32hiv32qi */

    case 423:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27886; /* *cond_truncv64hiv64qi */

    case 424:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27887; /* *cond_truncv128hiv128qi */

    case 425:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27888; /* *cond_truncv256hiv256qi */

    case 426:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27889; /* *cond_truncv512hiv512qi */

    case 427:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27890; /* *cond_truncv1024hiv1024qi */

    case 428:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27891; /* *cond_truncv2048hiv2048qi */

    case 429:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27892; /* *cond_truncv1siv1hi */

    case 430:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27893; /* *cond_truncv2siv2hi */

    case 431:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27894; /* *cond_truncv4siv4hi */

    case 432:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27895; /* *cond_truncv8siv8hi */

    case 433:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27896; /* *cond_truncv16siv16hi */

    case 434:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27897; /* *cond_truncv32siv32hi */

    case 435:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27898; /* *cond_truncv64siv64hi */

    case 436:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27899; /* *cond_truncv128siv128hi */

    case 437:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27900; /* *cond_truncv256siv256hi */

    case 438:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27901; /* *cond_truncv512siv512hi */

    case 439:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27902; /* *cond_truncv1024siv1024hi */

    case 440:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27903; /* *cond_truncv1div1si */

    case 441:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27904; /* *cond_truncv2div2si */

    case 442:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27905; /* *cond_truncv4div4si */

    case 443:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27906; /* *cond_truncv8div8si */

    case 444:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27907; /* *cond_truncv16div16si */

    case 445:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27908; /* *cond_truncv32div32si */

    case 446:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27909; /* *cond_truncv64div64si */

    case 447:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27910; /* *cond_truncv128div128si */

    case 448:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27911; /* *cond_truncv256div256si */

    case 449:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27912; /* *cond_truncv512div512si */

    case 450:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28507; /* *cond_vashrextendtruncrvvm8hi */

    case 451:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28511; /* *cond_vashrextendtruncrvvm4hi */

    case 452:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28515; /* *cond_vashrextendtruncrvvm2hi */

    case 453:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28519; /* *cond_vashrextendtruncrvvm1hi */

    case 454:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28523; /* *cond_vashrextendtruncrvvmf2hi */

    case 455:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28527; /* *cond_vashrextendtruncrvvmf4hi */

    case 456:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28531; /* *cond_vashrextendtruncrvvm8si */

    case 457:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28535; /* *cond_vashrextendtruncrvvm4si */

    case 458:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28539; /* *cond_vashrextendtruncrvvm2si */

    case 459:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28543; /* *cond_vashrextendtruncrvvm1si */

    case 460:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28547; /* *cond_vashrextendtruncrvvmf2si */

    case 461:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28551; /* *cond_vashrextendtruncrvvm8di */

    case 462:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28555; /* *cond_vashrextendtruncrvvm4di */

    case 463:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28559; /* *cond_vashrextendtruncrvvm2di */

    case 464:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28563; /* *cond_vashrextendtruncrvvm1di */

    case 465:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28567; /* *cond_vashrextendtruncv1hi */

    case 466:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28571; /* *cond_vashrextendtruncv2hi */

    case 467:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28575; /* *cond_vashrextendtruncv4hi */

    case 468:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28579; /* *cond_vashrextendtruncv8hi */

    case 469:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28583; /* *cond_vashrextendtruncv16hi */

    case 470:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28587; /* *cond_vashrextendtruncv32hi */

    case 471:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28591; /* *cond_vashrextendtruncv64hi */

    case 472:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28595; /* *cond_vashrextendtruncv128hi */

    case 473:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28599; /* *cond_vashrextendtruncv256hi */

    case 474:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28603; /* *cond_vashrextendtruncv512hi */

    case 475:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28607; /* *cond_vashrextendtruncv1024hi */

    case 476:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28611; /* *cond_vashrextendtruncv2048hi */

    case 477:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28615; /* *cond_vashrextendtruncv1si */

    case 478:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28619; /* *cond_vashrextendtruncv2si */

    case 479:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28623; /* *cond_vashrextendtruncv4si */

    case 480:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28627; /* *cond_vashrextendtruncv8si */

    case 481:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28631; /* *cond_vashrextendtruncv16si */

    case 482:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28635; /* *cond_vashrextendtruncv32si */

    case 483:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28639; /* *cond_vashrextendtruncv64si */

    case 484:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28643; /* *cond_vashrextendtruncv128si */

    case 485:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28647; /* *cond_vashrextendtruncv256si */

    case 486:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28651; /* *cond_vashrextendtruncv512si */

    case 487:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28655; /* *cond_vashrextendtruncv1024si */

    case 488:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28659; /* *cond_vashrextendtruncv1di */

    case 489:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28663; /* *cond_vashrextendtruncv2di */

    case 490:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28667; /* *cond_vashrextendtruncv4di */

    case 491:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28671; /* *cond_vashrextendtruncv8di */

    case 492:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28675; /* *cond_vashrextendtruncv16di */

    case 493:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28679; /* *cond_vashrextendtruncv32di */

    case 494:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28683; /* *cond_vashrextendtruncv64di */

    case 495:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28687; /* *cond_vashrextendtruncv128di */

    case 496:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28691; /* *cond_vashrextendtruncv256di */

    case 497:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28695; /* *cond_vashrextendtruncv512di */

    case 498:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28509; /* *cond_vashrzero_extendtruncrvvm8hi */

    case 499:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28513; /* *cond_vashrzero_extendtruncrvvm4hi */

    case 500:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28517; /* *cond_vashrzero_extendtruncrvvm2hi */

    case 501:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28521; /* *cond_vashrzero_extendtruncrvvm1hi */

    case 502:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28525; /* *cond_vashrzero_extendtruncrvvmf2hi */

    case 503:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28529; /* *cond_vashrzero_extendtruncrvvmf4hi */

    case 504:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28533; /* *cond_vashrzero_extendtruncrvvm8si */

    case 505:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28537; /* *cond_vashrzero_extendtruncrvvm4si */

    case 506:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28541; /* *cond_vashrzero_extendtruncrvvm2si */

    case 507:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28545; /* *cond_vashrzero_extendtruncrvvm1si */

    case 508:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28549; /* *cond_vashrzero_extendtruncrvvmf2si */

    case 509:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28553; /* *cond_vashrzero_extendtruncrvvm8di */

    case 510:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28557; /* *cond_vashrzero_extendtruncrvvm4di */

    case 511:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28561; /* *cond_vashrzero_extendtruncrvvm2di */

    case 512:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28565; /* *cond_vashrzero_extendtruncrvvm1di */

    case 513:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28569; /* *cond_vashrzero_extendtruncv1hi */

    case 514:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28573; /* *cond_vashrzero_extendtruncv2hi */

    case 515:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28577; /* *cond_vashrzero_extendtruncv4hi */

    case 516:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28581; /* *cond_vashrzero_extendtruncv8hi */

    case 517:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28585; /* *cond_vashrzero_extendtruncv16hi */

    case 518:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28589; /* *cond_vashrzero_extendtruncv32hi */

    case 519:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28593; /* *cond_vashrzero_extendtruncv64hi */

    case 520:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28597; /* *cond_vashrzero_extendtruncv128hi */

    case 521:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28601; /* *cond_vashrzero_extendtruncv256hi */

    case 522:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28605; /* *cond_vashrzero_extendtruncv512hi */

    case 523:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28609; /* *cond_vashrzero_extendtruncv1024hi */

    case 524:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28613; /* *cond_vashrzero_extendtruncv2048hi */

    case 525:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28617; /* *cond_vashrzero_extendtruncv1si */

    case 526:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28621; /* *cond_vashrzero_extendtruncv2si */

    case 527:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28625; /* *cond_vashrzero_extendtruncv4si */

    case 528:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28629; /* *cond_vashrzero_extendtruncv8si */

    case 529:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28633; /* *cond_vashrzero_extendtruncv16si */

    case 530:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28637; /* *cond_vashrzero_extendtruncv32si */

    case 531:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28641; /* *cond_vashrzero_extendtruncv64si */

    case 532:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28645; /* *cond_vashrzero_extendtruncv128si */

    case 533:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28649; /* *cond_vashrzero_extendtruncv256si */

    case 534:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28653; /* *cond_vashrzero_extendtruncv512si */

    case 535:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28657; /* *cond_vashrzero_extendtruncv1024si */

    case 536:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28661; /* *cond_vashrzero_extendtruncv1di */

    case 537:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28665; /* *cond_vashrzero_extendtruncv2di */

    case 538:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28669; /* *cond_vashrzero_extendtruncv4di */

    case 539:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28673; /* *cond_vashrzero_extendtruncv8di */

    case 540:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28677; /* *cond_vashrzero_extendtruncv16di */

    case 541:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28681; /* *cond_vashrzero_extendtruncv32di */

    case 542:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28685; /* *cond_vashrzero_extendtruncv64di */

    case 543:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28689; /* *cond_vashrzero_extendtruncv128di */

    case 544:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28693; /* *cond_vashrzero_extendtruncv256di */

    case 545:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28697; /* *cond_vashrzero_extendtruncv512di */

    case 546:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28699; /* *cond_ashrtruncrvvm8hi */

    case 547:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28701; /* *cond_ashrtruncrvvm4hi */

    case 548:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28703; /* *cond_ashrtruncrvvm2hi */

    case 549:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28705; /* *cond_ashrtruncrvvm1hi */

    case 550:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28707; /* *cond_ashrtruncrvvmf2hi */

    case 551:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28709; /* *cond_ashrtruncrvvmf4hi */

    case 552:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28711; /* *cond_ashrtruncrvvm8si */

    case 553:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28713; /* *cond_ashrtruncrvvm4si */

    case 554:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28715; /* *cond_ashrtruncrvvm2si */

    case 555:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28717; /* *cond_ashrtruncrvvm1si */

    case 556:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28719; /* *cond_ashrtruncrvvmf2si */

    case 557:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28721; /* *cond_ashrtruncrvvm8di */

    case 558:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28723; /* *cond_ashrtruncrvvm4di */

    case 559:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28725; /* *cond_ashrtruncrvvm2di */

    case 560:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28727; /* *cond_ashrtruncrvvm1di */

    case 561:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28729; /* *cond_ashrtruncv1hi */

    case 562:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28731; /* *cond_ashrtruncv2hi */

    case 563:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28733; /* *cond_ashrtruncv4hi */

    case 564:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28735; /* *cond_ashrtruncv8hi */

    case 565:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28737; /* *cond_ashrtruncv16hi */

    case 566:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28739; /* *cond_ashrtruncv32hi */

    case 567:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28741; /* *cond_ashrtruncv64hi */

    case 568:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28743; /* *cond_ashrtruncv128hi */

    case 569:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28745; /* *cond_ashrtruncv256hi */

    case 570:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28747; /* *cond_ashrtruncv512hi */

    case 571:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28749; /* *cond_ashrtruncv1024hi */

    case 572:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28751; /* *cond_ashrtruncv2048hi */

    case 573:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28753; /* *cond_ashrtruncv1si */

    case 574:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28755; /* *cond_ashrtruncv2si */

    case 575:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28757; /* *cond_ashrtruncv4si */

    case 576:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28759; /* *cond_ashrtruncv8si */

    case 577:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28761; /* *cond_ashrtruncv16si */

    case 578:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28763; /* *cond_ashrtruncv32si */

    case 579:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28765; /* *cond_ashrtruncv64si */

    case 580:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28767; /* *cond_ashrtruncv128si */

    case 581:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28769; /* *cond_ashrtruncv256si */

    case 582:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28771; /* *cond_ashrtruncv512si */

    case 583:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28773; /* *cond_ashrtruncv1024si */

    case 584:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28775; /* *cond_ashrtruncv1di */

    case 585:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28777; /* *cond_ashrtruncv2di */

    case 586:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28779; /* *cond_ashrtruncv4di */

    case 587:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28781; /* *cond_ashrtruncv8di */

    case 588:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28783; /* *cond_ashrtruncv16di */

    case 589:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28785; /* *cond_ashrtruncv32di */

    case 590:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28787; /* *cond_ashrtruncv64di */

    case 591:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28789; /* *cond_ashrtruncv128di */

    case 592:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28791; /* *cond_ashrtruncv256di */

    case 593:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28793; /* *cond_ashrtruncv512di */

    case 594:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28508; /* *cond_vlshrextendtruncrvvm8hi */

    case 595:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28512; /* *cond_vlshrextendtruncrvvm4hi */

    case 596:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28516; /* *cond_vlshrextendtruncrvvm2hi */

    case 597:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28520; /* *cond_vlshrextendtruncrvvm1hi */

    case 598:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28524; /* *cond_vlshrextendtruncrvvmf2hi */

    case 599:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28528; /* *cond_vlshrextendtruncrvvmf4hi */

    case 600:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28532; /* *cond_vlshrextendtruncrvvm8si */

    case 601:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28536; /* *cond_vlshrextendtruncrvvm4si */

    case 602:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28540; /* *cond_vlshrextendtruncrvvm2si */

    case 603:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28544; /* *cond_vlshrextendtruncrvvm1si */

    case 604:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28548; /* *cond_vlshrextendtruncrvvmf2si */

    case 605:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28552; /* *cond_vlshrextendtruncrvvm8di */

    case 606:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28556; /* *cond_vlshrextendtruncrvvm4di */

    case 607:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28560; /* *cond_vlshrextendtruncrvvm2di */

    case 608:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28564; /* *cond_vlshrextendtruncrvvm1di */

    case 609:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28568; /* *cond_vlshrextendtruncv1hi */

    case 610:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28572; /* *cond_vlshrextendtruncv2hi */

    case 611:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28576; /* *cond_vlshrextendtruncv4hi */

    case 612:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28580; /* *cond_vlshrextendtruncv8hi */

    case 613:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28584; /* *cond_vlshrextendtruncv16hi */

    case 614:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28588; /* *cond_vlshrextendtruncv32hi */

    case 615:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28592; /* *cond_vlshrextendtruncv64hi */

    case 616:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28596; /* *cond_vlshrextendtruncv128hi */

    case 617:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28600; /* *cond_vlshrextendtruncv256hi */

    case 618:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28604; /* *cond_vlshrextendtruncv512hi */

    case 619:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28608; /* *cond_vlshrextendtruncv1024hi */

    case 620:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28612; /* *cond_vlshrextendtruncv2048hi */

    case 621:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28616; /* *cond_vlshrextendtruncv1si */

    case 622:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28620; /* *cond_vlshrextendtruncv2si */

    case 623:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28624; /* *cond_vlshrextendtruncv4si */

    case 624:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28628; /* *cond_vlshrextendtruncv8si */

    case 625:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28632; /* *cond_vlshrextendtruncv16si */

    case 626:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28636; /* *cond_vlshrextendtruncv32si */

    case 627:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28640; /* *cond_vlshrextendtruncv64si */

    case 628:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28644; /* *cond_vlshrextendtruncv128si */

    case 629:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28648; /* *cond_vlshrextendtruncv256si */

    case 630:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28652; /* *cond_vlshrextendtruncv512si */

    case 631:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28656; /* *cond_vlshrextendtruncv1024si */

    case 632:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28660; /* *cond_vlshrextendtruncv1di */

    case 633:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28664; /* *cond_vlshrextendtruncv2di */

    case 634:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28668; /* *cond_vlshrextendtruncv4di */

    case 635:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28672; /* *cond_vlshrextendtruncv8di */

    case 636:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28676; /* *cond_vlshrextendtruncv16di */

    case 637:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28680; /* *cond_vlshrextendtruncv32di */

    case 638:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28684; /* *cond_vlshrextendtruncv64di */

    case 639:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28688; /* *cond_vlshrextendtruncv128di */

    case 640:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28692; /* *cond_vlshrextendtruncv256di */

    case 641:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28696; /* *cond_vlshrextendtruncv512di */

    case 642:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28510; /* *cond_vlshrzero_extendtruncrvvm8hi */

    case 643:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28514; /* *cond_vlshrzero_extendtruncrvvm4hi */

    case 644:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28518; /* *cond_vlshrzero_extendtruncrvvm2hi */

    case 645:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28522; /* *cond_vlshrzero_extendtruncrvvm1hi */

    case 646:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28526; /* *cond_vlshrzero_extendtruncrvvmf2hi */

    case 647:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28530; /* *cond_vlshrzero_extendtruncrvvmf4hi */

    case 648:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28534; /* *cond_vlshrzero_extendtruncrvvm8si */

    case 649:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28538; /* *cond_vlshrzero_extendtruncrvvm4si */

    case 650:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28542; /* *cond_vlshrzero_extendtruncrvvm2si */

    case 651:
      if (!
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28546; /* *cond_vlshrzero_extendtruncrvvm1si */

    case 652:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28550; /* *cond_vlshrzero_extendtruncrvvmf2si */

    case 653:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28554; /* *cond_vlshrzero_extendtruncrvvm8di */

    case 654:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28558; /* *cond_vlshrzero_extendtruncrvvm4di */

    case 655:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28562; /* *cond_vlshrzero_extendtruncrvvm2di */

    case 656:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28566; /* *cond_vlshrzero_extendtruncrvvm1di */

    case 657:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28570; /* *cond_vlshrzero_extendtruncv1hi */

    case 658:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28574; /* *cond_vlshrzero_extendtruncv2hi */

    case 659:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28578; /* *cond_vlshrzero_extendtruncv4hi */

    case 660:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28582; /* *cond_vlshrzero_extendtruncv8hi */

    case 661:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28586; /* *cond_vlshrzero_extendtruncv16hi */

    case 662:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28590; /* *cond_vlshrzero_extendtruncv32hi */

    case 663:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28594; /* *cond_vlshrzero_extendtruncv64hi */

    case 664:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28598; /* *cond_vlshrzero_extendtruncv128hi */

    case 665:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28602; /* *cond_vlshrzero_extendtruncv256hi */

    case 666:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28606; /* *cond_vlshrzero_extendtruncv512hi */

    case 667:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28610; /* *cond_vlshrzero_extendtruncv1024hi */

    case 668:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28614; /* *cond_vlshrzero_extendtruncv2048hi */

    case 669:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28618; /* *cond_vlshrzero_extendtruncv1si */

    case 670:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28622; /* *cond_vlshrzero_extendtruncv2si */

    case 671:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28626; /* *cond_vlshrzero_extendtruncv4si */

    case 672:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28630; /* *cond_vlshrzero_extendtruncv8si */

    case 673:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28634; /* *cond_vlshrzero_extendtruncv16si */

    case 674:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28638; /* *cond_vlshrzero_extendtruncv32si */

    case 675:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28642; /* *cond_vlshrzero_extendtruncv64si */

    case 676:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28646; /* *cond_vlshrzero_extendtruncv128si */

    case 677:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28650; /* *cond_vlshrzero_extendtruncv256si */

    case 678:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28654; /* *cond_vlshrzero_extendtruncv512si */

    case 679:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28658; /* *cond_vlshrzero_extendtruncv1024si */

    case 680:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28662; /* *cond_vlshrzero_extendtruncv1di */

    case 681:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28666; /* *cond_vlshrzero_extendtruncv2di */

    case 682:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28670; /* *cond_vlshrzero_extendtruncv4di */

    case 683:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28674; /* *cond_vlshrzero_extendtruncv8di */

    case 684:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28678; /* *cond_vlshrzero_extendtruncv16di */

    case 685:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28682; /* *cond_vlshrzero_extendtruncv32di */

    case 686:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28686; /* *cond_vlshrzero_extendtruncv64di */

    case 687:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28690; /* *cond_vlshrzero_extendtruncv128di */

    case 688:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28694; /* *cond_vlshrzero_extendtruncv256di */

    case 689:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28698; /* *cond_vlshrzero_extendtruncv512di */

    case 690:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28700; /* *cond_lshrtruncrvvm8hi */

    case 691:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28702; /* *cond_lshrtruncrvvm4hi */

    case 692:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28704; /* *cond_lshrtruncrvvm2hi */

    case 693:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28706; /* *cond_lshrtruncrvvm1hi */

    case 694:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28708; /* *cond_lshrtruncrvvmf2hi */

    case 695:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28710; /* *cond_lshrtruncrvvmf4hi */

    case 696:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28712; /* *cond_lshrtruncrvvm8si */

    case 697:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28714; /* *cond_lshrtruncrvvm4si */

    case 698:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28716; /* *cond_lshrtruncrvvm2si */

    case 699:
      if (!
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28718; /* *cond_lshrtruncrvvm1si */

    case 700:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28720; /* *cond_lshrtruncrvvmf2si */

    case 701:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28722; /* *cond_lshrtruncrvvm8di */

    case 702:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28724; /* *cond_lshrtruncrvvm4di */

    case 703:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28726; /* *cond_lshrtruncrvvm2di */

    case 704:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28728; /* *cond_lshrtruncrvvm1di */

    case 705:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28730; /* *cond_lshrtruncv1hi */

    case 706:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28732; /* *cond_lshrtruncv2hi */

    case 707:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28734; /* *cond_lshrtruncv4hi */

    case 708:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28736; /* *cond_lshrtruncv8hi */

    case 709:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28738; /* *cond_lshrtruncv16hi */

    case 710:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28740; /* *cond_lshrtruncv32hi */

    case 711:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28742; /* *cond_lshrtruncv64hi */

    case 712:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28744; /* *cond_lshrtruncv128hi */

    case 713:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28746; /* *cond_lshrtruncv256hi */

    case 714:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28748; /* *cond_lshrtruncv512hi */

    case 715:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28750; /* *cond_lshrtruncv1024hi */

    case 716:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28752; /* *cond_lshrtruncv2048hi */

    case 717:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28754; /* *cond_lshrtruncv1si */

    case 718:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28756; /* *cond_lshrtruncv2si */

    case 719:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28758; /* *cond_lshrtruncv4si */

    case 720:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28760; /* *cond_lshrtruncv8si */

    case 721:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28762; /* *cond_lshrtruncv16si */

    case 722:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28764; /* *cond_lshrtruncv32si */

    case 723:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28766; /* *cond_lshrtruncv64si */

    case 724:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28768; /* *cond_lshrtruncv128si */

    case 725:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28770; /* *cond_lshrtruncv256si */

    case 726:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28772; /* *cond_lshrtruncv512si */

    case 727:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28774; /* *cond_lshrtruncv1024si */

    case 728:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28776; /* *cond_lshrtruncv1di */

    case 729:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28778; /* *cond_lshrtruncv2di */

    case 730:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28780; /* *cond_lshrtruncv4di */

    case 731:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28782; /* *cond_lshrtruncv8di */

    case 732:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28784; /* *cond_lshrtruncv16di */

    case 733:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28786; /* *cond_lshrtruncv32di */

    case 734:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28788; /* *cond_lshrtruncv64di */

    case 735:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28790; /* *cond_lshrtruncv128di */

    case 736:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28792; /* *cond_lshrtruncv256di */

    case 737:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28794; /* *cond_lshrtruncv512di */

    case 738:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27913; /* *cond_extendrvvm4hfrvvm8sf */

    case 739:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27914; /* *cond_extendrvvm2hfrvvm4sf */

    case 740:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27915; /* *cond_extendrvvm1hfrvvm2sf */

    case 741:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27916; /* *cond_extendrvvmf2hfrvvm1sf */

    case 742:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27917; /* *cond_extendrvvmf4hfrvvmf2sf */

    case 743:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27918; /* *cond_extendrvvm4sfrvvm8df */

    case 744:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27919; /* *cond_extendrvvm2sfrvvm4df */

    case 745:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27920; /* *cond_extendrvvm1sfrvvm2df */

    case 746:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27921; /* *cond_extendrvvmf2sfrvvm1df */

    case 747:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27922; /* *cond_extendv1hfv1sf */

    case 748:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27923; /* *cond_extendv2hfv2sf */

    case 749:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27924; /* *cond_extendv4hfv4sf */

    case 750:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27925; /* *cond_extendv8hfv8sf */

    case 751:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27926; /* *cond_extendv16hfv16sf */

    case 752:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27927; /* *cond_extendv32hfv32sf */

    case 753:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27928; /* *cond_extendv64hfv64sf */

    case 754:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27929; /* *cond_extendv128hfv128sf */

    case 755:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27930; /* *cond_extendv256hfv256sf */

    case 756:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27931; /* *cond_extendv512hfv512sf */

    case 757:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27932; /* *cond_extendv1024hfv1024sf */

    case 758:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27933; /* *cond_extendv1sfv1df */

    case 759:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27934; /* *cond_extendv2sfv2df */

    case 760:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27935; /* *cond_extendv4sfv4df */

    case 761:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27936; /* *cond_extendv8sfv8df */

    case 762:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27937; /* *cond_extendv16sfv16df */

    case 763:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27938; /* *cond_extendv32sfv32df */

    case 764:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27939; /* *cond_extendv64sfv64df */

    case 765:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27940; /* *cond_extendv128sfv128df */

    case 766:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27941; /* *cond_extendv256sfv256df */

    case 767:
      if (!(
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27942; /* *cond_extendv512sfv512df */

    case 768:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27973; /* *cond_truncrvvm8sfrvvm4hf */

    case 769:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27974; /* *cond_truncrvvm4sfrvvm2hf */

    case 770:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27975; /* *cond_truncrvvm2sfrvvm1hf */

    case 771:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27976; /* *cond_truncrvvm1sfrvvmf2hf */

    case 772:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27977; /* *cond_truncrvvmf2sfrvvmf4hf */

    case 773:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27978; /* *cond_truncrvvm8dfrvvm4sf */

    case 774:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27979; /* *cond_truncrvvm4dfrvvm2sf */

    case 775:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27980; /* *cond_truncrvvm2dfrvvm1sf */

    case 776:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27981; /* *cond_truncrvvm1dfrvvmf2sf */

    case 777:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27982; /* *cond_truncv1sfv1hf */

    case 778:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27983; /* *cond_truncv2sfv2hf */

    case 779:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27984; /* *cond_truncv4sfv4hf */

    case 780:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27985; /* *cond_truncv8sfv8hf */

    case 781:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27986; /* *cond_truncv16sfv16hf */

    case 782:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27987; /* *cond_truncv32sfv32hf */

    case 783:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27988; /* *cond_truncv64sfv64hf */

    case 784:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27989; /* *cond_truncv128sfv128hf */

    case 785:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27990; /* *cond_truncv256sfv256hf */

    case 786:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27991; /* *cond_truncv512sfv512hf */

    case 787:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27992; /* *cond_truncv1024sfv1024hf */

    case 788:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27993; /* *cond_truncv1dfv1sf */

    case 789:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27994; /* *cond_truncv2dfv2sf */

    case 790:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27995; /* *cond_truncv4dfv4sf */

    case 791:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27996; /* *cond_truncv8dfv8sf */

    case 792:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27997; /* *cond_truncv16dfv16sf */

    case 793:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27998; /* *cond_truncv32dfv32sf */

    case 794:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27999; /* *cond_truncv64dfv64sf */

    case 795:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28000; /* *cond_truncv128dfv128sf */

    case 796:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28001; /* *cond_truncv256dfv256sf */

    case 797:
      if (!(
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28002; /* *cond_truncv512dfv512sf */

    case 798:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28003; /* *cond_fix_truncrvvm8hfrvvm8hi */

    case 799:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28005; /* *cond_fix_truncrvvm4hfrvvm4hi */

    case 800:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28363; /* *cond_fix_truncrvvm8sfrvvm4hi */

    case 801:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28007; /* *cond_fix_truncrvvm2hfrvvm2hi */

    case 802:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28365; /* *cond_fix_truncrvvm4sfrvvm2hi */

    case 803:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28009; /* *cond_fix_truncrvvm1hfrvvm1hi */

    case 804:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28367; /* *cond_fix_truncrvvm2sfrvvm1hi */

    case 805:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28011; /* *cond_fix_truncrvvmf2hfrvvmf2hi */

    case 806:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28369; /* *cond_fix_truncrvvm1sfrvvmf2hi */

    case 807:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28013; /* *cond_fix_truncrvvmf4hfrvvmf4hi */

    case 808:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28371; /* *cond_fix_truncrvvmf2sfrvvmf4hi */

    case 809:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28015; /* *cond_fix_truncrvvm8sfrvvm8si */

    case 810:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28195; /* *cond_fix_truncrvvm4hfrvvm8si */

    case 811:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28017; /* *cond_fix_truncrvvm4sfrvvm4si */

    case 812:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28197; /* *cond_fix_truncrvvm2hfrvvm4si */

    case 813:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28373; /* *cond_fix_truncrvvm8dfrvvm4si */

    case 814:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28019; /* *cond_fix_truncrvvm2sfrvvm2si */

    case 815:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28199; /* *cond_fix_truncrvvm1hfrvvm2si */

    case 816:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28375; /* *cond_fix_truncrvvm4dfrvvm2si */

    case 817:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28021; /* *cond_fix_truncrvvm1sfrvvm1si */

    case 818:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28201; /* *cond_fix_truncrvvmf2hfrvvm1si */

    case 819:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28377; /* *cond_fix_truncrvvm2dfrvvm1si */

    case 820:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28023; /* *cond_fix_truncrvvmf2sfrvvmf2si */

    case 821:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28203; /* *cond_fix_truncrvvmf4hfrvvmf2si */

    case 822:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28379; /* *cond_fix_truncrvvm1dfrvvmf2si */

    case 823:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28025; /* *cond_fix_truncrvvm8dfrvvm8di */

    case 824:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28205; /* *cond_fix_truncrvvm4sfrvvm8di */

    case 825:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28027; /* *cond_fix_truncrvvm4dfrvvm4di */

    case 826:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28207; /* *cond_fix_truncrvvm2sfrvvm4di */

    case 827:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28029; /* *cond_fix_truncrvvm2dfrvvm2di */

    case 828:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28209; /* *cond_fix_truncrvvm1sfrvvm2di */

    case 829:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28031; /* *cond_fix_truncrvvm1dfrvvm1di */

    case 830:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28211; /* *cond_fix_truncrvvmf2sfrvvm1di */

    case 831:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28033; /* *cond_fix_truncv1hfv1hi */

    case 832:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28405; /* *cond_fix_truncv1sfv1hi */

    case 833:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28035; /* *cond_fix_truncv2hfv2hi */

    case 834:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28407; /* *cond_fix_truncv2sfv2hi */

    case 835:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28037; /* *cond_fix_truncv4hfv4hi */

    case 836:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28409; /* *cond_fix_truncv4sfv4hi */

    case 837:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28039; /* *cond_fix_truncv8hfv8hi */

    case 838:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28411; /* *cond_fix_truncv8sfv8hi */

    case 839:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28041; /* *cond_fix_truncv16hfv16hi */

    case 840:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28413; /* *cond_fix_truncv16sfv16hi */

    case 841:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28043; /* *cond_fix_truncv32hfv32hi */

    case 842:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28415; /* *cond_fix_truncv32sfv32hi */

    case 843:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28045; /* *cond_fix_truncv64hfv64hi */

    case 844:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28417; /* *cond_fix_truncv64sfv64hi */

    case 845:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28047; /* *cond_fix_truncv128hfv128hi */

    case 846:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28419; /* *cond_fix_truncv128sfv128hi */

    case 847:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28049; /* *cond_fix_truncv256hfv256hi */

    case 848:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28421; /* *cond_fix_truncv256sfv256hi */

    case 849:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28051; /* *cond_fix_truncv512hfv512hi */

    case 850:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28423; /* *cond_fix_truncv512sfv512hi */

    case 851:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28053; /* *cond_fix_truncv1024hfv1024hi */

    case 852:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28425; /* *cond_fix_truncv1024sfv1024hi */

    case 853:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28055; /* *cond_fix_truncv2048hfv2048hi */

    case 854:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28057; /* *cond_fix_truncv1sfv1si */

    case 855:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 28213; /* *cond_fix_truncv1hfv1si */

    case 856:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28427; /* *cond_fix_truncv1dfv1si */

    case 857:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28059; /* *cond_fix_truncv2sfv2si */

    case 858:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 28215; /* *cond_fix_truncv2hfv2si */

    case 859:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28429; /* *cond_fix_truncv2dfv2si */

    case 860:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28061; /* *cond_fix_truncv4sfv4si */

    case 861:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 28217; /* *cond_fix_truncv4hfv4si */

    case 862:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28431; /* *cond_fix_truncv4dfv4si */

    case 863:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28063; /* *cond_fix_truncv8sfv8si */

    case 864:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 28219; /* *cond_fix_truncv8hfv8si */

    case 865:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28433; /* *cond_fix_truncv8dfv8si */

    case 866:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28065; /* *cond_fix_truncv16sfv16si */

    case 867:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28221; /* *cond_fix_truncv16hfv16si */

    case 868:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28435; /* *cond_fix_truncv16dfv16si */

    case 869:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28067; /* *cond_fix_truncv32sfv32si */

    case 870:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28223; /* *cond_fix_truncv32hfv32si */

    case 871:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28437; /* *cond_fix_truncv32dfv32si */

    case 872:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28069; /* *cond_fix_truncv64sfv64si */

    case 873:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28225; /* *cond_fix_truncv64hfv64si */

    case 874:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28439; /* *cond_fix_truncv64dfv64si */

    case 875:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28071; /* *cond_fix_truncv128sfv128si */

    case 876:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28227; /* *cond_fix_truncv128hfv128si */

    case 877:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28441; /* *cond_fix_truncv128dfv128si */

    case 878:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28073; /* *cond_fix_truncv256sfv256si */

    case 879:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28229; /* *cond_fix_truncv256hfv256si */

    case 880:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28443; /* *cond_fix_truncv256dfv256si */

    case 881:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28075; /* *cond_fix_truncv512sfv512si */

    case 882:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28231; /* *cond_fix_truncv512hfv512si */

    case 883:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28445; /* *cond_fix_truncv512dfv512si */

    case 884:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28077; /* *cond_fix_truncv1024sfv1024si */

    case 885:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28233; /* *cond_fix_truncv1024hfv1024si */

    case 886:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28079; /* *cond_fix_truncv1dfv1di */

    case 887:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28235; /* *cond_fix_truncv1sfv1di */

    case 888:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28081; /* *cond_fix_truncv2dfv2di */

    case 889:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28237; /* *cond_fix_truncv2sfv2di */

    case 890:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28083; /* *cond_fix_truncv4dfv4di */

    case 891:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28239; /* *cond_fix_truncv4sfv4di */

    case 892:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28085; /* *cond_fix_truncv8dfv8di */

    case 893:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28241; /* *cond_fix_truncv8sfv8di */

    case 894:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28087; /* *cond_fix_truncv16dfv16di */

    case 895:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28243; /* *cond_fix_truncv16sfv16di */

    case 896:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28089; /* *cond_fix_truncv32dfv32di */

    case 897:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28245; /* *cond_fix_truncv32sfv32di */

    case 898:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28091; /* *cond_fix_truncv64dfv64di */

    case 899:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28247; /* *cond_fix_truncv64sfv64di */

    case 900:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28093; /* *cond_fix_truncv128dfv128di */

    case 901:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28249; /* *cond_fix_truncv128sfv128di */

    case 902:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28095; /* *cond_fix_truncv256dfv256di */

    case 903:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28251; /* *cond_fix_truncv256sfv256di */

    case 904:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28097; /* *cond_fix_truncv512dfv512di */

    case 905:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28253; /* *cond_fix_truncv512sfv512di */

    case 906:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28351; /* *cond_fix_truncrvvm8hfrvvm4qi */

    case 907:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28353; /* *cond_fix_truncrvvm4hfrvvm2qi */

    case 908:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28355; /* *cond_fix_truncrvvm2hfrvvm1qi */

    case 909:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28357; /* *cond_fix_truncrvvm1hfrvvmf2qi */

    case 910:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28359; /* *cond_fix_truncrvvmf2hfrvvmf4qi */

    case 911:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28361; /* *cond_fix_truncrvvmf4hfrvvmf8qi */

    case 912:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28381; /* *cond_fix_truncv1hfv1qi */

    case 913:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28383; /* *cond_fix_truncv2hfv2qi */

    case 914:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28385; /* *cond_fix_truncv4hfv4qi */

    case 915:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28387; /* *cond_fix_truncv8hfv8qi */

    case 916:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28389; /* *cond_fix_truncv16hfv16qi */

    case 917:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28391; /* *cond_fix_truncv32hfv32qi */

    case 918:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28393; /* *cond_fix_truncv64hfv64qi */

    case 919:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28395; /* *cond_fix_truncv128hfv128qi */

    case 920:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28397; /* *cond_fix_truncv256hfv256qi */

    case 921:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28399; /* *cond_fix_truncv512hfv512qi */

    case 922:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28401; /* *cond_fix_truncv1024hfv1024qi */

    case 923:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28403; /* *cond_fix_truncv2048hfv2048qi */

    case 924:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28004; /* *cond_fixuns_truncrvvm8hfrvvm8hi */

    case 925:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28006; /* *cond_fixuns_truncrvvm4hfrvvm4hi */

    case 926:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28364; /* *cond_fixuns_truncrvvm8sfrvvm4hi */

    case 927:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28008; /* *cond_fixuns_truncrvvm2hfrvvm2hi */

    case 928:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28366; /* *cond_fixuns_truncrvvm4sfrvvm2hi */

    case 929:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28010; /* *cond_fixuns_truncrvvm1hfrvvm1hi */

    case 930:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28368; /* *cond_fixuns_truncrvvm2sfrvvm1hi */

    case 931:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28012; /* *cond_fixuns_truncrvvmf2hfrvvmf2hi */

    case 932:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28370; /* *cond_fixuns_truncrvvm1sfrvvmf2hi */

    case 933:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28014; /* *cond_fixuns_truncrvvmf4hfrvvmf4hi */

    case 934:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28372; /* *cond_fixuns_truncrvvmf2sfrvvmf4hi */

    case 935:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28016; /* *cond_fixuns_truncrvvm8sfrvvm8si */

    case 936:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28196; /* *cond_fixuns_truncrvvm4hfrvvm8si */

    case 937:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28018; /* *cond_fixuns_truncrvvm4sfrvvm4si */

    case 938:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28198; /* *cond_fixuns_truncrvvm2hfrvvm4si */

    case 939:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28374; /* *cond_fixuns_truncrvvm8dfrvvm4si */

    case 940:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28020; /* *cond_fixuns_truncrvvm2sfrvvm2si */

    case 941:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28200; /* *cond_fixuns_truncrvvm1hfrvvm2si */

    case 942:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28376; /* *cond_fixuns_truncrvvm4dfrvvm2si */

    case 943:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28022; /* *cond_fixuns_truncrvvm1sfrvvm1si */

    case 944:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28202; /* *cond_fixuns_truncrvvmf2hfrvvm1si */

    case 945:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28378; /* *cond_fixuns_truncrvvm2dfrvvm1si */

    case 946:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28024; /* *cond_fixuns_truncrvvmf2sfrvvmf2si */

    case 947:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28204; /* *cond_fixuns_truncrvvmf4hfrvvmf2si */

    case 948:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28380; /* *cond_fixuns_truncrvvm1dfrvvmf2si */

    case 949:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28026; /* *cond_fixuns_truncrvvm8dfrvvm8di */

    case 950:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28206; /* *cond_fixuns_truncrvvm4sfrvvm8di */

    case 951:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28028; /* *cond_fixuns_truncrvvm4dfrvvm4di */

    case 952:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28208; /* *cond_fixuns_truncrvvm2sfrvvm4di */

    case 953:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28030; /* *cond_fixuns_truncrvvm2dfrvvm2di */

    case 954:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28210; /* *cond_fixuns_truncrvvm1sfrvvm2di */

    case 955:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28032; /* *cond_fixuns_truncrvvm1dfrvvm1di */

    case 956:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28212; /* *cond_fixuns_truncrvvmf2sfrvvm1di */

    case 957:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28034; /* *cond_fixuns_truncv1hfv1hi */

    case 958:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28406; /* *cond_fixuns_truncv1sfv1hi */

    case 959:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28036; /* *cond_fixuns_truncv2hfv2hi */

    case 960:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28408; /* *cond_fixuns_truncv2sfv2hi */

    case 961:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28038; /* *cond_fixuns_truncv4hfv4hi */

    case 962:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28410; /* *cond_fixuns_truncv4sfv4hi */

    case 963:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28040; /* *cond_fixuns_truncv8hfv8hi */

    case 964:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28412; /* *cond_fixuns_truncv8sfv8hi */

    case 965:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28042; /* *cond_fixuns_truncv16hfv16hi */

    case 966:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28414; /* *cond_fixuns_truncv16sfv16hi */

    case 967:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28044; /* *cond_fixuns_truncv32hfv32hi */

    case 968:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28416; /* *cond_fixuns_truncv32sfv32hi */

    case 969:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28046; /* *cond_fixuns_truncv64hfv64hi */

    case 970:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28418; /* *cond_fixuns_truncv64sfv64hi */

    case 971:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28048; /* *cond_fixuns_truncv128hfv128hi */

    case 972:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28420; /* *cond_fixuns_truncv128sfv128hi */

    case 973:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28050; /* *cond_fixuns_truncv256hfv256hi */

    case 974:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28422; /* *cond_fixuns_truncv256sfv256hi */

    case 975:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28052; /* *cond_fixuns_truncv512hfv512hi */

    case 976:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28424; /* *cond_fixuns_truncv512sfv512hi */

    case 977:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28054; /* *cond_fixuns_truncv1024hfv1024hi */

    case 978:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28426; /* *cond_fixuns_truncv1024sfv1024hi */

    case 979:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28056; /* *cond_fixuns_truncv2048hfv2048hi */

    case 980:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28058; /* *cond_fixuns_truncv1sfv1si */

    case 981:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 28214; /* *cond_fixuns_truncv1hfv1si */

    case 982:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28428; /* *cond_fixuns_truncv1dfv1si */

    case 983:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28060; /* *cond_fixuns_truncv2sfv2si */

    case 984:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 28216; /* *cond_fixuns_truncv2hfv2si */

    case 985:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28430; /* *cond_fixuns_truncv2dfv2si */

    case 986:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28062; /* *cond_fixuns_truncv4sfv4si */

    case 987:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 28218; /* *cond_fixuns_truncv4hfv4si */

    case 988:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28432; /* *cond_fixuns_truncv4dfv4si */

    case 989:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28064; /* *cond_fixuns_truncv8sfv8si */

    case 990:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 28220; /* *cond_fixuns_truncv8hfv8si */

    case 991:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28434; /* *cond_fixuns_truncv8dfv8si */

    case 992:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28066; /* *cond_fixuns_truncv16sfv16si */

    case 993:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28222; /* *cond_fixuns_truncv16hfv16si */

    case 994:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28436; /* *cond_fixuns_truncv16dfv16si */

    case 995:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28068; /* *cond_fixuns_truncv32sfv32si */

    case 996:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28224; /* *cond_fixuns_truncv32hfv32si */

    case 997:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28438; /* *cond_fixuns_truncv32dfv32si */

    case 998:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28070; /* *cond_fixuns_truncv64sfv64si */

    case 999:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28226; /* *cond_fixuns_truncv64hfv64si */

    case 1000:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28440; /* *cond_fixuns_truncv64dfv64si */

    case 1001:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28072; /* *cond_fixuns_truncv128sfv128si */

    case 1002:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28228; /* *cond_fixuns_truncv128hfv128si */

    case 1003:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28442; /* *cond_fixuns_truncv128dfv128si */

    case 1004:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28074; /* *cond_fixuns_truncv256sfv256si */

    case 1005:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28230; /* *cond_fixuns_truncv256hfv256si */

    case 1006:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28444; /* *cond_fixuns_truncv256dfv256si */

    case 1007:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28076; /* *cond_fixuns_truncv512sfv512si */

    case 1008:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28232; /* *cond_fixuns_truncv512hfv512si */

    case 1009:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28446; /* *cond_fixuns_truncv512dfv512si */

    case 1010:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28078; /* *cond_fixuns_truncv1024sfv1024si */

    case 1011:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28234; /* *cond_fixuns_truncv1024hfv1024si */

    case 1012:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28080; /* *cond_fixuns_truncv1dfv1di */

    case 1013:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28236; /* *cond_fixuns_truncv1sfv1di */

    case 1014:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28082; /* *cond_fixuns_truncv2dfv2di */

    case 1015:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28238; /* *cond_fixuns_truncv2sfv2di */

    case 1016:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28084; /* *cond_fixuns_truncv4dfv4di */

    case 1017:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28240; /* *cond_fixuns_truncv4sfv4di */

    case 1018:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28086; /* *cond_fixuns_truncv8dfv8di */

    case 1019:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28242; /* *cond_fixuns_truncv8sfv8di */

    case 1020:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28088; /* *cond_fixuns_truncv16dfv16di */

    case 1021:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28244; /* *cond_fixuns_truncv16sfv16di */

    case 1022:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28090; /* *cond_fixuns_truncv32dfv32di */

    case 1023:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28246; /* *cond_fixuns_truncv32sfv32di */

    case 1024:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28092; /* *cond_fixuns_truncv64dfv64di */

    case 1025:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28248; /* *cond_fixuns_truncv64sfv64di */

    case 1026:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28094; /* *cond_fixuns_truncv128dfv128di */

    case 1027:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28250; /* *cond_fixuns_truncv128sfv128di */

    case 1028:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28096; /* *cond_fixuns_truncv256dfv256di */

    case 1029:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28252; /* *cond_fixuns_truncv256sfv256di */

    case 1030:
      if (!(
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28098; /* *cond_fixuns_truncv512dfv512di */

    case 1031:
      if (!(
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28254; /* *cond_fixuns_truncv512sfv512di */

    case 1032:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28352; /* *cond_fixuns_truncrvvm8hfrvvm4qi */

    case 1033:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28354; /* *cond_fixuns_truncrvvm4hfrvvm2qi */

    case 1034:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28356; /* *cond_fixuns_truncrvvm2hfrvvm1qi */

    case 1035:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28358; /* *cond_fixuns_truncrvvm1hfrvvmf2qi */

    case 1036:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28360; /* *cond_fixuns_truncrvvmf2hfrvvmf4qi */

    case 1037:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28362; /* *cond_fixuns_truncrvvmf4hfrvvmf8qi */

    case 1038:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28382; /* *cond_fixuns_truncv1hfv1qi */

    case 1039:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28384; /* *cond_fixuns_truncv2hfv2qi */

    case 1040:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28386; /* *cond_fixuns_truncv4hfv4qi */

    case 1041:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28388; /* *cond_fixuns_truncv8hfv8qi */

    case 1042:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28390; /* *cond_fixuns_truncv16hfv16qi */

    case 1043:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28392; /* *cond_fixuns_truncv32hfv32qi */

    case 1044:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28394; /* *cond_fixuns_truncv64hfv64qi */

    case 1045:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28396; /* *cond_fixuns_truncv128hfv128qi */

    case 1046:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28398; /* *cond_fixuns_truncv256hfv256qi */

    case 1047:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28400; /* *cond_fixuns_truncv512hfv512qi */

    case 1048:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28402; /* *cond_fixuns_truncv1024hfv1024qi */

    case 1049:
      if (!(
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28404; /* *cond_fixuns_truncv2048hfv2048qi */

    case 1050:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28099; /* *cond_floatrvvm8hirvvm8hf */

    case 1051:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28255; /* *cond_floatrvvm4qirvvm8hf */

    case 1052:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28101; /* *cond_floatrvvm4hirvvm4hf */

    case 1053:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28257; /* *cond_floatrvvm2qirvvm4hf */

    case 1054:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28447; /* *cond_floatrvvm8sirvvm4hf2 */

    case 1055:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28103; /* *cond_floatrvvm2hirvvm2hf */

    case 1056:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28259; /* *cond_floatrvvm1qirvvm2hf */

    case 1057:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28449; /* *cond_floatrvvm4sirvvm2hf2 */

    case 1058:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28105; /* *cond_floatrvvm1hirvvm1hf */

    case 1059:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28261; /* *cond_floatrvvmf2qirvvm1hf */

    case 1060:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28451; /* *cond_floatrvvm2sirvvm1hf2 */

    case 1061:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28107; /* *cond_floatrvvmf2hirvvmf2hf */

    case 1062:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28263; /* *cond_floatrvvmf4qirvvmf2hf */

    case 1063:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28453; /* *cond_floatrvvm1sirvvmf2hf2 */

    case 1064:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28109; /* *cond_floatrvvmf4hirvvmf4hf */

    case 1065:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28265; /* *cond_floatrvvmf8qirvvmf4hf */

    case 1066:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28455; /* *cond_floatrvvmf2sirvvmf4hf2 */

    case 1067:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28111; /* *cond_floatrvvm8sirvvm8sf */

    case 1068:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28267; /* *cond_floatrvvm4hirvvm8sf */

    case 1069:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28113; /* *cond_floatrvvm4sirvvm4sf */

    case 1070:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28269; /* *cond_floatrvvm2hirvvm4sf */

    case 1071:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28457; /* *cond_floatrvvm8dirvvm4sf2 */

    case 1072:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28115; /* *cond_floatrvvm2sirvvm2sf */

    case 1073:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28271; /* *cond_floatrvvm1hirvvm2sf */

    case 1074:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28459; /* *cond_floatrvvm4dirvvm2sf2 */

    case 1075:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28117; /* *cond_floatrvvm1sirvvm1sf */

    case 1076:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28273; /* *cond_floatrvvmf2hirvvm1sf */

    case 1077:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28461; /* *cond_floatrvvm2dirvvm1sf2 */

    case 1078:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28119; /* *cond_floatrvvmf2sirvvmf2sf */

    case 1079:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28275; /* *cond_floatrvvmf4hirvvmf2sf */

    case 1080:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28463; /* *cond_floatrvvm1dirvvmf2sf2 */

    case 1081:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28121; /* *cond_floatrvvm8dirvvm8df */

    case 1082:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28277; /* *cond_floatrvvm4sirvvm8df */

    case 1083:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28123; /* *cond_floatrvvm4dirvvm4df */

    case 1084:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28279; /* *cond_floatrvvm2sirvvm4df */

    case 1085:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28125; /* *cond_floatrvvm2dirvvm2df */

    case 1086:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28281; /* *cond_floatrvvm1sirvvm2df */

    case 1087:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28127; /* *cond_floatrvvm1dirvvm1df */

    case 1088:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28283; /* *cond_floatrvvmf2sirvvm1df */

    case 1089:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28129; /* *cond_floatv1hiv1hf */

    case 1090:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28285; /* *cond_floatv1qiv1hf */

    case 1091:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 28465; /* *cond_floatv1siv1hf2 */

    case 1092:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28131; /* *cond_floatv2hiv2hf */

    case 1093:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28287; /* *cond_floatv2qiv2hf */

    case 1094:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 28467; /* *cond_floatv2siv2hf2 */

    case 1095:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28133; /* *cond_floatv4hiv4hf */

    case 1096:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28289; /* *cond_floatv4qiv4hf */

    case 1097:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 28469; /* *cond_floatv4siv4hf2 */

    case 1098:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28135; /* *cond_floatv8hiv8hf */

    case 1099:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28291; /* *cond_floatv8qiv8hf */

    case 1100:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 28471; /* *cond_floatv8siv8hf2 */

    case 1101:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28137; /* *cond_floatv16hiv16hf */

    case 1102:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28293; /* *cond_floatv16qiv16hf */

    case 1103:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28473; /* *cond_floatv16siv16hf2 */

    case 1104:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28139; /* *cond_floatv32hiv32hf */

    case 1105:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28295; /* *cond_floatv32qiv32hf */

    case 1106:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28475; /* *cond_floatv32siv32hf2 */

    case 1107:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28141; /* *cond_floatv64hiv64hf */

    case 1108:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28297; /* *cond_floatv64qiv64hf */

    case 1109:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28477; /* *cond_floatv64siv64hf2 */

    case 1110:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28143; /* *cond_floatv128hiv128hf */

    case 1111:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28299; /* *cond_floatv128qiv128hf */

    case 1112:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28479; /* *cond_floatv128siv128hf2 */

    case 1113:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28145; /* *cond_floatv256hiv256hf */

    case 1114:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28301; /* *cond_floatv256qiv256hf */

    case 1115:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28481; /* *cond_floatv256siv256hf2 */

    case 1116:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28147; /* *cond_floatv512hiv512hf */

    case 1117:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28303; /* *cond_floatv512qiv512hf */

    case 1118:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28483; /* *cond_floatv512siv512hf2 */

    case 1119:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28149; /* *cond_floatv1024hiv1024hf */

    case 1120:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28305; /* *cond_floatv1024qiv1024hf */

    case 1121:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28485; /* *cond_floatv1024siv1024hf2 */

    case 1122:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28151; /* *cond_floatv2048hiv2048hf */

    case 1123:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28307; /* *cond_floatv2048qiv2048hf */

    case 1124:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28153; /* *cond_floatv1siv1sf */

    case 1125:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28309; /* *cond_floatv1hiv1sf */

    case 1126:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28487; /* *cond_floatv1div1sf2 */

    case 1127:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28155; /* *cond_floatv2siv2sf */

    case 1128:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28311; /* *cond_floatv2hiv2sf */

    case 1129:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28489; /* *cond_floatv2div2sf2 */

    case 1130:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28157; /* *cond_floatv4siv4sf */

    case 1131:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28313; /* *cond_floatv4hiv4sf */

    case 1132:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28491; /* *cond_floatv4div4sf2 */

    case 1133:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28159; /* *cond_floatv8siv8sf */

    case 1134:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28315; /* *cond_floatv8hiv8sf */

    case 1135:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28493; /* *cond_floatv8div8sf2 */

    case 1136:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28161; /* *cond_floatv16siv16sf */

    case 1137:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28317; /* *cond_floatv16hiv16sf */

    case 1138:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28495; /* *cond_floatv16div16sf2 */

    case 1139:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28163; /* *cond_floatv32siv32sf */

    case 1140:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28319; /* *cond_floatv32hiv32sf */

    case 1141:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28497; /* *cond_floatv32div32sf2 */

    case 1142:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28165; /* *cond_floatv64siv64sf */

    case 1143:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28321; /* *cond_floatv64hiv64sf */

    case 1144:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28499; /* *cond_floatv64div64sf2 */

    case 1145:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28167; /* *cond_floatv128siv128sf */

    case 1146:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28323; /* *cond_floatv128hiv128sf */

    case 1147:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28501; /* *cond_floatv128div128sf2 */

    case 1148:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28169; /* *cond_floatv256siv256sf */

    case 1149:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28325; /* *cond_floatv256hiv256sf */

    case 1150:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28503; /* *cond_floatv256div256sf2 */

    case 1151:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28171; /* *cond_floatv512siv512sf */

    case 1152:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28327; /* *cond_floatv512hiv512sf */

    case 1153:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28505; /* *cond_floatv512div512sf2 */

    case 1154:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28173; /* *cond_floatv1024siv1024sf */

    case 1155:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28329; /* *cond_floatv1024hiv1024sf */

    case 1156:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28175; /* *cond_floatv1div1df */

    case 1157:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28331; /* *cond_floatv1siv1df */

    case 1158:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28177; /* *cond_floatv2div2df */

    case 1159:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28333; /* *cond_floatv2siv2df */

    case 1160:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28179; /* *cond_floatv4div4df */

    case 1161:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28335; /* *cond_floatv4siv4df */

    case 1162:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28181; /* *cond_floatv8div8df */

    case 1163:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28337; /* *cond_floatv8siv8df */

    case 1164:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28183; /* *cond_floatv16div16df */

    case 1165:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28339; /* *cond_floatv16siv16df */

    case 1166:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28185; /* *cond_floatv32div32df */

    case 1167:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28341; /* *cond_floatv32siv32df */

    case 1168:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28187; /* *cond_floatv64div64df */

    case 1169:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28343; /* *cond_floatv64siv64df */

    case 1170:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28189; /* *cond_floatv128div128df */

    case 1171:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28345; /* *cond_floatv128siv128df */

    case 1172:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28191; /* *cond_floatv256div256df */

    case 1173:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28347; /* *cond_floatv256siv256df */

    case 1174:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28193; /* *cond_floatv512div512df */

    case 1175:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28349; /* *cond_floatv512siv512df */

    case 1176:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28100; /* *cond_floatunsrvvm8hirvvm8hf */

    case 1177:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28256; /* *cond_floatunsrvvm4qirvvm8hf */

    case 1178:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28102; /* *cond_floatunsrvvm4hirvvm4hf */

    case 1179:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28258; /* *cond_floatunsrvvm2qirvvm4hf */

    case 1180:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28448; /* *cond_floatunsrvvm8sirvvm4hf2 */

    case 1181:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28104; /* *cond_floatunsrvvm2hirvvm2hf */

    case 1182:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28260; /* *cond_floatunsrvvm1qirvvm2hf */

    case 1183:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28450; /* *cond_floatunsrvvm4sirvvm2hf2 */

    case 1184:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28106; /* *cond_floatunsrvvm1hirvvm1hf */

    case 1185:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28262; /* *cond_floatunsrvvmf2qirvvm1hf */

    case 1186:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28452; /* *cond_floatunsrvvm2sirvvm1hf2 */

    case 1187:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28108; /* *cond_floatunsrvvmf2hirvvmf2hf */

    case 1188:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28264; /* *cond_floatunsrvvmf4qirvvmf2hf */

    case 1189:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28454; /* *cond_floatunsrvvm1sirvvmf2hf2 */

    case 1190:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28110; /* *cond_floatunsrvvmf4hirvvmf4hf */

    case 1191:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28266; /* *cond_floatunsrvvmf8qirvvmf4hf */

    case 1192:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28456; /* *cond_floatunsrvvmf2sirvvmf4hf2 */

    case 1193:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28112; /* *cond_floatunsrvvm8sirvvm8sf */

    case 1194:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28268; /* *cond_floatunsrvvm4hirvvm8sf */

    case 1195:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28114; /* *cond_floatunsrvvm4sirvvm4sf */

    case 1196:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28270; /* *cond_floatunsrvvm2hirvvm4sf */

    case 1197:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28458; /* *cond_floatunsrvvm8dirvvm4sf2 */

    case 1198:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28116; /* *cond_floatunsrvvm2sirvvm2sf */

    case 1199:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28272; /* *cond_floatunsrvvm1hirvvm2sf */

    case 1200:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28460; /* *cond_floatunsrvvm4dirvvm2sf2 */

    case 1201:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28118; /* *cond_floatunsrvvm1sirvvm1sf */

    case 1202:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28274; /* *cond_floatunsrvvmf2hirvvm1sf */

    case 1203:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28462; /* *cond_floatunsrvvm2dirvvm1sf2 */

    case 1204:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28120; /* *cond_floatunsrvvmf2sirvvmf2sf */

    case 1205:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28276; /* *cond_floatunsrvvmf4hirvvmf2sf */

    case 1206:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28464; /* *cond_floatunsrvvm1dirvvmf2sf2 */

    case 1207:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28122; /* *cond_floatunsrvvm8dirvvm8df */

    case 1208:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28278; /* *cond_floatunsrvvm4sirvvm8df */

    case 1209:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28124; /* *cond_floatunsrvvm4dirvvm4df */

    case 1210:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28280; /* *cond_floatunsrvvm2sirvvm4df */

    case 1211:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28126; /* *cond_floatunsrvvm2dirvvm2df */

    case 1212:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28282; /* *cond_floatunsrvvm1sirvvm2df */

    case 1213:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28128; /* *cond_floatunsrvvm1dirvvm1df */

    case 1214:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28284; /* *cond_floatunsrvvmf2sirvvm1df */

    case 1215:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28130; /* *cond_floatunsv1hiv1hf */

    case 1216:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28286; /* *cond_floatunsv1qiv1hf */

    case 1217:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 28466; /* *cond_floatunsv1siv1hf2 */

    case 1218:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28132; /* *cond_floatunsv2hiv2hf */

    case 1219:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28288; /* *cond_floatunsv2qiv2hf */

    case 1220:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 28468; /* *cond_floatunsv2siv2hf2 */

    case 1221:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28134; /* *cond_floatunsv4hiv4hf */

    case 1222:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28290; /* *cond_floatunsv4qiv4hf */

    case 1223:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 28470; /* *cond_floatunsv4siv4hf2 */

    case 1224:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28136; /* *cond_floatunsv8hiv8hf */

    case 1225:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28292; /* *cond_floatunsv8qiv8hf */

    case 1226:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 28472; /* *cond_floatunsv8siv8hf2 */

    case 1227:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28138; /* *cond_floatunsv16hiv16hf */

    case 1228:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28294; /* *cond_floatunsv16qiv16hf */

    case 1229:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28474; /* *cond_floatunsv16siv16hf2 */

    case 1230:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28140; /* *cond_floatunsv32hiv32hf */

    case 1231:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28296; /* *cond_floatunsv32qiv32hf */

    case 1232:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28476; /* *cond_floatunsv32siv32hf2 */

    case 1233:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28142; /* *cond_floatunsv64hiv64hf */

    case 1234:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28298; /* *cond_floatunsv64qiv64hf */

    case 1235:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28478; /* *cond_floatunsv64siv64hf2 */

    case 1236:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28144; /* *cond_floatunsv128hiv128hf */

    case 1237:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28300; /* *cond_floatunsv128qiv128hf */

    case 1238:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28480; /* *cond_floatunsv128siv128hf2 */

    case 1239:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28146; /* *cond_floatunsv256hiv256hf */

    case 1240:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28302; /* *cond_floatunsv256qiv256hf */

    case 1241:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28482; /* *cond_floatunsv256siv256hf2 */

    case 1242:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28148; /* *cond_floatunsv512hiv512hf */

    case 1243:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28304; /* *cond_floatunsv512qiv512hf */

    case 1244:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28484; /* *cond_floatunsv512siv512hf2 */

    case 1245:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28150; /* *cond_floatunsv1024hiv1024hf */

    case 1246:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28306; /* *cond_floatunsv1024qiv1024hf */

    case 1247:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28486; /* *cond_floatunsv1024siv1024hf2 */

    case 1248:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28152; /* *cond_floatunsv2048hiv2048hf */

    case 1249:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28308; /* *cond_floatunsv2048qiv2048hf */

    case 1250:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28154; /* *cond_floatunsv1siv1sf */

    case 1251:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28310; /* *cond_floatunsv1hiv1sf */

    case 1252:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28488; /* *cond_floatunsv1div1sf2 */

    case 1253:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28156; /* *cond_floatunsv2siv2sf */

    case 1254:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28312; /* *cond_floatunsv2hiv2sf */

    case 1255:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28490; /* *cond_floatunsv2div2sf2 */

    case 1256:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28158; /* *cond_floatunsv4siv4sf */

    case 1257:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28314; /* *cond_floatunsv4hiv4sf */

    case 1258:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28492; /* *cond_floatunsv4div4sf2 */

    case 1259:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28160; /* *cond_floatunsv8siv8sf */

    case 1260:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28316; /* *cond_floatunsv8hiv8sf */

    case 1261:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28494; /* *cond_floatunsv8div8sf2 */

    case 1262:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28162; /* *cond_floatunsv16siv16sf */

    case 1263:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28318; /* *cond_floatunsv16hiv16sf */

    case 1264:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28496; /* *cond_floatunsv16div16sf2 */

    case 1265:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28164; /* *cond_floatunsv32siv32sf */

    case 1266:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28320; /* *cond_floatunsv32hiv32sf */

    case 1267:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28498; /* *cond_floatunsv32div32sf2 */

    case 1268:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28166; /* *cond_floatunsv64siv64sf */

    case 1269:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28322; /* *cond_floatunsv64hiv64sf */

    case 1270:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28500; /* *cond_floatunsv64div64sf2 */

    case 1271:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28168; /* *cond_floatunsv128siv128sf */

    case 1272:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28324; /* *cond_floatunsv128hiv128sf */

    case 1273:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28502; /* *cond_floatunsv128div128sf2 */

    case 1274:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28170; /* *cond_floatunsv256siv256sf */

    case 1275:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28326; /* *cond_floatunsv256hiv256sf */

    case 1276:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28504; /* *cond_floatunsv256div256sf2 */

    case 1277:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28172; /* *cond_floatunsv512siv512sf */

    case 1278:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28328; /* *cond_floatunsv512hiv512sf */

    case 1279:
      if (!(
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28506; /* *cond_floatunsv512div512sf2 */

    case 1280:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28174; /* *cond_floatunsv1024siv1024sf */

    case 1281:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28330; /* *cond_floatunsv1024hiv1024sf */

    case 1282:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28176; /* *cond_floatunsv1div1df */

    case 1283:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28332; /* *cond_floatunsv1siv1df */

    case 1284:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28178; /* *cond_floatunsv2div2df */

    case 1285:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28334; /* *cond_floatunsv2siv2df */

    case 1286:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28180; /* *cond_floatunsv4div4df */

    case 1287:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28336; /* *cond_floatunsv4siv4df */

    case 1288:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28182; /* *cond_floatunsv8div8df */

    case 1289:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28338; /* *cond_floatunsv8siv8df */

    case 1290:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28184; /* *cond_floatunsv16div16df */

    case 1291:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28340; /* *cond_floatunsv16siv16df */

    case 1292:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28186; /* *cond_floatunsv32div32df */

    case 1293:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28342; /* *cond_floatunsv32siv32df */

    case 1294:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28188; /* *cond_floatunsv64div64df */

    case 1295:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28344; /* *cond_floatunsv64siv64df */

    case 1296:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28190; /* *cond_floatunsv128div128df */

    case 1297:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28346; /* *cond_floatunsv128siv128df */

    case 1298:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28192; /* *cond_floatunsv256div256df */

    case 1299:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28348; /* *cond_floatunsv256siv256df */

    case 1300:
      if (!(
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28194; /* *cond_floatunsv512div512df */

    case 1301:
      if (!(
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28350; /* *cond_floatunsv512siv512df */

    case 1302:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28795; /* *cond_smulrvvm8qi3_highpart */

    case 1303:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28797; /* *cond_smulrvvm4qi3_highpart */

    case 1304:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28799; /* *cond_smulrvvm2qi3_highpart */

    case 1305:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28801; /* *cond_smulrvvm1qi3_highpart */

    case 1306:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28803; /* *cond_smulrvvmf2qi3_highpart */

    case 1307:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28805; /* *cond_smulrvvmf4qi3_highpart */

    case 1308:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 488 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28807; /* *cond_smulrvvmf8qi3_highpart */

    case 1309:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28809; /* *cond_smulrvvm8hi3_highpart */

    case 1310:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28811; /* *cond_smulrvvm4hi3_highpart */

    case 1311:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28813; /* *cond_smulrvvm2hi3_highpart */

    case 1312:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28815; /* *cond_smulrvvm1hi3_highpart */

    case 1313:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28817; /* *cond_smulrvvmf2hi3_highpart */

    case 1314:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28819; /* *cond_smulrvvmf4hi3_highpart */

    case 1315:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28821; /* *cond_smulrvvm8si3_highpart */

    case 1316:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28823; /* *cond_smulrvvm4si3_highpart */

    case 1317:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28825; /* *cond_smulrvvm2si3_highpart */

    case 1318:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28827; /* *cond_smulrvvm1si3_highpart */

    case 1319:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 492 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28829; /* *cond_smulrvvmf2si3_highpart */

    case 1320:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28831; /* *cond_smulrvvm8di3_highpart */

    case 1321:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28833; /* *cond_smulrvvm4di3_highpart */

    case 1322:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28835; /* *cond_smulrvvm2di3_highpart */

    case 1323:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28837; /* *cond_smulrvvm1di3_highpart */

    case 1324:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 496 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 28839; /* *cond_smulv1qi3_highpart */

    case 1325:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 497 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 28841; /* *cond_smulv2qi3_highpart */

    case 1326:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 498 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 28843; /* *cond_smulv4qi3_highpart */

    case 1327:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 499 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 28845; /* *cond_smulv8qi3_highpart */

    case 1328:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 500 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 28847; /* *cond_smulv16qi3_highpart */

    case 1329:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 501 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 28849; /* *cond_smulv32qi3_highpart */

    case 1330:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28851; /* *cond_smulv64qi3_highpart */

    case 1331:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 503 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28853; /* *cond_smulv128qi3_highpart */

    case 1332:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28855; /* *cond_smulv256qi3_highpart */

    case 1333:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28857; /* *cond_smulv512qi3_highpart */

    case 1334:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28859; /* *cond_smulv1024qi3_highpart */

    case 1335:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28861; /* *cond_smulv2048qi3_highpart */

    case 1336:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28863; /* *cond_smulv4096qi3_highpart */

    case 1337:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28865; /* *cond_smulv1hi3_highpart */

    case 1338:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28867; /* *cond_smulv2hi3_highpart */

    case 1339:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28869; /* *cond_smulv4hi3_highpart */

    case 1340:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28871; /* *cond_smulv8hi3_highpart */

    case 1341:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28873; /* *cond_smulv16hi3_highpart */

    case 1342:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28875; /* *cond_smulv32hi3_highpart */

    case 1343:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28877; /* *cond_smulv64hi3_highpart */

    case 1344:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28879; /* *cond_smulv128hi3_highpart */

    case 1345:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28881; /* *cond_smulv256hi3_highpart */

    case 1346:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28883; /* *cond_smulv512hi3_highpart */

    case 1347:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28885; /* *cond_smulv1024hi3_highpart */

    case 1348:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28887; /* *cond_smulv2048hi3_highpart */

    case 1349:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28889; /* *cond_smulv1si3_highpart */

    case 1350:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28891; /* *cond_smulv2si3_highpart */

    case 1351:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28893; /* *cond_smulv4si3_highpart */

    case 1352:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28895; /* *cond_smulv8si3_highpart */

    case 1353:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28897; /* *cond_smulv16si3_highpart */

    case 1354:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28899; /* *cond_smulv32si3_highpart */

    case 1355:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28901; /* *cond_smulv64si3_highpart */

    case 1356:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28903; /* *cond_smulv128si3_highpart */

    case 1357:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28905; /* *cond_smulv256si3_highpart */

    case 1358:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28907; /* *cond_smulv512si3_highpart */

    case 1359:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28909; /* *cond_smulv1024si3_highpart */

    case 1360:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 28911; /* *cond_smulv1di3_highpart */

    case 1361:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 28913; /* *cond_smulv2di3_highpart */

    case 1362:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 28915; /* *cond_smulv4di3_highpart */

    case 1363:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28917; /* *cond_smulv8di3_highpart */

    case 1364:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28919; /* *cond_smulv16di3_highpart */

    case 1365:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28921; /* *cond_smulv32di3_highpart */

    case 1366:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28923; /* *cond_smulv64di3_highpart */

    case 1367:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28925; /* *cond_smulv128di3_highpart */

    case 1368:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28927; /* *cond_smulv256di3_highpart */

    case 1369:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28929; /* *cond_smulv512di3_highpart */

    case 1370:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28796; /* *cond_umulrvvm8qi3_highpart */

    case 1371:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28798; /* *cond_umulrvvm4qi3_highpart */

    case 1372:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28800; /* *cond_umulrvvm2qi3_highpart */

    case 1373:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28802; /* *cond_umulrvvm1qi3_highpart */

    case 1374:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28804; /* *cond_umulrvvmf2qi3_highpart */

    case 1375:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28806; /* *cond_umulrvvmf4qi3_highpart */

    case 1376:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 488 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28808; /* *cond_umulrvvmf8qi3_highpart */

    case 1377:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28810; /* *cond_umulrvvm8hi3_highpart */

    case 1378:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28812; /* *cond_umulrvvm4hi3_highpart */

    case 1379:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28814; /* *cond_umulrvvm2hi3_highpart */

    case 1380:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28816; /* *cond_umulrvvm1hi3_highpart */

    case 1381:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28818; /* *cond_umulrvvmf2hi3_highpart */

    case 1382:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28820; /* *cond_umulrvvmf4hi3_highpart */

    case 1383:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28822; /* *cond_umulrvvm8si3_highpart */

    case 1384:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28824; /* *cond_umulrvvm4si3_highpart */

    case 1385:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28826; /* *cond_umulrvvm2si3_highpart */

    case 1386:
      if (!
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28828; /* *cond_umulrvvm1si3_highpart */

    case 1387:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 492 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28830; /* *cond_umulrvvmf2si3_highpart */

    case 1388:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28832; /* *cond_umulrvvm8di3_highpart */

    case 1389:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28834; /* *cond_umulrvvm4di3_highpart */

    case 1390:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28836; /* *cond_umulrvvm2di3_highpart */

    case 1391:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28838; /* *cond_umulrvvm1di3_highpart */

    case 1392:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 496 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 28840; /* *cond_umulv1qi3_highpart */

    case 1393:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 497 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 28842; /* *cond_umulv2qi3_highpart */

    case 1394:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 498 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 28844; /* *cond_umulv4qi3_highpart */

    case 1395:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 499 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 28846; /* *cond_umulv8qi3_highpart */

    case 1396:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 500 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 28848; /* *cond_umulv16qi3_highpart */

    case 1397:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 501 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 28850; /* *cond_umulv32qi3_highpart */

    case 1398:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28852; /* *cond_umulv64qi3_highpart */

    case 1399:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 503 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28854; /* *cond_umulv128qi3_highpart */

    case 1400:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28856; /* *cond_umulv256qi3_highpart */

    case 1401:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28858; /* *cond_umulv512qi3_highpart */

    case 1402:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28860; /* *cond_umulv1024qi3_highpart */

    case 1403:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28862; /* *cond_umulv2048qi3_highpart */

    case 1404:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28864; /* *cond_umulv4096qi3_highpart */

    case 1405:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28866; /* *cond_umulv1hi3_highpart */

    case 1406:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28868; /* *cond_umulv2hi3_highpart */

    case 1407:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28870; /* *cond_umulv4hi3_highpart */

    case 1408:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28872; /* *cond_umulv8hi3_highpart */

    case 1409:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28874; /* *cond_umulv16hi3_highpart */

    case 1410:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28876; /* *cond_umulv32hi3_highpart */

    case 1411:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28878; /* *cond_umulv64hi3_highpart */

    case 1412:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28880; /* *cond_umulv128hi3_highpart */

    case 1413:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28882; /* *cond_umulv256hi3_highpart */

    case 1414:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28884; /* *cond_umulv512hi3_highpart */

    case 1415:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28886; /* *cond_umulv1024hi3_highpart */

    case 1416:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28888; /* *cond_umulv2048hi3_highpart */

    case 1417:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28890; /* *cond_umulv1si3_highpart */

    case 1418:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28892; /* *cond_umulv2si3_highpart */

    case 1419:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28894; /* *cond_umulv4si3_highpart */

    case 1420:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28896; /* *cond_umulv8si3_highpart */

    case 1421:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28898; /* *cond_umulv16si3_highpart */

    case 1422:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28900; /* *cond_umulv32si3_highpart */

    case 1423:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28902; /* *cond_umulv64si3_highpart */

    case 1424:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28904; /* *cond_umulv128si3_highpart */

    case 1425:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28906; /* *cond_umulv256si3_highpart */

    case 1426:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28908; /* *cond_umulv512si3_highpart */

    case 1427:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28910; /* *cond_umulv1024si3_highpart */

    case 1428:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 28912; /* *cond_umulv1di3_highpart */

    case 1429:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 28914; /* *cond_umulv2di3_highpart */

    case 1430:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 28916; /* *cond_umulv4di3_highpart */

    case 1431:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28918; /* *cond_umulv8di3_highpart */

    case 1432:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28920; /* *cond_umulv16di3_highpart */

    case 1433:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28922; /* *cond_umulv32di3_highpart */

    case 1434:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28924; /* *cond_umulv64di3_highpart */

    case 1435:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28926; /* *cond_umulv128di3_highpart */

    case 1436:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28928; /* *cond_umulv256di3_highpart */

    case 1437:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28930; /* *cond_umulv512di3_highpart */

    default:
      return -1;
    }
}

 rtx_insn *
split_143 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern151 (x2))
        {
        case 0:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4333 (insn, operands);

        case 1:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4334 (insn, operands);

        case 2:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4335 (insn, operands);

        case 3:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4336 (insn, operands);

        case 4:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4337 (insn, operands);

        case 5:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4338 (insn, operands);

        case 6:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4339 (insn, operands);

        case 7:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4340 (insn, operands);

        case 8:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4341 (insn, operands);

        case 9:
          if (!(
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4342 (insn, operands);

        case 10:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4343 (insn, operands);

        case 11:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4344 (insn, operands);

        case 12:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4345 (insn, operands);

        case 13:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4346 (insn, operands);

        case 14:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4347 (insn, operands);

        case 15:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4348 (insn, operands);

        case 16:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4349 (insn, operands);

        case 17:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4350 (insn, operands);

        case 18:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4351 (insn, operands);

        case 19:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4352 (insn, operands);

        case 20:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4353 (insn, operands);

        case 21:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4354 (insn, operands);

        case 22:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4355 (insn, operands);

        case 23:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4356 (insn, operands);

        case 24:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4357 (insn, operands);

        case 25:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4358 (insn, operands);

        case 26:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4359 (insn, operands);

        case 27:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4360 (insn, operands);

        case 28:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4361 (insn, operands);

        case 29:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4362 (insn, operands);

        case 30:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4363 (insn, operands);

        case 31:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4364 (insn, operands);

        case 32:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4365 (insn, operands);

        case 33:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4366 (insn, operands);

        case 34:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4367 (insn, operands);

        case 35:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4368 (insn, operands);

        case 36:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4369 (insn, operands);

        case 37:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4370 (insn, operands);

        case 38:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4371 (insn, operands);

        case 39:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4372 (insn, operands);

        case 40:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4373 (insn, operands);

        case 41:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4374 (insn, operands);

        case 42:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4375 (insn, operands);

        case 43:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4376 (insn, operands);

        case 44:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4377 (insn, operands);

        case 45:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4378 (insn, operands);

        case 46:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4379 (insn, operands);

        case 47:
          if (!((
#line 777 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4380 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern155 (x2))
        {
        case 0:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7844 (insn, operands);

        case 1:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7848 (insn, operands);

        case 2:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7852 (insn, operands);

        case 3:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7856 (insn, operands);

        case 4:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7860 (insn, operands);

        case 5:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7864 (insn, operands);

        case 6:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7868 (insn, operands);

        case 7:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7872 (insn, operands);

        case 8:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7876 (insn, operands);

        case 9:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7880 (insn, operands);

        case 10:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7884 (insn, operands);

        case 11:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7888 (insn, operands);

        case 12:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7892 (insn, operands);

        case 13:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7896 (insn, operands);

        case 14:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7900 (insn, operands);

        case 15:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7904 (insn, operands);

        case 16:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7908 (insn, operands);

        case 17:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7912 (insn, operands);

        case 18:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7916 (insn, operands);

        case 19:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7920 (insn, operands);

        case 20:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7924 (insn, operands);

        case 21:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7928 (insn, operands);

        case 22:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7932 (insn, operands);

        case 23:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7936 (insn, operands);

        case 24:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7940 (insn, operands);

        case 25:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7944 (insn, operands);

        case 26:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7948 (insn, operands);

        case 27:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7952 (insn, operands);

        case 28:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7956 (insn, operands);

        case 29:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7960 (insn, operands);

        case 30:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7964 (insn, operands);

        case 31:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7968 (insn, operands);

        case 32:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7972 (insn, operands);

        case 33:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7976 (insn, operands);

        case 34:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7980 (insn, operands);

        case 35:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7984 (insn, operands);

        case 36:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7988 (insn, operands);

        case 37:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7992 (insn, operands);

        case 38:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7996 (insn, operands);

        case 39:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8000 (insn, operands);

        case 40:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8004 (insn, operands);

        case 41:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8008 (insn, operands);

        case 42:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8012 (insn, operands);

        case 43:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8016 (insn, operands);

        case 44:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8020 (insn, operands);

        case 45:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8024 (insn, operands);

        case 46:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8028 (insn, operands);

        case 47:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8032 (insn, operands);

        case 48:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7846 (insn, operands);

        case 49:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7850 (insn, operands);

        case 50:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7854 (insn, operands);

        case 51:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7858 (insn, operands);

        case 52:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7862 (insn, operands);

        case 53:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7866 (insn, operands);

        case 54:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7870 (insn, operands);

        case 55:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7874 (insn, operands);

        case 56:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7878 (insn, operands);

        case 57:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7882 (insn, operands);

        case 58:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7886 (insn, operands);

        case 59:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7890 (insn, operands);

        case 60:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7894 (insn, operands);

        case 61:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7898 (insn, operands);

        case 62:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7902 (insn, operands);

        case 63:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7906 (insn, operands);

        case 64:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7910 (insn, operands);

        case 65:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7914 (insn, operands);

        case 66:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7918 (insn, operands);

        case 67:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7922 (insn, operands);

        case 68:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7926 (insn, operands);

        case 69:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7930 (insn, operands);

        case 70:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7934 (insn, operands);

        case 71:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7938 (insn, operands);

        case 72:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7942 (insn, operands);

        case 73:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7946 (insn, operands);

        case 74:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7950 (insn, operands);

        case 75:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7954 (insn, operands);

        case 76:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7958 (insn, operands);

        case 77:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7962 (insn, operands);

        case 78:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7966 (insn, operands);

        case 79:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7970 (insn, operands);

        case 80:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7974 (insn, operands);

        case 81:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7978 (insn, operands);

        case 82:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7982 (insn, operands);

        case 83:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7986 (insn, operands);

        case 84:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7990 (insn, operands);

        case 85:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7994 (insn, operands);

        case 86:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7998 (insn, operands);

        case 87:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8002 (insn, operands);

        case 88:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8006 (insn, operands);

        case 89:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8010 (insn, operands);

        case 90:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8014 (insn, operands);

        case 91:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8018 (insn, operands);

        case 92:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8022 (insn, operands);

        case 93:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8026 (insn, operands);

        case 94:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8030 (insn, operands);

        case 95:
          if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8034 (insn, operands);

        case 96:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8036 (insn, operands);

        case 97:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8038 (insn, operands);

        case 98:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8040 (insn, operands);

        case 99:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8042 (insn, operands);

        case 100:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8044 (insn, operands);

        case 101:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8046 (insn, operands);

        case 102:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8048 (insn, operands);

        case 103:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8050 (insn, operands);

        case 104:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8052 (insn, operands);

        case 105:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8054 (insn, operands);

        case 106:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8056 (insn, operands);

        case 107:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8058 (insn, operands);

        case 108:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8060 (insn, operands);

        case 109:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8062 (insn, operands);

        case 110:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8064 (insn, operands);

        case 111:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8066 (insn, operands);

        case 112:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8068 (insn, operands);

        case 113:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8070 (insn, operands);

        case 114:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8072 (insn, operands);

        case 115:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8074 (insn, operands);

        case 116:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8076 (insn, operands);

        case 117:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8078 (insn, operands);

        case 118:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8080 (insn, operands);

        case 119:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8082 (insn, operands);

        case 120:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8084 (insn, operands);

        case 121:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8086 (insn, operands);

        case 122:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8088 (insn, operands);

        case 123:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8090 (insn, operands);

        case 124:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8092 (insn, operands);

        case 125:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8094 (insn, operands);

        case 126:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8096 (insn, operands);

        case 127:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8098 (insn, operands);

        case 128:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8100 (insn, operands);

        case 129:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8102 (insn, operands);

        case 130:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8104 (insn, operands);

        case 131:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8106 (insn, operands);

        case 132:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8108 (insn, operands);

        case 133:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8110 (insn, operands);

        case 134:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8112 (insn, operands);

        case 135:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8114 (insn, operands);

        case 136:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8116 (insn, operands);

        case 137:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8118 (insn, operands);

        case 138:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8120 (insn, operands);

        case 139:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8122 (insn, operands);

        case 140:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8124 (insn, operands);

        case 141:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8126 (insn, operands);

        case 142:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8128 (insn, operands);

        case 143:
          if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8130 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      return split_142 (x1, insn);

    case ASHIFT:
      return split_141 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_154 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4411 (insn, operands);

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4412 (insn, operands);

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4413 (insn, operands);

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4414 (insn, operands);

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4415 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4416 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4417 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4418 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4419 (insn, operands);

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4420 (insn, operands);

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4421 (insn, operands);

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4422 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4423 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4424 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4425 (insn, operands);

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4426 (insn, operands);

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4427 (insn, operands);

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4428 (insn, operands);

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4429 (insn, operands);

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4430 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4431 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4432 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4433 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4434 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4435 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4436 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4437 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4438 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4439 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !((
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 865 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4440 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_159 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (XINT (x3, 1) != 91
              || pattern260 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case CONST_VECTOR:
              operands[1] = x4;
              x5 = XVECEXP (x3, 0, 1);
              operands[4] = x5;
              if (!vector_length_operand (operands[4], E_VOIDmode))
                return NULL;
              x6 = XVECEXP (x3, 0, 2);
              operands[5] = x6;
              x7 = XEXP (x2, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 2);
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_RVVMF64BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF64BImode)
                      || pattern574 (x2, 
E_RVVMF64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_779 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF64BImode, 5))))
                    return NULL;
                  return gen_split_2431 (insn, operands);

                case E_RVVMF32BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF32BImode)
                      || pattern574 (x2, 
E_RVVMF32BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_780 (insn, operands);
                  if (!(
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF32BImode, 5))))
                    return NULL;
                  return gen_split_2432 (insn, operands);

                case E_RVVMF16BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF16BImode)
                      || pattern574 (x2, 
E_RVVMF16BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_781 (insn, operands);
                  if (!(
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF16BImode, 5))))
                    return NULL;
                  return gen_split_2433 (insn, operands);

                case E_RVVMF8BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF8BImode)
                      || pattern574 (x2, 
E_RVVMF8BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_782 (insn, operands);
                  if (!(
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8BImode, 5))))
                    return NULL;
                  return gen_split_2434 (insn, operands);

                case E_RVVMF4BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF4BImode)
                      || pattern574 (x2, 
E_RVVMF4BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_783 (insn, operands);
                  if (!(
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BImode, 5))))
                    return NULL;
                  return gen_split_2435 (insn, operands);

                case E_RVVMF2BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF2BImode)
                      || pattern574 (x2, 
E_RVVMF2BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_784 (insn, operands);
                  if (!(
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BImode, 5))))
                    return NULL;
                  return gen_split_2436 (insn, operands);

                case E_RVVM1BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVM1BImode)
                      || pattern574 (x2, 
E_RVVM1BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_785 (insn, operands);
                  if (!(
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BImode, 5))))
                    return NULL;
                  return gen_split_2437 (insn, operands);

                case E_V1BImode:
                  if (!nonimmediate_operand (operands[0], E_V1BImode)
                      || pattern574 (x2, 
E_V1BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_786 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1BImode, 5))))
                    return NULL;
                  return gen_split_2438 (insn, operands);

                case E_V2BImode:
                  if (!nonimmediate_operand (operands[0], E_V2BImode)
                      || pattern574 (x2, 
E_V2BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_787 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2BImode, 5))))
                    return NULL;
                  return gen_split_2439 (insn, operands);

                case E_V4BImode:
                  if (!nonimmediate_operand (operands[0], E_V4BImode)
                      || pattern574 (x2, 
E_V4BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_788 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4BImode, 5))))
                    return NULL;
                  return gen_split_2440 (insn, operands);

                case E_V8BImode:
                  if (!nonimmediate_operand (operands[0], E_V8BImode)
                      || pattern574 (x2, 
E_V8BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_789 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8BImode, 5))))
                    return NULL;
                  return gen_split_2441 (insn, operands);

                case E_V16BImode:
                  if (!nonimmediate_operand (operands[0], E_V16BImode)
                      || pattern574 (x2, 
E_V16BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_790 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16BImode, 5))))
                    return NULL;
                  return gen_split_2442 (insn, operands);

                case E_V32BImode:
                  if (!nonimmediate_operand (operands[0], E_V32BImode)
                      || pattern574 (x2, 
E_V32BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_791 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32BImode, 5))))
                    return NULL;
                  return gen_split_2443 (insn, operands);

                case E_V64BImode:
                  if (!nonimmediate_operand (operands[0], E_V64BImode)
                      || pattern574 (x2, 
E_V64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_792 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64BImode, 5))))
                    return NULL;
                  return gen_split_2444 (insn, operands);

                case E_V128BImode:
                  if (!nonimmediate_operand (operands[0], E_V128BImode)
                      || pattern574 (x2, 
E_V128BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_793 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128BImode, 5))))
                    return NULL;
                  return gen_split_2445 (insn, operands);

                case E_V256BImode:
                  if (!nonimmediate_operand (operands[0], E_V256BImode)
                      || pattern574 (x2, 
E_V256BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_794 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256BImode, 5))))
                    return NULL;
                  return gen_split_2446 (insn, operands);

                case E_V512BImode:
                  if (!nonimmediate_operand (operands[0], E_V512BImode)
                      || pattern574 (x2, 
E_V512BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_795 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512BImode, 5))))
                    return NULL;
                  return gen_split_2447 (insn, operands);

                case E_V1024BImode:
                  if (!nonimmediate_operand (operands[0], E_V1024BImode)
                      || pattern574 (x2, 
E_V1024BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_796 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024BImode, 5))))
                    return NULL;
                  return gen_split_2448 (insn, operands);

                case E_V2048BImode:
                  if (!nonimmediate_operand (operands[0], E_V2048BImode)
                      || pattern574 (x2, 
E_V2048BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_797 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048BImode, 5))))
                    return NULL;
                  return gen_split_2449 (insn, operands);

                case E_V4096BImode:
                  if (!nonimmediate_operand (operands[0], E_V4096BImode)
                      || pattern574 (x2, 
E_V4096BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 177 "../../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_798 (insn, operands);
                  if (!((
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1970 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096BImode, 5))))
                    return NULL;
                  return gen_split_2450 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
            case REG:
            case SUBREG:
              return split_124 (x1, insn);

            default:
              return NULL;
            }

        case 7:
          return split_132 (x1, insn);

        case 6:
          if (pattern262 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[4] = x5;
          if (!vector_length_operand (operands[4], E_VOIDmode))
            return NULL;
          x6 = XVECEXP (x3, 0, 2);
          operands[5] = x6;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return NULL;
          x9 = XVECEXP (x3, 0, 3);
          operands[6] = x9;
          if (!const_int_operand (operands[6], E_VOIDmode))
            return NULL;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF64BImode:
              if (!register_operand (operands[0], E_RVVMF64BImode)
                  || pattern574 (x2, 
E_RVVMF64BImode) != 0
                  || !(
#line 51 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return NULL;
              return gen_split_6307 (insn, operands);

            case E_RVVMF32BImode:
              if (!register_operand (operands[0], E_RVVMF32BImode)
                  || pattern574 (x2, 
E_RVVMF32BImode) != 0
                  || !
#line 51 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6308 (insn, operands);

            case E_RVVMF16BImode:
              if (!register_operand (operands[0], E_RVVMF16BImode)
                  || pattern574 (x2, 
E_RVVMF16BImode) != 0
                  || !
#line 51 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6309 (insn, operands);

            case E_RVVMF8BImode:
              if (!register_operand (operands[0], E_RVVMF8BImode)
                  || pattern574 (x2, 
E_RVVMF8BImode) != 0
                  || !
#line 51 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6310 (insn, operands);

            case E_RVVMF4BImode:
              if (!register_operand (operands[0], E_RVVMF4BImode)
                  || pattern574 (x2, 
E_RVVMF4BImode) != 0
                  || !
#line 51 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6311 (insn, operands);

            case E_RVVMF2BImode:
              if (!register_operand (operands[0], E_RVVMF2BImode)
                  || pattern574 (x2, 
E_RVVMF2BImode) != 0
                  || !
#line 51 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6312 (insn, operands);

            case E_RVVM1BImode:
              if (!register_operand (operands[0], E_RVVM1BImode)
                  || pattern574 (x2, 
E_RVVM1BImode) != 0
                  || !
#line 51 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6313 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      return split_133 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_165 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2598 (insn, operands);

    case 1:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2612 (insn, operands);

    case 2:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2626 (insn, operands);

    case 3:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2640 (insn, operands);

    case 4:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2654 (insn, operands);

    case 5:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2668 (insn, operands);

    case 6:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2682 (insn, operands);

    case 7:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2696 (insn, operands);

    case 8:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2710 (insn, operands);

    case 9:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2724 (insn, operands);

    case 10:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2738 (insn, operands);

    case 11:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2752 (insn, operands);

    case 12:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2766 (insn, operands);

    case 13:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2780 (insn, operands);

    case 14:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2794 (insn, operands);

    case 15:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2808 (insn, operands);

    case 16:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2822 (insn, operands);

    case 17:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2836 (insn, operands);

    case 18:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2850 (insn, operands);

    case 19:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2864 (insn, operands);

    case 20:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2878 (insn, operands);

    case 21:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2892 (insn, operands);

    case 22:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2906 (insn, operands);

    case 23:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2920 (insn, operands);

    case 24:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2934 (insn, operands);

    case 25:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2948 (insn, operands);

    case 26:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2962 (insn, operands);

    case 27:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2976 (insn, operands);

    case 28:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2990 (insn, operands);

    case 29:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3004 (insn, operands);

    case 30:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3018 (insn, operands);

    case 31:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3032 (insn, operands);

    case 32:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3046 (insn, operands);

    case 33:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3060 (insn, operands);

    case 34:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3074 (insn, operands);

    case 35:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3088 (insn, operands);

    case 36:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3102 (insn, operands);

    case 37:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3116 (insn, operands);

    case 38:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3130 (insn, operands);

    case 39:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3144 (insn, operands);

    case 40:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3158 (insn, operands);

    case 41:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3172 (insn, operands);

    case 42:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3186 (insn, operands);

    case 43:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3200 (insn, operands);

    case 44:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3214 (insn, operands);

    case 45:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3228 (insn, operands);

    case 46:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3242 (insn, operands);

    case 47:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3256 (insn, operands);

    case 48:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3270 (insn, operands);

    case 49:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3284 (insn, operands);

    case 50:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3298 (insn, operands);

    case 51:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3312 (insn, operands);

    case 52:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3326 (insn, operands);

    case 53:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3340 (insn, operands);

    case 54:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3354 (insn, operands);

    case 55:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3368 (insn, operands);

    case 56:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3382 (insn, operands);

    case 57:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3396 (insn, operands);

    case 58:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3410 (insn, operands);

    case 59:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3424 (insn, operands);

    case 60:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3438 (insn, operands);

    case 61:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3452 (insn, operands);

    case 62:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3466 (insn, operands);

    case 63:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3480 (insn, operands);

    case 64:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3494 (insn, operands);

    case 65:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3508 (insn, operands);

    case 66:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3522 (insn, operands);

    case 67:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3536 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_174 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT
      || GET_MODE (x4) != E_DImode)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != E_DImode)
    return NULL;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_SImode))
    return NULL;
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern463 (x10))
        {
        case 0:
          if (!((
#line 734 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 739 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 1:
          if (!((
#line 762 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 766 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern463 (x10))
        {
        case 0:
          if (!((
#line 734 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 739 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_156 (insn, operands);

        case 1:
          if (!((
#line 762 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 766 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_175 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !p2m1_shift_operand (operands[2], E_SImode)
              || !register_operand (operands[3], E_SImode))
            return NULL;
          return gen_split_50 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[3], E_DImode))
            return NULL;
          if (p2m1_shift_operand (operands[2], E_DImode)
              && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return gen_split_51 (insn, operands);
          if (!high_mask_shift_operand (operands[2], E_DImode)
              || !
#line 3105 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return NULL;
          return gen_split_52 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (pattern334 (x1) != 0
          || !(
#line 3124 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)) && 
#line 3127 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_53 (insn, operands);

    case NOT:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          switch (pattern368 (x1))
            {
            case 0:
              if (((
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 243 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_112 (insn, operands);
              break;

            case 1:
              if (((
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 243 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_114 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) != SUBREG
              || maybe_ne (SUBREG_BYTE (x8), 0)
              || GET_MODE (x8) != E_DImode)
            return NULL;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x9, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return NULL;
          x11 = XEXP (x9, 1);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!arith_operand (operands[2], E_DImode))
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!register_operand (operands[3], E_DImode)
              || !
#line 891 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS
   && clz_hwi (INTVAL (operands[2])) >= 33))
            return NULL;
          return gen_split_168 (insn, operands);

        case SIGN_EXTEND:
          switch (pattern374 (x1))
            {
            case 0:
              if (!((
#line 734 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 739 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_157 (insn, operands);

            case 1:
              if (!((
#line 762 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 766 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_161 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern374 (x1))
            {
            case 0:
              if (!((
#line 734 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 739 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_158 (insn, operands);

            case 1:
              if (!((
#line 762 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 766 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_162 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NEG:
      if (GET_MODE (x4) != E_DImode)
        return NULL;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != GE
          || GET_MODE (x8) != E_DImode)
        return NULL;
      x12 = XEXP (x8, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_DImode))
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!register_operand (operands[3], E_DImode)
          || !
#line 258 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
        return NULL;
      return gen_split_116 (insn, operands);

    case SIGN_EXTRACT:
      x13 = XEXP (x4, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x14 = XEXP (x4, 2);
      operands[2] = x14;
      if (!immediate_operand (operands[2], E_VOIDmode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern444 (x3, 
E_SImode) != 0)
            return NULL;
          if ((
#line 106 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10407 (insn, operands);
          if ((
#line 119 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && !TARGET_ZBS && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10409 (insn, operands);
          if ((
#line 49 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10451 (insn, operands);
          if (!(
#line 62 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10453 (insn, operands);

        case E_DImode:
          if (pattern444 (x3, 
E_DImode) != 0)
            return NULL;
          if ((
#line 106 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10408 (insn, operands);
          if ((
#line 119 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && !TARGET_ZBS && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10410 (insn, operands);
          if ((
#line 49 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10452 (insn, operands);
          if (!(
#line 62 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10454 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern350 (x1))
        {
        case 0:
          if (!(
#line 137 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10411 (insn, operands);

        case 1:
          if (!(
#line 137 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10415 (insn, operands);

        case 2:
          if (!(
#line 137 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10412 (insn, operands);

        case 3:
          if (!(
#line 137 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10416 (insn, operands);

        case 4:
          if (!(
#line 137 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10413 (insn, operands);

        case 5:
          if (!(
#line 137 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10417 (insn, operands);

        case 6:
          if (!(
#line 137 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10414 (insn, operands);

        case 7:
          if (!(
#line 137 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10418 (insn, operands);

        case 8:
          if (!(
#line 150 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10419 (insn, operands);

        case 9:
          if (!(
#line 150 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10421 (insn, operands);

        case 10:
          if (!(
#line 150 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10420 (insn, operands);

        case 11:
          if (!(
#line 150 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10422 (insn, operands);

        case 12:
          if (!(
#line 163 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10423 (insn, operands);

        case 13:
          if (!(
#line 163 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10425 (insn, operands);

        case 14:
          if (!(
#line 163 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10424 (insn, operands);

        case 15:
          if (!(
#line 163 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10426 (insn, operands);

        case 16:
          if (!(
#line 176 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10427 (insn, operands);

        case 17:
          if (!(
#line 176 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10429 (insn, operands);

        case 18:
          if (!(
#line 176 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10428 (insn, operands);

        case 19:
          if (!(
#line 176 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10430 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      switch (pattern350 (x1))
        {
        case 0:
          if (!(
#line 192 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10431 (insn, operands);

        case 1:
          if (!(
#line 192 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10435 (insn, operands);

        case 2:
          if (!(
#line 192 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10432 (insn, operands);

        case 3:
          if (!(
#line 192 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10436 (insn, operands);

        case 4:
          if (!(
#line 192 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10433 (insn, operands);

        case 5:
          if (!(
#line 192 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10437 (insn, operands);

        case 6:
          if (!(
#line 192 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10434 (insn, operands);

        case 7:
          if (!(
#line 192 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10438 (insn, operands);

        case 8:
          if (!(
#line 205 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10439 (insn, operands);

        case 9:
          if (!(
#line 205 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10441 (insn, operands);

        case 10:
          if (!(
#line 205 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10440 (insn, operands);

        case 11:
          if (!(
#line 205 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10442 (insn, operands);

        case 12:
          if (!(
#line 218 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10443 (insn, operands);

        case 13:
          if (!(
#line 218 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10445 (insn, operands);

        case 14:
          if (!(
#line 218 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10444 (insn, operands);

        case 15:
          if (!(
#line 218 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10446 (insn, operands);

        case 16:
          if (!(
#line 231 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10447 (insn, operands);

        case 17:
          if (!(
#line 231 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10449 (insn, operands);

        case 18:
          if (!(
#line 231 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10448 (insn, operands);

        case 19:
          if (!(
#line 231 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10450 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
